#include "driver.h"
#include "megadriv.h"
#include "segamsys.h"

/* SMS / GG support isn't very good
   No Parent / Clone relationships are set up
   Names haven't been improved
   Custom mappers not supported
   Should use MESS code instead
*/

MACHINE_DRIVER_START( smsu )
	MDRV_IMPORT_FROM( sms )
MACHINE_DRIVER_END

MACHINE_DRIVER_START( smse )
	MDRV_IMPORT_FROM( sms )
MACHINE_DRIVER_END

MACHINE_DRIVER_START( smsj )
	MDRV_IMPORT_FROM( sms )
MACHINE_DRIVER_END

MACHINE_DRIVER_START( ggu )
	MDRV_IMPORT_FROM( sms )
MACHINE_DRIVER_END

MACHINE_DRIVER_START( gge )
	MDRV_IMPORT_FROM( sms )
MACHINE_DRIVER_END

MACHINE_DRIVER_START( ggj )
	MDRV_IMPORT_FROM( sms )
MACHINE_DRIVER_END


static DRIVER_INIT( smsu )
{
	DRIVER_INIT_CALL( sms );
}

static DRIVER_INIT( smse )
{
	DRIVER_INIT_CALL( smspal );
}

static DRIVER_INIT( smsj )
{
	DRIVER_INIT_CALL( sms );
}

static DRIVER_INIT( ggu )
{
	DRIVER_INIT_CALL( smsgg );
}

static DRIVER_INIT( gge )
{
	//DRIVER_INIT_CALL( smspal );
	DRIVER_INIT_CALL( smsgg ); // gg is always ntsc?
}

static DRIVER_INIT( ggj )
{
	DRIVER_INIT_CALL( smsgg );
}

#define CONSOLE_ROM_LOAD( set, name,offset,length,hash)	\
ROM_START( set ) \
ROM_REGION( 0x400000, "maincpu", 0 ) \
ROM_LOAD(name, offset, length, hash) \
ROM_END \

/* Master System */

CONSOLE_ROM_LOAD( s_20embr, "20 em 1 (brazil).sms",                                                                      0x000000 , 0x40000,	 CRC(f0f35c22) SHA1(2012763dc08dedc68af8538698bd66618212785d) )
CONSOLE_ROM_LOAD( s_aceofa, "ace of aces (europe).sms",                                                                  0x000000 , 0x40000,	 CRC(887d9f6b) SHA1(08a79905767b8e5af8a9c9c232342e6c47588093) )
CONSOLE_ROM_LOAD( s_action, "action fighter (japan, europe) (v1.1).sms",                                                 0x000000 , 0x20000,	 CRC(d91b340d) SHA1(5dbcfb75958f4cfa1b61d9ea114bab67787b113e) )
CONSOLE_ROM_LOAD( s_actio1, "action fighter (usa, europe) (v1.2).sms",                                                   0x000000 , 0x20000,	 CRC(3658f3e0) SHA1(b462246fed3cbb9dc3909a2d5befaec65d7a0014) )
CONSOLE_ROM_LOAD( s_addams, "addams family, the (europe).sms",                                                           0x000000 , 0x40000,	 CRC(72420f38) SHA1(3fc6ccc556a1e4eb376f77eef8f16b1ff76a17d0) )
CONSOLE_ROM_LOAD( s_aerial, "aerial assault (europe).sms",                                                               0x000000 , 0x40000,	 CRC(ecf491cf) SHA1(2a9090ed365e7425ca7a59f87b942c16b376f0a3) )
CONSOLE_ROM_LOAD( s_aeria1, "aerial assault (usa).sms",                                                                  0x000000 , 0x40000,	 CRC(15576613) SHA1(e57b1d4476ca33d18d9071e022ddc9cc702d6497) )
CONSOLE_ROM_LOAD( s_afterb, "after burner (world).sms",                                                                  0x000000 , 0x80000,	 CRC(1c951f8e) SHA1(51531df038783c84640a0cab93122e0b59e3b69a) )
CONSOLE_ROM_LOAD( s_airres, "air rescue (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(8b43d21d) SHA1(4edd1b62abbbf2220961a06eb139db1838fb700b) )
CONSOLE_ROM_LOAD( s_aladdi, "aladdin (europe).sms",                                                                      0x000000 , 0x80000,	 CRC(c8718d40) SHA1(585967f400473e289cda611e7686ae98ae43172e) )
CONSOLE_ROM_LOAD( s_aleste, "aleste (japan).sms",                                                                        0x000000 , 0x20000,	 CRC(d8c4165b) SHA1(cba75b0d54df3c9a8e399851a05c194c7a05fbfe) )
CONSOLE_ROM_LOAD( s_alexki, "alex kidd - high-tech world (usa, europe).sms",                                             0x000000 , 0x20000,	 CRC(013c0a94) SHA1(2d0a581da1c787b1407fb1cfefd0571e37899978) )
CONSOLE_ROM_LOAD( s_alexk1, "alex kidd - the lost stars (world).sms",                                                    0x000000 , 0x40000,	 CRC(c13896d5) SHA1(6dbf2684c3dfea7442d0b40a9ff7c8b8fc9b1b98) )
CONSOLE_ROM_LOAD( s_alexk2, "alex kidd bmx trial (japan).sms",                                                           0x000000 , 0x20000,	 CRC(f9dbb533) SHA1(77cc767bfae01e9cc81612c780c939ed954a6312) )
CONSOLE_ROM_LOAD( s_alexk3, "alex kidd in miracle world (b) (v1.1) [p1][!].sms",                                         0x000000 , 0x20000,	 CRC(7545d7c2) SHA1(823c3051018c7acce15a7ff1d704eab5dd686a1f) )
CONSOLE_ROM_LOAD( s_alexk4, "alex kidd in miracle world (usa, europe) (v1.1).sms",                                       0x000000 , 0x20000,	 CRC(aed9aac4) SHA1(6d052e0cca3f2712434efd856f733c03011be41c) )
CONSOLE_ROM_LOAD( s_alexk5, "alex kidd in miracle world (usa, europe).sms",                                              0x000000 , 0x20000,	 CRC(17a40e29) SHA1(8cecf8ed0f765163b2657be1b0a3ce2a9cb767f4) )
CONSOLE_ROM_LOAD( s_alexk6, "alex kidd in shinobi world (usa, europe).sms",                                              0x000000 , 0x40000,	 CRC(d2417ed7) SHA1(e7c7c24e208afb986ab389883f98a1b5a8249fea) )
CONSOLE_ROM_LOAD( s_alexk7, "alex kidd no miracle world (japan).sms",                                                    0x000000 , 0x20000,	 CRC(08c9ec91) SHA1(62fdc25501e17b87c355378562c3b1966e5f9008) )
CONSOLE_ROM_LOAD( s_alfusa, "alf (usa).sms",                                                                             0x000000 , 0x20000,	 CRC(82038ad4) SHA1(7706485b735f5d7f7a59c7d626b13b23e8696087) )
CONSOLE_ROM_LOAD( s_aliene, "alien 3 (europe).sms",                                                                      0x000000 , 0x40000,	 CRC(b618b144) SHA1(be40ffc72ee19620a8bac89d5d96bbafcefc74e7) )
CONSOLE_ROM_LOAD( s_aliens, "alien storm (europe).sms",                                                                  0x000000 , 0x40000,	 CRC(7f30f793) SHA1(aece64ecbfbe08b199b29df9bc75743773ea3d34) )
CONSOLE_ROM_LOAD( s_alien1, "alien syndrome (japan).sms",                                                                0x000000 , 0x40000,	 CRC(4cc11df9) SHA1(5d786476b275de34efb95f576dd556cf4b335a83) )
CONSOLE_ROM_LOAD( s_alien2, "alien syndrome (usa, europe).sms",                                                          0x000000 , 0x40000,	 CRC(5cbfe997) SHA1(0da0b9755b6a6ef145ec3b95e651d2a384b3f7f9) )
CONSOLE_ROM_LOAD( s_altere, "altered beast (usa, europe).sms",                                                           0x000000 , 0x40000,	 CRC(bba2fe98) SHA1(413986f174799f094a8dd776d91dcf018ee17290) )
CONSOLE_ROM_LOAD( s_americ, "american baseball (europe).sms",                                                            0x000000 , 0x40000,	 CRC(7b27202f) SHA1(fff4006fe47de8138db246af8863e28b81718abe) )
CONSOLE_ROM_LOAD( s_ameri1, "american pro football (europe).sms",                                                        0x000000 , 0x40000,	 CRC(3727d8b2) SHA1(986b860465fc9748c6be1815c0e4c0ea94473040) )
CONSOLE_ROM_LOAD( s_andrea, "andre agassi tennis (europe).sms",                                                          0x000000 , 0x40000,	 CRC(f499034d) SHA1(81dbacad4739b98281c750d9af21606275398fc8) )
CONSOLE_ROM_LOAD( s_anmits, "anmitsu hime (japan).sms",                                                                  0x000000 , 0x20000,	 CRC(fff63b0b) SHA1(74057d3b7f384c91871a2db2fbc86d3e700c45e5) )
CONSOLE_ROM_LOAD( s_arcade, "arcade smash hits (europe).sms",                                                            0x000000 , 0x40000,	 CRC(e4163163) SHA1(44ed3aeaa4c8a627b88c099b184ca99710fac0ad) )
CONSOLE_ROM_LOAD( s_argosn, "argos no juujiken (j) [a1][!].sms",                                                         0x000000 , 0x20000,	 CRC(32da4b0d) SHA1(6c11879612dc00c18f6d2a1823bdd26522dc9c91) )
CONSOLE_ROM_LOAD( s_argos1, "argos no juujiken (japan).sms",                                                             0x000000 , 0x20000,	 CRC(bae75805) SHA1(a4b63ed417380f8170091e66c0417123799a731f) )
CONSOLE_ROM_LOAD( s_arielt, "ariel - the little mermaid (brazil).sms",                                                   0x000000 , 0x40000,	 CRC(f4b3a7bd) SHA1(77a35c0b622786183d6703a5d7546728db44b68d) )
CONSOLE_ROM_LOAD( s_ashura, "ashura (japan).sms",                                                                        0x000000 , 0x20000,	 CRC(ae705699) SHA1(e9f90d63320295e4bd9a87e6078186c5efb7e84e) )
CONSOLE_ROM_LOAD( s_assaul, "assault city (europe) (light phaser).sms",                                                  0x000000 , 0x40000,	 CRC(861b6e79) SHA1(835217550ecb92422d887a3353ff43890c71566b) )
CONSOLE_ROM_LOAD( s_assau1, "assault city (europe).sms",                                                                 0x000000 , 0x40000,	 CRC(0bd8da96) SHA1(ea46350ce4827b282b73600a7f4feadbec7c0ed4) )
CONSOLE_ROM_LOAD( s_asteri, "asterix (europe) (en,fr) (v1.1).sms",                                                       0x000000 , 0x80000,	 CRC(8c9d5be8) SHA1(ae56c708bc197f462b68c3e5ff9f0379d841c8b0) )
CONSOLE_ROM_LOAD( s_aster1, "asterix (europe) (en,fr).sms",                                                              0x000000 , 0x80000,	 CRC(147e02fa) SHA1(70e311421467acd01e55f1908eae653bf20de175) )
CONSOLE_ROM_LOAD( s_aster2, "asterix and the great rescue (europe) (en,fr,de,es,it).sms",                                0x000000 , 0x80000,	 CRC(f9b7d26b) SHA1(5e409247f6a611437380b7a9f0e3cccab5dd1987) )
CONSOLE_ROM_LOAD( s_aster3, "asterix and the secret mission (europe) (en,fr,de).sms",                                    0x000000 , 0x80000,	 CRC(def9b14e) SHA1(de6a32a548551553a4b3ae332f4bf98ed22d8ab5) )
CONSOLE_ROM_LOAD( s_astrof, "astro flash (j) [p1][!].sms",                                                               0x000000 , 0x8000,	 CRC(0e21e6cf) SHA1(e522a7ad519091a0955a6cf54590a7bd9708c56f) )
CONSOLE_ROM_LOAD( s_astro1, "astro flash (japan).sms",                                                                   0x000000 , 0x8000,	 CRC(c795182d) SHA1(8370957b1192349d0a610437cd5d91ea4e3892c4) )
CONSOLE_ROM_LOAD( s_astrow, "astro warrior & pit pot (europe).sms",                                                      0x000000 , 0x20000,	 CRC(69efd483) SHA1(2b3a9da256f2918b859ebcb6ffa1b36a09e7595d) )
CONSOLE_ROM_LOAD( s_astro2, "astro warrior (japan, usa).sms",                                                            0x000000 , 0x20000,	 CRC(299cbb74) SHA1(901697a3535ad70190647f34ad5b30b695d54542) )
CONSOLE_ROM_LOAD( s_ayrton, "ayrton senna's super monaco gp ii (europe).sms",                                            0x000000 , 0x80000,	 CRC(e890331d) SHA1(b6819b014168aaa03b65dae97ba6cd5fa0d7f0d9) )
CONSOLE_ROM_LOAD( s_azteca, "aztec adventure - the golden road to paradise (world).sms",                                 0x000000 , 0x20000,	 CRC(ff614eb3) SHA1(317775a17867530a8fe3a5b17b681d5ada351432) )
CONSOLE_ROM_LOAD( s_backto, "back to the future part ii (europe).sms",                                                   0x000000 , 0x40000,	 CRC(e5ff50d8) SHA1(31af58e655e12728b01e7da64b46934979b82ecf) )
CONSOLE_ROM_LOAD( s_backt1, "back to the future part iii (europe).sms",                                                  0x000000 , 0x40000,	 CRC(2d48c1d3) SHA1(7d67dd38fea5dba4224a119cc4840f6fb8e023b9) )
CONSOLE_ROM_LOAD( s_bakuba, "baku baku animal (brazil).sms",                                                             0x000000 , 0x40000,	 CRC(35d84dc2) SHA1(07d8f300b3a3542734fcd24fa8312fe99fbfef0e) )
CONSOLE_ROM_LOAD( s_bankpa, "bank panic (e) [p1][!].sms",                                                                0x000000 , 0x8000,	 CRC(b4dfb825) SHA1(983c10f9431e19e0f79627cf72d5425895fd32f8) )
CONSOLE_ROM_LOAD( s_bankp1, "bank panic (europe).sms",                                                                   0x000000 , 0x8000,	 CRC(655fb1f4) SHA1(661bbe20f01b7afb242936d409fdd30420c6de5f) )
CONSOLE_ROM_LOAD( s_basket, "basket ball nightmare (europe).sms",                                                        0x000000 , 0x40000,	 CRC(0df8597f) SHA1(0fa1156931c83763bc6906efce75045327cdd7aa) )
CONSOLE_ROM_LOAD( s_batman, "batman returns (europe).sms",                                                               0x000000 , 0x40000,	 CRC(b154ec38) SHA1(0ccc0e2d91a345c39a7406e148da147a2edce979) )
CONSOLE_ROM_LOAD( s_battle, "battle out run (europe).sms",                                                               0x000000 , 0x40000,	 CRC(c19430ce) SHA1(cfa8721d4fc71b1f14e9a06f2db715a6f88be7dd) )
CONSOLE_ROM_LOAD( s_battl1, "battlemaniacs (brazil).sms",                                                                0x000000 , 0x40000,	 CRC(1cbb7bf1) SHA1(0854e36d3bb011e712a06633f188c0d64cd65893) )
CONSOLE_ROM_LOAD( s_blackb, "black belt (usa, europe).sms",                                                              0x000000 , 0x20000,	 CRC(da3a2f57) SHA1(7c5524cff2de9b694e925297e8e74c7c8d292e46) )
CONSOLE_ROM_LOAD( s_bladee, "blade eagle (world) (beta).sms",                                                            0x000000 , 0x40000,	 CRC(58d5fc48) SHA1(9cdfda85b4fa4e689617d8bcbdd6478b19d215ca) )
CONSOLE_ROM_LOAD( s_blade1, "blade eagle (world).sms",                                                                   0x000000 , 0x40000,	 CRC(8ecd201c) SHA1(b786d15b26b914c24cd1c36a8fca41b215c0a4e7) )
CONSOLE_ROM_LOAD( s_bomber, "bomber raid (world).sms",                                                                   0x000000 , 0x40000,	 CRC(3084cf11) SHA1(d754ef2b6e05c76502c02c71dbfcf6150ee12f6f) )
CONSOLE_ROM_LOAD( s_bonanz, "bonanza bros. (europe).sms",                                                                0x000000 , 0x40000,	 CRC(caea8002) SHA1(bbaedefa0bb489ece4bbd965f09a417be4b76cc7) )
CONSOLE_ROM_LOAD( s_bonker, "bonkers wax up! (brazil).sms",                                                              0x000000 , 0x80000,	 CRC(b3768a7a) SHA1(e1f8da3897f0756c8764ece6605f940ce79e81ca) )
CONSOLE_ROM_LOAD( s_bramst, "bram stoker's dracula (europe).sms",                                                        0x000000 , 0x40000,	 CRC(1b10a951) SHA1(6c9f52cdae96541020eaaa543ca6f729763f3ada) )
CONSOLE_ROM_LOAD( s_bubble, "bubble bobble (europe).sms",                                                                0x000000 , 0x40000,	 CRC(e843ba7e) SHA1(44876b44089b4174858e54202e567e02efa76859) )
CONSOLE_ROM_LOAD( s_buggyr, "buggy run (europe).sms",                                                                    0x000000 , 0x80000,	 CRC(b0fc4577) SHA1(4b1975190ac9d6281325de0925980283fdce51ca) )
CONSOLE_ROM_LOAD( s_califo, "california games (usa, europe).sms",                                                        0x000000 , 0x40000,	 CRC(ac6009a7) SHA1(d0f8298bb2a30a3569c65372a959612df3b608db) )
CONSOLE_ROM_LOAD( s_calif1, "california games ii (brazil, korea).sms",                                                   0x000000 , 0x40000,	 CRC(45c50294) SHA1(4d6c46dedfe38fcfb740e948563b8eeec3bd4305) )
CONSOLE_ROM_LOAD( s_calif2, "california games ii (europe).sms",                                                          0x000000 , 0x40000,	 CRC(c0e25d62) SHA1(5c7d99ba54caf9a674328df787a89e0ab4730de8) )
CONSOLE_ROM_LOAD( s_captai, "captain silver (japan, europe).sms",                                                        0x000000 , 0x40000,	 CRC(a4852757) SHA1(88402392e93b220632a61e0c07731a7ed087cbef) )
CONSOLE_ROM_LOAD( s_capta1, "captain silver (usa).sms",                                                                  0x000000 , 0x20000,	 CRC(b81f6fa5) SHA1(7c2b23f4a806c89a533f27e190499243e7311c47) )
CONSOLE_ROM_LOAD( s_casino, "casino games (usa, europe).sms",                                                            0x000000 , 0x40000,	 CRC(3cff6e80) SHA1(8353b86965a87c724b95bb768d00dc84eeadce96) )
CONSOLE_ROM_LOAD( s_castel, "castelo ra-tim-bum (brazil).sms",                                                           0x000000 , 0x80000,	 CRC(31ffd7c3) SHA1(4e40155720957a0ca7cf67d7c99bbc178e2f0fd4) )
CONSOLE_ROM_LOAD( s_castle, "castle of illusion - starring mickey mouse (unknown) (sample).sms",                         0x000000 , 0x8000,	 CRC(bd610939) SHA1(f00a3c8200a67579dbc9f1d2290d5a509de36eae) )
CONSOLE_ROM_LOAD( s_castl1, "castle of illusion starring mickey mouse (europe).sms",                                     0x000000 , 0x40000,	 CRC(953f42e1) SHA1(c200b5e585d59f8bfcbb40fd6d4314de8abcfae3) )
CONSOLE_ROM_LOAD( s_castl2, "castle of illusion starring mickey mouse (usa).sms",                                        0x000000 , 0x40000,	 CRC(b9db4282) SHA1(c31d80429801e8c927cb0536d66a16d51788ff4f) )
CONSOLE_ROM_LOAD( s_champi, "champions of europe (europe).sms",                                                          0x000000 , 0x40000,	 CRC(23163a12) SHA1(e1d0b1b25b7d9bb423dadfe792bd177e01bc2ca2) )
CONSOLE_ROM_LOAD( s_champ1, "championship hockey (europe).sms",                                                          0x000000 , 0x40000,	 CRC(7e5839a0) SHA1(d11eefe122de42a73d221d9efde1086d4a8ce147) )
CONSOLE_ROM_LOAD( s_chapol, "chapolim x dracula - um duelo assustador (brazil).sms",                                     0x000000 , 0x20000,	 CRC(492c7c6e) SHA1(6590080f5db87afab1286f11ce77c60c3167b2b7) )
CONSOLE_ROM_LOAD( s_cheese, "cheese cat-astrophe starring speedy gonzales (europe) (en,fr,de,es).sms",                   0x000000 , 0x80000,	 CRC(46340c41) SHA1(09edc943fc6da8657231b09f75d5e5c6bbbac24d) )
CONSOLE_ROM_LOAD( s_chopli, "choplifter (japan) (proto).sms",                                                            0x000000 , 0x20000,	 CRC(16ec3575) SHA1(c8e87b309bbae6af7cf05602ffbd28f9495c83d8) )
CONSOLE_ROM_LOAD( s_chopl1, "choplifter (usa, europe).sms",                                                              0x000000 , 0x20000,	 CRC(4a21c15f) SHA1(856e741eec9692fcc3b22c5c5642f54482e6e00b) )
CONSOLE_ROM_LOAD( s_chouon, "chouon senshi borgman (japan).sms",                                                         0x000000 , 0x20000,	 CRC(e421e466) SHA1(9f987e022090a40506b78d89523e9f88b3bb0c0b) )
CONSOLE_ROM_LOAD( s_chuckr, "chuck rock (europe).sms",                                                                   0x000000 , 0x80000,	 CRC(dd0e2927) SHA1(0199c62afb5c09f09999a4815079875b480129f3) )
CONSOLE_ROM_LOAD( s_chuck1, "chuck rock ii - son of chuck (brazil).sms",                                                 0x000000 , 0x80000,	 CRC(87783c04) SHA1(b966120d9eacea683bc136c405c50a81763ecab8) )
CONSOLE_ROM_LOAD( s_chuck2, "chuck rock ii - son of chuck (europe).sms",                                                 0x000000 , 0x80000,	 CRC(c30e690a) SHA1(46c326d7eb73b0393de7fc40bf2ee094ebab482d) )
CONSOLE_ROM_LOAD( s_circui, "circuit, the (japan).sms",                                                                  0x000000 , 0x20000,	 CRC(8fb75994) SHA1(34307a745d3d52a4b814e9831b7041f25e8052d1) )
CONSOLE_ROM_LOAD( s_cloudm, "cloud master (usa, europe).sms",                                                            0x000000 , 0x40000,	 CRC(e7f62e6d) SHA1(b936276b272d8361bca8d7b05d1ebc59f1f639bc) )
CONSOLE_ROM_LOAD( s_colors, "color & switch test (unknown) (v1.3).sms",                                                  0x000000 , 0x8000,	 CRC(7253c3ec) SHA1(3d23afcc802cd414849b0eac69ce712bf2fa72ff) )
CONSOLE_ROM_LOAD( s_column, "columns (usa, europe).sms",                                                                 0x000000 , 0x20000,	 CRC(665fda92) SHA1(3d16b0954b5419b071de270b44d38fc6570a8439) )
CONSOLE_ROM_LOAD( s_comica, "comical machine gun joe (japan).sms",                                                       0x000000 , 0x8000,	 CRC(9d549e08) SHA1(33c21d164fd3cdf7aa9e7e0fe1a3ae5a491bd9f5) )
CONSOLE_ROM_LOAD( s_coolsp, "cool spot (europe).sms",                                                                    0x000000 , 0x40000,	 CRC(13ac9023) SHA1(cf36c1900d1c658cbfd974464761d145af3467c8) )
CONSOLE_ROM_LOAD( s_cosmic, "cosmic spacehead (europe) (en,fr,de,es).sms",                                               0x000000 , 0x40000,	 CRC(29822980) SHA1(f46f716dd34a1a5013a2d8a59769f6ef7536a567) )
CONSOLE_ROM_LOAD( s_cybers, "cyber shinobi, the (europe).sms",                                                           0x000000 , 0x40000,	 CRC(1350e4f8) SHA1(991803feb42a6f0f93ac0e97854132736def2933) )
CONSOLE_ROM_LOAD( s_cyborg, "cyborg hunter (usa, europe).sms",                                                           0x000000 , 0x20000,	 CRC(908e7524) SHA1(b6131585cb944d7fae69ad609802a1b5d51b442f) )
CONSOLE_ROM_LOAD( s_daffyd, "daffy duck in hollywood (europe) (en,fr,de,es,it).sms",                                     0x000000 , 0x80000,	 CRC(71abef27) SHA1(50ab645971b7d9c25a0a93080f70f3a9c6910c59) )
CONSOLE_ROM_LOAD( s_dallye, "dallyeora pigu-wang (korea) (unl).sms",                                                     0x000000 , 0x6c000,	 CRC(89b79e77) SHA1(9ebd5a7b025e980795eaac206f3f6f5dc297084f) )
CONSOLE_ROM_LOAD( s_danant, "danan - the jungle fighter (europe).sms",                                                   0x000000 , 0x40000,	 CRC(ae4a28d7) SHA1(c99f2562117a2bf7100a3992608e9a2bcb50df35) )
CONSOLE_ROM_LOAD( s_deadan, "dead angle (usa, europe).sms",                                                              0x000000 , 0x40000,	 CRC(e2f7193e) SHA1(0236c5239c924b425a99367260b9ebfa8b8e0bca) )
CONSOLE_ROM_LOAD( s_deepdu, "deep duck trouble starring donald duck (europe).sms",                                       0x000000 , 0x80000,	 CRC(42fc3a6e) SHA1(26ec82b96650a7329b66bf90b54b869c1ec12f6b) )
CONSOLE_ROM_LOAD( s_desert, "desert speedtrap starring road runner and wile e. coyote (europe) (en,fr,de,es,it).sms",    0x000000 , 0x40000,	 CRC(b137007a) SHA1(60e2b6ec69d73dd73c1ef846634942c81800655b) )
CONSOLE_ROM_LOAD( s_deser1, "desert strike (europe) (en,fr,de,es).sms",                                                  0x000000 , 0x80000,	 CRC(6c1433f9) SHA1(e6181baef80ecc88b3eb82a46cf93793f06e01f1) )
CONSOLE_ROM_LOAD( s_dicktr, "dick tracy (usa, europe).sms",                                                              0x000000 , 0x40000,	 CRC(f6fab48d) SHA1(b788f0394aafbc213e6fa6dcfae40ebb7659f533) )
CONSOLE_ROM_LOAD( s_dinoba, "dinobasher starring bignose the caveman (europe) (proto).sms",                              0x000000 , 0x40000,	 CRC(ea5c3a6f) SHA1(05b4f23e33ada08e0a8b1fc6feccd8a97c690a21) )
CONSOLE_ROM_LOAD( s_dinosa, "dinosaur dooley, the (korea) (unl).sms",                                                    0x000000 , 0x20000,	 CRC(32f4b791) SHA1(f9e14ea9ce5f11ca5cb831f3eaf87609d7aea8f2) )
CONSOLE_ROM_LOAD( s_dokido, "doki doki penguin land - uchuu daibouken (japan).sms",                                      0x000000 , 0x20000,	 CRC(2bcdb8fa) SHA1(c01cf44eee335d509dc20a165add8514e7fbb7c4) )
CONSOLE_ROM_LOAD( s_double, "double dragon (world).sms",                                                                 0x000000 , 0x40000,	 CRC(a55d89f3) SHA1(cad5532af94ed75c0ada8820a83fa04d22f7bef5) )
CONSOLE_ROM_LOAD( s_doubl1, "double hawk (europe) (beta).sms",                                                           0x000000 , 0x40000,	 CRC(f76d5cee) SHA1(44e30fea309911a9c114b8e31ca7ec5584295b21) )
CONSOLE_ROM_LOAD( s_doubl2, "double hawk (europe).sms",                                                                  0x000000 , 0x40000,	 CRC(8370f6cd) SHA1(d2428baf22da8a70a08ff35389d59030ce764372) )
CONSOLE_ROM_LOAD( s_doubl3, "double target - cynthia no nemuri (japan).sms",                                             0x000000 , 0x20000,	 CRC(52b83072) SHA1(51f9ce05e383983ce1fe930ec178406b277db69c) )
CONSOLE_ROM_LOAD( s_drhell, "dr. hello (k).sms",                                                                         0x000000 , 0x8000,	 CRC(16537865) SHA1(8206e4b1df9468f4f60e654a0a4044083bd6e5d1) )
CONSOLE_ROM_LOAD( s_drrobo, "dr. robotnik's mean bean machine (europe).sms",                                             0x000000 , 0x40000,	 CRC(6c696221) SHA1(89df035da8de68517f82bdf176d3b3f2edcd9e31) )
CONSOLE_ROM_LOAD( s_dragon, "dragon - the bruce lee story (europe).sms",                                                 0x000000 , 0x40000,	 CRC(c88a5064) SHA1(3d41a4e3b9ffc3e2ba87bd89baf13271f8560775) )
CONSOLE_ROM_LOAD( s_drago1, "dragon crystal (europe).sms",                                                               0x000000 , 0x20000,	 CRC(9549fce4) SHA1(021c6983fdab4b0215ca324734deef0d32c29562) )
CONSOLE_ROM_LOAD( s_dynami, "dynamite duke (europe).sms",                                                                0x000000 , 0x40000,	 CRC(07306947) SHA1(258901a74176fc78f9c669cd7d716da0c872ca67) )
CONSOLE_ROM_LOAD( s_dynam1, "dynamite dux (europe).sms",                                                                 0x000000 , 0x40000,	 CRC(0e1cc1e0) SHA1(2a513aef0f0bdcdf4aaa71e7b26a15ce686db765) )
CONSOLE_ROM_LOAD( s_dynam2, "dynamite headdy (brazil).sms",                                                              0x000000 , 0x80000,	 CRC(7db5b0fa) SHA1(12877c1c9bfba6462606717cf0a94f700ac970e4) )
CONSOLE_ROM_LOAD( s_eswatc, "e-swat - city under siege (usa, europe) (easy version).sms",                                0x000000 , 0x40000,	 CRC(c4bb1676) SHA1(075297d2f3a8ec4c399eaeab6b60e246e11b41fe) )
CONSOLE_ROM_LOAD( s_eswat1, "e-swat - city under siege (usa, europe) (hard version).sms",                                0x000000 , 0x40000,	 CRC(c10fce39) SHA1(c481b4e5ca136fbb4105ae465259125392faffd3) )
CONSOLE_ROM_LOAD( s_earthw, "earthworm jim (brazil).sms",                                                                0x000000 , 0x80000,	 CRC(c4d5efc5) SHA1(a1966c2d8e75ea17df461a46c4a1a8b0b5fecd4e) )
CONSOLE_ROM_LOAD( s_eccoth, "ecco - the tides of time (brazil).sms",                                                     0x000000 , 0x80000,	 CRC(7c28703a) SHA1(61cef405e5bc71f1a603881c025bc245a8d14be4) )
CONSOLE_ROM_LOAD( s_eccot1, "ecco the dolphin (europe).sms",                                                             0x000000 , 0x80000,	 CRC(6687fab9) SHA1(3bfdef48f27f2e53e2c31cb9626606a1541889dd) )
CONSOLE_ROM_LOAD( s_enduro, "enduro racer (japan).sms",                                                                  0x000000 , 0x40000,	 CRC(5d5c50b3) SHA1(7a0216af8d4a5aeda1d42e2703f140d08b3f92f6) )
CONSOLE_ROM_LOAD( s_endur1, "enduro racer (usa, europe).sms",                                                            0x000000 , 0x20000,	 CRC(00e73541) SHA1(10dc132166c1aa47ca7b89fbb1f0a4e56b428359) )
CONSOLE_ROM_LOAD( s_excell, "excellent dizzy collection, the (usa, europe) (en,fr,de,es,it) (proto).sms",                0x000000 , 0x40000,	 CRC(8813514b) SHA1(09a2acf3ed90101be2629384c5c702f6a5408035) )
CONSOLE_ROM_LOAD( s_f16fig, "f-16 fighter (usa, europe).sms",                                                            0x000000 , 0x8000,	 CRC(eaebf323) SHA1(de63ca2f59adb94fac87623fe68de75940397449) )
CONSOLE_ROM_LOAD( s_f16fi1, "f-16 fighting falcon (japan).sms",                                                          0x000000 , 0x8000,	 CRC(7ce06fce) SHA1(0f60f545ce99366860a94fbb115ce7d8531ab7ba) )
CONSOLE_ROM_LOAD( s_f16fi2, "f-16 fighting falcon (usa).sms",                                                            0x000000 , 0x8000,	 CRC(184c23b7) SHA1(a8f083b3db721b672b5b023d673a64577cb48ef3) )
CONSOLE_ROM_LOAD( s_f1euro, "f1 (europe).sms",                                                                           0x000000 , 0x40000,	 CRC(ec788661) SHA1(247fd74485073695a88f6813482f67516860b3a0) )
CONSOLE_ROM_LOAD( s_family, "family games (japan).sms",                                                                  0x000000 , 0x20000,	 CRC(7abc70e9) SHA1(dfbf0186d497cf53d1f21a9430991ed4124cc4c2) )
CONSOLE_ROM_LOAD( s_fantas, "fantastic dizzy (europe) (en,fr,de,es,it).sms",                                             0x000000 , 0x40000,	 CRC(b9664ae1) SHA1(4202ce26832046c7ca8209240f097a8a0a84d981) )
CONSOLE_ROM_LOAD( s_fanta1, "fantasy zone (japan).sms",                                                                  0x000000 , 0x20000,	 CRC(0ffbcaa3) SHA1(b486d8be0cf669117e134f9e53a452bf71097479) )
CONSOLE_ROM_LOAD( s_fanta2, "fantasy zone (world) (v1.1) (beta).sms",                                                    0x000000 , 0x20000,	 CRC(f46264fe) SHA1(b46cb68c330dad61cd2a2ef1f5f5480af303816a) )
CONSOLE_ROM_LOAD( s_fanta3, "fantasy zone (world) (v1.2).sms",                                                           0x000000 , 0x20000,	 CRC(65d7e4e0) SHA1(0278cd120dc3a7707eda9314c46c7f27f9e8fdda) )
CONSOLE_ROM_LOAD( s_fanta4, "fantasy zone - the maze (usa, europe).sms",                                                 0x000000 , 0x20000,	 CRC(d29889ad) SHA1(a2cd356826c8116178394d8aba444cb636ef784e) )
CONSOLE_ROM_LOAD( s_fanta5, "fantasy zone ii - opa-opa no namida (japan).sms",                                           0x000000 , 0x40000,	 CRC(c722fb42) SHA1(60d8135e8f15fe48f504d0ec69010a4b886dcda8) )
CONSOLE_ROM_LOAD( s_fanta6, "fantasy zone ii - the tears of opa-opa (usa, europe).sms",                                  0x000000 , 0x40000,	 CRC(b8b141f9) SHA1(b84831378c7c19798b6fd560647e2941842bb80a) )
CONSOLE_ROM_LOAD( s_felipe, "felipe em acao (b).sms",                                                                    0x000000 , 0x8000,	 CRC(ccb2cab4) SHA1(b7601ff0116490b85c9bd50109db175ce2dd9104) )
CONSOLE_ROM_LOAD( s_ferias, "ferias frustradas do pica pau (brazil).sms",                                                0x000000 , 0x80000,	 CRC(bf6c2e37) SHA1(81dd4d7f1376e639cabebecdc821e9b5a635952b) )
CONSOLE_ROM_LOAD( s_fifain, "fifa international soccer (brazil) (en,es,pt).sms",                                         0x000000 , 0x80000,	 CRC(9bb3b5f9) SHA1(360073cb28e87a05b7f3a5922a24601981330046) )
CONSOLE_ROM_LOAD( s_finalb, "final bubble bobble (japan).sms",                                                           0x000000 , 0x40000,	 CRC(3ebb7457) SHA1(ab585612fddb90b5285e2804f63fd7fb7ba02900) )
CONSOLE_ROM_LOAD( s_firefo, "fire & forget ii (europe).sms",                                                             0x000000 , 0x40000,	 CRC(f6ad7b1d) SHA1(f934b35d27330cc2737d6a2d590dcef56004b983) )
CONSOLE_ROM_LOAD( s_fireic, "fire & ice (brazil).sms",                                                                   0x000000 , 0x40000,	 CRC(8b24a640) SHA1(0e12ce919cda400b8681e18bdad31ba74f07a92b) )
CONSOLE_ROM_LOAD( s_flasht, "flash, the (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(be31d63f) SHA1(1732b4c13fd00dd5efc5bf1ccb1ab6ed3889c8ba) )
CONSOLE_ROM_LOAD( s_flints, "flintstones, the (europe).sms",                                                             0x000000 , 0x40000,	 CRC(ca5c78a5) SHA1(a0aa76d89f6831999c328877057a99e72c6b533b) )
CONSOLE_ROM_LOAD( s_forgot, "forgotten worlds (europe).sms",                                                             0x000000 , 0x40000,	 CRC(38c53916) SHA1(3f034429b23b6976c961595c1bcbd68826cb760d) )
CONSOLE_ROM_LOAD( s_fushig, "fushigi no oshiro pit pot (j) [p1][!].sms",                                                 0x000000 , 0x8000,	 CRC(5d08e823) SHA1(1298aab2a29071e258dcbb962c3b80f8fc337b7a) )
CONSOLE_ROM_LOAD( s_fushi1, "fushigi no oshiro pit pot (japan).sms",                                                     0x000000 , 0x8000,	 CRC(e6795c53) SHA1(b1afa682b2f70bfc4ab2020d7c3047aabbaf9a24) )
CONSOLE_ROM_LOAD( s_glocai, "g-loc air battle (europe).sms",                                                             0x000000 , 0x40000,	 CRC(05cdc24e) SHA1(144bd2f8f6e480829c50f71baa370a838e8cec41) )
CONSOLE_ROM_LOAD( s_gaeguj, "gaegujangi ggachi (korea) (unl).sms",                                                       0x000000 , 0x80000,	 CRC(8b40f6bf) SHA1(320e3491da0266b46ff52103c23d25da2176e91c) )
CONSOLE_ROM_LOAD( s_gaingr, "gain ground (europe).sms",                                                                  0x000000 , 0x40000,	 CRC(3ec5e627) SHA1(62c0ca61ad8f679f90f253ab6bbffd0c7737a8c0) )
CONSOLE_ROM_LOAD( s_galact, "galactic protector (japan).sms",                                                            0x000000 , 0x20000,	 CRC(a6fa42d0) SHA1(e8bcc3621e30ee445a74e6ddbe0842d0a6753f36) )
CONSOLE_ROM_LOAD( s_galaxy, "galaxy force (europe).sms",                                                                 0x000000 , 0x80000,	 CRC(a4ac35d8) SHA1(54fe2f686fb9ec3e34b41d58778118b11f920440) )
CONSOLE_ROM_LOAD( s_galax1, "galaxy force (usa).sms",                                                                    0x000000 , 0x80000,	 CRC(6c827520) SHA1(874289a1e8110312db48c5111fbf8e70b2426b5f) )
CONSOLE_ROM_LOAD( s_gamebo, "game box serie esportes radicais (brazil).sms",                                             0x000000 , 0x40000,	 CRC(1890f407) SHA1(c0ee197e93c9ec81f5b788e8d6b20b3ab57d2259) )
CONSOLE_ROM_LOAD( s_gangst, "gangster town (usa, europe).sms",                                                           0x000000 , 0x20000,	 CRC(5fc74d2a) SHA1(57f0972109cb6f9a74c65d70d6497bc02fdfc942) )
CONSOLE_ROM_LOAD( s_gauntl, "gauntlet (europe).sms",                                                                     0x000000 , 0x20000,	 CRC(d9190956) SHA1(4e583ce9b95e20ecddc6c1dac9941c28a3e80808) )
CONSOLE_ROM_LOAD( s_george, "george foreman's ko boxing (europe).sms",                                                   0x000000 , 0x40000,	 CRC(a64898ce) SHA1(d0ddb71c6ca823c53d7e927a0de7de4b56745331) )
CONSOLE_ROM_LOAD( s_gerald, "geraldinho (brazil).sms",                                                                   0x000000 , 0x8000,	 CRC(956c416b) SHA1(d82145b582e21ae5cb562030b5042ec85d440add) )
CONSOLE_ROM_LOAD( s_ghosth, "ghost house (j) [p1][!].sms",                                                               0x000000 , 0x8000,	 CRC(dabcc054) SHA1(4f93c7185c9ebdd70d9f7be56761bf9031934c6a) )
CONSOLE_ROM_LOAD( s_ghost1, "ghost house (japan).sms",                                                                   0x000000 , 0x8000,	 CRC(c0f3ce7e) SHA1(051e74c499c6792f891668a7be23a11c2c4087af) )
CONSOLE_ROM_LOAD( s_ghost2, "ghost house (usa, europe) (beta).sms",                                                      0x000000 , 0x8000,	 CRC(c3e7c1ed) SHA1(f341e68bad5029bf475922c2c1b79eb109f467a1) )
CONSOLE_ROM_LOAD( s_ghost3, "ghost house (usa, europe).sms",                                                             0x000000 , 0x8000,	 CRC(f1f8ff2d) SHA1(cbce4c5d819be524f874ec9b60ca9442047a6681) )
CONSOLE_ROM_LOAD( s_ghostb, "ghostbusters (usa, europe).sms",                                                            0x000000 , 0x20000,	 CRC(1ddc3059) SHA1(8945a9dfc99a2081a6fb74bbabf8feaac83a7e1a) )
CONSOLE_ROM_LOAD( s_ghouls, "ghouls'n ghosts (usa, europe).sms",                                                         0x000000 , 0x40000,	 CRC(7a92eba6) SHA1(b193e624795b2beb741249981d621cb650c658db) )
CONSOLE_ROM_LOAD( s_global, "global defense (usa, europe) (beta).sms",                                                   0x000000 , 0x20000,	 CRC(91a0fc4e) SHA1(f92e1a9f7499b344e7865b18c042e09e7d614796) )
CONSOLE_ROM_LOAD( s_globa1, "global defense (usa, europe).sms",                                                          0x000000 , 0x20000,	 CRC(b746a6f5) SHA1(189ee1d4250a1f33e97053aa804a97b4e1467728) )
CONSOLE_ROM_LOAD( s_gokuak, "gokuaku doumei dump matsumoto (japan).sms",                                                 0x000000 , 0x20000,	 CRC(a249fa9d) SHA1(77f1e788f43fb59456f982472f02f109f53c7918) )
CONSOLE_ROM_LOAD( s_golden, "golden axe (usa, europe).sms",                                                              0x000000 , 0x80000,	 CRC(c08132fb) SHA1(d92538cb16a7a456255fa0da2bd8d0f588cd12ab) )
CONSOLE_ROM_LOAD( s_golde1, "golden axe warrior (usa, europe).sms",                                                      0x000000 , 0x40000,	 CRC(c7ded988) SHA1(fbda0486b393708a89756bb57d116ad6007484e4) )
CONSOLE_ROM_LOAD( s_golfam, "golfamania (europe) (beta).sms",                                                            0x000000 , 0x40000,	 CRC(5dabfdc3) SHA1(da88dc3e84daa2f8b8d803b00a13b5fb3185d8c5) )
CONSOLE_ROM_LOAD( s_golfa1, "golfamania (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(48651325) SHA1(d0b964dd7cd8ccdd730de4d8e4bb2e87bea7686e) )
CONSOLE_ROM_LOAD( s_golvel, "golvellius (usa, europe).sms",                                                              0x000000 , 0x40000,	 CRC(a51376fe) SHA1(cb8c2de9a8e91c0e4e60e5d4d9958e671d84da4c) )
CONSOLE_ROM_LOAD( s_gpride, "gp rider (europe).sms",                                                                     0x000000 , 0x80000,	 CRC(ec2da554) SHA1(3083069782c7cfcf2cc1229aca38f8f2971cf284) )
CONSOLE_ROM_LOAD( s_greatb, "great baseball (j) [p1][!].sms",                                                            0x000000 , 0x8000,	 CRC(c1e699db) SHA1(878852cb66427b0de11fba76bf6c8830a751d29f) )
CONSOLE_ROM_LOAD( s_great1, "great baseball (japan).sms",                                                                0x000000 , 0x8000,	 CRC(89e98a7c) SHA1(e6eaaec61bec32dee5161ae59a7a0902f0d05dc9) )
CONSOLE_ROM_LOAD( s_great2, "great baseball (usa, europe).sms",                                                          0x000000 , 0x20000,	 CRC(10ed6b57) SHA1(b332344eb529bad29dfb582633e787f7e42f71ae) )
CONSOLE_ROM_LOAD( s_great3, "great basketball (world).sms",                                                              0x000000 , 0x20000,	 CRC(2ac001eb) SHA1(2fdb7ebce61e316ded27b575535d4f475c9dd822) )
CONSOLE_ROM_LOAD( s_greatf, "great football (world).sms",                                                                0x000000 , 0x20000,	 CRC(2055825f) SHA1(a768f44ce7e50083ffe8c4b5e3ac93ceb7bd3266) )
CONSOLE_ROM_LOAD( s_greatg, "great golf (japan).sms",                                                                    0x000000 , 0x20000,	 CRC(6586bd1f) SHA1(417739aa248032f5aebe05750a5de85346e36712) )
CONSOLE_ROM_LOAD( s_great4, "great golf (ue) (v1.0) [!].sms",                                                            0x000000 , 0x20000,	 CRC(c6611c84) SHA1(eab0eed872dd26b13bcf0b2dd74fcbbc078812c9) )
CONSOLE_ROM_LOAD( s_great5, "great golf (world) (beta).sms",                                                             0x000000 , 0x20000,	 CRC(4847bc91) SHA1(ce0662179bb0ca4a6491ef2be8839168b993c04e) )
CONSOLE_ROM_LOAD( s_great6, "great golf (world).sms",                                                                    0x000000 , 0x20000,	 CRC(98e4ae4a) SHA1(3c0b12cfb70f2515429b6e88e0753d69dbb907ab) )
CONSOLE_ROM_LOAD( s_greati, "great ice hockey (japan, usa).sms",                                                         0x000000 , 0x10000,	 CRC(0cb7e21f) SHA1(bbe6bd6b59e5ae20cd1a4a8c72276aac7d2964a3) )
CONSOLE_ROM_LOAD( s_greats, "great soccer (europe).sms",                                                                 0x000000 , 0x8000,	 CRC(0ed170c9) SHA1(7d1a381be96474f18ba1dac8eaf6710010b0e481) )
CONSOLE_ROM_LOAD( s_great7, "great soccer (j) [p1][!].sms",                                                              0x000000 , 0x8000,	 CRC(84665648) SHA1(88611c50fcaa307bfd70b2bd5effeb39c2c4f3ae) )
CONSOLE_ROM_LOAD( s_great8, "great soccer (japan).sms",                                                                  0x000000 , 0x8000,	 CRC(2d7fd7ef) SHA1(110536303b7bccc193bef4437ba5a9eb6fd4ac8e) )
CONSOLE_ROM_LOAD( s_greatt, "great tennis (japan).sms",                                                                  0x000000 , 0x8000,	 CRC(95cbf3dd) SHA1(e7f3529689cd29be3fa02f94266e4ee8e0795d7d) )
CONSOLE_ROM_LOAD( s_greatv, "great volleyball (japan).sms",                                                              0x000000 , 0x20000,	 CRC(6819b0c0) SHA1(b9e3284c7b557eed84661c98bc733d32b46c7a07) )
CONSOLE_ROM_LOAD( s_great9, "great volleyball (usa, europe).sms",                                                        0x000000 , 0x20000,	 CRC(8d43ea95) SHA1(133ffdde0a5a0ce951c667a4c5d7f9d9f35e9658) )
CONSOLE_ROM_LOAD( s_hajano, "haja no fuuin (japan).sms",                                                                 0x000000 , 0x40000,	 CRC(b9fdf6d9) SHA1(46a032004d49fec58099aa6bf0dd796997e95142) )
CONSOLE_ROM_LOAD( s_hangon, "hang-on & astro warrior (usa).sms",                                                         0x000000 , 0x20000,	 CRC(1c5059f0) SHA1(ae29f676846fc740a2cfc69756875b6480265f97) )
CONSOLE_ROM_LOAD( s_hango1, "hang-on & safari hunt (usa).sms",                                                           0x000000 , 0x20000,	 CRC(e167a561) SHA1(7c741493889788d4511979bcaa3c48708d6240ed) )
CONSOLE_ROM_LOAD( s_hango2, "hang-on (europe).sms",                                                                      0x000000 , 0x8000,	 CRC(071b045e) SHA1(e601257f6477b85eb0b25a5b6d46ebc070d8a05a) )
CONSOLE_ROM_LOAD( s_hango3, "hang-on (japan).sms",                                                                       0x000000 , 0x8000,	 CRC(5c01adf9) SHA1(43552f58f0c0c292f3e4c1b1525fd0344dc220c6) )
CONSOLE_ROM_LOAD( s_heavyw, "heavyweight champ (europe).sms",                                                            0x000000 , 0x40000,	 CRC(fdab876a) SHA1(7e2523061df0c08b7df7b446b5504c4eb0fea163) )
CONSOLE_ROM_LOAD( s_heroes, "heroes of the lance (europe).sms",                                                          0x000000 , 0x80000,	 CRC(cde13ffb) SHA1(16b2219a1493c06d18c973fc550ea563c3116207) )
CONSOLE_ROM_LOAD( s_highsc, "high school! kimengumi (japan).sms",                                                        0x000000 , 0x20000,	 CRC(9eb1aa4f) SHA1(d3c0aeeacccef77c45ab4219c7d6d8ed04d467cb) )
CONSOLE_ROM_LOAD( s_hokuto, "hokuto no ken (j) [p1][!].sms",                                                             0x000000 , 0x20000,	 CRC(656d1a3e) SHA1(e77c7150ad274fb9d7df378e460e64daa9b9e9b6) )
CONSOLE_ROM_LOAD( s_hokut1, "hokuto no ken (japan).sms",                                                                 0x000000 , 0x20000,	 CRC(24f5fe8c) SHA1(26c5da3ee48bc0f8fd3d20f9408e584242edcd9d) )
CONSOLE_ROM_LOAD( s_homeal, "home alone (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(c9dbf936) SHA1(9b9be300fdc386f864af516000ffa3a53f1613e2) )
CONSOLE_ROM_LOAD( s_hookeu, "hook (europe) (proto).sms",                                                                 0x000000 , 0x40000,	 CRC(9ced34a7) SHA1(b7bbd78b301244d7ce83f79d72fd28c56a870905) )
CONSOLE_ROM_LOAD( s_hoshiw, "hoshi wo sagasite... (japan).sms",                                                          0x000000 , 0x40000,	 CRC(955a009e) SHA1(f9ce8b80d8671db6ab38ba5b7ce46324a65ebc3d) )
CONSOLE_ROM_LOAD( s_hwaran, "hwarang ui geom (korea).sms",                                                               0x000000 , 0x40000,	 CRC(e4b7c56a) SHA1(cfee7ce6fadf4be1e8418451ae4a1f019de012f8) )
CONSOLE_ROM_LOAD( s_imposs, "impossible mission (europe) (beta).sms",                                                    0x000000 , 0x20000,	 CRC(71c4ca8f) SHA1(9c6c28610603d05664d9ae44b62b5c1ac47f829c) )
CONSOLE_ROM_LOAD( s_impos1, "impossible mission (europe).sms",                                                           0x000000 , 0x20000,	 CRC(64d6af3b) SHA1(d883f28e77e575edca6dcb1c4cd1f2b1f11393b2) )
CONSOLE_ROM_LOAD( s_incred, "incredible crash dummies, the (europe).sms",                                                0x000000 , 0x40000,	 CRC(b4584dde) SHA1(94a4ba183de82fc0066a0edab2acaee5e8bdd0e7) )
CONSOLE_ROM_LOAD( s_incre1, "incredible hulk, the (europe).sms",                                                         0x000000 , 0x80000,	 CRC(be9a7071) SHA1(235ad7d259023610d8aa59d066aaf0dba2ff8138) )
CONSOLE_ROM_LOAD( s_indian, "indiana jones and the last crusade (europe) (beta).sms",                                    0x000000 , 0x40000,	 CRC(acec894d) SHA1(5f29a0fc637cf7bd175a3e7be720530bde23402e) )
CONSOLE_ROM_LOAD( s_india1, "indiana jones and the last crusade (europe).sms",                                           0x000000 , 0x40000,	 CRC(8aeb574b) SHA1(68e23692a12628dde805ded9de356c5e19e4eba6) )
CONSOLE_ROM_LOAD( s_jamesb, "james 'buster' douglas knockout boxing (usa).sms",                                          0x000000 , 0x40000,	 CRC(6a664405) SHA1(b07000feb0c74824f2e3e74fd415631a8f3c4da6) )
CONSOLE_ROM_LOAD( s_james1, "james bond 007 - the duel (brazil).sms",                                                    0x000000 , 0x40000,	 CRC(8feff688) SHA1(cc3eec4da3758fe9e407ab80fa88dc952d33cdd5) )
CONSOLE_ROM_LOAD( s_james2, "james bond 007 - the duel (europe).sms",                                                    0x000000 , 0x40000,	 CRC(8d23587f) SHA1(89f86869b90af986bee2acff44defe420e405a1e) )
CONSOLE_ROM_LOAD( s_jamesp, "james pond 2 - codename robocod (europe).sms",                                              0x000000 , 0x80000,	 CRC(102d5fea) SHA1(df4f55f7ff9236f65aee737743e7500c4d96cf12) )
CONSOLE_ROM_LOAD( s_joemon, "joe montana football (usa, europe).sms",                                                    0x000000 , 0x40000,	 CRC(0a9089e5) SHA1(7452f7286cee78ce4bbd05841a4d087fdfba12e3) )
CONSOLE_ROM_LOAD( s_jungle, "jungle book, the (europe).sms",                                                             0x000000 , 0x40000,	 CRC(695a9a15) SHA1(f65b5957b4b21bd16b4aa8a6e93fed944dd7d9ac) )
CONSOLE_ROM_LOAD( s_jurass, "jurassic park (europe).sms",                                                                0x000000 , 0x80000,	 CRC(0667ed9f) SHA1(67a6e6c132362f3d9263dda68d77c279b08f1fde) )
CONSOLE_ROM_LOAD( s_kensei, "kenseiden (japan).sms",                                                                     0x000000 , 0x40000,	 CRC(05ea5353) SHA1(cd349833ff41821635c6242a0b8cef7e071103d5) )
CONSOLE_ROM_LOAD( s_kense1, "kenseiden (usa, europe).sms",                                                               0x000000 , 0x40000,	 CRC(516ed32e) SHA1(3fce661d57e8bc764e7190ddbee4bf3d3e214c6c) )
CONSOLE_ROM_LOAD( s_kingsq, "king's quest - quest for the crown (usa) (beta).sms",                                       0x000000 , 0x20000,	 CRC(b7fe0a9d) SHA1(1b6330199444e303aafb9a2fd3f2119cedab0712) )
CONSOLE_ROM_LOAD( s_kings1, "king's quest - quest for the crown (usa).sms",                                              0x000000 , 0x20000,	 CRC(f8d33bc4) SHA1(d05ae9652b85c858f4e7db0b7b7c457a4e0a6a49) )
CONSOLE_ROM_LOAD( s_klaxeu, "klax (europe).sms",                                                                         0x000000 , 0x20000,	 CRC(2b435fd6) SHA1(53ae621e66d8e5f2e7276e461e8771c3c2037a7a) )
CONSOLE_ROM_LOAD( s_krusty, "krusty's fun house (europe).sms",                                                           0x000000 , 0x40000,	 CRC(64a585eb) SHA1(54714a19c2d24260b117ebc5ae391d9b24ca9166) )
CONSOLE_ROM_LOAD( s_kujaku, "kujaku ou (japan).sms",                                                                     0x000000 , 0x80000,	 CRC(d11d32e4) SHA1(6974d27bc31c2634bec54c4e9935a28461fb60f7) )
CONSOLE_ROM_LOAD( s_kungfu, "kung fu kid (usa, europe).sms",                                                             0x000000 , 0x20000,	 CRC(1e949d1f) SHA1(7e1c32f5abf9ff906ffe113ffab6eecd1c86b381) )
CONSOLE_ROM_LOAD( s_landof, "land of illusion starring mickey mouse (europe).sms",                                       0x000000 , 0x80000,	 CRC(24e97200) SHA1(a120f29c6bf2e733775d5b984bd3a156682699c6) )
CONSOLE_ROM_LOAD( s_laserg, "laser ghost (europe).sms",                                                                  0x000000 , 0x40000,	 CRC(0ca95637) SHA1(a21286d282ca994c66d8e7a91ee0a05ff69c7981) )
CONSOLE_ROM_LOAD( s_legend, "legend of illusion starring mickey mouse (brazil).sms",                                     0x000000 , 0x80000,	 CRC(6350e649) SHA1(62adbd8e5a41d08c4745e9fbb1c51f0091c9dea6) )
CONSOLE_ROM_LOAD( s_lemmin, "lemmings (europe) (beta).sms",                                                              0x000000 , 0x40000,	 CRC(2c61ed88) SHA1(8d8692d363348f7c93f402c6485f5f831d1c8190) )
CONSOLE_ROM_LOAD( s_lemmi1, "lemmings (europe).sms",                                                                     0x000000 , 0x40000,	 CRC(f369b2d8) SHA1(f3a853cce1249a0848bfc0344f3ee2db6efa4c01) )
CONSOLE_ROM_LOAD( s_lineof, "line of fire (europe).sms",                                                                 0x000000 , 0x80000,	 CRC(cb09f355) SHA1(985f78bcaf64bb088d64517f80b0acc7f5034b24) )
CONSOLE_ROM_LOAD( s_lionki, "lion king, the (europe).sms",                                                               0x000000 , 0x80000,	 CRC(c352c7eb) SHA1(3a64657e3523a5da1b99db9d89b1a48ed4ccc5ed) )
CONSOLE_ROM_LOAD( s_lordof, "lord of sword (japan).sms",                                                                 0x000000 , 0x40000,	 CRC(aa7d6f45) SHA1(6a08d913fd92a213b1ecf5aa7c5630362cccc6b4) )
CONSOLE_ROM_LOAD( s_lordo1, "lord of the sword (usa, europe).sms",                                                       0x000000 , 0x40000,	 CRC(e8511b08) SHA1(a5326a0029f7c3101add3335a599a01ccd7634c5) )
CONSOLE_ROM_LOAD( s_lorett, "loretta no shouzou (japan).sms",                                                            0x000000 , 0x20000,	 CRC(323f357f) SHA1(0ddd7448f5bd437d0d33b85a44f2bcc2bf2ea05e) )
CONSOLE_ROM_LOAD( s_luckyd, "lucky dime caper starring donald duck, the (europe) (beta).sms",                            0x000000 , 0x40000,	 CRC(7f6d0df6) SHA1(5ac3e68b34ee4499ddbdee28b47a1440782a9c04) )
CONSOLE_ROM_LOAD( s_lucky1, "lucky dime caper starring donald duck, the (europe).sms",                                   0x000000 , 0x40000,	 CRC(a1710f13) SHA1(a08815d27e431f0bee70b4ebfb870a3196c2a732) )
CONSOLE_ROM_LOAD( s_mahjon, "mahjong sengoku jidai (japan) (beta).sms",                                                  0x000000 , 0x20000,	 CRC(996b2a07) SHA1(169510c0575e4f53b9da8197fc48608993351182) )
CONSOLE_ROM_LOAD( s_mahjo1, "mahjong sengoku jidai (japan).sms",                                                         0x000000 , 0x20000,	 CRC(bcfbfc67) SHA1(9b7cd3a25b2a1fc880683dcdca81457c93d46de5) )
CONSOLE_ROM_LOAD( s_makair, "makai retsuden (japan).sms",                                                                0x000000 , 0x20000,	 CRC(ca860451) SHA1(59d520fdb2b6cbd5736b2bd6045ad3ee3ad2e3a6) )
CONSOLE_ROM_LOAD( s_maougo, "maou golvellius (japan).sms",                                                               0x000000 , 0x40000,	 CRC(bf0411ad) SHA1(f62c5c9dea4368e6475517c4220a62e40fedd35d) )
CONSOLE_ROM_LOAD( s_marble, "marble madness (europe).sms",                                                               0x000000 , 0x40000,	 CRC(bf6f3e5f) SHA1(f5efe0635e283a08f98272a9ff1bc7d37c35692c) )
CONSOLE_ROM_LOAD( s_marksm, "marksman shooting & trap shooting & safari hunt (europe).sms",                              0x000000 , 0x20000,	 CRC(e8215c2e) SHA1(eaae5c9d9de24c0991500122042b3aa2210d50d9) )
CONSOLE_ROM_LOAD( s_marks1, "marksman shooting & trap shooting (usa).sms",                                               0x000000 , 0x20000,	 CRC(e8ea842c) SHA1(5491cce7b9c19cb49060da94ab8f9c4331e77cb3) )
CONSOLE_ROM_LOAD( s_master, "master of darkness (europe).sms",                                                           0x000000 , 0x40000,	 CRC(96fb4d4b) SHA1(ed3569be5d5a49ff5a09b2b04ec0101d4edfa81e) )
CONSOLE_ROM_LOAD( s_maste1, "masters of combat (europe).sms",                                                            0x000000 , 0x40000,	 CRC(93141463) SHA1(9596400394f2bb3dbf7eb4a26b820cdfe5cd6094) )
CONSOLE_ROM_LOAD( s_mazehu, "maze hunter 3-d (usa, europe).sms",                                                         0x000000 , 0x20000,	 CRC(31b8040b) SHA1(6d94c2159a67f3140d0c9158b58aa8f0474eaaba) )
CONSOLE_ROM_LOAD( s_mazewa, "maze walker (japan).sms",                                                                   0x000000 , 0x20000,	 CRC(871562b0) SHA1(ade756eccaf94c79e8b3636921b6f8669a163265) )
CONSOLE_ROM_LOAD( s_megumi, "megumi rescue (japan).sms",                                                                 0x000000 , 0x20000,	 CRC(29bc7fad) SHA1(7bd156cf8dc2ad07c666ac58ccb3c0ff6671b93f) )
CONSOLE_ROM_LOAD( s_mercse, "mercs (europe).sms",                                                                        0x000000 , 0x80000,	 CRC(d7416b83) SHA1(f2cfad96a116bde9a91240eb1ad520dc448fa20f) )
CONSOLE_ROM_LOAD( s_michae, "michael jackson's moonwalker (usa, europe) (beta).sms",                                     0x000000 , 0x40000,	 CRC(54123936) SHA1(67557e7551ad785802b1f2abc4b456e3268f564c) )
CONSOLE_ROM_LOAD( s_micha1, "michael jackson's moonwalker (usa, europe).sms",                                            0x000000 , 0x40000,	 CRC(56cc906b) SHA1(939416cebb381458d28ff628afb3d1f80293afa9) )
CONSOLE_ROM_LOAD( s_mickma, "mick & mack as the global gladiators (europe).sms",                                         0x000000 , 0x40000,	 CRC(b67ceb76) SHA1(e2e2f45e43f0d4fa5974327e96d7c3ee7f057fad) )
CONSOLE_ROM_LOAD( s_mickey, "mickey's ultimate challenge (brazil).sms",                                                  0x000000 , 0x40000,	 CRC(25051dd5) SHA1(7253b4df642c56f266e5542a60065ca2c00ad0df) )
CONSOLE_ROM_LOAD( s_microm, "micro machines (europe).sms",                                                               0x000000 , 0x40000,	 CRC(a577ce46) SHA1(425621f350d011fd021850238c6de9999625fd69) )
CONSOLE_ROM_LOAD( s_miracl, "miracle warriors - seal of the dark lord (usa, europe) (beta).sms",                         0x000000 , 0x40000,	 CRC(301a59aa) SHA1(5f1cfc974a8ffc965f18216a89472fd1a980d7cb) )
CONSOLE_ROM_LOAD( s_mirac1, "miracle warriors - seal of the dark lord (usa, europe).sms",                                0x000000 , 0x40000,	 CRC(0e333b6e) SHA1(f952406bca4918ee91a89b27e949e224eae96d85) )
CONSOLE_ROM_LOAD( s_missil, "missile defense 3-d (usa, europe).sms",                                                     0x000000 , 0x20000,	 CRC(fbe5cfbb) SHA1(86242fcc8b9f93cdad2241f40c3eebbf4c9ff213) )
CONSOLE_ROM_LOAD( s_monica, "monica no castelo do dragao (brazil).sms",                                                  0x000000 , 0x40000,	 CRC(01d67c0b) SHA1(e05953a3772452f821c3815231a25940a1d93803) )
CONSOLE_ROM_LOAD( s_monopo, "monopoly (usa).sms",                                                                        0x000000 , 0x20000,	 CRC(69538469) SHA1(8dd7bb4f666f70f7f57687823d0068c9100af8e5) )
CONSOLE_ROM_LOAD( s_monop1, "monopoly (usa, europe).sms",                                                                0x000000 , 0x20000,	 CRC(026d94a4) SHA1(6bad7176011dd4bbd007498d167399daacde173d) )
CONSOLE_ROM_LOAD( s_montez, "montezuma's revenge featuring panama joe (usa).sms",                                        0x000000 , 0x20000,	 CRC(82fda895) SHA1(a2665093b8588d5d6f24c6b329080fb3ebee896e) )
CONSOLE_ROM_LOAD( s_mortal, "mortal kombat (europe).sms",                                                                0x000000 , 0x80000,	 CRC(302dc686) SHA1(3f67e0e702f391839b51a43125f971ae1c5fad92) )
CONSOLE_ROM_LOAD( s_morta1, "mortal kombat 3 (brazil).sms",                                                              0x000000 , 0x80000,	 CRC(395ae757) SHA1(f1f43f57982dd22caa8869a85b1a05fa61c349dd) )
CONSOLE_ROM_LOAD( s_morta2, "mortal kombat ii (europe).sms",                                                             0x000000 , 0x80000,	 CRC(2663bf18) SHA1(12bd887efb87f410d3b65bf9e6dfe2745b345539) )
CONSOLE_ROM_LOAD( s_mspacm, "ms. pac-man (europe).sms",                                                                  0x000000 , 0x20000,	 CRC(3cd816c6) SHA1(4dd7cb303793792edd9a4c717a727f46db857dae) )
CONSOLE_ROM_LOAD( s_myhero, "my hero (usa, europe).sms",                                                                 0x000000 , 0x8000,	 CRC(62f0c23d) SHA1(7583c5fb1963c070b7bda72b447cc3fd611ddf1a) )
CONSOLE_ROM_LOAD( s_nekkyu, "nekkyuu koushien (japan).sms",                                                              0x000000 , 0x40000,	 CRC(5b5f9106) SHA1(35e882723189178c1dc811a04125daec4487e693) )
CONSOLE_ROM_LOAD( s_newzea, "new zealand story, the (europe).sms",                                                       0x000000 , 0x40000,	 CRC(c660ff34) SHA1(e433b21b505ed5428d1b2f07255e49c6db2edc6c) )
CONSOLE_ROM_LOAD( s_ninjaj, "ninja (japan).sms",                                                                         0x000000 , 0x20000,	 CRC(320313ec) SHA1(e9acdae112a898f7db090fc0b8f1ce9b86637234) )
CONSOLE_ROM_LOAD( s_ninjag, "ninja gaiden (europe) (beta).sms",                                                          0x000000 , 0x40000,	 CRC(761e9396) SHA1(c67db6539dc609b08d3ca6f9e6f8f41daf150743) )
CONSOLE_ROM_LOAD( s_ninja1, "ninja gaiden (europe).sms",                                                                 0x000000 , 0x40000,	 CRC(1b1d8cc2) SHA1(4c65db563e8407444020ab7fd93fc45193ae923a) )
CONSOLE_ROM_LOAD( s_ninjat, "ninja, the (usa, europe).sms",                                                              0x000000 , 0x20000,	 CRC(66a15bd9) SHA1(76396a25902700e18adf6bc5c8668e2a8bdf03a9) )
CONSOLE_ROM_LOAD( s_olympi, "olympic gold (europe) (en,fr,de,es,it,nl,pt,sv).sms",                                       0x000000 , 0x40000,	 CRC(6a5a1e39) SHA1(21d7e4d99b1d35ad7c169cc16162a0873661fcd4) )
CONSOLE_ROM_LOAD( s_olymp1, "olympic gold (korea) (en,fr,de,es,it,nl,pt,sv).sms",                                        0x000000 , 0x40000,	 CRC(d1a7b1aa) SHA1(d3b0aa53159403c59e53e486597f882730556d96) )
CONSOLE_ROM_LOAD( s_opaopa, "opa opa (japan).sms",                                                                       0x000000 , 0x20000,	 CRC(bea27d5c) SHA1(38bd50181b98216c9ccf1d7dd6bc2c0a21e9a283) )
CONSOLE_ROM_LOAD( s_operat, "operation wolf (europe).sms",                                                               0x000000 , 0x40000,	 CRC(205caae8) SHA1(064040452b6bacc75443dae7916a0fd573f1600d) )
CONSOLE_ROM_LOAD( s_ottifa, "ottifants, the (europe) (en,fr,de,es,it).sms",                                              0x000000 , 0x40000,	 CRC(82ef2a7d) SHA1(465e7a8cdfad8fc96587f6516770eb81a171f036) )
CONSOLE_ROM_LOAD( s_outrun, "out run (world).sms",                                                                       0x000000 , 0x40000,	 CRC(5589d8d2) SHA1(4f9b61b24f0d9fee0448cdbbe8fc05411dbb1102) )
CONSOLE_ROM_LOAD( s_outru1, "out run 3-d (europe).sms",                                                                  0x000000 , 0x40000,	 CRC(d6f43dda) SHA1(93c3fbe23848556fc6a737db1b5182537db5961d) )
CONSOLE_ROM_LOAD( s_outru2, "out run europa (europe).sms",                                                               0x000000 , 0x40000,	 CRC(3932adbc) SHA1(c8fbf18eabdcf90cd70fc77444cf309ff47f5827) )
CONSOLE_ROM_LOAD( s_pacman, "pac-mania (europe).sms",                                                                    0x000000 , 0x20000,	 CRC(be57a9a5) SHA1(c0a11248bbb556b643accd3c76737be35cbada54) )
CONSOLE_ROM_LOAD( s_paperb, "paperboy (europe).sms",                                                                     0x000000 , 0x20000,	 CRC(294e0759) SHA1(e91dae35a3ca3a475e30b7863c03375d656ec734) )
CONSOLE_ROM_LOAD( s_paper1, "paperboy (usa).sms",                                                                        0x000000 , 0x20000,	 CRC(327a0b4c) SHA1(736718efab4737ebf9d06221ac35fa2fcc4593ce) )
CONSOLE_ROM_LOAD( s_parlou, "parlour games (usa, europe).sms",                                                           0x000000 , 0x20000,	 CRC(e030e66c) SHA1(06664daf208f07cb00b603b12eccfc3f01213a17) )
CONSOLE_ROM_LOAD( s_patril, "pat riley basketball (usa) (proto).sms",                                                    0x000000 , 0x40000,	 CRC(9aefe664) SHA1(8b49c7772bd398665217bf81648353ff46485cac) )
CONSOLE_ROM_LOAD( s_pengui, "penguin land (usa, europe).sms",                                                            0x000000 , 0x20000,	 CRC(f97e9875) SHA1(8762239c339a084dfb8443cc38515301476bde28) )
CONSOLE_ROM_LOAD( s_pgatou, "pga tour golf (europe).sms",                                                                0x000000 , 0x40000,	 CRC(95b9ea95) SHA1(bdbb1337453234289fbd193d7d7fcf1ad3c3807c) )
CONSOLE_ROM_LOAD( s_phanta, "phantasy star (brazil).sms",                                                                0x000000 , 0x80000,	 CRC(75971bef) SHA1(fd8dad6acb6fa75dc8e9bbaea2a7e9fd486fc2dd) )
CONSOLE_ROM_LOAD( s_phant1, "phantasy star (j) (from saturn collection cd) [!].sms",                                     0x000000 , 0x80000,	 CRC(07301f83) SHA1(b3ae447dc739256616b44cbd77cb903c9f19e980) )
CONSOLE_ROM_LOAD( s_phant2, "phantasy star (japan).sms",                                                                 0x000000 , 0x80000,	 CRC(6605d36a) SHA1(c9a40ddd217c58dddcd6b5c0fe66c3a50d3e68e4) )
CONSOLE_ROM_LOAD( s_phant3, "phantasy star (korea).sms",                                                                 0x000000 , 0x80000,	 CRC(747e83b5) SHA1(52b2aa52a1c96e15869498a8e42b074705070007) )
CONSOLE_ROM_LOAD( s_phant4, "phantasy star (usa, europe) (v1.2).sms",                                                    0x000000 , 0x80000,	 CRC(e4a65e79) SHA1(257ca76ebcd54c75a414ca7ce968fa59ea42f150) )
CONSOLE_ROM_LOAD( s_phant5, "phantasy star (usa, europe) (v1.3).sms",                                                    0x000000 , 0x80000,	 CRC(00bef1d7) SHA1(07fcf297be4f4c9d92cd3f119a7ac48467e06838) )
CONSOLE_ROM_LOAD( s_pitfig, "pit fighter (brazil).sms",                                                                  0x000000 , 0x80000,	 CRC(aa4d4b5a) SHA1(409ccca9dcb78a20f7dd917699ce2c70f87f857f) )
CONSOLE_ROM_LOAD( s_pitfi1, "pit fighter (europe).sms",                                                                  0x000000 , 0x80000,	 CRC(b840a446) SHA1(e2856b4ae331aea100984ac778b5e726f5da8709) )
CONSOLE_ROM_LOAD( s_populo, "populous (europe).sms",                                                                     0x000000 , 0x40000,	 CRC(c7a1fdef) SHA1(d6142584b9796a96941b6a95bda14cf137b47085) )
CONSOLE_ROM_LOAD( s_poseid, "poseidon wars 3-d (usa, europe).sms",                                                       0x000000 , 0x40000,	 CRC(abd48ad2) SHA1(c177effd5fd18a082393a2b4167c49bcc5db1f64) )
CONSOLE_ROM_LOAD( s_powers, "power strike (usa, europe).sms",                                                            0x000000 , 0x20000,	 CRC(4077efd9) SHA1(f6f245c41163b15bce95368e4684b045790a1148) )
CONSOLE_ROM_LOAD( s_power1, "power strike ii (europe).sms",                                                              0x000000 , 0x80000,	 CRC(a109a6fe) SHA1(3bcffd47294f25b25cccb7f42c3a9c3f74333d73) )
CONSOLE_ROM_LOAD( s_predat, "predator 2 (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(0047b615) SHA1(ee26c9f5fd08ac73b5e28b20f35889d24c88c6db) )
CONSOLE_ROM_LOAD( s_prince, "prince of persia (europe).sms",                                                             0x000000 , 0x40000,	 CRC(7704287d) SHA1(7ef7b4e2fcec69946844c186c62836c0ae34665f) )
CONSOLE_ROM_LOAD( s_prowre, "pro wrestling (usa, europe).sms",                                                           0x000000 , 0x20000,	 CRC(fbde42d3) SHA1(b0e4832af04b4fb832092ad093d982ce11160eef) )
CONSOLE_ROM_LOAD( s_proyak, "pro yakyuu pennant race, the (japan).sms",                                                  0x000000 , 0x20000,	 CRC(da9be8f0) SHA1(1ee602f8711d82d13b006984cef95512a93c7783) )
CONSOLE_ROM_LOAD( s_promoc, "promocao especial m. system iii compact (brazil) (sample).sms",                             0x000000 , 0x8000,	 CRC(30af0233) SHA1(53b50a1c574479359f85327a8000d3f03f0963d5) )
CONSOLE_ROM_LOAD( s_psychi, "psychic world (europe).sms",                                                                0x000000 , 0x40000,	 CRC(5c0b1f0f) SHA1(5fa54329692e680a190291d0744580968aa8b3fe) )
CONSOLE_ROM_LOAD( s_psycho, "psycho fox (usa, europe).sms",                                                              0x000000 , 0x40000,	 CRC(97993479) SHA1(278cc3853905626138e83b6cfa39c26ba8e4f632) )
CONSOLE_ROM_LOAD( s_puttpu, "putt & putter (europe) (beta).sms",                                                         0x000000 , 0x20000,	 CRC(8167ccc4) SHA1(c6d3f256f938827899807884253817f432379d7c) )
CONSOLE_ROM_LOAD( s_puttp1, "putt & putter (europe).sms",                                                                0x000000 , 0x20000,	 CRC(357d4f78) SHA1(760d330047a77b98e2fff786052741dc7e3760e8) )
CONSOLE_ROM_LOAD( s_quarte, "quartet (usa, europe).sms",                                                                 0x000000 , 0x20000,	 CRC(e0f34fa6) SHA1(08a3484e862a284f6038b7cd0dfc745a8b7c6c51) )
CONSOLE_ROM_LOAD( s_questf, "quest for the shaven yak starring ren hoek & stimpy (brazil).sms",                          0x000000 , 0x80000,	 CRC(f42e145c) SHA1(418ea57fdbd06aca4285447db2ecb2b0392a178d) )
CONSOLE_ROM_LOAD( s_rtypew, "r-type (world).sms",                                                                        0x000000 , 0x80000,	 CRC(bb54b6b0) SHA1(08ec70a2cd98fcb2645f59857f845d41b0045115) )
CONSOLE_ROM_LOAD( s_rcgran, "r.c. grand prix (usa, europe).sms",                                                         0x000000 , 0x40000,	 CRC(54316fea) SHA1(94cc64f6febdb0fe4e89ecd9deeca96694e5bead) )
CONSOLE_ROM_LOAD( s_rainbo, "rainbow islands - the story of bubble bobble 2 (brazil).sms",                               0x000000 , 0x40000,	 CRC(00ec173a) SHA1(a3958277129916a4fd32f3d5f2345b8d0fc23faf) )
CONSOLE_ROM_LOAD( s_rainb1, "rainbow islands - the story of bubble bobble 2 (europe).sms",                               0x000000 , 0x40000,	 CRC(c172a22c) SHA1(acff4b6175aaaed9075f6e41cf387cbfd03eb330) )
CONSOLE_ROM_LOAD( s_rambof, "rambo - first blood part ii (usa).sms",                                                     0x000000 , 0x20000,	 CRC(bbda65f0) SHA1(dc44b090a01d6a4d9b5700ada764b00c62c00e91) )
CONSOLE_ROM_LOAD( s_ramboi, "rambo iii (usa, europe).sms",                                                               0x000000 , 0x40000,	 CRC(da5a7013) SHA1(6d9746c0e3c50e87fa773a64e2f0bb76f722d76c) )
CONSOLE_ROM_LOAD( s_rampag, "rampage (usa, europe).sms",                                                                 0x000000 , 0x40000,	 CRC(42fc47ee) SHA1(cbf5b6f06bec42db8a99c7b9c00118521aded858) )
CONSOLE_ROM_LOAD( s_rampar, "rampart (europe).sms",                                                                      0x000000 , 0x40000,	 CRC(426e5c8a) SHA1(bfea7112a7e2eb2c5e7c20147197ffe3b06d5711) )
CONSOLE_ROM_LOAD( s_rastan, "rastan (usa, europe).sms",                                                                  0x000000 , 0x40000,	 CRC(c547eb1b) SHA1(90f9ccf516db2a1cf20e199cfd5d31d4cfce0f1f) )
CONSOLE_ROM_LOAD( s_reggie, "reggie jackson baseball (usa).sms",                                                         0x000000 , 0x40000,	 CRC(6d94bb0e) SHA1(b7c387256e58a95bd3c3c4358a8a106f2304e9f2) )
CONSOLE_ROM_LOAD( s_renega, "renegade (europe).sms",                                                                     0x000000 , 0x40000,	 CRC(3be7f641) SHA1(c07a04f3ab811b52c97b9bf850670057148de6f0) )
CONSOLE_ROM_LOAD( s_rescue, "rescue mission (usa, europe).sms",                                                          0x000000 , 0x20000,	 CRC(79ac8e7f) SHA1(6a561bff2f8022261708b91722caf1ec0e63f9c4) )
CONSOLE_ROM_LOAD( s_roadra, "road rash (europe).sms",                                                                    0x000000 , 0x80000,	 CRC(b876fc74) SHA1(7976e717125757b1900a540a68e0ef3083839f85) )
CONSOLE_ROM_LOAD( s_roboco, "robocop 3 (europe).sms",                                                                    0x000000 , 0x40000,	 CRC(9f951756) SHA1(459a01f6e240e6f81726f174fadcfe06badce841) )
CONSOLE_ROM_LOAD( s_roboc1, "robocop versus the terminator (europe).sms",                                                0x000000 , 0x80000,	 CRC(8212b754) SHA1(a5fe99ce04cb172714a431b12ce14e39fcc573e4) )
CONSOLE_ROM_LOAD( s_rockyw, "rocky (world).sms",                                                                         0x000000 , 0x40000,	 CRC(1bcc7be3) SHA1(8601927ca17419f5d61f757e9371ce533228f7bb) )
CONSOLE_ROM_LOAD( s_runnin, "running battle (europe).sms",                                                               0x000000 , 0x40000,	 CRC(1fdae719) SHA1(8f680b3a9782304a2f879f6590dc78ea4e366163) )
CONSOLE_ROM_LOAD( s_sagaia, "sagaia (europe).sms",                                                                       0x000000 , 0x40000,	 CRC(66388128) SHA1(2a3e859139f8ca83494bb800dc848fe4d02db82a) )
CONSOLE_ROM_LOAD( s_sangok, "sangokushi 3 (korea) (unl).sms",                                                            0x000000 , 0x100000,	 CRC(97d03541) SHA1(c0256188b15271bb814bb8356b3311340e53ea3e) )
CONSOLE_ROM_LOAD( s_sapoxu, "sapo xule - o mestre do kung fu (brazil).sms",                                              0x000000 , 0x40000,	 CRC(890e83e4) SHA1(f14a7448f38766640c0bc9ea3410eb55194da58f) )
CONSOLE_ROM_LOAD( s_sapox1, "sapo xule - s.o.s lagoa poluida (brazil).sms",                                              0x000000 , 0x20000,	 CRC(7ab2946a) SHA1(2583b9027fd2a4d84ed324ed03fc82b9eedd1ff4) )
CONSOLE_ROM_LOAD( s_sapox2, "sapo xule vs. os invasores do brejo (brazil).sms",                                          0x000000 , 0x40000,	 CRC(9a608327) SHA1(fb4205bf1c1df55455a7ab4d4a6a9c5fe7d12a0b) )
CONSOLE_ROM_LOAD( s_satell, "satellite 7 (j) [p1][!].sms",                                                               0x000000 , 0x8000,	 CRC(87b9ecb8) SHA1(a48b642ac12379944fc829585dacb8e7effdcc82) )
CONSOLE_ROM_LOAD( s_satel1, "satellite 7 (japan).sms",                                                                   0x000000 , 0x8000,	 CRC(16249e19) SHA1(88fc5596773ea31eda8ae5a8baf6f0ce5c3f7e5e) )
CONSOLE_ROM_LOAD( s_schtro, "schtroumpfs autour du monde, les (europe) (en,fr,de,es) (beta).sms",                        0x000000 , 0x40000,	 CRC(7982ae67) SHA1(a82627f47400555e5e6fdeca11ffac56d7296f80) )
CONSOLE_ROM_LOAD( s_schtr1, "schtroumpfs autour du monde, les (europe) (en,fr,de,es).sms",                               0x000000 , 0x40000,	 CRC(97e5bb7d) SHA1(16f756e00314781e07af84c871e82ec8e0a68a57) )
CONSOLE_ROM_LOAD( s_scramb, "scramble spirits (europe).sms",                                                             0x000000 , 0x40000,	 CRC(9a8b28ec) SHA1(430154dc7ac1bb580c7663019ca476e5333e0508) )
CONSOLE_ROM_LOAD( s_sdijap, "sdi (japan).sms",                                                                           0x000000 , 0x20000,	 CRC(1de2c2d0) SHA1(2000b3b291dd7b76c3b8801a88fb0e293ca7e278) )
CONSOLE_ROM_LOAD( s_secret, "secret command (europe).sms",                                                               0x000000 , 0x20000,	 CRC(00529114) SHA1(e7a952f8bd6dddbb365870e906801021b240a533) )
CONSOLE_ROM_LOAD( s_segach, "sega chess (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(a8061aef) SHA1(2c386825dce99b340084b28bdf90fb4ee7107317) )
CONSOLE_ROM_LOAD( s_segawo, "sega world tournament golf (europe).sms",                                                   0x000000 , 0x40000,	 CRC(296879dd) SHA1(fd5a92e74a3c5fa16727637f1839b28595449bf6) )
CONSOLE_ROM_LOAD( s_seishu, "seishun scandal (japan).sms",                                                               0x000000 , 0x8000,	 CRC(f0ba2bc6) SHA1(6942f38e608cc7d70cf9cc8c13ee8c22e4b81679) )
CONSOLE_ROM_LOAD( s_seishy, "seishyun scandal (j) [p1][!].sms",                                                          0x000000 , 0x8000,	 CRC(bcd91d78) SHA1(3da61c3f36aaa885c3efa58807fd122f24643ded) )
CONSOLE_ROM_LOAD( s_sensib, "sensible soccer (europe).sms",                                                              0x000000 , 0x20000,	 CRC(f8176918) SHA1(08b4f5b8096bc811bc9a7750deb21def67711a9f) )
CONSOLE_ROM_LOAD( s_shadow, "shadow dancer (europe).sms",                                                                0x000000 , 0x80000,	 CRC(3793c01a) SHA1(99a5995f31dcf6fbbef56d3ea0d2094ef039479f) )
CONSOLE_ROM_LOAD( s_shado1, "shadow of the beast (europe).sms",                                                          0x000000 , 0x40000,	 CRC(1575581d) SHA1(45943b021cbaee80a149b80ddb6f3fb5eb8b9e43) )
CONSOLE_ROM_LOAD( s_shangh, "shanghai (usa, europe) (beta).sms",                                                         0x000000 , 0x20000,	 CRC(d5d25156) SHA1(98615e4994fcc1e973c7483303b580dfeb756eec) )
CONSOLE_ROM_LOAD( s_shang1, "shanghai (usa, europe).sms",                                                                0x000000 , 0x20000,	 CRC(aab67ec3) SHA1(58f01556d1f2da0af9dfcddcb3ac26cb299220d3) )
CONSOLE_ROM_LOAD( s_shinob, "shinobi (japan).sms",                                                                       0x000000 , 0x40000,	 CRC(e1fff1bb) SHA1(26070deaa2d3c170d31ac395a50231204250bdf3) )
CONSOLE_ROM_LOAD( s_shino1, "shinobi (usa, europe).sms",                                                                 0x000000 , 0x40000,	 CRC(0c6fac4e) SHA1(7c0778c055dc9c2b0aae1d166dbdb4734e55b9d1) )
CONSOLE_ROM_LOAD( s_shooti, "shooting gallery (usa, europe).sms",                                                        0x000000 , 0x20000,	 CRC(4b051022) SHA1(6c22e3fa928c2aed468e925af65ea7f7c6292905) )
CONSOLE_ROM_LOAD( s_simpso, "simpsons, the - bart vs. the space mutants (europe).sms",                                   0x000000 , 0x40000,	 CRC(d1cc08ee) SHA1(4fa839db6de21fd589f6a91791fff25ca2ab88f4) )
CONSOLE_ROM_LOAD( s_simps1, "simpsons, the - bart vs. the world (europe).sms",                                           0x000000 , 0x40000,	 CRC(f6b2370a) SHA1(038920e63437e05d8431e4cbab2131dd76fb3345) )
CONSOLE_ROM_LOAD( s_sitiod, "sitio do picapau amarelo (brazil).sms",                                                     0x000000 , 0x100000,	 CRC(abdf3923) SHA1(9d626e9faa29a63ed396959894d4a481f1e7a01d) )
CONSOLE_ROM_LOAD( s_slapsh, "slap shot (europe).sms",                                                                    0x000000 , 0x40000,	 CRC(d33b296a) SHA1(5979ee84570f7c930f20be473e895fc1d2b9e3f4) )
CONSOLE_ROM_LOAD( s_slaps1, "slap shot (usa) (v1.1).sms",                                                                0x000000 , 0x40000,	 CRC(702c3e98) SHA1(2259dcf3ce702b5ddc8d0a5ed335263f45ecd2ce) )
CONSOLE_ROM_LOAD( s_slaps2, "slap shot (usa).sms",                                                                       0x000000 , 0x40000,	 CRC(c93bd0e9) SHA1(6327fb7129ecfcebdcd6b9c941703fda15a8a195) )
CONSOLE_ROM_LOAD( s_smurfs, "smurfs, the (europe) (en,fr,de,es).sms",                                                    0x000000 , 0x40000,	 CRC(3e63768a) SHA1(82f75232e195b8bdcd9c0d852076d999899cc92e) )
CONSOLE_ROM_LOAD( s_solomo, "solomon no kagi - oujo rihita no namida (japan).sms",                                       0x000000 , 0x20000,	 CRC(11645549) SHA1(875f35d0775609776ec75ea2a8fa2297643e906c) )
CONSOLE_ROM_LOAD( s_sonicb, "sonic blast (brazil).sms",                                                                  0x000000 , 0x100000,	 CRC(96b3f29e) SHA1(4ad77a472e98002dc0d5c1463965720a257e1b8f) )
CONSOLE_ROM_LOAD( s_sonicc, "sonic chaos (europe).sms",                                                                  0x000000 , 0x80000,	 CRC(aedf3bdf) SHA1(f64c8eea26a103582f09831c3e02c6045a6aff94) )
CONSOLE_ROM_LOAD( s_sonics, "sonic spinball (europe).sms",                                                               0x000000 , 0x80000,	 CRC(11c1bc8a) SHA1(a6aa8038feb54e84759fcdfced2270afbbef9bfc) )
CONSOLE_ROM_LOAD( s_sonict, "sonic the hedgehog (usa, europe).sms",                                                      0x000000 , 0x40000,	 CRC(b519e833) SHA1(6b9677e4a9abb37765d6db4658f4324251807e07) )
CONSOLE_ROM_LOAD( s_sonic1, "sonic the hedgehog 2 (europe) (v1.1).sms",                                                  0x000000 , 0x80000,	 CRC(d6f2bfca) SHA1(689339bac11c3565dd774f8cd4d8ea1b27831118) )
CONSOLE_ROM_LOAD( s_sonic2, "sonic the hedgehog 2 (europe).sms",                                                         0x000000 , 0x80000,	 CRC(5b3b922c) SHA1(acdb0b5e8bf9c1e9c9d1a8ac6d282cb8017d091c) )
CONSOLE_ROM_LOAD( s_sonic3, "sonic's edusoft (unknown) (proto).sms",                                                     0x000000 , 0x40000,	 CRC(d9096263) SHA1(f1357505cbcebfab52327a5fc9c3437f54d8da40) )
CONSOLE_ROM_LOAD( s_spaceg, "space gun (europe).sms",                                                                    0x000000 , 0x80000,	 CRC(a908cff5) SHA1(c5afd5fa7b26da55d243df6822c16dae3a401ac1) )
CONSOLE_ROM_LOAD( s_spaceh, "space harrier (japan).sms",                                                                 0x000000 , 0x40000,	 CRC(beddf80e) SHA1(51ba2185a2b93957c1c51b0a2e2b80394463bed8) )
CONSOLE_ROM_LOAD( s_space1, "space harrier (usa, europe).sms",                                                           0x000000 , 0x40000,	 CRC(ca1d3752) SHA1(9e92d8e27fad71635c71612e8bdd632d760f9a2d) )
CONSOLE_ROM_LOAD( s_space2, "space harrier 3-d (usa, europe).sms",                                                       0x000000 , 0x40000,	 CRC(6bd5c2bf) SHA1(ce3507f62563f7d4cb4b2fc6497317685626af92) )
CONSOLE_ROM_LOAD( s_space3, "space harrier 3d (japan).sms",                                                              0x000000 , 0x40000,	 CRC(156948f9) SHA1(7caf44ecc3de6daffedf7a494d449202888a6156) )
CONSOLE_ROM_LOAD( s_specia, "special criminal investigation (europe) (beta).sms",                                        0x000000 , 0x40000,	 CRC(1b7d2a20) SHA1(a0b4be5b62a0a836e227983647e0140df3eafe4d) )
CONSOLE_ROM_LOAD( s_speci1, "special criminal investigation (europe).sms",                                               0x000000 , 0x40000,	 CRC(fa8e4ca0) SHA1(8daabf51099bd2702fe4418fd202eff532bc710a) )
CONSOLE_ROM_LOAD( s_speedb, "speedball (europe) (mirrorsoft).sms",                                                       0x000000 , 0x20000,	 CRC(a57cad18) SHA1(e51cbdb9b74ce4b53747215b23b54eb62f8392b3) )
CONSOLE_ROM_LOAD( s_speed1, "speedball (europe) (virgin).sms",                                                           0x000000 , 0x20000,	 CRC(5ccc1a65) SHA1(a4cf72c985d0fe51ac36388774c7f0bf982c19e3) )
CONSOLE_ROM_LOAD( s_speed2, "speedball 2 (europe).sms",                                                                  0x000000 , 0x40000,	 CRC(0c7366a0) SHA1(4e0b456441f0acef737e463e6ee5bbcb377ea308) )
CONSOLE_ROM_LOAD( s_spellc, "spellcaster (usa, europe).sms",                                                             0x000000 , 0x80000,	 CRC(4752cae7) SHA1(eed8b01fca86dbd8291d5ca2d1e6f6ca1b60fe68) )
CONSOLE_ROM_LOAD( s_spider, "spider-man - return of the sinister six (europe).sms",                                      0x000000 , 0x40000,	 CRC(ebe45388) SHA1(5d4fbf3873af14afcda10fadfdb3f4f8919b3b1e) )
CONSOLE_ROM_LOAD( s_spide1, "spider-man vs. the kingpin (usa, europe).sms",                                              0x000000 , 0x40000,	 CRC(908ff25c) SHA1(02ebee891d88bacdadd37a3e75e05763b7ad3c9b) )
CONSOLE_ROM_LOAD( s_sports, "sports pad football (usa).sms",                                                             0x000000 , 0x20000,	 CRC(e42e4998) SHA1(556d9ab4ba3c3a34440b36c6fc8e972f70f16d72) )
CONSOLE_ROM_LOAD( s_sport1, "sports pad soccer (japan).sms",                                                             0x000000 , 0x20000,	 CRC(41c948bf) SHA1(7634ce39e87049dad1ee4f32a80d728e4bd1f81f) )
CONSOLE_ROM_LOAD( s_spyvss, "spy vs spy (japan).sms",                                                                    0x000000 , 0x8000,	 CRC(d41b9a08) SHA1(c5e004b34d6569e6e1d99bff6be940f308e2c39f) )
CONSOLE_ROM_LOAD( s_spyvs1, "spy vs. spy (u) (display-unit cart) [!].sms",                                               0x000000 , 0x40000,	 CRC(b87e1b2b) SHA1(03eec0d33d7c3b376fe08ffec79f84091f58366b) )
CONSOLE_ROM_LOAD( s_spyvs2, "spy vs. spy (usa, europe).sms",                                                             0x000000 , 0x8000,	 CRC(78d7faab) SHA1(feab16dd8b807b88395e91c67e9ff52f8f7aa7e4) )
CONSOLE_ROM_LOAD( s_starwa, "star wars (europe).sms",                                                                    0x000000 , 0x80000,	 CRC(d4b8f66d) SHA1(be75ca8ace66b72a063b4be2da2b1ed92f8449b0) )
CONSOLE_ROM_LOAD( s_street, "street fighter ii (brazil).sms",                                                            0x000000 , 0xc8000,	 CRC(0f8287ec) SHA1(1866752a92abbf0eb55fbf9de1cd1b731ec62a54) )
CONSOLE_ROM_LOAD( s_stree1, "streets of rage (europe).sms",                                                              0x000000 , 0x80000,	 CRC(4ab3790f) SHA1(5bdec24d9ba0f6ed359dcb3b11910ec86866ec98) )
CONSOLE_ROM_LOAD( s_stree2, "streets of rage ii (europe).sms",                                                           0x000000 , 0x80000,	 CRC(04e9c089) SHA1(cc18171a860711f6ad18ff89254dd7bd05c54654) )
CONSOLE_ROM_LOAD( s_stride, "strider (usa, europe).sms",                                                                 0x000000 , 0x80000,	 CRC(9802ed31) SHA1(051e72c8ffec7606c04409ef38244cfdd592252f) )
CONSOLE_ROM_LOAD( s_strid1, "strider ii (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(b8f0915a) SHA1(f9d58bd9a5a99f2fd26fb411b0783fcd220249a4) )
CONSOLE_ROM_LOAD( s_submar, "submarine attack (europe).sms",                                                             0x000000 , 0x40000,	 CRC(d8f2f1b9) SHA1(44384ec8bf91e1ca5512ff88bbcf1ae1ce5a1a35) )
CONSOLE_ROM_LOAD( s_sukeba, "sukeban deka ii - shoujo tekkamen densetsu (japan).sms",                                    0x000000 , 0x20000,	 CRC(b13df647) SHA1(5cd041990c7418ba63cde54f83d3e0e323b42c3b) )
CONSOLE_ROM_LOAD( s_summer, "summer games (europe) (beta).sms",                                                          0x000000 , 0x20000,	 CRC(80eb1fff) SHA1(91b46d3169e66549c94bdb4a5f92c2fc4bb2abe8) )
CONSOLE_ROM_LOAD( s_summe1, "summer games (europe).sms",                                                                 0x000000 , 0x20000,	 CRC(8da5c93f) SHA1(f9638b693ca3a7c65cfc589aaea0bbab56fc7238) )
CONSOLE_ROM_LOAD( s_superb, "super basketball (usa) (sample).sms",                                                       0x000000 , 0x10000,	 CRC(0dbf3b4a) SHA1(616b95baad61086f08d8688c2bf06838b902ac75) )
CONSOLE_ROM_LOAD( s_superk, "super kick off (europe) (en,fr,de,es,it,nl,pt,sv).sms",                                     0x000000 , 0x40000,	 CRC(406aa0c2) SHA1(4116e4a742e3209ca5db9887cd92219d15cf3c9a) )
CONSOLE_ROM_LOAD( s_superm, "super monaco gp (europe).sms",                                                              0x000000 , 0x40000,	 CRC(55bf81a0) SHA1(0f11b9d7d6d16b09f7be0dace3b6c7d3524da725) )
CONSOLE_ROM_LOAD( s_super1, "super monaco gp (usa).sms",                                                                 0x000000 , 0x40000,	 CRC(3ef12baa) SHA1(fc933d9ec3a7e699c1e2cda89b957665e7321a80) )
CONSOLE_ROM_LOAD( s_supero, "super off road (europe).sms",                                                               0x000000 , 0x20000,	 CRC(54f68c2a) SHA1(804cd74bbcf452613f6c3a722be1c94338499813) )
CONSOLE_ROM_LOAD( s_superr, "super racing (japan).sms",                                                                  0x000000 , 0x40000,	 CRC(7e0ef8cb) SHA1(442f3ba8a66a0d9c49a46091df83fcdba4b63c3a) )
CONSOLE_ROM_LOAD( s_supers, "super smash t.v. (europe).sms",                                                             0x000000 , 0x40000,	 CRC(e0b1aff8) SHA1(b4515aad1cad31980d041632e23d3be82aa31828) )
CONSOLE_ROM_LOAD( s_super2, "super space invaders (europe).sms",                                                         0x000000 , 0x40000,	 CRC(1d6244ee) SHA1(b28d2a9c0fe597892e21fb2611798765f5435885) )
CONSOLE_ROM_LOAD( s_supert, "super tennis (usa, europe).sms",                                                            0x000000 , 0x8000,	 CRC(914514e3) SHA1(67787f3f29a5b5e74b5f6a636428da4517a0f992) )
CONSOLE_ROM_LOAD( s_superw, "super wonder boy (japan).sms",                                                              0x000000 , 0x20000,	 CRC(e2fcb6f3) SHA1(14210196f454b6d938f15cf7b52076796c5d0f7d) )
CONSOLE_ROM_LOAD( s_super3, "super wonder boy - monster world (japan).sms",                                              0x000000 , 0x40000,	 CRC(b1da6a30) SHA1(f4cd1ee6f98bc77fb36e232bf755d61d88e219d7) )
CONSOLE_ROM_LOAD( s_super4, "superman - the man of steel (europe).sms",                                                  0x000000 , 0x40000,	 CRC(6f9ac98f) SHA1(f12b0eddfc271888bbcb1de3df25072b96b024ec) )
CONSOLE_ROM_LOAD( s_t2thea, "t2 - the arcade game (europe).sms",                                                         0x000000 , 0x80000,	 CRC(93ca8152) SHA1(cfa4a899185fced837991d14f011cdaca81e9dd7) )
CONSOLE_ROM_LOAD( s_taitoc, "taito chase h.q. (europe).sms",                                                             0x000000 , 0x40000,	 CRC(85cfc9c9) SHA1(495e3ced83ccd938b549bc76905097dba0aaf32b) )
CONSOLE_ROM_LOAD( s_tazine, "taz in escape from mars (brazil).sms",                                                      0x000000 , 0x80000,	 CRC(11ce074c) SHA1(36a67210ca9762f280364007fcacbd7b1416d6ee) )
CONSOLE_ROM_LOAD( s_tazman, "taz-mania (europe) (beta).sms",                                                             0x000000 , 0x40000,	 CRC(1b312e04) SHA1(274641b3b05245504f763a5e4bc359183d16a092) )
CONSOLE_ROM_LOAD( s_tazma1, "taz-mania (europe).sms",                                                                    0x000000 , 0x40000,	 CRC(7cc3e837) SHA1(ac98f23ddc24609cb77bb13102e0386f8c2a4a76) )
CONSOLE_ROM_LOAD( s_tecmow, "tecmo world cup '92 (europe) (beta).sms",                                                   0x000000 , 0x40000,	 CRC(96e75f48) SHA1(bfc473bcfd849c8955f24e82347423fef4f7faf5) )
CONSOLE_ROM_LOAD( s_tecmo1, "tecmo world cup '93 (europe).sms",                                                          0x000000 , 0x40000,	 CRC(5a1c3dde) SHA1(43a30da241f57cf086ab9b2ed25fe018171f2908) )
CONSOLE_ROM_LOAD( s_teddyb, "teddy boy (usa, europe).sms",                                                               0x000000 , 0x8000,	 CRC(2728faa3) SHA1(6ae39718703dbf7126f71387ce24ad956710a315) )
CONSOLE_ROM_LOAD( s_teddy1, "teddy boy blues (j) [p1][!].sms",                                                           0x000000 , 0x8000,	 CRC(9dfa67ee) SHA1(839da36557b494299b427bda4e32d2ba61977b25) )
CONSOLE_ROM_LOAD( s_teddy2, "teddy boy blues (japan) (proto) (ep-mycard).sms",                                           0x000000 , 0xc000,	 CRC(d7508041) SHA1(51014d89cd8770df8a3d837a0208cb69d5bf7903) )
CONSOLE_ROM_LOAD( s_teddy3, "teddy boy blues (japan).sms",                                                               0x000000 , 0x8000,	 CRC(316727dd) SHA1(fb61c04f30c83733fdbf503b16e17aa8086932df) )
CONSOLE_ROM_LOAD( s_tennis, "tennis ace (europe).sms",                                                                   0x000000 , 0x40000,	 CRC(1a390b93) SHA1(0d202166d4a3bdfcf90514c711c77e4f20764552) )
CONSOLE_ROM_LOAD( s_tensai, "tensai bakabon (japan).sms",                                                                0x000000 , 0x40000,	 CRC(8132ab2c) SHA1(ca802b7bdbc0b458d02fda2da32c2e27e50eef19) )
CONSOLE_ROM_LOAD( s_termin, "terminator 2 - judgment day (europe).sms",                                                  0x000000 , 0x40000,	 CRC(ac56104f) SHA1(a8fe50e27fa9d44f3bd05d249a964352a32d1799) )
CONSOLE_ROM_LOAD( s_termi1, "terminator, the (brazil).sms",                                                              0x000000 , 0x40000,	 CRC(e3d5ce9a) SHA1(bea0a1d0271faa2273e4cf1e968241d018c81da1) )
CONSOLE_ROM_LOAD( s_termi2, "terminator, the (europe).sms",                                                              0x000000 , 0x40000,	 CRC(edc5c012) SHA1(eaf733d385e61526b90c1b194bf605078d43e2d3) )
CONSOLE_ROM_LOAD( s_threed, "three dragon story, the (k).sms",                                                           0x000000 , 0x8000,	 CRC(8640e7e8) SHA1(a05a7a41295c38add5dfc71032d2d83b96f518b1) )
CONSOLE_ROM_LOAD( s_thunde, "thunder blade (japan).sms",                                                                 0x000000 , 0x40000,	 CRC(c0ce19b1) SHA1(535dbd339f4b5c5efd502cffbbe719d7b3e7f1c3) )
CONSOLE_ROM_LOAD( s_thund1, "thunder blade (usa, europe).sms",                                                           0x000000 , 0x40000,	 CRC(ae920e4b) SHA1(c38f3eea4e7224bc6042723e88b26c85b1a56ddc) )
CONSOLE_ROM_LOAD( s_timeso, "time soldiers (usa, europe).sms",                                                           0x000000 , 0x40000,	 CRC(51bd14be) SHA1(89842cb30cc3ba626901a5da41481f6d157ebd15) )
CONSOLE_ROM_LOAD( s_tomjer, "tom & jerry (europe) (beta).sms",                                                           0x000000 , 0x40000,	 CRC(0c2fc2de) SHA1(83133cc875f4124b6ede7a9afc29aa311b36c285) )
CONSOLE_ROM_LOAD( s_tomand, "tom and jerry - the movie (europe).sms",                                                    0x000000 , 0x40000,	 CRC(bf7b7285) SHA1(30224286c65beddf37dc83f688f1bd362f325227) )
CONSOLE_ROM_LOAD( s_totowo, "toto world 3 (korea) (unl).sms",                                                            0x000000 , 0x40000,	 CRC(4f8d75ec) SHA1(55ca8a8b1f2a342fc8b8fc3f3ccd98ed44b2fe98) )
CONSOLE_ROM_LOAD( s_transb, "transbot (usa, europe).sms",                                                                0x000000 , 0x8000,	 CRC(4bc42857) SHA1(73273e6d44ad7aea828b642d22f6f1c138be9d2b) )
CONSOLE_ROM_LOAD( s_treina, "treinamento do mymo (b).sms",                                                               0x000000 , 0x40000,	 CRC(e94784f2) SHA1(327c3518363ee060b681ff34c0b2eea3ffea27e4) )
CONSOLE_ROM_LOAD( s_trivia, "trivial pursuit - genus edition (europe) (en,fr,de,es).sms",                                0x000000 , 0x80000,	 CRC(e5374022) SHA1(bafaaeaa376e109db5d52a484a3efcd6ed84d4d6) )
CONSOLE_ROM_LOAD( s_turmad, "turma da monica em o resgate (brazil).sms",                                                 0x000000 , 0x40000,	 CRC(22cca9bb) SHA1(77b4ec8086d81029b596020f202df3e210df985d) )
CONSOLE_ROM_LOAD( s_tvcolo, "tv colosso (brazil).sms",                                                                   0x000000 , 0x80000,	 CRC(e1714a88) SHA1(1b4f7eca8a3f04ead404e6f439a6c49a0d0500df) )
CONSOLE_ROM_LOAD( s_ultima, "ultima iv - quest of the avatar (europe) (beta).sms",                                       0x000000 , 0x80000,	 CRC(de9f8517) SHA1(bb1ae06b62a9f7d3259c51eee4cfded781eb5d30) )
CONSOLE_ROM_LOAD( s_ultim1, "ultima iv - quest of the avatar (europe).sms",                                              0x000000 , 0x80000,	 CRC(b52d60c8) SHA1(a90e21e5961bcf2e10b715a009c04e7c2017a3b1) )
CONSOLE_ROM_LOAD( s_ultim2, "ultimate soccer (europe) (en,fr,de,es,it).sms",                                             0x000000 , 0x40000,	 CRC(15668ca4) SHA1(e0adf52b6e1f54260dd6ea80e99ffb8bf76fd49a) )
CONSOLE_ROM_LOAD( s_vampir, "vampire (europe) (beta).sms",                                                               0x000000 , 0x40000,	 CRC(20f40cae) SHA1(d03fb8fb31d6c49ce92e0a4c952768896f798dd5) )
CONSOLE_ROM_LOAD( s_vigila, "vigilante (usa, europe).sms",                                                               0x000000 , 0x40000,	 CRC(dfb0b161) SHA1(0dc37f1104508c2c0e2593b10dffc3f268ae8ff9) )
CONSOLE_ROM_LOAD( s_virtua, "virtua fighter animation (brazil).sms",                                                     0x000000 , 0x100000,	 CRC(57f1545b) SHA1(ee24af11f2066dc8ffbefb72a5048a2471576229) )
CONSOLE_ROM_LOAD( s_walter, "walter payton football (usa).sms",                                                          0x000000 , 0x40000,	 CRC(3d55759b) SHA1(2d1201523540ae1673fe75bd2c9d1db1cc61987d) )
CONSOLE_ROM_LOAD( s_wanted, "wanted (usa, europe).sms",                                                                  0x000000 , 0x20000,	 CRC(5359762d) SHA1(6135e4d0f76812f9d35ddb5b3e7d34d56a5458b3) )
CONSOLE_ROM_LOAD( s_wherei, "where in the world is carmen sandiego (brazil).sms",                                        0x000000 , 0x20000,	 CRC(88aa8ca6) SHA1(c848e92899dc9b6f664e98ad247fed86c0e46a41) )
CONSOLE_ROM_LOAD( s_where1, "where in the world is carmen sandiego (usa).sms",                                           0x000000 , 0x20000,	 CRC(428b1e7c) SHA1(683317c8d7d8b974066d7ddb3ed64f99801aa9de) )
CONSOLE_ROM_LOAD( s_wimble, "wimbledon (europe).sms",                                                                    0x000000 , 0x40000,	 CRC(912d92af) SHA1(07bc7896efc9eae77a9be68c190071c99eb17a8a) )
CONSOLE_ROM_LOAD( s_wimbl1, "wimbledon ii (europe).sms",                                                                 0x000000 , 0x40000,	 CRC(7f3afe58) SHA1(55dd4aaa92de4bdaa1d8b6463a34887f4a8baa28) )
CONSOLE_ROM_LOAD( s_winter, "winter olympics - lillehammer '94 (brazil) (en,fr,de,es,it,pt,sv,no).sms",                  0x000000 , 0x80000,	 CRC(2fec2b4a) SHA1(758f3dc68db93f35e315fbf2fcd904484cce2ad1) )
CONSOLE_ROM_LOAD( s_winte1, "winter olympics - lillehammer '94 (europe) (en,fr,de,es,it,pt,sv,no).sms",                  0x000000 , 0x80000,	 CRC(a20290b6) SHA1(20b73d53e6868957f07b1a813b853943bfb90307) )
CONSOLE_ROM_LOAD( s_wolfch, "wolfchild (europe).sms",                                                                    0x000000 , 0x40000,	 CRC(1f8efa1d) SHA1(92873f8d7b81a57114b135a2dfffc58d45643703) )
CONSOLE_ROM_LOAD( s_wonder, "wonder boy (usa, europe).sms",                                                              0x000000 , 0x20000,	 CRC(73705c02) SHA1(63149f20bf69cd2f24d0e58841fcfcdace972f49) )
CONSOLE_ROM_LOAD( s_wonde1, "wonder boy iii - the dragon's trap (usa, europe).sms",                                      0x000000 , 0x40000,	 CRC(679e1676) SHA1(99e73de2ffe5ea5d40998faec16504c226f4c1ba) )
CONSOLE_ROM_LOAD( s_wonde2, "wonder boy in monster land (ue) (v1.1) [h1].sms",                                           0x000000 , 0x40000,	 CRC(7522cf0a) SHA1(24889396756fc5a1e043e89d70c5431c9d98df7d) )
CONSOLE_ROM_LOAD( s_wonde3, "wonder boy in monster land (usa, europe).sms",                                              0x000000 , 0x40000,	 CRC(8cbef0c1) SHA1(51715db7a49a18452292dadb2bba0108aa6d6402) )
CONSOLE_ROM_LOAD( s_wonde4, "wonder boy in monster world (europe) (beta).sms",                                           0x000000 , 0x80000,	 CRC(81bff9bb) SHA1(7a26de7a544c602daeadbd3507028ac68ef35e91) )
CONSOLE_ROM_LOAD( s_wonde5, "wonder boy in monster world (europe).sms",                                                  0x000000 , 0x80000,	 CRC(7d7ce80b) SHA1(da0acdb1b9e806aa67a0216a675cb02ed24abf8b) )
CONSOLE_ROM_LOAD( s_woodyp, "woody pop - shinjinrui no block kuzushi (japan).sms",                                       0x000000 , 0x8000,	 CRC(315917d4) SHA1(b74078c4a3e6d20d21ca81e88c0cb3381b0c84a4) )
CONSOLE_ROM_LOAD( s_worldc, "world class leader board (europe).sms",                                                     0x000000 , 0x40000,	 CRC(c9a449b7) SHA1(7bd82131944020a20167f37071ccc1dfa3ae0b3d) )
CONSOLE_ROM_LOAD( s_world1, "world cup italia '90 (europe).sms",                                                         0x000000 , 0x20000,	 CRC(6e1ad6fd) SHA1(dfa51a4f982d0bec61532e16a679edae605d0aea) )
CONSOLE_ROM_LOAD( s_world2, "world cup usa 94 (europe) (en,fr,de,es,it,nl,pt,sv).sms",                                   0x000000 , 0x80000,	 CRC(a6bf8f9e) SHA1(f41d81710f24b08a2a3ac28f2679338a47ca5890) )
CONSOLE_ROM_LOAD( s_worldg, "world games (europe) (beta).sms",                                                           0x000000 , 0x20000,	 CRC(914d3fc4) SHA1(6361f796248c71ecfaaa02aafe6ddbbaebf6ebba) )
CONSOLE_ROM_LOAD( s_world3, "world games (europe).sms",                                                                  0x000000 , 0x20000,	 CRC(a2a60bc8) SHA1(4f3c04e40dd4b94d5d090068ba99b8461af56f51) )
CONSOLE_ROM_LOAD( s_world4, "world grand prix (europe).sms",                                                             0x000000 , 0x20000,	 CRC(4aaad0d6) SHA1(650f15ebbd149f5c357f089d7bd305fcb20b068f) )
CONSOLE_ROM_LOAD( s_world5, "world grand prix (usa).sms",                                                                0x000000 , 0x20000,	 CRC(7b369892) SHA1(feff411732ca2dc17dab6d7868749d79326993d7) )
CONSOLE_ROM_LOAD( s_worlds, "world soccer (world).sms",                                                                  0x000000 , 0x20000,	 CRC(72112b75) SHA1(bd385b69805c623ab9934174a19a30371584c4b0) )
CONSOLE_ROM_LOAD( s_wwfwre, "wwf wrestlemania - steel cage challenge (europe).sms",                                      0x000000 , 0x40000,	 CRC(2db21448) SHA1(6fd4f5af0f14e1e0a934cd9e39a6bb476eda7e97) )
CONSOLE_ROM_LOAD( s_xmenmo, "x-men - mojo world (brazil).sms",                                                           0x000000 , 0x80000,	 CRC(3e1387f6) SHA1(6405a2f8b6f220b4349f8006c3d75dfcdcd6db6d) )
CONSOLE_ROM_LOAD( s_xenonm, "xenon 2 - megablast (europe) (image works).sms",                                            0x000000 , 0x40000,	 CRC(5c205ee1) SHA1(72cb8a24f63e9e79c65c26141abdf53f96c60c0c) )
CONSOLE_ROM_LOAD( s_xenon1, "xenon 2 - megablast (europe) (virgin).sms",                                                 0x000000 , 0x40000,	 CRC(ec726c0d) SHA1(860cff21eff077acd92b06a71d859bf3e81fe628) )
CONSOLE_ROM_LOAD( s_ysjapa, "ys (japan).sms",                                                                            0x000000 , 0x40000,	 CRC(32759751) SHA1(614b589080b732e17cc0d253e17216a72a268955) )
CONSOLE_ROM_LOAD( s_ysthev, "ys - the vanished omens (usa, europe).sms",                                                 0x000000 , 0x40000,	 CRC(b33e2827) SHA1(e73e836c353543e9f48315410b0d72278899ff59) )
CONSOLE_ROM_LOAD( s_zaxxon, "zaxxon 3-d (world) (beta).sms",                                                             0x000000 , 0x40000,	 CRC(bba74147) SHA1(85a67064c71dfa58eb150cc090beb5ae6639b527) )
CONSOLE_ROM_LOAD( s_zaxxo1, "zaxxon 3-d (world).sms",                                                                    0x000000 , 0x40000,	 CRC(a3ef13cb) SHA1(257946fe8a230ac1308fc60a8ed43851cfe6b915) )
CONSOLE_ROM_LOAD( s_zillio, "zillion (europe) (v1.2).sms",                                                               0x000000 , 0x20000,	 CRC(7ba54510) SHA1(5dbe3ac8c4888298f3f7008ed359d0187cf46695) )
CONSOLE_ROM_LOAD( s_zilli1, "zillion (japan, europe) (en,ja).sms",                                                       0x000000 , 0x20000,	 CRC(60c19645) SHA1(6a0a21426cadadb5567907d9cc4cdaf63195d5c3) )
CONSOLE_ROM_LOAD( s_zilli2, "zillion (usa) (v1.1).sms",                                                                  0x000000 , 0x20000,	 CRC(5718762c) SHA1(3aab3e95dac0fa93612da20cf525dba4dc4ca6ba) )
CONSOLE_ROM_LOAD( s_zilli3, "zillion ii - the tri formation (world).sms",                                                0x000000 , 0x20000,	 CRC(2f2e3bc9) SHA1(1e08be828ecf4cf5db787704ab8779f4b5a444b5) )
CONSOLE_ROM_LOAD( s_zoolni, "zool - ninja of the 'nth' dimension (europe).sms",                                          0x000000 , 0x40000,	 CRC(9d9d0a5f) SHA1(aed98f2fc885c9a6e121982108f843388eb46304) )
CONSOLE_ROM_LOAD( s_biosal, "[bios] alex kidd in miracle world (korea).sms",                                             0x000000 , 0x20000,	 CRC(9c5bad91) SHA1(2feafd8f1c40fdf1bd5668f8c5c02e5560945b17) )
CONSOLE_ROM_LOAD( s_biosa1, "[bios] alex kidd in miracle world (usa, europe).sms",                                       0x000000 , 0x20000,	 CRC(cf4a09ea) SHA1(3af7b66248d34eb26da40c92bf2fa4c73a46a051) )
CONSOLE_ROM_LOAD( s_biosha, "[bios] hang-on & safari hunt (usa, europe) (v2.4).sms",                                     0x000000 , 0x20000,	 CRC(91e93385) SHA1(9e179392cd416af14024d8f31c981d9ee9a64517) )
CONSOLE_ROM_LOAD( s_biosh1, "[bios] hang-on (usa, europe) (v3.4).sms",                                                   0x000000 , 0x20000,	 CRC(8edf7ac6) SHA1(51fd6d7990f62cd9d18c9ecfc62ed7936169107e) )
CONSOLE_ROM_LOAD( s_biosmi, "[bios] missile defense 3-d (usa, europe) (v4.4).sms",                                       0x000000 , 0x20000,	 CRC(e79bb689) SHA1(aa92ae576ca670b00855e278378d89e9f85e0351) )
CONSOLE_ROM_LOAD( s_biosse, "[bios] sega master system (japan) (v2.1).sms",                                              0x000000 , 0x2000,	 CRC(48d44a13) SHA1(a8c1b39a2e41137835eda6a5de6d46dd9fadbaf2) )
CONSOLE_ROM_LOAD( s_bioss1, "[bios] sega master system (usa) (m404) (proto).sms",                                        0x000000 , 0x2000,	 CRC(1a15dfcc) SHA1(4a06c8e66261611dce0305217c42138b71331701) )
CONSOLE_ROM_LOAD( s_bioss2, "[bios] sega master system (usa) (store display unit).sms",                                  0x000000 , 0x4000,	 CRC(ee2c29ba) SHA1(fc465122134d95363112eb51b9ab71db3576cefd) )
CONSOLE_ROM_LOAD( s_bioss3, "[bios] sega master system (usa) (v1.3) [b].sms",                                            0x000000 , 0x2000,	 CRC(0072ed54) SHA1(c315672807d8ddb8d91443729405c766dd95cae7) )
CONSOLE_ROM_LOAD( s_biosso, "[bios] sonic the hedgehog (europe).sms",                                                    0x000000 , 0x40000,	 CRC(81c3476b) SHA1(6aca0e3dffe461ba1cb11a86cd4caf5b97e1b8df) )



GAME( 19??, s_20embr, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) 20 em 1 (Brazil)", 0)
GAME( 19??, s_aceofa, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ace of Aces (Europe)", 0)
GAME( 19??, s_action, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Action Fighter (Japan, Europe) (v1.1)", 0)
GAME( 19??, s_actio1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Action Fighter (USA, Europe) (v1.2)", 0)
GAME( 19??, s_addams, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Addams Family, The (Europe)", 0)
GAME( 19??, s_aerial, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Aerial Assault (Europe)", 0)
GAME( 19??, s_aeria1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Aerial Assault (USA)", 0)
GAME( 19??, s_afterb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) After Burner (World)", 0)
GAME( 19??, s_airres, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Air Rescue (Europe)", 0)
GAME( 19??, s_aladdi, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Aladdin (Europe)", 0)
GAME( 19??, s_aleste, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Aleste (Japan)", 0)
GAME( 19??, s_alexki, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alex Kidd - High-Tech World (USA, Europe)", 0)
GAME( 19??, s_alexk1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alex Kidd - The Lost Stars (World)", 0)
GAME( 19??, s_alexk2, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Alex Kidd BMX Trial (Japan)", 0)
GAME( 19??, s_alexk3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alex Kidd in Miracle World (B) (V1.1) [p1][!]", 0)
GAME( 19??, s_alexk4, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alex Kidd in Miracle World (USA, Europe) (v1.1)", 0)
GAME( 19??, s_alexk5, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alex Kidd in Miracle World (USA, Europe)", 0)
GAME( 19??, s_alexk6, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alex Kidd in Shinobi World (USA, Europe)", 0)
GAME( 19??, s_alexk7, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Alex Kidd no Miracle World (Japan)", 0)
GAME( 19??, s_alfusa, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alf (USA)", 0)
GAME( 19??, s_aliene, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Alien 3 (Europe)", 0)
GAME( 19??, s_aliens, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Alien Storm (Europe)", 0)
GAME( 19??, s_alien1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Alien Syndrome (Japan)", 0)
GAME( 19??, s_alien2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Alien Syndrome (USA, Europe)", 0)
GAME( 19??, s_altere, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Altered Beast (USA, Europe)", 0)
GAME( 19??, s_americ, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) American Baseball (Europe)", 0)
GAME( 19??, s_ameri1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) American Pro Football (Europe)", 0)
GAME( 19??, s_andrea, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Andre Agassi Tennis (Europe)", 0)
GAME( 19??, s_anmits, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Anmitsu Hime (Japan)", 0)
GAME( 19??, s_arcade, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Arcade Smash Hits (Europe)", 0)
GAME( 19??, s_argosn, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Argos no Juujiken (J) [a1][!]", 0)
GAME( 19??, s_argos1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Argos no Juujiken (Japan)", 0)
GAME( 19??, s_arielt, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ariel - The Little Mermaid (Brazil)", 0)
GAME( 19??, s_ashura, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Ashura (Japan)", 0)
GAME( 19??, s_assaul, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Assault City (Europe) (Light Phaser)", 0)
GAME( 19??, s_assau1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Assault City (Europe)", 0)
GAME( 19??, s_asteri, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Asterix (Europe) (En,Fr) (v1.1)", 0)
GAME( 19??, s_aster1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Asterix (Europe) (En,Fr)", 0)
GAME( 19??, s_aster2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Asterix and the Great Rescue (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, s_aster3, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Asterix and the Secret Mission (Europe) (En,Fr,De)", 0)
GAME( 19??, s_astrof, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Astro Flash (J) [p1][!]", 0)
GAME( 19??, s_astro1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Astro Flash (Japan)", 0)
GAME( 19??, s_astrow, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Astro Warrior & Pit Pot (Europe)", 0)
GAME( 19??, s_astro2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Astro Warrior (Japan, USA)", 0)
GAME( 19??, s_ayrton, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ayrton Senna's Super Monaco GP II (Europe)", 0)
GAME( 19??, s_azteca, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Aztec Adventure - The Golden Road to Paradise (World)", 0)
GAME( 19??, s_backto, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Back to the Future Part II (Europe)", 0)
GAME( 19??, s_backt1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Back to the Future Part III (Europe)", 0)
GAME( 19??, s_bakuba, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Baku Baku Animal (Brazil)", 0)
GAME( 19??, s_bankpa, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Bank Panic (E) [p1][!]", 0)
GAME( 19??, s_bankp1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Bank Panic (Europe)", 0)
GAME( 19??, s_basket, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Basket Ball Nightmare (Europe)", 0)
GAME( 19??, s_batman, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Batman Returns (Europe)", 0)
GAME( 19??, s_battle, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Battle Out Run (Europe)", 0)
GAME( 19??, s_battl1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Battlemaniacs (Brazil)", 0)
GAME( 19??, s_blackb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Black Belt (USA, Europe)", 0)
GAME( 19??, s_bladee, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Blade Eagle (World) (Beta)", 0)
GAME( 19??, s_blade1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Blade Eagle (World)", 0)
GAME( 19??, s_bomber, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Bomber Raid (World)", 0)
GAME( 19??, s_bonanz, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Bonanza Bros. (Europe)", 0)
GAME( 19??, s_bonker, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Bonkers Wax Up! (Brazil)", 0)
GAME( 19??, s_bramst, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Bram Stoker's Dracula (Europe)", 0)
GAME( 19??, s_bubble, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Bubble Bobble (Europe)", 0)
GAME( 19??, s_buggyr, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Buggy Run (Europe)", 0)
GAME( 19??, s_califo, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) California Games (USA, Europe)", 0)
GAME( 19??, s_calif1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) California Games II (Brazil, Korea)", 0)
GAME( 19??, s_calif2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) California Games II (Europe)", 0)
GAME( 19??, s_captai, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Captain Silver (Japan, Europe)", 0)
GAME( 19??, s_capta1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Captain Silver (USA)", 0)
GAME( 19??, s_casino, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Casino Games (USA, Europe)", 0)
GAME( 19??, s_castel, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Castelo Ra-Tim-Bum (Brazil)", 0)
GAME( 19??, s_castle, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Castle of Illusion - Starring Mickey Mouse (Unknown) (Sample)", 0)
GAME( 19??, s_castl1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Castle of Illusion Starring Mickey Mouse (Europe)", 0)
GAME( 19??, s_castl2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Castle of Illusion Starring Mickey Mouse (USA)", 0)
GAME( 19??, s_champi, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Champions of Europe (Europe)", 0)
GAME( 19??, s_champ1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Championship Hockey (Europe)", 0)
GAME( 19??, s_chapol, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Chapolim x Dracula - Um Duelo Assustador (Brazil)", 0)
GAME( 19??, s_cheese, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Cheese Cat-astrophe Starring Speedy Gonzales (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, s_chopli, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Choplifter (Japan) (Proto)", 0)
GAME( 19??, s_chopl1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Choplifter (USA, Europe)", 0)
GAME( 19??, s_chouon, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Chouon Senshi Borgman (Japan)", 0)
GAME( 19??, s_chuckr, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Chuck Rock (Europe)", 0)
GAME( 19??, s_chuck1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Chuck Rock II - Son of Chuck (Brazil)", 0)
GAME( 19??, s_chuck2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Chuck Rock II - Son of Chuck (Europe)", 0)
GAME( 19??, s_circui, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Circuit, The (Japan)", 0)
GAME( 19??, s_cloudm, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Cloud Master (USA, Europe)", 0)
GAME( 19??, s_colors, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Color & Switch Test (Unknown) (v1.3)", 0)
GAME( 19??, s_column, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Columns (USA, Europe)", 0)
GAME( 19??, s_comica, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Comical Machine Gun Joe (Japan)", 0)
GAME( 19??, s_coolsp, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Cool Spot (Europe)", 0)
GAME( 19??, s_cosmic, 0       , smse, sms, smscm, ROT0, "Codemasters", "(Master System) Cosmic Spacehead (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, s_cybers, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Cyber Shinobi, The (Europe)", 0)
GAME( 19??, s_cyborg, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Cyborg Hunter (USA, Europe)", 0)
GAME( 19??, s_daffyd, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Daffy Duck in Hollywood (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, s_dallye, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Dallyeora Pigu-Wang (Korea) (Unl)", 0)
GAME( 19??, s_danant, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Danan - The Jungle Fighter (Europe)", 0)
GAME( 19??, s_deadan, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Dead Angle (USA, Europe)", 0)
GAME( 19??, s_deepdu, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Deep Duck Trouble Starring Donald Duck (Europe)", 0)
GAME( 19??, s_desert, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Desert Speedtrap Starring Road Runner and Wile E. Coyote (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, s_deser1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Desert Strike (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, s_dicktr, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Dick Tracy (USA, Europe)", 0)
GAME( 19??, s_dinoba, 0       , smse, sms, smscm, ROT0, "Codemasters", "(Master System) Dinobasher Starring Bignose the Caveman (Europe) (Proto)", 0)
GAME( 19??, s_dinosa, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Dinosaur Dooley, The (Korea) (Unl)", 0)
GAME( 19??, s_dokido, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Doki Doki Penguin Land - Uchuu Daibouken (Japan)", 0)
GAME( 19??, s_double, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Double Dragon (World)", 0)
GAME( 19??, s_doubl1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Double Hawk (Europe) (Beta)", 0)
GAME( 19??, s_doubl2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Double Hawk (Europe)", 0)
GAME( 19??, s_doubl3, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Double Target - Cynthia no Nemuri (Japan)", 0)
GAME( 19??, s_drhell, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Dr. HELLO (K)", 0)
GAME( 19??, s_drrobo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Dr. Robotnik's Mean Bean Machine (Europe)", 0)
GAME( 19??, s_dragon, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Dragon - The Bruce Lee Story (Europe)", 0)
GAME( 19??, s_drago1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Dragon Crystal (Europe)", 0)
GAME( 19??, s_dynami, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Dynamite Duke (Europe)", 0)
GAME( 19??, s_dynam1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Dynamite Dux (Europe)", 0)
GAME( 19??, s_dynam2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Dynamite Headdy (Brazil)", 0)
GAME( 19??, s_eswatc, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) E-SWAT - City Under Siege (USA, Europe) (Easy Version)", 0)
GAME( 19??, s_eswat1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) E-SWAT - City Under Siege (USA, Europe) (Hard Version)", 0)
GAME( 19??, s_earthw, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Earthworm Jim (Brazil)", 0)
GAME( 19??, s_eccoth, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ecco - The Tides of Time (Brazil)", 0)
GAME( 19??, s_eccot1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ecco the Dolphin (Europe)", 0)
GAME( 19??, s_enduro, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Enduro Racer (Japan)", 0)
GAME( 19??, s_endur1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Enduro Racer (USA, Europe)", 0)
GAME( 19??, s_excell, 0       , smsu, sms, smscm, ROT0, "Codemasters", "(Master System) Excellent Dizzy Collection, The (USA, Europe) (En,Fr,De,Es,It) (Proto)", 0)
GAME( 19??, s_f16fig, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) F-16 Fighter (USA, Europe)", 0)
GAME( 19??, s_f16fi1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) F-16 Fighting Falcon (Japan)", 0)
GAME( 19??, s_f16fi2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) F-16 Fighting Falcon (USA)", 0)
GAME( 19??, s_f1euro, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) F1 (Europe)", 0)
GAME( 19??, s_family, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Family Games (Japan)", 0)
GAME( 19??, s_fantas, 0       , smse, sms, smse, ROT0, "Codemasters", "(Master System) Fantastic Dizzy (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, s_fanta1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Fantasy Zone (Japan)", 0)
GAME( 19??, s_fanta2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Fantasy Zone (World) (v1.1) (Beta)", 0)
GAME( 19??, s_fanta3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Fantasy Zone (World) (v1.2)", 0)
GAME( 19??, s_fanta4, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Fantasy Zone - The Maze (USA, Europe)", 0)
GAME( 19??, s_fanta5, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Fantasy Zone II - Opa-Opa no Namida (Japan)", 0)
GAME( 19??, s_fanta6, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Fantasy Zone II - The Tears of Opa-Opa (USA, Europe)", 0)
GAME( 19??, s_felipe, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Felipe em Acao (B)", 0)
GAME( 19??, s_ferias, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ferias Frustradas do Pica Pau (Brazil)", 0)
GAME( 19??, s_fifain, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) FIFA International Soccer (Brazil) (En,Es,Pt)", 0)
GAME( 19??, s_finalb, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Final Bubble Bobble (Japan)", 0)
GAME( 19??, s_firefo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Fire & Forget II (Europe)", 0)
GAME( 19??, s_fireic, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Fire & Ice (Brazil)", 0)
GAME( 19??, s_flasht, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Flash, The (Europe)", 0)
GAME( 19??, s_flints, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Flintstones, The (Europe)", 0)
GAME( 19??, s_forgot, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Forgotten Worlds (Europe)", 0)
GAME( 19??, s_fushig, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Fushigi no Oshiro Pit Pot (J) [p1][!]", 0)
GAME( 19??, s_fushi1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Fushigi no Oshiro Pit Pot (Japan)", 0)
GAME( 19??, s_glocai, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) G-LOC Air Battle (Europe)", 0)
GAME( 19??, s_gaeguj, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Gaegujangi Ggachi (Korea) (Unl)", 0)
GAME( 19??, s_gaingr, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Gain Ground (Europe)", 0)
GAME( 19??, s_galact, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Galactic Protector (Japan)", 0)
GAME( 19??, s_galaxy, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Galaxy Force (Europe)", 0)
GAME( 19??, s_galax1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Galaxy Force (USA)", 0)
GAME( 19??, s_gamebo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Game Box Serie Esportes Radicais (Brazil)", 0)
GAME( 19??, s_gangst, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Gangster Town (USA, Europe)", 0)
GAME( 19??, s_gauntl, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Gauntlet (Europe)", 0)
GAME( 19??, s_george, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) George Foreman's KO Boxing (Europe)", 0)
GAME( 19??, s_gerald, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Geraldinho (Brazil)", 0)
GAME( 19??, s_ghosth, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Ghost House (J) [p1][!]", 0)
GAME( 19??, s_ghost1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Ghost House (Japan)", 0)
GAME( 19??, s_ghost2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Ghost House (USA, Europe) (Beta)", 0)
GAME( 19??, s_ghost3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Ghost House (USA, Europe)", 0)
GAME( 19??, s_ghostb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Ghostbusters (USA, Europe)", 0)
GAME( 19??, s_ghouls, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Ghouls'n Ghosts (USA, Europe)", 0)
GAME( 19??, s_global, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Global Defense (USA, Europe) (Beta)", 0)
GAME( 19??, s_globa1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Global Defense (USA, Europe)", 0)
GAME( 19??, s_gokuak, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Gokuaku Doumei Dump Matsumoto (Japan)", 0)
GAME( 19??, s_golden, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Golden Axe (USA, Europe)", 0)
GAME( 19??, s_golde1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Golden Axe Warrior (USA, Europe)", 0)
GAME( 19??, s_golfam, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Golfamania (Europe) (Beta)", 0)
GAME( 19??, s_golfa1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Golfamania (Europe)", 0)
GAME( 19??, s_golvel, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Golvellius (USA, Europe)", 0)
GAME( 19??, s_gpride, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) GP Rider (Europe)", 0)
GAME( 19??, s_greatb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Baseball (J) [p1][!]", 0)
GAME( 19??, s_great1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Great Baseball (Japan)", 0)
GAME( 19??, s_great2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Baseball (USA, Europe)", 0)
GAME( 19??, s_great3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Basketball (World)", 0)
GAME( 19??, s_greatf, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Football (World)", 0)
GAME( 19??, s_greatg, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Great Golf (Japan)", 0)
GAME( 19??, s_great4, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Golf (UE) (V1.0) [!]", 0)
GAME( 19??, s_great5, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Golf (World) (Beta)", 0)
GAME( 19??, s_great6, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Golf (World)", 0)
GAME( 19??, s_greati, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Ice Hockey (Japan, USA)", 0)
GAME( 19??, s_greats, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Great Soccer (Europe)", 0)
GAME( 19??, s_great7, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Soccer (J) [p1][!]", 0)
GAME( 19??, s_great8, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Great Soccer (Japan)", 0)
GAME( 19??, s_greatt, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Great Tennis (Japan)", 0)
GAME( 19??, s_greatv, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Great Volleyball (Japan)", 0)
GAME( 19??, s_great9, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Great Volleyball (USA, Europe)", 0)
GAME( 19??, s_hajano, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Haja no Fuuin (Japan)", 0)
GAME( 19??, s_hangon, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Hang-On & Astro Warrior (USA)", 0)
GAME( 19??, s_hango1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Hang-On & Safari Hunt (USA)", 0)
GAME( 19??, s_hango2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Hang-On (Europe)", 0)
GAME( 19??, s_hango3, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Hang-On (Japan)", 0)
GAME( 19??, s_heavyw, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Heavyweight Champ (Europe)", 0)
GAME( 19??, s_heroes, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Heroes of the Lance (Europe)", 0)
GAME( 19??, s_highsc, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) High School! Kimengumi (Japan)", 0)
GAME( 19??, s_hokuto, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Hokuto no Ken (J) [p1][!]", 0)
GAME( 19??, s_hokut1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Hokuto no Ken (Japan)", 0)
GAME( 19??, s_homeal, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Home Alone (Europe)", 0)
GAME( 19??, s_hookeu, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Hook (Europe) (Proto)", 0)
GAME( 19??, s_hoshiw, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Hoshi wo Sagasite... (Japan)", 0)
GAME( 19??, s_hwaran, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Hwarang Ui Geom (Korea)", 0)
GAME( 19??, s_imposs, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Impossible Mission (Europe) (Beta)", 0)
GAME( 19??, s_impos1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Impossible Mission (Europe)", 0)
GAME( 19??, s_incred, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Incredible Crash Dummies, The (Europe)", 0)
GAME( 19??, s_incre1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Incredible Hulk, The (Europe)", 0)
GAME( 19??, s_indian, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Indiana Jones and the Last Crusade (Europe) (Beta)", 0)
GAME( 19??, s_india1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Indiana Jones and the Last Crusade (Europe)", 0)
GAME( 19??, s_jamesb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) James 'Buster' Douglas Knockout Boxing (USA)", 0)
GAME( 19??, s_james1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) James Bond 007 - The Duel (Brazil)", 0)
GAME( 19??, s_james2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) James Bond 007 - The Duel (Europe)", 0)
GAME( 19??, s_jamesp, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) James Pond 2 - Codename RoboCod (Europe)", 0)
GAME( 19??, s_joemon, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Joe Montana Football (USA, Europe)", 0)
GAME( 19??, s_jungle, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Jungle Book, The (Europe)", 0)
GAME( 19??, s_jurass, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Jurassic Park (Europe)", 0)
GAME( 19??, s_kensei, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Kenseiden (Japan)", 0)
GAME( 19??, s_kense1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Kenseiden (USA, Europe)", 0)
GAME( 19??, s_kingsq, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) King's Quest - Quest for the Crown (USA) (Beta)", 0)
GAME( 19??, s_kings1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) King's Quest - Quest for the Crown (USA)", 0)
GAME( 19??, s_klaxeu, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Klax (Europe)", 0)
GAME( 19??, s_krusty, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Krusty's Fun House (Europe)", 0)
GAME( 19??, s_kujaku, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Kujaku Ou (Japan)", 0)
GAME( 19??, s_kungfu, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Kung Fu Kid (USA, Europe)", 0)
GAME( 19??, s_landof, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Land of Illusion Starring Mickey Mouse (Europe)", 0)
GAME( 19??, s_laserg, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Laser Ghost (Europe)", 0)
GAME( 19??, s_legend, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Legend of Illusion Starring Mickey Mouse (Brazil)", 0)
GAME( 19??, s_lemmin, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Lemmings (Europe) (Beta)", 0)
GAME( 19??, s_lemmi1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Lemmings (Europe)", 0)
GAME( 19??, s_lineof, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Line of Fire (Europe)", 0)
GAME( 19??, s_lionki, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Lion King, The (Europe)", 0)
GAME( 19??, s_lordof, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Lord of Sword (Japan)", 0)
GAME( 19??, s_lordo1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Lord of the Sword (USA, Europe)", 0)
GAME( 19??, s_lorett, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Loretta no Shouzou (Japan)", 0)
GAME( 19??, s_luckyd, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Lucky Dime Caper Starring Donald Duck, The (Europe) (Beta)", 0)
GAME( 19??, s_lucky1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Lucky Dime Caper Starring Donald Duck, The (Europe)", 0)
GAME( 19??, s_mahjon, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Mahjong Sengoku Jidai (Japan) (Beta)", 0)
GAME( 19??, s_mahjo1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Mahjong Sengoku Jidai (Japan)", 0)
GAME( 19??, s_makair, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Makai Retsuden (Japan)", 0)
GAME( 19??, s_maougo, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Maou Golvellius (Japan)", 0)
GAME( 19??, s_marble, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Marble Madness (Europe)", 0)
GAME( 19??, s_marksm, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Marksman Shooting & Trap Shooting & Safari Hunt (Europe)", 0)
GAME( 19??, s_marks1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Marksman Shooting & Trap Shooting (USA)", 0)
GAME( 19??, s_master, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Master of Darkness (Europe)", 0)
GAME( 19??, s_maste1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Masters of Combat (Europe)", 0)
GAME( 19??, s_mazehu, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Maze Hunter 3-D (USA, Europe)", 0)
GAME( 19??, s_mazewa, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Maze Walker (Japan)", 0)
GAME( 19??, s_megumi, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Megumi Rescue (Japan)", 0)
GAME( 19??, s_mercse, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Mercs (Europe)", 0)
GAME( 19??, s_michae, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Michael Jackson's Moonwalker (USA, Europe) (Beta)", 0)
GAME( 19??, s_micha1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Michael Jackson's Moonwalker (USA, Europe)", 0)
GAME( 19??, s_mickma, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Mick & Mack as the Global Gladiators (Europe)", 0)
GAME( 19??, s_mickey, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Mickey's Ultimate Challenge (Brazil)", 0)
GAME( 19??, s_microm, 0       , smse, sms, smscm, ROT0, "Codemasters", "(Master System) Micro Machines (Europe)", 0)
GAME( 19??, s_miracl, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Miracle Warriors - Seal of the Dark Lord (USA, Europe) (Beta)", 0)
GAME( 19??, s_mirac1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Miracle Warriors - Seal of the Dark Lord (USA, Europe)", 0)
GAME( 19??, s_missil, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Missile Defense 3-D (USA, Europe)", 0)
GAME( 19??, s_monica, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Monica no Castelo do Dragao (Brazil)", 0)
GAME( 19??, s_monopo, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Monopoly (USA)", 0)
GAME( 19??, s_monop1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Monopoly (USA, Europe)", 0)
GAME( 19??, s_montez, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Montezuma's Revenge Featuring Panama Joe (USA)", 0)
GAME( 19??, s_mortal, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Mortal Kombat (Europe)", 0)
GAME( 19??, s_morta1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Mortal Kombat 3 (Brazil)", 0)
GAME( 19??, s_morta2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Mortal Kombat II (Europe)", 0)
GAME( 19??, s_mspacm, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ms. Pac-Man (Europe)", 0)
GAME( 19??, s_myhero, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) My Hero (USA, Europe)", 0)
GAME( 19??, s_nekkyu, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Nekkyuu Koushien (Japan)", 0)
GAME( 19??, s_newzea, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) New Zealand Story, The (Europe)", 0)
GAME( 19??, s_ninjaj, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Ninja (Japan)", 0)
GAME( 19??, s_ninjag, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ninja Gaiden (Europe) (Beta)", 0)
GAME( 19??, s_ninja1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ninja Gaiden (Europe)", 0)
GAME( 19??, s_ninjat, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Ninja, The (USA, Europe)", 0)
GAME( 19??, s_olympi, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Olympic Gold (Europe) (En,Fr,De,Es,It,Nl,Pt,Sv)", 0)
GAME( 19??, s_olymp1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Olympic Gold (Korea) (En,Fr,De,Es,It,Nl,Pt,Sv)", 0)
GAME( 19??, s_opaopa, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Opa Opa (Japan)", 0)
GAME( 19??, s_operat, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Operation Wolf (Europe)", 0)
GAME( 19??, s_ottifa, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ottifants, The (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, s_outrun, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Out Run (World)", 0)
GAME( 19??, s_outru1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Out Run 3-D (Europe)", 0)
GAME( 19??, s_outru2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Out Run Europa (Europe)", 0)
GAME( 19??, s_pacman, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Pac-Mania (Europe)", 0)
GAME( 19??, s_paperb, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Paperboy (Europe)", 0)
GAME( 19??, s_paper1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Paperboy (USA)", 0)
GAME( 19??, s_parlou, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Parlour Games (USA, Europe)", 0)
GAME( 19??, s_patril, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Pat Riley Basketball (USA) (Proto)", 0)
GAME( 19??, s_pengui, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Penguin Land (USA, Europe)", 0)
GAME( 19??, s_pgatou, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) PGA Tour Golf (Europe)", 0)
GAME( 19??, s_phanta, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Phantasy Star (Brazil)", 0)
GAME( 19??, s_phant1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Phantasy Star (J) (from Saturn Collection CD) [!]", 0)
GAME( 19??, s_phant2, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Phantasy Star (Japan)", 0)
GAME( 19??, s_phant3, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Phantasy Star (Korea)", 0)
GAME( 19??, s_phant4, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Phantasy Star (USA, Europe) (v1.2)", 0)
GAME( 19??, s_phant5, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Phantasy Star (USA, Europe) (v1.3)", 0)
GAME( 19??, s_pitfig, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Pit Fighter (Brazil)", 0)
GAME( 19??, s_pitfi1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Pit Fighter (Europe)", 0)
GAME( 19??, s_populo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Populous (Europe)", 0)
GAME( 19??, s_poseid, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Poseidon Wars 3-D (USA, Europe)", 0)
GAME( 19??, s_powers, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Power Strike (USA, Europe)", 0)
GAME( 19??, s_power1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Power Strike II (Europe)", 0)
GAME( 19??, s_predat, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Predator 2 (Europe)", 0)
GAME( 19??, s_prince, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Prince of Persia (Europe)", 0)
GAME( 19??, s_prowre, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Pro Wrestling (USA, Europe)", 0)
GAME( 19??, s_proyak, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Pro Yakyuu Pennant Race, The (Japan)", 0)
GAME( 19??, s_promoc, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Promocao Especial M. System III Compact (Brazil) (Sample)", 0)
GAME( 19??, s_psychi, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Psychic World (Europe)", 0)
GAME( 19??, s_psycho, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Psycho Fox (USA, Europe)", 0)
GAME( 19??, s_puttpu, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Putt & Putter (Europe) (Beta)", 0)
GAME( 19??, s_puttp1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Putt & Putter (Europe)", 0)
GAME( 19??, s_quarte, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Quartet (USA, Europe)", 0)
GAME( 19??, s_questf, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Quest for the Shaven Yak Starring Ren Hoek & Stimpy (Brazil)", 0)
GAME( 19??, s_rtypew, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) R-Type (World)", 0)
GAME( 19??, s_rcgran, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) R.C. Grand Prix (USA, Europe)", 0)
GAME( 19??, s_rainbo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Rainbow Islands - The Story of Bubble Bobble 2 (Brazil)", 0)
GAME( 19??, s_rainb1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Rainbow Islands - The Story of Bubble Bobble 2 (Europe)", 0)
GAME( 19??, s_rambof, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Rambo - First Blood Part II (USA)", 0)
GAME( 19??, s_ramboi, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Rambo III (USA, Europe)", 0)
GAME( 19??, s_rampag, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Rampage (USA, Europe)", 0)
GAME( 19??, s_rampar, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Rampart (Europe)", 0)
GAME( 19??, s_rastan, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Rastan (USA, Europe)", 0)
GAME( 19??, s_reggie, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Reggie Jackson Baseball (USA)", 0)
GAME( 19??, s_renega, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Renegade (Europe)", 0)
GAME( 19??, s_rescue, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Rescue Mission (USA, Europe)", 0)
GAME( 19??, s_roadra, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Road Rash (Europe)", 0)
GAME( 19??, s_roboco, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) RoboCop 3 (Europe)", 0)
GAME( 19??, s_roboc1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) RoboCop versus The Terminator (Europe)", 0)
GAME( 19??, s_rockyw, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Rocky (World)", 0)
GAME( 19??, s_runnin, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Running Battle (Europe)", 0)
GAME( 19??, s_sagaia, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sagaia (Europe)", 0)
GAME( 19??, s_sangok, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Sangokushi 3 (Korea) (Unl)", 0)
GAME( 19??, s_sapoxu, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sapo Xule - O Mestre do Kung Fu (Brazil)", 0)
GAME( 19??, s_sapox1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sapo Xule - S.O.S Lagoa Poluida (Brazil)", 0)
GAME( 19??, s_sapox2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sapo Xule vs. Os Invasores do Brejo (Brazil)", 0)
GAME( 19??, s_satell, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Satellite 7 (J) [p1][!]", 0)
GAME( 19??, s_satel1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Satellite 7 (Japan)", 0)
GAME( 19??, s_schtro, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Schtroumpfs Autour du Monde, Les (Europe) (En,Fr,De,Es) (Beta)", 0)
GAME( 19??, s_schtr1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Schtroumpfs Autour du Monde, Les (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, s_scramb, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Scramble Spirits (Europe)", 0)
GAME( 19??, s_sdijap, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) SDI (Japan)", 0)
GAME( 19??, s_secret, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Secret Command (Europe)", 0)
GAME( 19??, s_segach, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sega Chess (Europe)", 0)
GAME( 19??, s_segawo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sega World Tournament Golf (Europe)", 0)
GAME( 19??, s_seishu, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Seishun Scandal (Japan)", 0)
GAME( 19??, s_seishy, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Seishyun Scandal (J) [p1][!]", 0)
GAME( 19??, s_sensib, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sensible Soccer (Europe)", 0)
GAME( 19??, s_shadow, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Shadow Dancer (Europe)", 0)
GAME( 19??, s_shado1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Shadow of the Beast (Europe)", 0)
GAME( 19??, s_shangh, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Shanghai (USA, Europe) (Beta)", 0)
GAME( 19??, s_shang1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Shanghai (USA, Europe)", 0)
GAME( 19??, s_shinob, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Shinobi (Japan)", 0)
GAME( 19??, s_shino1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Shinobi (USA, Europe)", 0)
GAME( 19??, s_shooti, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Shooting Gallery (USA, Europe)", 0)
GAME( 19??, s_simpso, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Simpsons, The - Bart vs. The Space Mutants (Europe)", 0)
GAME( 19??, s_simps1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Simpsons, The - Bart vs. The World (Europe)", 0)
GAME( 19??, s_sitiod, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sitio do Picapau Amarelo (Brazil)", 0)
GAME( 19??, s_slapsh, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Slap Shot (Europe)", 0)
GAME( 19??, s_slaps1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Slap Shot (USA) (v1.1)", 0)
GAME( 19??, s_slaps2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Slap Shot (USA)", 0)
GAME( 19??, s_smurfs, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Smurfs, The (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, s_solomo, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Solomon no Kagi - Oujo Rihita no Namida (Japan)", 0)
GAME( 19??, s_sonicb, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sonic Blast (Brazil)", 0)
GAME( 19??, s_sonicc, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sonic Chaos (Europe)", 0)
GAME( 19??, s_sonics, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sonic Spinball (Europe)", 0)
GAME( 19??, s_sonict, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Sonic The Hedgehog (USA, Europe)", 0)
GAME( 19??, s_sonic1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sonic The Hedgehog 2 (Europe) (v1.1)", 0)
GAME( 19??, s_sonic2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Sonic The Hedgehog 2 (Europe)", 0)
GAME( 19??, s_sonic3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Sonic's Edusoft (Unknown) (Proto)", 0)
GAME( 19??, s_spaceg, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Space Gun (Europe)", 0)
GAME( 19??, s_spaceh, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Space Harrier (Japan)", 0)
GAME( 19??, s_space1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Space Harrier (USA, Europe)", 0)
GAME( 19??, s_space2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Space Harrier 3-D (USA, Europe)", 0)
GAME( 19??, s_space3, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Space Harrier 3D (Japan)", 0)
GAME( 19??, s_specia, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Special Criminal Investigation (Europe) (Beta)", 0)
GAME( 19??, s_speci1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Special Criminal Investigation (Europe)", 0)
GAME( 19??, s_speedb, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Speedball (Europe) (Mirrorsoft)", 0)
GAME( 19??, s_speed1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Speedball (Europe) (Virgin)", 0)
GAME( 19??, s_speed2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Speedball 2 (Europe)", 0)
GAME( 19??, s_spellc, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) SpellCaster (USA, Europe)", 0)
GAME( 19??, s_spider, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Spider-Man - Return of the Sinister Six (Europe)", 0)
GAME( 19??, s_spide1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Spider-Man vs. The Kingpin (USA, Europe)", 0)
GAME( 19??, s_sports, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Sports Pad Football (USA)", 0)
GAME( 19??, s_sport1, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Sports Pad Soccer (Japan)", 0)
GAME( 19??, s_spyvss, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Spy vs Spy (Japan)", 0)
GAME( 19??, s_spyvs1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Spy vs. Spy (U) (Display-Unit Cart) [!]", 0)
GAME( 19??, s_spyvs2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Spy vs. Spy (USA, Europe)", 0)
GAME( 19??, s_starwa, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Star Wars (Europe)", 0)
GAME( 19??, s_street, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Street Fighter II (Brazil)", 0)
GAME( 19??, s_stree1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Streets of Rage (Europe)", 0)
GAME( 19??, s_stree2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Streets of Rage II (Europe)", 0)
GAME( 19??, s_stride, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Strider (USA, Europe)", 0)
GAME( 19??, s_strid1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Strider II (Europe)", 0)
GAME( 19??, s_submar, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Submarine Attack (Europe)", 0)
GAME( 19??, s_sukeba, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Sukeban Deka II - Shoujo Tekkamen Densetsu (Japan)", 0)
GAME( 19??, s_summer, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Summer Games (Europe) (Beta)", 0)
GAME( 19??, s_summe1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Summer Games (Europe)", 0)
GAME( 19??, s_superb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Super Basketball (USA) (Sample)", 0)
GAME( 19??, s_superk, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Super Kick Off (Europe) (En,Fr,De,Es,It,Nl,Pt,Sv)", 0)
GAME( 19??, s_superm, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Super Monaco GP (Europe)", 0)
GAME( 19??, s_super1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Super Monaco GP (USA)", 0)
GAME( 19??, s_supero, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Super Off Road (Europe)", 0)
GAME( 19??, s_superr, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Super Racing (Japan)", 0)
GAME( 19??, s_supers, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Super Smash T.V. (Europe)", 0)
GAME( 19??, s_super2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Super Space Invaders (Europe)", 0)
GAME( 19??, s_supert, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Super Tennis (USA, Europe)", 0)
GAME( 19??, s_superw, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Super Wonder Boy (Japan)", 0)
GAME( 19??, s_super3, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Super Wonder Boy - Monster World (Japan)", 0)
GAME( 19??, s_super4, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Superman - The Man of Steel (Europe)", 0)
GAME( 19??, s_t2thea, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) T2 - The Arcade Game (Europe)", 0)
GAME( 19??, s_taitoc, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Taito Chase H.Q. (Europe)", 0)
GAME( 19??, s_tazine, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Taz in Escape from Mars (Brazil)", 0)
GAME( 19??, s_tazman, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Taz-Mania (Europe) (Beta)", 0)
GAME( 19??, s_tazma1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Taz-Mania (Europe)", 0)
GAME( 19??, s_tecmow, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Tecmo World Cup '92 (Europe) (Beta)", 0)
GAME( 19??, s_tecmo1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Tecmo World Cup '93 (Europe)", 0)
GAME( 19??, s_teddyb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Teddy Boy (USA, Europe)", 0)
GAME( 19??, s_teddy1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Teddy Boy Blues (J) [p1][!]", 0)
GAME( 19??, s_teddy2, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Teddy Boy Blues (Japan) (Proto) (Ep-MyCard)", 0)
GAME( 19??, s_teddy3, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Teddy Boy Blues (Japan)", 0)
GAME( 19??, s_tennis, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Tennis Ace (Europe)", 0)
GAME( 19??, s_tensai, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Tensai Bakabon (Japan)", 0)
GAME( 19??, s_termin, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Terminator 2 - Judgment Day (Europe)", 0)
GAME( 19??, s_termi1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Terminator, The (Brazil)", 0)
GAME( 19??, s_termi2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Terminator, The (Europe)", 0)
GAME( 19??, s_threed, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Three Dragon Story, The (K)", 0)
GAME( 19??, s_thunde, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Thunder Blade (Japan)", 0)
GAME( 19??, s_thund1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Thunder Blade (USA, Europe)", 0)
GAME( 19??, s_timeso, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Time Soldiers (USA, Europe)", 0)
GAME( 19??, s_tomjer, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Tom & Jerry (Europe) (Beta)", 0)
GAME( 19??, s_tomand, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Tom and Jerry - The Movie (Europe)", 0)
GAME( 19??, s_totowo, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Toto World 3 (Korea) (Unl)", 0)
GAME( 19??, s_transb, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) TransBot (USA, Europe)", 0)
GAME( 19??, s_treina, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Treinamento Do Mymo (B)", 0)
GAME( 19??, s_trivia, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Trivial Pursuit - Genus Edition (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, s_turmad, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Turma da Monica em O Resgate (Brazil)", 0)
GAME( 19??, s_tvcolo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) TV Colosso (Brazil)", 0)
GAME( 19??, s_ultima, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ultima IV - Quest of the Avatar (Europe) (Beta)", 0)
GAME( 19??, s_ultim1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ultima IV - Quest of the Avatar (Europe)", 0)
GAME( 19??, s_ultim2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Ultimate Soccer (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, s_vampir, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Vampire (Europe) (Beta)", 0)
GAME( 19??, s_vigila, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Vigilante (USA, Europe)", 0)
GAME( 19??, s_virtua, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Virtua Fighter Animation (Brazil)", 0)
GAME( 19??, s_walter, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Walter Payton Football (USA)", 0)
GAME( 19??, s_wanted, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Wanted (USA, Europe)", 0)
GAME( 19??, s_wherei, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Where in the World is Carmen Sandiego (Brazil)", 0)
GAME( 19??, s_where1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Where in the World is Carmen Sandiego (USA)", 0)
GAME( 19??, s_wimble, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Wimbledon (Europe)", 0)
GAME( 19??, s_wimbl1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Wimbledon II (Europe)", 0)
GAME( 19??, s_winter, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Winter Olympics - Lillehammer '94 (Brazil) (En,Fr,De,Es,It,Pt,Sv,No)", 0)
GAME( 19??, s_winte1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Winter Olympics - Lillehammer '94 (Europe) (En,Fr,De,Es,It,Pt,Sv,No)", 0)
GAME( 19??, s_wolfch, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Wolfchild (Europe)", 0)
GAME( 19??, s_wonder, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Wonder Boy (USA, Europe)", 0)
GAME( 19??, s_wonde1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Wonder Boy III - The Dragon's Trap (USA, Europe)", 0)
GAME( 19??, s_wonde2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Wonder Boy in Monster Land (UE) (V1.1) [h1]", 0)
GAME( 19??, s_wonde3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Wonder Boy in Monster Land (USA, Europe)", 0)
GAME( 19??, s_wonde4, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Wonder Boy in Monster World (Europe) (Beta)", 0)
GAME( 19??, s_wonde5, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Wonder Boy in Monster World (Europe)", 0)
GAME( 19??, s_woodyp, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Woody Pop - Shinjinrui no Block Kuzushi (Japan)", 0)
GAME( 19??, s_worldc, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) World Class Leader Board (Europe)", 0)
GAME( 19??, s_world1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) World Cup Italia '90 (Europe)", 0)
GAME( 19??, s_world2, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) World Cup USA 94 (Europe) (En,Fr,De,Es,It,Nl,Pt,Sv)", 0)
GAME( 19??, s_worldg, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) World Games (Europe) (Beta)", 0)
GAME( 19??, s_world3, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) World Games (Europe)", 0)
GAME( 19??, s_world4, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) World Grand Prix (Europe)", 0)
GAME( 19??, s_world5, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) World Grand Prix (USA)", 0)
GAME( 19??, s_worlds, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) World Soccer (World)", 0)
GAME( 19??, s_wwfwre, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) WWF Wrestlemania - Steel Cage Challenge (Europe)", 0)
GAME( 19??, s_xmenmo, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) X-Men - Mojo World (Brazil)", 0)
GAME( 19??, s_xenonm, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Xenon 2 - Megablast (Europe) (Image Works)", 0)
GAME( 19??, s_xenon1, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Xenon 2 - Megablast (Europe) (Virgin)", 0)
GAME( 19??, s_ysjapa, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) Ys (Japan)", 0)
GAME( 19??, s_ysthev, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Ys - The Vanished Omens (USA, Europe)", 0)
GAME( 19??, s_zaxxon, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Zaxxon 3-D (World) (Beta)", 0)
GAME( 19??, s_zaxxo1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Zaxxon 3-D (World)", 0)
GAME( 19??, s_zillio, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Zillion (Europe) (v1.2)", 0)
GAME( 19??, s_zilli1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Zillion (Japan, Europe) (En,Ja)", 0)
GAME( 19??, s_zilli2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Zillion (USA) (v1.1)", 0)
GAME( 19??, s_zilli3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) Zillion II - The Tri Formation (World)", 0)
GAME( 19??, s_zoolni, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) Zool - Ninja of the 'Nth' Dimension (Europe)", 0)
GAME( 19??, s_biosal, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) [BIOS] Alex Kidd in Miracle World (Korea)", 0)
GAME( 19??, s_biosa1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) [BIOS] Alex Kidd in Miracle World (USA, Europe)", 0)
GAME( 19??, s_biosha, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) [BIOS] Hang-On & Safari Hunt (USA, Europe) (v2.4)", 0)
GAME( 19??, s_biosh1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) [BIOS] Hang-On (USA, Europe) (v3.4)", 0)
GAME( 19??, s_biosmi, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) [BIOS] Missile Defense 3-D (USA, Europe) (v4.4)", 0)
GAME( 19??, s_biosse, 0       , smsj, sms, smsj, ROT0, "Sega License", "(Master System) [BIOS] Sega Master System (Japan) (v2.1)", 0)
GAME( 19??, s_bioss1, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) [BIOS] Sega Master System (USA) (M404) (Proto)", 0)
GAME( 19??, s_bioss2, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) [BIOS] Sega Master System (USA) (Store Display Unit)", 0)
GAME( 19??, s_bioss3, 0       , smsu, sms, smsu, ROT0, "Sega License", "(Master System) [BIOS] Sega Master System (USA) (v1.3) [b]", 0)
GAME( 19??, s_biosso, 0       , smse, sms, smse, ROT0, "Sega License", "(Master System) [BIOS] Sonic The Hedgehog (Europe)", 0)





CONSOLE_ROM_LOAD( gg5in1fu, "5 in 1 funpak (usa).gg",                                                                    0x000000 , 0x40000,	 CRC(f85a8ce8) SHA1(dc8f5848fede37a914dbf1c104c3efb5a804ccbd) )
CONSOLE_ROM_LOAD( ggaahari, "aa harimanada (japan).gg",                                                                  0x000000 , 0x80000,	 CRC(1d17d2a0) SHA1(0fa7111fcd98670d4bef725d11e670e14eaaa7eb) )
CONSOLE_ROM_LOAD( ggaddams, "addams family, the (world).gg",                                                             0x000000 , 0x40000,	 CRC(1d01f999) SHA1(3231d574e5eb0ac3a77b1d65d74f3a581819a9c7) )
CONSOLE_ROM_LOAD( ggadvent, "adventures of batman & robin, the (prototype - apr 27, 1995).gg",       0x000000 , 0x7fff6,	 CRC(acce0d15) SHA1(ac60f308640eea536bb3007d2a0b78d95b81d160) )
CONSOLE_ROM_LOAD( ggadven1, "adventures of batman & robin, the (prototype - apr 29, 1995 - a).gg",   0x000000 , 0x7fbdc,	 CRC(14867057) SHA1(7877c4f8c271c37fc7d72208460231e60e63b95e) )
CONSOLE_ROM_LOAD( ggadven2, "adventures of batman & robin, the (prototype - apr 30, 1995).gg",       0x000000 , 0x7fbdc,	 CRC(50376471) SHA1(cda657eb423a8891304cb64cf4a43fd434c60588) )
CONSOLE_ROM_LOAD( ggadven3, "adventures of batman & robin, the (prototype - may 02, 1995).gg",       0x000000 , 0x7fbdc,	 CRC(e57566f3) SHA1(81cb20d64acc5cee4bc7b56f0dcec9125b55f66f) )
CONSOLE_ROM_LOAD( ggadven4, "adventures of batman & robin, the (prototype - may 04, 1995).gg",       0x000000 , 0x7fbdc,	 CRC(a9cf66ed) SHA1(19f890a237d4aa0868121d80944055a314275f81) )
CONSOLE_ROM_LOAD( ggadven5, "adventures of batman & robin, the (prototype - may 06, 1995 - b).gg",   0x000000 , 0x7fffa,	 CRC(50c2f1ad) SHA1(8cebb48b14c4c1ee4d168f764b074a87cc4e5324) )
CONSOLE_ROM_LOAD( ggadven6, "adventures of batman & robin, the (prototype - may 06, 1995).gg",       0x000000 , 0x7fffa,	 CRC(c403264a) SHA1(0afd0624bd054430b7894c24e2fb186d5f44af99) )
CONSOLE_ROM_LOAD( ggadven7, "adventures of batman & robin, the (prototype - may 07, 1995).gg",       0x000000 , 0x7fffa,	 CRC(fc916fd7) SHA1(ea5b5b79f92f5546a733efc10f42997956037463) )
CONSOLE_ROM_LOAD( ggadven8, "adventures of batman & robin, the (usa, europe).gg",                                        0x000000 , 0x80000,	 CRC(bb4f23ff) SHA1(50e8726be1b26d066ea9e2e2b5cd7407c356187e) )
CONSOLE_ROM_LOAD( ggaerial, "aerial assault (japan) (v1.1).gg",                                                          0x000000 , 0x20000,	 CRC(04fe6dde) SHA1(2a91ab5817938dddf2724df2dfd95a3bc6f5156d) )
CONSOLE_ROM_LOAD( ggaeria1, "aerial assault (world).gg",                                                                 0x000000 , 0x20000,	 CRC(3e549b7a) SHA1(cbdbaaeb62a8483d9d5a8757b0f19233dfb9b416) )
CONSOLE_ROM_LOAD( ggaladdi, "aladdin (japan).gg",                                                                        0x000000 , 0x80000,	 CRC(770e95e1) SHA1(7ddfd53e91d8220e4238d3994921bf18fe383717) )
CONSOLE_ROM_LOAD( ggaladd1, "aladdin (prototype - dec 29, 1993).gg",                                 0x000000 , 0x80000,	 CRC(5b1f717f) SHA1(ed303cb2debbc74f65a02f863e8c5bbb446155c4) )
CONSOLE_ROM_LOAD( ggaladd2, "aladdin (prototype - jan 11, 1994).gg",                                 0x000000 , 0x80000,	 CRC(8a1693ab) SHA1(7ec48d31a35006ccba4abcf108e187e0b222852b) )
CONSOLE_ROM_LOAD( ggaladd3, "aladdin (prototype - jan 13, 1994).gg",                                 0x000000 , 0x80000,	 CRC(75a7f142) SHA1(a968ee77938233a4ff94c73266c7fb36fa25657d) )
CONSOLE_ROM_LOAD( ggaladd4, "aladdin (prototype with - jan 23, 1994).gg",                            0x000000 , 0x80000,	 CRC(75a7f142) SHA1(a968ee77938233a4ff94c73266c7fb36fa25657d) )
CONSOLE_ROM_LOAD( ggaladd5, "aladdin (usa, europe).gg",                                                                  0x000000 , 0x80000,	 CRC(7a41c1dc) SHA1(20ba7f5e5c801fbe48a537d2551a3d4525eb63e7) )
CONSOLE_ROM_LOAD( ggalienu, "alien 3 (usa, europe).gg",                                                                  0x000000 , 0x40000,	 CRC(11a68c08) SHA1(f3b976fefc331f37c3e4d883791eba68890279a5) )
CONSOLE_ROM_LOAD( ggaliens, "alien syndrome (japan).gg",                                                                 0x000000 , 0x20000,	 CRC(ffe4ed47) SHA1(b72e54493bfa7f13883a608bcf8c9f315dd490ca) )
CONSOLE_ROM_LOAD( ggalien1, "alien syndrome (usa, europe).gg",                                                           0x000000 , 0x20000,	 CRC(bb5e10e0) SHA1(112c7fba070eb7b6bdd41675d49caf934c17dc17) )
CONSOLE_ROM_LOAD( ggandrea, "andre agassi tennis (usa).gg",                                                              0x000000 , 0x40000,	 CRC(46c9fa3e) SHA1(9bd46e137723795a62cca429effcdd51f3b71257) )
CONSOLE_ROM_LOAD( ggarcade, "arcade classics (usa).gg",                                                                  0x000000 , 0x40000,	 CRC(3deca813) SHA1(fde19f418f4f13bbe43e6610f411065db9a6f550) )
CONSOLE_ROM_LOAD( ggarchri, "arch rivals (usa).gg",                                                                      0x000000 , 0x40000,	 CRC(f0204191) SHA1(9a2260a9cb9564a18f50edc8149a9e1e517bf649) )
CONSOLE_ROM_LOAD( ggarenau, "arena (usa, europe).gg",                                                                    0x000000 , 0x80000,	 CRC(7cb3facf) SHA1(91e411d979789f2e31dcfe94fb7f757815f60680) )
CONSOLE_ROM_LOAD( ggarielt, "ariel the little mermaid (usa, europe).gg",                                                 0x000000 , 0x40000,	 CRC(97e3a18c) SHA1(d2f1b95a6d0a2cacd93ed307a5a6576f954a7d56) )
CONSOLE_ROM_LOAD( ggarliel, "arliel - crystal densetsu (japan).gg",                                                      0x000000 , 0x40000,	 CRC(35fa3f68) SHA1(75a04fa483fccd12a52aa18e494d542f4486577f) )
CONSOLE_ROM_LOAD( ggasteri, "asterix (prototype - feb 16, 1994).gg",                                 0x000000 , 0x80000,	 CRC(1e8d735c) SHA1(7d411f499e313bece6cd0a6f32c614adc0405190) )
CONSOLE_ROM_LOAD( ggaster1, "asterix (prototype - feb 22, 1994).gg",                                 0x000000 , 0x80000,	 CRC(31bd3d8a) SHA1(ca04b12f93d3657e323db8ae3f3f31a6220ec732) )
CONSOLE_ROM_LOAD( ggaster2, "asterix (prototype - jan 25, 1994).gg",                                 0x000000 , 0x80000,	 CRC(ba45f00f) SHA1(4d52303ce4aa680fcf5813317804b5805b9222a4) )
CONSOLE_ROM_LOAD( ggaster3, "asterix (prototype - mar 13, 1994).gg",                                 0x000000 , 0x80000,	 CRC(faf09846) SHA1(cde9940d29dc834806b55cc1783c1b7944eb7600) )
CONSOLE_ROM_LOAD( ggaster4, "asterix (prototype - mar 15, 1994).gg",                                 0x000000 , 0x80000,	 CRC(66d8eb63) SHA1(be292971696ecfa753d312c97c5b4788f5adfbee) )
CONSOLE_ROM_LOAD( ggaster5, "asterix and the great rescue (europe) (en,fr,de,es,it).gg",                                 0x000000 , 0x80000,	 CRC(328c5cc8) SHA1(6083f57bc33c761ebf06b7c7512d1ee10bf619c8) )
CONSOLE_ROM_LOAD( ggaster6, "asterix and the great rescue (usa).gg",                                                     0x000000 , 0x80000,	 CRC(78208b40) SHA1(821a0f9087001831fb9828fe2ef193877f960db6) )
CONSOLE_ROM_LOAD( ggaster7, "asterix and the secret mission (europe) (en,fr,de).gg",                                     0x000000 , 0x80000,	 CRC(c01a8051) SHA1(8ab4ea406a0503b09c1bd89e3217c5735b36ebed) )
CONSOLE_ROM_LOAD( ggaxbatt, "ax battler - a legend of golden axe (usa, europe) (v2.4).gg",                               0x000000 , 0x40000,	 CRC(663bcf8a) SHA1(9f5bf2973225b8ee337fcec460829724a0c63d9e) )
CONSOLE_ROM_LOAD( ggaxbat1, "ax battler - golden axe densetsu (japan) (v1.5).gg",                                        0x000000 , 0x40000,	 CRC(dfcf555f) SHA1(ff7931d3461c69ffc3a82d892ae3bb3bb00788b3) )
CONSOLE_ROM_LOAD( ggayrton, "ayrton senna's super monaco gp ii (japan).gg",                                              0x000000 , 0x40000,	 CRC(661faeff) SHA1(44f2c2bfa6ab57c1fd533996a5e404ebaa07264b) )
CONSOLE_ROM_LOAD( ggayrto1, "ayrton senna's super monaco gp ii (usa, europe).gg",                                        0x000000 , 0x40000,	 CRC(1d1b1dd3) SHA1(e6a86010a4dad0a6102783d3c00ad126e8221597) )
CONSOLE_ROM_LOAD( ggbakuba, "baku baku animal (usa).gg",                                                                 0x000000 , 0x40000,	 CRC(8d8bfdc4) SHA1(f4f31d08e17b9936dea621fef9b38e1cd067bef2) )
CONSOLE_ROM_LOAD( ggbakub1, "baku baku animal - sekai shiikugakari senshu-ken (japan).gg",                               0x000000 , 0x40000,	 CRC(10ac9374) SHA1(5145967d0a3632cf6bb1a9d58b2ef04faecd40db) )
CONSOLE_ROM_LOAD( ggbarbie, "barbie super model (unknown) (proto).gg",                                                   0x000000 , 0x40000,	 CRC(03a0ce9e) SHA1(4fabaf794081074ac1a76eb0efc4262efb627610) )
CONSOLE_ROM_LOAD( ggbartma, "bartman meets radioactive man (usa, europe).gg",                                            0x000000 , 0x40000,	 CRC(ffa447a9) SHA1(9dd99ca1b28dbb16f5f118e2729613d1452aba73) )
CONSOLE_ROM_LOAD( ggbatman, "batman forever (world).gg",                                                                 0x000000 , 0x80000,	 CRC(618b19e2) SHA1(775ecf7ba87345c2f89f0e9d6e55544db8878786) )
CONSOLE_ROM_LOAD( ggbatma1, "batman returns (world).gg",                                                                 0x000000 , 0x40000,	 CRC(7ac4a3ca) SHA1(85994b2f506c7bded0b02a59d96b1d949e48d518) )
CONSOLE_ROM_LOAD( ggbatter, "batter up (usa, europe).gg",                                                                0x000000 , 0x20000,	 CRC(16448209) SHA1(107496f1afff8bcebcd507226e953871fc4d80e4) )
CONSOLE_ROM_LOAD( ggbattle, "battleship (usa, europe).gg",                                                               0x000000 , 0x10000,	 CRC(fddd8cd9) SHA1(eae1ebec2c1be522924f669a2dc884f9f4a68cf3) )
CONSOLE_ROM_LOAD( ggbattl1, "battletoads (japan, europe).gg",                                                            0x000000 , 0x40000,	 CRC(cb3cd075) SHA1(77a284b993c6f60652d88468b836d7a2ee7b4600) )
CONSOLE_ROM_LOAD( ggbattl2, "battletoads (usa).gg",                                                                      0x000000 , 0x40000,	 CRC(817cc0ca) SHA1(f566a19d1cfd5c20d5b91b396f29323be2209911) )
CONSOLE_ROM_LOAD( ggbeavis, "beavis and butt-head (europe).gg",                                                          0x000000 , 0x80000,	 CRC(a6bf865e) SHA1(dd2ea76c05d933b91f1b03140f6a04bf02f746d1) )
CONSOLE_ROM_LOAD( ggbeavi1, "beavis and butt-head (usa).gg",                                                             0x000000 , 0x80000,	 CRC(3858f14f) SHA1(ef47d449f65cfe129368a77cc0a4679a0d55ee63) )
CONSOLE_ROM_LOAD( ggberens, "berenstain bears (prototype - aug 01, 1994).gg",                        0x000000 , 0x40000,	 CRC(882b8f53) SHA1(c7e0ccefdcc4f12d7ecdbab383e441b829a2c789) )
CONSOLE_ROM_LOAD( ggberen1, "berenstain bears (prototype - aug 11, 1994 - a).gg",                    0x000000 , 0x40000,	 CRC(81a5e68f) SHA1(af14fcb9329c0ded9775473ef78e241fb6b2d365) )
CONSOLE_ROM_LOAD( ggberen2, "berenstain bears (prototype - aug 11, 1994).gg",                        0x000000 , 0x40000,	 CRC(50d400b8) SHA1(2d6ecb588299bbe9cb0eb54954663043355d759e) )
CONSOLE_ROM_LOAD( ggberen3, "berenstain bears (prototype - aug 12, 1994).gg",                        0x000000 , 0x40000,	 CRC(0e676927) SHA1(9b2aa818cdadc435ca1aee8ae54809377dce26f3) )
CONSOLE_ROM_LOAD( ggberen4, "berenstain bears (prototype - aug 13, 1994).gg",                        0x000000 , 0x40000,	 CRC(f8f11b2a) SHA1(b43373e626d96649f11d5f0ac1101a20b7404978) )
CONSOLE_ROM_LOAD( ggberen5, "berenstain bears (prototype - aug 14, 1994).gg",                        0x000000 , 0x40000,	 CRC(d0971f78) SHA1(a8adae0ac9301b3342d79715b18e8cdebc6d84f6) )
CONSOLE_ROM_LOAD( ggberen6, "berenstain bears (prototype - aug 19, 1994).gg",                        0x000000 , 0x40000,	 CRC(177d65ac) SHA1(0e44212a90383b82cd0d4e03b6cd12a6b38e2d48) )
CONSOLE_ROM_LOAD( ggberen7, "berenstain bears (prototype - aug 20, 1994).gg",                        0x000000 , 0x40000,	 CRC(f61ac1e8) SHA1(6aad469e328614d9ed3f8f84bd90ef2dac2e71db) )
CONSOLE_ROM_LOAD( ggberen8, "berenstain bears (prototype - aug 24, 1994).gg",                        0x000000 , 0x40000,	 CRC(b73486d6) SHA1(480537a721631fc9cebe67422010dfe5739002ef) )
CONSOLE_ROM_LOAD( ggberen9, "berenstain bears (prototype - aug 25, 1994 - b).gg",                    0x000000 , 0x40000,	 CRC(e07b865e) SHA1(ac152aa09dc09419c26761c18276fe4d679d8992) )
CONSOLE_ROM_LOAD( ggbere10, "berenstain bears (prototype - aug 26, 1994 - b).gg",                    0x000000 , 0x40000,	 CRC(217b1ef0) SHA1(bd1ff3c4669379b2a02bd8e1d76b9c02fefc783e) )
CONSOLE_ROM_LOAD( ggbere11, "berenstain bears (prototype - aug 26, 1994).gg",                        0x000000 , 0x40000,	 CRC(167a4af6) SHA1(09bb4a3e936dcce34b46090f5f2f1353dee1d6f6) )
CONSOLE_ROM_LOAD( ggbere12, "berenstain bears (prototype - jul 15, 1994 - b).gg",                    0x000000 , 0x40000,	 CRC(fcf47bc9) SHA1(5fc1a46c47bb847fd3dbca54c9ba729011546b76) )
CONSOLE_ROM_LOAD( ggbere13, "berenstain bears (prototype - jul 21, 1994).gg",                        0x000000 , 0x40000,	 CRC(a279c6bc) SHA1(92ed587953db4c0001d19395c9c8c611d15d0cef) )
CONSOLE_ROM_LOAD( ggbere14, "berenstain bears (prototype - jul 22, 1994).gg",                        0x000000 , 0x40000,	 CRC(ffbf5abe) SHA1(83e3d4ed1437b6ed042b88129f3c1fb3d1846c94) )
CONSOLE_ROM_LOAD( ggbere15, "berenstain bears (prototype - jul 27, 1994).gg",                        0x000000 , 0x40000,	 CRC(112b123f) SHA1(801ed129a09373ad9606f7dedc9ce0bd7ce7dd21) )
CONSOLE_ROM_LOAD( ggbere16, "berenstain bears (prototype - jun 28, 1994).gg",                        0x000000 , 0x40000,	 CRC(75a7a8ca) SHA1(9e16aa6a11186089510fac9413bdd8e62001a761) )
CONSOLE_ROM_LOAD( ggbere17, "berenstain bears' camping adventure, the (usa).gg",                                         0x000000 , 0x40000,	 CRC(a4bb9ffb) SHA1(a35bef59a59df2a6d3dc4b8d3fe2e4cc79464537) )
CONSOLE_ROM_LOAD( ggberlin, "berlin no kabe (japan).gg",                                                                 0x000000 , 0x40000,	 CRC(325b1797) SHA1(1d58d3d8b957d33bab8b50ae60dc0c31eafc08af) )
CONSOLE_ROM_LOAD( ggbishou, "bishoujo senshi sailor moon s (japan).gg",                                                  0x000000 , 0x80000,	 CRC(fe7374d2) SHA1(824e463d0be5c0e81205a475b5ad7e55c366e486) )
CONSOLE_ROM_LOAD( ggbonker, "bonkers wax up! (prototype - dec 03, 1994).gg",                         0x000000 , 0x80000,	 CRC(63429025) SHA1(7e426a1db56125836dd93ea57d5ac82cff1be23f) )
CONSOLE_ROM_LOAD( ggbonke1, "bonkers wax up! (prototype - dec 05, 1994).gg",                         0x000000 , 0x80000,	 CRC(c2229b6e) SHA1(dcbb000cda6f303d902a308a50e08ebc4803d511) )
CONSOLE_ROM_LOAD( ggbonke2, "bonkers wax up! (prototype - dec 07, 1994 - c).gg",                     0x000000 , 0x80000,	 CRC(edaf25e7) SHA1(415fc9e0021f544cbf8fd0895d013465654fd1d5) )
CONSOLE_ROM_LOAD( ggbonke3, "bonkers wax up! (prototype - dec 08, 1994 - b).gg",                     0x000000 , 0x80000,	 CRC(9907a738) SHA1(c8844bfda83a94ce648588ef945a0d76503b84ce) )
CONSOLE_ROM_LOAD( ggbonke4, "bonkers wax up! (prototype - dec 08, 1994 - c).gg",                     0x000000 , 0x80000,	 CRC(91258adc) SHA1(50897d1cbda11e7b20678924d7461f8acd6f0686) )
CONSOLE_ROM_LOAD( ggbonke5, "bonkers wax up! (prototype - dec 11, 1994).gg",                         0x000000 , 0x80000,	 CRC(9a405d0d) SHA1(e797640e2363f517fb83ee42903f5d13a1ffad73) )
CONSOLE_ROM_LOAD( ggbonke6, "bonkers wax up! (prototype - dec 12, 1994 - b).gg",                     0x000000 , 0x80000,	 CRC(9a405d0d) SHA1(e797640e2363f517fb83ee42903f5d13a1ffad73) )
CONSOLE_ROM_LOAD( ggbonke7, "bonkers wax up! (prototype - dec 12, 1994 - d).gg",                     0x000000 , 0x80000,	 CRC(6d295894) SHA1(368286ded1662eddfff056ad77583d62ce83f58b) )
CONSOLE_ROM_LOAD( ggbonke8, "bonkers wax up! (prototype - nov 15, 1994).gg",                         0x000000 , 0x80000,	 CRC(85510a57) SHA1(6cd8fee2110bc5010a2840c6e5b3fb32270efc02) )
CONSOLE_ROM_LOAD( ggbonke9, "bonkers wax up! (prototype - nov 21, 1994).gg",                         0x000000 , 0x80000,	 CRC(dab43f8f) SHA1(c60fbd9e191e4154e26e73f0fd1be1dc6e999e11) )
CONSOLE_ROM_LOAD( ggbonk10, "bonkers wax up! (prototype - nov 23, 1994).gg",                         0x000000 , 0x80000,	 CRC(1b081950) SHA1(ac22b149fcd6b500875c93f71e12b2a6cedea507) )
CONSOLE_ROM_LOAD( ggbonk11, "bonkers wax up! (prototype - nov 26, 1994).gg",                         0x000000 , 0x80000,	 CRC(eb3f22c2) SHA1(fbdccd5ee5f38b8ce5654a0093f32e3811c8b56b) )
CONSOLE_ROM_LOAD( ggbonk12, "bonkers wax up! (prototype - nov 29, 1994).gg",                         0x000000 , 0x80000,	 CRC(ad6a62fa) SHA1(4ad7947a4ffee9a76d146fecc9c3c2f6c5e680b7) )
CONSOLE_ROM_LOAD( ggbonk13, "bonkers wax up! (prototype - oct 31, 1994).gg",                         0x000000 , 0x80000,	 CRC(777dfd80) SHA1(160d28c7fd900ab25117247eccecf2ecdb164ce4) )
CONSOLE_ROM_LOAD( ggbonk14, "bonkers wax up! (usa, europe).gg",                                                          0x000000 , 0x80000,	 CRC(bfceba5f) SHA1(b98bd9467fe8bf782989172b576c7844f3666ae9) )
CONSOLE_ROM_LOAD( ggbramst, "bram stoker's dracula (usa).gg",                                                            0x000000 , 0x40000,	 CRC(69ebe5fa) SHA1(ea753b5dce4b319cc1709451a4c8cb55daf2b76b) )
CONSOLE_ROM_LOAD( ggbubble, "bubble bobble (usa, europe).gg",                                                            0x000000 , 0x40000,	 CRC(fba338c5) SHA1(c2c99d798bd0d4960021743a55e74644ad9020c6) )
CONSOLE_ROM_LOAD( ggbugsbu, "bugs bunny in double trouble (usa, europe).gg",                                             0x000000 , 0x80000,	 CRC(5c34d9cd) SHA1(a29dabb90532ff6114437f28970203e16003c11e) )
CONSOLE_ROM_LOAD( ggbustam, "bust-a-move (usa, europe).gg",                                                              0x000000 , 0x40000,	 CRC(c90f29ef) SHA1(e6bb5f72cffb11c8dd44ac3e378088b04cec1297) )
CONSOLE_ROM_LOAD( ggbuster, "buster ball (japan).gg",                                                                    0x000000 , 0x20000,	 CRC(7cb079d0) SHA1(5d67f38ec0c2e577a7ad88915849da696ad162aa) )
CONSOLE_ROM_LOAD( ggbuste1, "buster fight (japan).gg",                                                                   0x000000 , 0x40000,	 CRC(a72a1753) SHA1(5c87048082a95acd6bc27b98f85bda731617c739) )
CONSOLE_ROM_LOAD( ggcaesar, "caesars palace (usa).gg",                                                                   0x000000 , 0x40000,	 CRC(c53b60b8) SHA1(ce3f7d6f2df8509764f0ad06a05801ca76d6fb0a) )
CONSOLE_ROM_LOAD( ggcaptai, "captain america and the avengers (usa, europe).gg",                                         0x000000 , 0x40000,	 CRC(5675dfdd) SHA1(4b859174d57cc4a5a575f8aa9547a83d08e6c117) )
CONSOLE_ROM_LOAD( ggcarlic, "car licence (japan).gg",                                                                    0x000000 , 0x80000,	 CRC(f6a697f8) SHA1(0cf691dba7080a1f8d4a181563948b188115ec89) )
CONSOLE_ROM_LOAD( ggcasino, "casino funpak (usa).gg",                                                                    0x000000 , 0x40000,	 CRC(2b732056) SHA1(5b512d5c3ea92498831b40cd740b99107c369b56) )
CONSOLE_ROM_LOAD( ggcastle, "castle of illusion starring mickey mouse (usa, europe).sms",                                0x000000 , 0x40000,	 CRC(59840fd6) SHA1(06bbeb784f913b37f58c2581c66d4ecb099deace) )
CONSOLE_ROM_LOAD( ggchakan, "chakan (usa, europe).gg",                                                                   0x000000 , 0x40000,	 CRC(dfc7adc8) SHA1(bdb82464147ef20792162cff7922824d4dee0dc1) )
CONSOLE_ROM_LOAD( ggchaseh, "chase h.q. (j) [s][!].gg",                                                                  0x000000 , 0x20000,	 CRC(44fbe8f6) SHA1(cc8e0d3a9826348bbb90ebcc5021b4e2e909965f) )
CONSOLE_ROM_LOAD( ggchessm, "chessmaster, the (usa, europe).gg",                                                         0x000000 , 0x20000,	 CRC(da811ba6) SHA1(daea9a76dedc080b9965cfa32e2ddb1eaaaab0b4) )
CONSOLE_ROM_LOAD( ggchicag, "chicago syndicate (prototype - jul 03, 1995).gg",                       0x000000 , 0x80000,	 CRC(e3c0ea98) SHA1(e526b1ff96c245d4ec69064a2cc8e57169081802) )
CONSOLE_ROM_LOAD( ggchica1, "chicago syndicate (prototype - jul 05, 1995).gg",                       0x000000 , 0x80000,	 CRC(4158e203) SHA1(18b2a946800d4a6347cd96c8790add2f34fe4dfa) )
CONSOLE_ROM_LOAD( ggchica2, "chicago syndicate (prototype - jul 07, 1995).gg",                       0x000000 , 0x80000,	 CRC(e44d1b01) SHA1(b76a7e673e5581a2084098f737ff551ce8880296) )
CONSOLE_ROM_LOAD( ggchica3, "chicago syndicate (prototype - jul 10, 1995).gg",                       0x000000 , 0x80000,	 CRC(42becef6) SHA1(b32ec7e95dc39f0b78dd3d0b17c2d504f5f24f9a) )
CONSOLE_ROM_LOAD( ggchica4, "chicago syndicate (prototype - jul 11, 1995).gg",                       0x000000 , 0x80000,	 CRC(afe46aa8) SHA1(bc01553450523d4860c2fb42d84297fd80cbf5d2) )
CONSOLE_ROM_LOAD( ggchica5, "chicago syndicate (prototype - jul 19, 1995).gg",                       0x000000 , 0x80000,	 CRC(dd5f9327) SHA1(b70863b4a6aec101cee895baf3f8ea27e076e369) )
CONSOLE_ROM_LOAD( ggchica6, "chicago syndicate (prototype - jul 20, 1995).gg",                       0x000000 , 0x80000,	 CRC(b0597a54) SHA1(087df96c15aa1258a46690b4859a5447481e058f) )
CONSOLE_ROM_LOAD( ggchica7, "chicago syndicate (prototype - jul 21, 1995 - b).gg",                   0x000000 , 0x80000,	 CRC(26ced733) SHA1(5c6db9314cbc4c7933dacc076e59948147ad79ae) )
CONSOLE_ROM_LOAD( ggchica8, "chicago syndicate (prototype - jul 21, 1995).gg",                       0x000000 , 0x80000,	 CRC(8e149bb8) SHA1(17887be88692097acc74488b16a255b7b6b95aee) )
CONSOLE_ROM_LOAD( ggchica9, "chicago syndicate (prototype - jun 01, 1995).gg",                       0x000000 , 0x80000,	 CRC(448c6890) SHA1(5ab2358c0db7c486ce2e9bcc663c054a694bff46) )
CONSOLE_ROM_LOAD( ggchic10, "chicago syndicate (prototype - jun 05, 1995).gg",                       0x000000 , 0x80000,	 CRC(af43b940) SHA1(0fc9d9a9bbbc00dc286f350de07b0e53a507c01f) )
CONSOLE_ROM_LOAD( ggchic11, "chicago syndicate (prototype - jun 07, 1995).gg",                       0x000000 , 0x80000,	 CRC(9b2fd7f3) SHA1(6154bbc7c0c06d354283af2292eb041e1d87944a) )
CONSOLE_ROM_LOAD( ggchic12, "chicago syndicate (prototype - jun 08, 1995).gg",                       0x000000 , 0x80000,	 CRC(2036d4b7) SHA1(7138742323b2ba7d18eb9497f78fcb6cd2025df1) )
CONSOLE_ROM_LOAD( ggchic13, "chicago syndicate (prototype - jun 12, 1995).gg",                       0x000000 , 0x80000,	 CRC(f2c24745) SHA1(99aeac9b5b3800ddd8ee6630e373af73496c8b3a) )
CONSOLE_ROM_LOAD( ggchic14, "chicago syndicate (prototype - jun 14, 1995).gg",                       0x000000 , 0x80000,	 CRC(463a2197) SHA1(7f83c523a6b0813a2c1f72e71f5dbc0e1ea556cb) )
CONSOLE_ROM_LOAD( ggchic15, "chicago syndicate (prototype - jun 19, 1995).gg",                       0x000000 , 0x80000,	 CRC(3cdb35b1) SHA1(61ca81b15fad4d71a8222a8dc9f9c1fc05561549) )
CONSOLE_ROM_LOAD( ggchic16, "chicago syndicate (prototype - jun 20, 1995).gg",                       0x000000 , 0x80000,	 CRC(bf82cf83) SHA1(924bb32515d4a0435fb318f852483fdc1974e771) )
CONSOLE_ROM_LOAD( ggchic17, "chicago syndicate (prototype - jun 22, 1995).gg",                       0x000000 , 0x80000,	 CRC(4ac79cec) SHA1(821bc6a27dd1cf519033d65ffe41458f3bee21cd) )
CONSOLE_ROM_LOAD( ggchic18, "chicago syndicate (prototype - jun 26, 1995).gg",                       0x000000 , 0x80000,	 CRC(abe696e5) SHA1(148d09a535e50730672557668c3161f3b18b4834) )
CONSOLE_ROM_LOAD( ggchic19, "chicago syndicate (prototype - jun 28, 1995).gg",                       0x000000 , 0x80000,	 CRC(5cd07aed) SHA1(5a46ace9f6b24e8403caead2b6ec39e4059e68e6) )
CONSOLE_ROM_LOAD( ggchic20, "chicago syndicate (prototype - jun 29, 1995 - b).gg",                   0x000000 , 0x80000,	 CRC(d3614e4e) SHA1(6fd25c55c8cc6b10f928af6d5de83d61685df940) )
CONSOLE_ROM_LOAD( ggchic21, "chicago syndicate (prototype - jun 29, 1995).gg",                       0x000000 , 0x80000,	 CRC(e1112763) SHA1(f72c381fabef9286da6a7ede230156277364c5d1) )
CONSOLE_ROM_LOAD( ggchic22, "chicago syndicate (prototype - jun 30, 1995 - b).gg",                   0x000000 , 0x80000,	 CRC(f68a3581) SHA1(5fc82fc2866b7dd99868dfa1a0b619ad688d1221) )
CONSOLE_ROM_LOAD( ggchic23, "chicago syndicate (prototype - may 05, 1995).gg",                       0x000000 , 0x80000,	 CRC(a5fa4eaf) SHA1(6534e73ea631de8df56779f3ba4c1948b0070400) )
CONSOLE_ROM_LOAD( ggchic24, "chicago syndicate (usa, europe).gg",                                                        0x000000 , 0x80000,	 CRC(6b0fcec3) SHA1(d7746e4c78aa86bc698fc25a52a791ba27a71add) )
CONSOLE_ROM_LOAD( ggchopli, "choplifter iii (usa, europe).gg",                                                           0x000000 , 0x40000,	 CRC(c2e8a692) SHA1(c0152f5b07b6ff47dfedda5258eda1d4e335cdbf) )
CONSOLE_ROM_LOAD( ggchuckr, "chuck rock (world).gg",                                                                     0x000000 , 0x40000,	 CRC(191b1ed8) SHA1(2b08a3231c0504d86caca74c8508d85c8ef6a86a) )
CONSOLE_ROM_LOAD( ggchuck1, "chuck rock ii - son of chuck (europe).gg",                                                  0x000000 , 0x40000,	 CRC(656708bf) SHA1(8ee080538e87e0f39720c9254bb4a2d85f637967) )
CONSOLE_ROM_LOAD( ggchuck2, "chuck rock ii - son of chuck (usa).gg",                                                     0x000000 , 0x40000,	 CRC(3fcc28c9) SHA1(f6aa6a9a641b3a588a8091cf44e8b0a55ebbd613) )
CONSOLE_ROM_LOAD( ggcliffh, "cliffhanger (usa, europe).gg",                                                              0x000000 , 0x40000,	 CRC(bf75b153) SHA1(7aaf4f7afc2af8dfbf9cc84c7db48788ab1b2d83) )
CONSOLE_ROM_LOAD( ggclutch, "clutch hitter (usa).gg",                                                                    0x000000 , 0x20000,	 CRC(d228a467) SHA1(df7af6588652c3163ea6f445fa21ef76b9764cd0) )
CONSOLE_ROM_LOAD( ggcocaco, "coca cola kid (japan).gg",                                                                  0x000000 , 0x80000,	 CRC(c7598b81) SHA1(e0a6caba7d8433175a3b7f1dfb593f9ca2c67cd1) )
CONSOLE_ROM_LOAD( ggcolumn, "columns (japan).gg",                                                                        0x000000 , 0x8000,	 CRC(f3ca6676) SHA1(8b39ba23132af102b8dc313c5c1c211f4a4f27e1) )
CONSOLE_ROM_LOAD( ggcolum1, "columns (usa, europe).gg",                                                                  0x000000 , 0x8000,	 CRC(83fa26d9) SHA1(05b73f39a90fd59e01262cbd3f4e7a21575d468a) )
CONSOLE_ROM_LOAD( ggcoolsp, "cool spot (usa).gg",                                                                        0x000000 , 0x40000,	 CRC(2c758fc8) SHA1(c5f39a81c33327dc86b41d6f416efe09b131e14d) )
CONSOLE_ROM_LOAD( ggcosmic, "cosmic spacehead (europe).gg",                                                              0x000000 , 0x40000,	 CRC(6caa625b) SHA1(c24f48ca3fb7df3b50b4353095c7a070653f3539) )
CONSOLE_ROM_LOAD( ggcrayon, "crayon shin-chan - taiketsu! kantam panic!! (japan).gg",                                    0x000000 , 0x80000,	 CRC(03d28eab) SHA1(65bcbd89637b8e6837cf36c7f1241eacf85abaa9) )
CONSOLE_ROM_LOAD( ggcrysta, "crystal warriors (usa, europe).gg",                                                         0x000000 , 0x40000,	 CRC(529c864e) SHA1(6b03183b7183de17ad6fbc9938599d3d18badc1a) )
CONSOLE_ROM_LOAD( ggcutthr, "cutthroat island (usa, europe).gg",                                                         0x000000 , 0x80000,	 CRC(6a24e47e) SHA1(95d2012c4027228fda50ef434b53ae5633a7eb8c) )
CONSOLE_ROM_LOAD( ggdaffyd, "daffy duck in hollywood (europe) (en,fr,de,es,it).gg",                                      0x000000 , 0x80000,	 CRC(aae268fc) SHA1(2d058f3885bee45b04b74cbe16f3974d4eb2bfcf) )
CONSOLE_ROM_LOAD( ggdeepdu, "deep duck trouble starring donald duck (usa, europe).gg",                                   0x000000 , 0x80000,	 CRC(5a136d7e) SHA1(24485549001bc57b5cffee1449ad0af80e862773) )
CONSOLE_ROM_LOAD( ggdefend, "defenders of oasis (usa, europe).gg",                                                       0x000000 , 0x80000,	 CRC(e2791cc1) SHA1(07c1167c3b6eea294a73272c256934406f48f9d5) )
CONSOLE_ROM_LOAD( ggdesert, "desert speedtrap (europe) (en,fr,de,es,it).gg",                                             0x000000 , 0x40000,	 CRC(ec808026) SHA1(a253283456010bd73d3bde209566f26b6f8c582f) )
CONSOLE_ROM_LOAD( ggdeser1, "desert speedtrap (usa).gg",                                                                 0x000000 , 0x40000,	 CRC(c2e111ac) SHA1(6b88fb212f0556ea57e01a3a1cd5123db5631e28) )
CONSOLE_ROM_LOAD( ggdeser2, "desert strike - return to the gulf (usa, europe).gg",                                       0x000000 , 0x80000,	 CRC(f6c400da) SHA1(80b91bdf20605d940401738202c473df632d0765) )
CONSOLE_ROM_LOAD( ggdevili, "devilish (europe).gg",                                                                      0x000000 , 0x20000,	 CRC(d43ac6c5) SHA1(3eb7e6cbe74d16bb14c42e91ab6334c156071f6b) )
CONSOLE_ROM_LOAD( ggdevil1, "devilish (japan).gg",                                                                       0x000000 , 0x20000,	 CRC(25db174f) SHA1(5b1d4295920ebe4d6d9b9610764939b2aaa6c598) )
CONSOLE_ROM_LOAD( ggdevil2, "devilish (usa).gg",                                                                         0x000000 , 0x20000,	 CRC(c01293b0) SHA1(421a416c71dd245d80b362af57d01c80547cf042) )
CONSOLE_ROM_LOAD( ggdonald, "donald duck no 4-tsu no hihou (japan).gg",                                                  0x000000 , 0x80000,	 CRC(4457e7c0) SHA1(d5e278b5c68864da7ddfd1f9cfa5b25e462496b0) )
CONSOLE_ROM_LOAD( ggdonal1, "donald duck no lucky dime (japan).gg",                                                      0x000000 , 0x40000,	 CRC(2d98bd87) SHA1(ee70ac64973775adc2063a8cdff203965f2e7e1d) )
CONSOLE_ROM_LOAD( ggdonal2, "donald no magical world (japan) (en,ja).gg",                                                0x000000 , 0x80000,	 CRC(87b8b612) SHA1(5f9afdd5720f88f7cc18715f8e50fc5635b15323) )
CONSOLE_ROM_LOAD( ggdoraem, "doraemon - waku waku pocket paradise (japan).gg",                                           0x000000 , 0x80000,	 CRC(733292a6) SHA1(495816dbd49560cf02e841b53bd996456078c36b) )
CONSOLE_ROM_LOAD( ggdouble, "double dragon (usa, europe) (beta).gg",                                                     0x000000 , 0x40000,	 CRC(331904c0) SHA1(b24aa3e31efbf09e8d0d9ae9d07b4d219b648f96) )
CONSOLE_ROM_LOAD( ggdoubl1, "double dragon (usa, europe).gg",                                                            0x000000 , 0x40000,	 CRC(1307a290) SHA1(baebe28fc7549cbb06c94fcb36a3c40231933c01) )
CONSOLE_ROM_LOAD( ggdrrobo, "dr. robotnik's mean bean machine (usa, europe).gg",                                         0x000000 , 0x40000,	 CRC(3c2d4f48) SHA1(c36bda8a86994d430506b196922ec1365622e560) )
CONSOLE_ROM_LOAD( ggdragon, "dragon - the bruce lee story (europe).gg",                                                  0x000000 , 0x40000,	 CRC(19e1cf2b) SHA1(f1a90ffdff1003b4dedc61ce688591006a2d40be) )
CONSOLE_ROM_LOAD( ggdrago1, "dragon - the bruce lee story (usa).gg",                                                     0x000000 , 0x40000,	 CRC(17f588e8) SHA1(60c7cbe782c3df094452835076b9425c329c82ee) )
CONSOLE_ROM_LOAD( ggdrago2, "dragon crystal (usa, europe).gg",                                                           0x000000 , 0x20000,	 CRC(0ef2ed93) SHA1(6d53f32001d419a5b5e9c16cb62e07e548d2f44a) )
CONSOLE_ROM_LOAD( ggdrago3, "dragon crystal - tsurani no meikyuu (japan).gg",                                            0x000000 , 0x20000,	 CRC(89f12e1e) SHA1(ea323c4ac28d7762277039450c341d0f025093d8) )
CONSOLE_ROM_LOAD( ggdropzo, "dropzone (europe).gg",                                                                      0x000000 , 0x20000,	 CRC(152f0dcc) SHA1(b78bc3fe6bfbc7d6f5e85d59d79be19bf7372bcc) )
CONSOLE_ROM_LOAD( ggdunkki, "dunk kids (japan).gg",                                                                      0x000000 , 0x80000,	 CRC(77ed48f5) SHA1(7525923ba2531d5079d66b2b1156cb5e7d44c66a) )
CONSOLE_ROM_LOAD( ggdynami, "dynamite headdy (japan).gg",                                                                0x000000 , 0x80000,	 CRC(f6af4b6b) SHA1(a8e3f447089537b52e40958c07610bfead82442d) )
CONSOLE_ROM_LOAD( ggdynam1, "dynamite headdy (prototype - jul 01, 1994).gg",                         0x000000 , 0x80000,	 CRC(49389319) SHA1(0e408b4c9dfbb94bdf556b7aa920d4ac71d88c56) )
CONSOLE_ROM_LOAD( ggdynam2, "dynamite headdy (prototype - jul 05, 1994).gg",                         0x000000 , 0x80000,	 CRC(c7bea89a) SHA1(59807e03d32837db34e2912d0e85db812edf823c) )
CONSOLE_ROM_LOAD( ggdynam3, "dynamite headdy (prototype - jun 15, 1994).gg",                         0x000000 , 0x80000,	 CRC(7bf339c0) SHA1(0e8bccb304898a80efcbae8351303103ec4145ee) )
CONSOLE_ROM_LOAD( ggdynam4, "dynamite headdy (usa, europe).gg",                                                          0x000000 , 0x80000,	 CRC(610ff95c) SHA1(a8c8b5252a885d466e044e6055336513d988e661) )
CONSOLE_ROM_LOAD( ggearthw, "earthworm jim (usa).gg",                                                                    0x000000 , 0x80000,	 CRC(5d3f23a9) SHA1(dbb149da0b0373f23750ed954dbb5e08bc634615) )
CONSOLE_ROM_LOAD( ggeccoii, "ecco ii - the tides of time (usa, europe).gg",                                              0x000000 , 0x80000,	 CRC(e2f3b203) SHA1(61913f6803977bb54fda7c3d969dc2c0f7c6da62) )
CONSOLE_ROM_LOAD( ggeccoth, "ecco the dolphin (japan).gg",                                                               0x000000 , 0x80000,	 CRC(a32eb9d5) SHA1(5f0de698e8e0d4323b36bd78e2bd1af1c3370f3e) )
CONSOLE_ROM_LOAD( ggeccot1, "ecco the dolphin (usa, europe).gg",                                                         0x000000 , 0x80000,	 CRC(866c7113) SHA1(7c6c8f44d5aa799726adc3a9e21c9f35cacea87f) )
CONSOLE_ROM_LOAD( ggeccot2, "ecco the dolphin ii (japan).gg",                                                            0x000000 , 0x80000,	 CRC(ba9cef4f) SHA1(36095f4c92f6f66ed6bc20d9b96227d6fb0dae5b) )
CONSOLE_ROM_LOAD( ggerniee, "ernie els golf (europe) (en,fr,de,es,it).gg",                                               0x000000 , 0x40000,	 CRC(5e53c7f7) SHA1(a8d75c2af514dc81ba4dc66a508384d730a77ce4) )
CONSOLE_ROM_LOAD( ggeterna, "eternal legend - eien no densetsu (japan).gg",                                              0x000000 , 0x40000,	 CRC(04302bbd) SHA1(717b4e33cf3956e4194b912533bf1b7bf9d20725) )
CONSOLE_ROM_LOAD( ggevande, "evander holyfield boxing (usa, europe).gg",                                                 0x000000 , 0x40000,	 CRC(36aaf536) SHA1(3093d6e6e332c864da8473ac2eab7d17eb65b523) )
CONSOLE_ROM_LOAD( ggexcell, "excellent dizzy collection, the (europe).sms",                                              0x000000 , 0x80000,	 CRC(aa140c9c) SHA1(db3c0686715373242911f8471a1e91673811d62a) )
CONSOLE_ROM_LOAD( ggexcel1, "excellent dizzy collection, the (prototype) [s][!].gg",                                     0x000000 , 0x40000,	 CRC(8813514b) SHA1(09a2acf3ed90101be2629384c5c702f6a5408035) )
CONSOLE_ROM_LOAD( ggf15str, "f-15 strike eagle (usa, europe).gg",                                                        0x000000 , 0x40000,	 CRC(8bdb0806) SHA1(4bfdafa848223598ca16699ad44fe4a19a1c2ba2) )
CONSOLE_ROM_LOAD( ggf1usae, "f1 (usa, europe).gg",                                                                       0x000000 , 0x40000,	 CRC(d0a93e00) SHA1(b5a1985d671e8b9e0eed7922e6db695011071e99) )
CONSOLE_ROM_LOAD( ggfaceba, "faceball 2000 (japan).gg",                                                                  0x000000 , 0x40000,	 CRC(aaf6f87d) SHA1(967c50a5b64adc6da7bc730900c267e45c90053a) )
CONSOLE_ROM_LOAD( ggfactor, "factory panic (europe).gg",                                                                 0x000000 , 0x20000,	 CRC(59e3be92) SHA1(94beb8b6334bb9dc104ffdb0ad2bdd4964ed91a5) )
CONSOLE_ROM_LOAD( ggfantas, "fantastic dizzy (europe) (en,fr,de,es,it).sms",                                             0x000000 , 0x40000,	 CRC(c888222b) SHA1(b6a13d51c72b576738f0d7e8e328db2ffeb0b38c) )
CONSOLE_ROM_LOAD( ggfanta1, "fantasy zone gear (japan, europe).gg",                                                      0x000000 , 0x20000,	 CRC(d69097e8) SHA1(5951d500d6f53b0537f045adb85d94068a838f32) )
CONSOLE_ROM_LOAD( ggfanta2, "fantasy zone gear (ju) [a1].gg",                                                            0x000000 , 0x20000,	 CRC(365b92cf) SHA1(002de139e9e330f2811cf56401b9e3cc7f233b91) )
CONSOLE_ROM_LOAD( ggfatalf, "fatal fury special (usa).gg",                                                               0x000000 , 0x80000,	 CRC(449787e2) SHA1(7ce20ca34b7bc91ba7e73f830b40830ad6bafbc8) )
CONSOLE_ROM_LOAD( ggfifain, "fifa international soccer (japan).gg",                                                      0x000000 , 0x80000,	 CRC(78159325) SHA1(70385b99320f91fef54ea88123761af9d7ff54c5) )
CONSOLE_ROM_LOAD( ggfifai1, "fifa international soccer (usa, europe).gg",                                                0x000000 , 0x80000,	 CRC(e632a3a2) SHA1(0725626fc9988b690fc1fc77b294d31b78cbfb5a) )
CONSOLE_ROM_LOAD( ggfifaso, "fifa soccer 96 (usa, europe) (en,fr,de,es).gg",                                             0x000000 , 0x80000,	 CRC(c379de95) SHA1(f928c32acba90ed5ebca131af03e76a0efb38797) )
CONSOLE_ROM_LOAD( ggforema, "foreman for real (world).gg",                                                               0x000000 , 0x80000,	 CRC(d46d5685) SHA1(d7109dc1db52bb4828a01b433a4b2993ac2e59e1) )
CONSOLE_ROM_LOAD( ggfrankt, "frank thomas big hurt baseball (usa).gg",                                                   0x000000 , 0x80000,	 CRC(c443c35c) SHA1(aab42351d96e32d46631c540bdfa43a621ab0e76) )
CONSOLE_ROM_LOAD( ggfraysh, "fray - shugyou hen (japan).gg",                                                             0x000000 , 0x40000,	 CRC(e123d9b8) SHA1(0dc770773f651718881ce17a87f145e2f0b02fb1) )
CONSOLE_ROM_LOAD( ggfredco, "fred couples' golf (japan).gg",                                                             0x000000 , 0x80000,	 CRC(b1196cd7) SHA1(fb7b3c6652c3105497b8254daf063d25519fea61) )
CONSOLE_ROM_LOAD( ggfredc1, "fred couples' golf (usa).gg",                                                               0x000000 , 0x80000,	 CRC(46f40b9f) SHA1(fc160122f14772fd1c4476effae5a4010a6c012d) )
CONSOLE_ROM_LOAD( ggfrogge, "frogger (usa) (proto).gg",                                                                  0x000000 , 0x20000,	 CRC(02bbf994) SHA1(b917ac6fbd3e5d18c07246f1309d81943ee1dd47) )
CONSOLE_ROM_LOAD( ggfromtv, "from tv animation - slam dunk - shouri e no starting 5 (japan).gg",                         0x000000 , 0x80000,	 CRC(751dad4c) SHA1(bee62a373655d0ef931d8b9a4ed88fb0f4d1a8bc) )
CONSOLE_ROM_LOAD( ggglocai, "g-loc air battle (japan) (v1.1).gg",                                                        0x000000 , 0x20000,	 CRC(33237f50) SHA1(033c65e52011fd6b9be86ecb0f5d8209dbbdbbca) )
CONSOLE_ROM_LOAD( gggloca1, "g-loc air battle (japan).gg",                                                               0x000000 , 0x20000,	 CRC(2333f615) SHA1(ed32016476e40fde06d8a1a9777875b75d49adf6) )
CONSOLE_ROM_LOAD( gggloca2, "g-loc air battle (usa, europe).gg",                                                         0x000000 , 0x20000,	 CRC(18de59ed) SHA1(407da6e4d0916d3f54ad1ba8d45face04dad5657) )
CONSOLE_ROM_LOAD( gggalaga, "galaga '91 (japan).gg",                                                                     0x000000 , 0x20000,	 CRC(0593ba24) SHA1(7cd59fc473b9b1a1fdd659fdec2ae6cb1d3f471a) )
CONSOLE_ROM_LOAD( gggalag1, "galaga 2 (europe).gg",                                                                      0x000000 , 0x20000,	 CRC(95ecece2) SHA1(33b552eb21ef4bf5cf10ab18afa9f2fbcd6635cd) )
CONSOLE_ROM_LOAD( gggamble, "gamble panic (japan).gg",                                                                   0x000000 , 0x80000,	 CRC(09534742) SHA1(d33cd19676fdb0e6180a24ed406a61cdf30f0065) )
CONSOLE_ROM_LOAD( gggambl1, "gambler jikochuushinha (japan).gg",                                                         0x000000 , 0x40000,	 CRC(423803a7) SHA1(ec26aa5f41f8abf1c0fa911c2031ac422f6280a6) )
CONSOLE_ROM_LOAD( ggganbar, "ganbare gorby! (japan).gg",                                                                 0x000000 , 0x20000,	 CRC(a1f2f4a1) SHA1(cd3e8910a99bf6717e63aed3aa212ead0597e5cd) )
CONSOLE_ROM_LOAD( gggarfie, "garfield - caught in the act (usa, europe).gg",                                             0x000000 , 0x100000,	 CRC(cd53f3af) SHA1(dc65f458cad3c165d0963b9b6da258d438da2ef7) )
CONSOLE_ROM_LOAD( gggaroud, "garou densetsu special (japan).gg",                                                         0x000000 , 0x80000,	 CRC(9afb6f33) SHA1(ec2f11e28bff47d149df1987673f80da08c1af6d) )
CONSOLE_ROM_LOAD( gggearst, "gear stadium (japan).gg",                                                                   0x000000 , 0x20000,	 CRC(0e300223) SHA1(10124c1ca517fa933ca0488f288d205b0cc80d9c) )
CONSOLE_ROM_LOAD( gggears1, "gear stadium heiseiban (japan).gg",                                                         0x000000 , 0x20000,	 CRC(a0530664) SHA1(210fef406c4fe8e0ed995f92ea7597e8f1b7f91c) )
CONSOLE_ROM_LOAD( gggearwo, "gear works (usa).gg",                                                                       0x000000 , 0x20000,	 CRC(e9a2efb4) SHA1(dc71c749c4a78e28922e10df645d23cc8289531f) )
CONSOLE_ROM_LOAD( gggeorge, "george foreman's ko boxing (usa, europe).gg",                                               0x000000 , 0x20000,	 CRC(58b44585) SHA1(5b3e3e3b88079108a4379c2428e70007d62c7b51) )
CONSOLE_ROM_LOAD( ggggales, "gg aleste (japan).gg",                                                                      0x000000 , 0x40000,	 CRC(1b80a75b) SHA1(4c13dc3601a1702692c35eb6c89f0e09ab966f69) )
CONSOLE_ROM_LOAD( ggggdora, "gg doraemon - noranosuke no yabou (japan).gg",                                              0x000000 , 0x40000,	 CRC(9a8b2c16) SHA1(6976b170879767889994b1e763a52726aa62ed98) )
CONSOLE_ROM_LOAD( ggggport, "gg portrait - pai chen (japan).gg",                                                         0x000000 , 0x80000,	 CRC(695cc120) SHA1(cf752897523814951401994c95de299cd42fdb50) )
CONSOLE_ROM_LOAD( ggggpor1, "gg portrait - yuuki akira (japan).gg",                                                      0x000000 , 0x80000,	 CRC(51159f8f) SHA1(4cbb453663665a06e986a6ab015a041463b48373) )
CONSOLE_ROM_LOAD( ggggshin, "gg shinobi, the (japan).gg",                                                                0x000000 , 0x40000,	 CRC(83926bd1) SHA1(c5e1c2329f94f0804140792a3e3d5be2ac0d5d0d) )
CONSOLE_ROM_LOAD( gggodzil, "godzilla - kaijuu daishingeki (japan).gg",                                                  0x000000 , 0x80000,	 CRC(4cf97801) SHA1(ff3e8905635a02eb85556146225020b52506424c) )
CONSOLE_ROM_LOAD( gggpride, "gp rider (japan).gg",                                                                       0x000000 , 0x80000,	 CRC(7a26ec6a) SHA1(b1c4315dc4afe58256f3834cff8e94c6b02bc1b6) )
CONSOLE_ROM_LOAD( gggprid1, "gp rider (prototype - jan 04, 1994).gg",                                0x000000 , 0x80000,	 CRC(12e4f6db) SHA1(5e13822bf04facc19d44a718635647ad4db6cd2a) )
CONSOLE_ROM_LOAD( gggprid2, "gp rider (usa, europe).gg",                                                                 0x000000 , 0x80000,	 CRC(876e9b72) SHA1(7777f091c8b540d3248fd7c0fb21e742af6f0ede) )
CONSOLE_ROM_LOAD( gggreend, "greendog (usa, europe).gg",                                                                 0x000000 , 0x40000,	 CRC(f27925b0) SHA1(b5bf962000636bb1cbdf134759baa1e25b25d097) )
CONSOLE_ROM_LOAD( gggriffi, "griffin (japan).gg",                                                                        0x000000 , 0x20000,	 CRC(a93e8b0f) SHA1(b479d977533398cef21ef9ff7cd8fc81bdbfa488) )
CONSOLE_ROM_LOAD( gggunsta, "gunstar heroes (japan).gg",                                                                 0x000000 , 0x80000,	 CRC(c3c52767) SHA1(c373d3876659095bb869ff0e4bb7ffc68123cf3e) )
CONSOLE_ROM_LOAD( gghalley, "halley wars (japan).gg",                                                                    0x000000 , 0x20000,	 CRC(def5a5d0) SHA1(1c9932f592bb12e61acf597985e0bd5041e45da5) )
CONSOLE_ROM_LOAD( gghalle1, "halley wars (usa, europe).gg",                                                              0x000000 , 0x20000,	 CRC(7e9dea46) SHA1(77637e9916a774529d971370c1509eec0b7e1651) )
CONSOLE_ROM_LOAD( ggheadbu, "head buster (japan).gg",                                                                    0x000000 , 0x20000,	 CRC(7e689995) SHA1(51432c7892d87b31f5f3216d3ef01eadc591b768) )
CONSOLE_ROM_LOAD( ggheavyw, "heavy weight champ (japan).gg",                                                             0x000000 , 0x20000,	 CRC(beed9150) SHA1(7cfd703ebdab4b2665f402adeac0060740615b6c) )
CONSOLE_ROM_LOAD( gghomeal, "home alone (usa, europe).gg",                                                               0x000000 , 0x40000,	 CRC(dde29f74) SHA1(abad566f587affcb35102ed5b45c4e3a8ee22dc9) )
CONSOLE_ROM_LOAD( gghonoon, "honoo no toukyuuji - dodge danpei (japan).gg",                                              0x000000 , 0x20000,	 CRC(dfa805a0) SHA1(66032cc214d728b2f1c59ad2934277e378b36865) )
CONSOLE_ROM_LOAD( gghookus, "hook (usa, europe).gg",                                                                     0x000000 , 0x40000,	 CRC(f53ced2e) SHA1(b9bd292fa4f3ef7dd86ebae9e1b5364ce6653c45) )
CONSOLE_ROM_LOAD( gghurric, "hurricanes (europe).gg",                                                                    0x000000 , 0x80000,	 CRC(0a25eec5) SHA1(d4f0a691f11de7d91ede6ff95d26343a50840eb1) )
CONSOLE_ROM_LOAD( gghyokko, "hyokkori hyoutan jima - hyoutan jima no daikoukai (japan).gg",                              0x000000 , 0x20000,	 CRC(42389270) SHA1(0b0270060342f4e79d58104a85a7be04426683bd) )
CONSOLE_ROM_LOAD( gghyperp, "hyper pro yakyuu '92 (japan).gg",                                                           0x000000 , 0x20000,	 CRC(056cae74) SHA1(245699bff66440b1e4483e8d68e468bbc3ba6ab3) )
CONSOLE_ROM_LOAD( ggichida, "ichidant~r gg (japan).gg",                                                                  0x000000 , 0x80000,	 CRC(9f64c2bb) SHA1(34f95713ae3fbd91452eb71ce1721ead153517e5) )
CONSOLE_ROM_LOAD( gginthew, "in the wake of vampire (japan).gg",                                                         0x000000 , 0x40000,	 CRC(dab0f265) SHA1(da5116b7ed890f35506c5b33c5c9716f528169b1) )
CONSOLE_ROM_LOAD( ggincred, "incredible crash dummies, the (usa, europe).gg",                                            0x000000 , 0x40000,	 CRC(087fc247) SHA1(6858554fc26f2382a262736854496e11f0925d40) )
CONSOLE_ROM_LOAD( ggincre1, "incredible hulk, the (usa, europe).gg",                                                     0x000000 , 0x80000,	 CRC(d7055f88) SHA1(0410dafce21e5f40263ccb39871188ca84f7dd22) )
CONSOLE_ROM_LOAD( ggindian, "indiana jones and the last crusade (u).gg",                                                 0x000000 , 0x40000,	 CRC(8c048325) SHA1(a171c8f9ded70023588a3736f8b031d45b6c32de) )
CONSOLE_ROM_LOAD( ggindia1, "indiana jones and the last crusade (usa, europe).gg",                                       0x000000 , 0x40000,	 CRC(b875226b) SHA1(2607f99263c8dd732d199b2357400638e08402ec) )
CONSOLE_ROM_LOAD( ggironma, "iron man x-o manowar in heavy metal (u) [a1].gg",                                           0x000000 , 0x80000,	 CRC(847ae5ce) SHA1(609edf453719c82b044e5f6d89152241b637de77) )
CONSOLE_ROM_LOAD( ggironm1, "iron man x-o manowar in heavy metal (usa, europe).gg",                                      0x000000 , 0x80000,	 CRC(8927b69b) SHA1(3da4166c88ee24ab86a18554ae7c5ee7bce42f11) )
CONSOLE_ROM_LOAD( ggitchys, "itchy & scratchy game, the (usa, europe).gg",                                               0x000000 , 0x40000,	 CRC(44e7e2da) SHA1(2d0c2be09b977cc68a7e8f0fc415d8783ad7f8ae) )
CONSOLE_ROM_LOAD( ggjleagu, "j.league gg pro striker '94 (japan).gg",                                                    0x000000 , 0x80000,	 CRC(a12a28a0) SHA1(04248e53ce54c9f17daae9885fed87d39f0117b6) )
CONSOLE_ROM_LOAD( ggjleag1, "j.league soccer - dream eleven (japan).gg",                                                 0x000000 , 0x80000,	 CRC(abddf0eb) SHA1(bed727b732712f115ddc4dc5fd873e6cd3787b62) )
CONSOLE_ROM_LOAD( ggjamesb, "james bond 007 - the duel (europe).gg",                                                     0x000000 , 0x40000,	 CRC(881a4524) SHA1(6e2124b40db7d1fc22b4f1e41565710500611d8e) )
CONSOLE_ROM_LOAD( ggjamesp, "james pond 3 - operation starfi5h (europe).gg",                                             0x000000 , 0x80000,	 CRC(68bb7f71) SHA1(53790edee813a0a444b0369fd15672bb2a343780) )
CONSOLE_ROM_LOAD( ggjames1, "james pond ii - codename robocod (usa).gg",                                                 0x000000 , 0x80000,	 CRC(9fb5c155) SHA1(6c4a9c1613bc436033b54914acaf951c62593972) )
CONSOLE_ROM_LOAD( ggjangpu, "jang pung ii (k) [s].gg",                                                                   0x000000 , 0x40000,	 CRC(76c5bdfb) SHA1(2b3bb8fd76fe706d7e564b372d2d71dfce53cb1b) )
CONSOLE_ROM_LOAD( ggjeopar, "jeopardy! (usa).gg",                                                                        0x000000 , 0x40000,	 CRC(d7820c21) SHA1(28ef5cc2689a1f3bc3bd1b24c3e4132a423fc274) )
CONSOLE_ROM_LOAD( ggjeopa1, "jeopardy! - sports edition (usa, europe).gg",                                               0x000000 , 0x40000,	 CRC(2dd850b7) SHA1(55cb5cb3c37e8403ebf4a47560f0ece416323c56) )
CONSOLE_ROM_LOAD( ggjoemon, "joe montana's football (japan).gg",                                                         0x000000 , 0x40000,	 CRC(4a98678b) SHA1(253196b98d83b910c289b0211b6de025c66c916c) )
CONSOLE_ROM_LOAD( ggjoemo1, "joe montana's football (usa, europe).gg",                                                   0x000000 , 0x40000,	 CRC(2e01ba6c) SHA1(24c3b2cd18967b7141850d4f63b4992c3dad3ad4) )
CONSOLE_ROM_LOAD( ggjourne, "journey from darkness - strider returns (usa, europe).gg",                                  0x000000 , 0x40000,	 CRC(1ebfa5ca) SHA1(ed5d1fc5ba8a47992551b0d577c1a6a06d0f7ac2) )
CONSOLE_ROM_LOAD( ggjudged, "judge dredd (usa, europe).gg",                                                              0x000000 , 0x80000,	 CRC(04d23fc4) SHA1(4c9d00faeb4454a8f538b5ccc6453b3464930afa) )
CONSOLE_ROM_LOAD( ggjuncti, "junction (usa, europe).gg",                                                                 0x000000 , 0x20000,	 CRC(a8ef36a7) SHA1(70cac7959d29903ad22316e9f5edf60834381d27) )
CONSOLE_ROM_LOAD( ggjungle, "jungle book, the (europe).gg",                                                              0x000000 , 0x40000,	 CRC(90100884) SHA1(14a5d4ea99ee91aec948d62cab56fc1c05cc7c45) )
CONSOLE_ROM_LOAD( ggjungl1, "jungle book, the (usa).gg",                                                                 0x000000 , 0x40000,	 CRC(30c09f31) SHA1(f9da97db661f8ef7e7af87a83d23100c2fed4fb0) )
CONSOLE_ROM_LOAD( ggjurass, "jurassic park (japan).gg",                                                                  0x000000 , 0x80000,	 CRC(2f536ae3) SHA1(89486678a6a065c56102296eebc7b25c5ef32d21) )
CONSOLE_ROM_LOAD( ggjuras1, "jurassic park (usa, europe).gg",                                                            0x000000 , 0x80000,	 CRC(bd6f2321) SHA1(0425dc09465a4b7be78ab7aa46107987ba61e82a) )
CONSOLE_ROM_LOAD( ggkaitou, "kaitou saint tale (japan).gg",                                                              0x000000 , 0x80000,	 CRC(937fd52b) SHA1(3e4e7ec4a4ce5d48baed7d583ede8bb9f92a44a6) )
CONSOLE_ROM_LOAD( ggkawasa, "kawasaki superbike challenge (usa, europe).gg",                                             0x000000 , 0x40000,	 CRC(23f9150a) SHA1(7b0801c4ad6c15546f61decf2620f198b990425d) )
CONSOLE_ROM_LOAD( ggkenyuu, "kenyuu densetsu yaiba (japan).gg",                                                          0x000000 , 0x80000,	 CRC(d9ce3f4c) SHA1(21b08c5c4b086e169d5f780cafc22c041e19807b) )
CONSOLE_ROM_LOAD( ggkickru, "kick & rush (japan).gg",                                                                    0x000000 , 0x40000,	 CRC(fd14ce00) SHA1(d1c04a94a21684be2e83fbd0e0677bbc8ef86f57) )
CONSOLE_ROM_LOAD( ggkineti, "kinetic connection (japan).gg",                                                             0x000000 , 0x20000,	 CRC(4af7f2aa) SHA1(7447e0ad5e8e14c3ae05a274d393ca34de044855) )
CONSOLE_ROM_LOAD( ggkishin, "kishin douji zenki (japan).gg",                                                             0x000000 , 0x80000,	 CRC(7d622bdd) SHA1(0fb3530633070551f3d5a04839fc42babc092fbd) )
CONSOLE_ROM_LOAD( ggklaxus, "klax (usa, europe).gg",                                                                     0x000000 , 0x20000,	 CRC(9b40fc8e) SHA1(4705bbc862169cdfeb3b30dba6f274b094ab99b3) )
CONSOLE_ROM_LOAD( ggkrusty, "krusty's fun house (usa, europe).gg",                                                       0x000000 , 0x40000,	 CRC(d01e784f) SHA1(a24fd153669e0c38d55ff939e1ea52b6a316ad0d) )
CONSOLE_ROM_LOAD( ggkunich, "kuni-chan no game tengoku (japan).gg",                                                      0x000000 , 0x40000,	 CRC(398f2358) SHA1(497f137e0f33b45a1560f51ca06b2bfaef51484a) )
CONSOLE_ROM_LOAD( ggkunic1, "kuni-chan no game tengoku part 2 (japan).gg",                                               0x000000 , 0x40000,	 CRC(f3774c65) SHA1(f11af70a52cfd96ad4d03da8ca9227ddd5bcc382) )
CONSOLE_ROM_LOAD( gglandof, "land of illusion starring mickey mouse (usa, europe).gg",                                   0x000000 , 0x80000,	 CRC(52dbf3e1) SHA1(5975bf7d01c84b9433c2859e6d38d26545fd3bc9) )
CONSOLE_ROM_LOAD( gglastac, "last action hero (usa).gg",                                                                 0x000000 , 0x40000,	 CRC(2d367c43) SHA1(340e0e8ab5b4e89f6d56bc30cabf8322e79b2347) )
CONSOLE_ROM_LOAD( gglegend, "legend of illusion starring mickey mouse (prototype - oct 11, 1994).gg",0x000000 , 0x80000,	 CRC(f9d4cee9) SHA1(13c6f75a1360a76673bcebdf18b9735ddaa113c7) )
CONSOLE_ROM_LOAD( gglegen1, "legend of illusion starring mickey mouse (prototype - oct 14, 1994).gg",0x000000 , 0x80000,	 CRC(670ede92) SHA1(98c4adaf6e74d960760f686f256f63bc887c1a2b) )
CONSOLE_ROM_LOAD( gglegen2, "legend of illusion starring mickey mouse (prototype - oct 17, 1994).gg",0x000000 , 0x80000,	 CRC(de8545af) SHA1(ccbcda1e7d74e0bfe94ecb1214d4ca1a5d1504ab) )
CONSOLE_ROM_LOAD( gglegen3, "legend of illusion starring mickey mouse (prototype - sep 22, 1994).gg",0x000000 , 0x80000,	 CRC(1cc16ad9) SHA1(2d78a5b6449c9d20cd03156a56cbc6bc10c2ef68) )
CONSOLE_ROM_LOAD( gglegen4, "legend of illusion starring mickey mouse (prototype - sep 30, 1994 - sel).gg",0x000000 , 0x80000,	 CRC(a0565a5c) SHA1(14f266482bfd25238c6e44087c26aca329d4fa64) )
CONSOLE_ROM_LOAD( gglegen5, "legend of illusion starring mickey mouse (prototype - sep 30, 1994).gg",0x000000 , 0x80000,	 CRC(63020617) SHA1(94ec7c72e2fb6e4bd51ef55eac9646fb2fa8d791) )
CONSOLE_ROM_LOAD( gglegen6, "legend of illusion starring mickey mouse (usa, europe).gg",                                 0x000000 , 0x80000,	 CRC(ce5ad8b7) SHA1(fa1200fd34a81796222eae97175c2fb72a77e970) )
CONSOLE_ROM_LOAD( gglemmin, "lemmings (world) (beta).gg",                                                                0x000000 , 0x40000,	 CRC(51548f61) SHA1(31b9926efff652151c8390529fc2c8a211aafb0b) )
CONSOLE_ROM_LOAD( gglemmi1, "lemmings (world).gg",                                                                       0x000000 , 0x40000,	 CRC(0fde7baa) SHA1(5a79b6fa15b7085fc7062945f0e6d469d49871e1) )
CONSOLE_ROM_LOAD( gglionki, "lion king, the (e) [t1].gg",                                                                0x000000 , 0x80000,	 CRC(040512ce) SHA1(64d02b7791865d295474b3661c5b6bc10d64e979) )
CONSOLE_ROM_LOAD( gglionk1, "lion king, the (europe).gg",                                                                0x000000 , 0x80000,	 CRC(0cd9c20b) SHA1(49f00887a297f70a51711fe18433bc168ec49fc9) )
CONSOLE_ROM_LOAD( gglionk2, "lion king, the (prototype - aug 03, 1994).gg",                          0x000000 , 0x7d909,	 CRC(aacb7387) SHA1(6d71ff5dfd04ec1641b0db367b52ae3f23805e60) )
CONSOLE_ROM_LOAD( gglionk3, "lion king, the (prototype - aug 11, 1994).gg",                          0x000000 , 0x7d992,	 CRC(214c13dc) SHA1(9d8fdc7b48f2c09bcbbb30061941e46ddf986e4e) )
CONSOLE_ROM_LOAD( gglionk4, "lion king, the (prototype - aug 12, 1994).gg",                          0x000000 , 0x7d9ae,	 CRC(0e80efe0) SHA1(0e5f5156be26d18f8c2678f7d2400a54b9c51f37) )
CONSOLE_ROM_LOAD( gglionk5, "lion king, the (prototype - aug 13, 1994).gg",                          0x000000 , 0x7d9b2,	 CRC(8250c11e) SHA1(05d6e8f6b8adde3a03ea89f53dd02f02f3366477) )
CONSOLE_ROM_LOAD( gglionk6, "lion king, the (prototype - aug 14, 1994).gg",                          0x000000 , 0x7d9b6,	 CRC(eb10a2d4) SHA1(cdce953f16e4db6e9137ea8d523588b3469a544d) )
CONSOLE_ROM_LOAD( gglionk7, "lion king, the (prototype - aug 15, 1994).gg",                          0x000000 , 0x7d9b6,	 CRC(eb10a2d4) SHA1(cdce953f16e4db6e9137ea8d523588b3469a544d) )
CONSOLE_ROM_LOAD( gglionk8, "lion king, the (prototype - aug 16, 1994).gg",                          0x000000 , 0x7d9b6,	 CRC(c6af9643) SHA1(14c4d13eb118dc5082441f4eddaac229019b2598) )
CONSOLE_ROM_LOAD( gglionk9, "lion king, the (prototype - aug 17, 1994 - 2).gg",                      0x000000 , 0x7da3a,	 CRC(b65030d0) SHA1(d3d44f8cbe32970f2e138c183078b8190808e625) )
CONSOLE_ROM_LOAD( gglion10, "lion king, the (prototype - aug 17, 1994).gg",                          0x000000 , 0x7d9ea,	 CRC(4214c474) SHA1(6301d8ede680007e645c84d24064df5e76ea996b) )
CONSOLE_ROM_LOAD( gglion11, "lion king, the (prototype - aug 20, 1994).gg",                          0x000000 , 0x7fe56,	 CRC(3d0b31a2) SHA1(79f221ca2654d5df64392e4e06c498557eaebf19) )
CONSOLE_ROM_LOAD( gglion12, "lion king, the (u) [t1].gg",                                                                0x000000 , 0x80000,	 CRC(90d40776) SHA1(151dc547dc42c214052b3ee8b2f686b73a17d200) )
CONSOLE_ROM_LOAD( gglion13, "lion king, the (usa).gg",                                                                   0x000000 , 0x80000,	 CRC(9808d7b3) SHA1(e21025b2f6d5bbc18107905ad6c0c58d061d9c17) )
CONSOLE_ROM_LOAD( gglostwo, "lost world, the - jurassic park (usa).gg",                                                  0x000000 , 0x100000,	 CRC(8d1597f5) SHA1(1730b85fac5478da92b0905c6525e715bb4470d4) )
CONSOLE_ROM_LOAD( ggluckyd, "lucky dime caper, the (usa, europe).gg",                                                    0x000000 , 0x40000,	 CRC(07a7815a) SHA1(5cc5caa887a63c580c1e3ff344a4b0ade643f24b) )
CONSOLE_ROM_LOAD( gglunars, "lunar - sanposuru gakuen (japan).gg",                                                       0x000000 , 0x80000,	 CRC(58459edd) SHA1(1b0cc847d31956d843cadab7d86a2f434220301e) )
CONSOLE_ROM_LOAD( ggmadden, "madden nfl '95 (usa).gg",                                                                   0x000000 , 0x80000,	 CRC(75c71ebf) SHA1(69d900be52502a4630ebcf9073175d8af45b655d) )
CONSOLE_ROM_LOAD( ggmadde1, "madden nfl '96 (u) [!].gg",                                                                 0x000000 , 0x80000,	 CRC(75e273eb) SHA1(73fb57977b2e1aa96003b4c15a38885ccd3f51a1) )
CONSOLE_ROM_LOAD( ggmadde2, "madden nfl '96 (usa, europe).gg",                                                           0x000000 , 0x80000,	 CRC(9f59d302) SHA1(49412ebef31558afd8cb534c6914f5612eaa25b1) )
CONSOLE_ROM_LOAD( ggmadoum, "madou monogatari a - dokidoki vacation (japan).gg",                                         0x000000 , 0x80000,	 CRC(7ec95282) SHA1(c027aa76fe0e09a2d1b982eea0df2c8b687aadf7) )
CONSOLE_ROM_LOAD( ggmadou1, "madou monogatari i - 3-tsu no madoukyuu (japan).gg",                                        0x000000 , 0x80000,	 CRC(00c34d94) SHA1(5ccd474cefcb8e086e2e1f77c0fdd5c1d2bf82e7) )
CONSOLE_ROM_LOAD( ggmadou2, "madou monogatari ii - arle 16-sai (japan).gg",                                              0x000000 , 0x80000,	 CRC(12eb2287) SHA1(deead79fa4cb2e87652a9c8a76f2a7174f48f37a) )
CONSOLE_ROM_LOAD( ggmadou3, "madou monogatari iii - kyuukyoku joou-sama (japan) (v1.1).gg",                              0x000000 , 0x80000,	 CRC(568f4825) SHA1(673670f954176ffab28a0280aa49856a457f36b1) )
CONSOLE_ROM_LOAD( ggmadou4, "madou monogatari iii - kyuukyoku joou-sama (japan).gg",                                     0x000000 , 0x80000,	 CRC(0a634d79) SHA1(dd590c9086161b1f97573c48720c32cc5506dabc) )
CONSOLE_ROM_LOAD( ggmagick, "magic knight rayearth (japan).gg",                                                          0x000000 , 0x80000,	 CRC(8f82a6b9) SHA1(6c13e3b9bb24eafc1186c5ffa322b1f40c676b3d) )
CONSOLE_ROM_LOAD( ggmagic1, "magic knight rayearth 2 - making of magic knight (japan).gg",                               0x000000 , 0x80000,	 CRC(1c2c2b04) SHA1(29615d86057f3323ecda75d47102e77d364f6499) )
CONSOLE_ROM_LOAD( ggmagica, "magical puzzle popils (world) (en,ja).gg",                                                  0x000000 , 0x20000,	 CRC(cf6d7bc5) SHA1(fb939f0810d0763b9abaeec1a2bfbabacaad5441) )
CONSOLE_ROM_LOAD( ggmagic2, "magical taruruuto-kun (japan).gg",                                                          0x000000 , 0x20000,	 CRC(6e1cc23c) SHA1(40fae12f1d565849158ff87700e25d6967038867) )
CONSOLE_ROM_LOAD( ggmajors, "majors pro baseball, the (usa).gg",                                                         0x000000 , 0x40000,	 CRC(36ebcd6d) SHA1(76f3c504d717067134a88f7f1d0ef38bd6698e50) )
CONSOLE_ROM_LOAD( ggmappyj, "mappy (japan).gg",                                                                          0x000000 , 0x20000,	 CRC(01d2dd2a) SHA1(44d0b857d88a293da47dc161115422d830d81302) )
CONSOLE_ROM_LOAD( ggmarble, "marble madness (usa, europe).gg",                                                           0x000000 , 0x40000,	 CRC(9559e339) SHA1(42c5cd5afebbf860a8ad80ea684f9b216762109e) )
CONSOLE_ROM_LOAD( ggmarkos, "marko's magic football (europe) (en,fr,de,es).gg",                                          0x000000 , 0x80000,	 CRC(22c418bf) SHA1(f255d7ea194d88a1588a2bf3ff34926de17c7ff1) )
CONSOLE_ROM_LOAD( ggmegama, "mega man (usa, europe).gg",                                                                 0x000000 , 0x80000,	 CRC(1ace93af) SHA1(085517c4ac940b937d0e0a900e4735a2247ca4dd) )
CONSOLE_ROM_LOAD( ggmegami, "megami tensei gaiden - last bible (japan).gg",                                              0x000000 , 0x80000,	 CRC(2e4ec17b) SHA1(d98332eba27fd4a0db82d551a54bee4fdccf41a2) )
CONSOLE_ROM_LOAD( ggmegam1, "megami tensei gaiden - last bible s (japan).gg",                                            0x000000 , 0x80000,	 CRC(4ec30806) SHA1(ca597064a8f0dd8221e89655584ec0cc67dbe026) )
CONSOLE_ROM_LOAD( ggmickma, "mick & mack as the global gladiators (usa, europe).gg",                                     0x000000 , 0x40000,	 CRC(d2b6021e) SHA1(ddad863406d429acb218c75042d5e5c511bdad4f) )
CONSOLE_ROM_LOAD( ggmickey, "mickey mouse densetsu no oukoku - legend of illusion (japan).gg",                           0x000000 , 0x80000,	 CRC(fe12a92f) SHA1(cdcde96fe2a86fc2c404e7746c8670c44f8e169c) )
CONSOLE_ROM_LOAD( ggmicke1, "mickey mouse no castle illusion (japan).sms",                                               0x000000 , 0x40000,	 CRC(9942b69b) SHA1(d2580137c641192d7faa98dbf8c715623e7d0bed) )
CONSOLE_ROM_LOAD( ggmicke2, "mickey mouse no mahou no crystal (japan).gg",                                               0x000000 , 0x80000,	 CRC(0117c3df) SHA1(5cc1a27f801491971e20551b9b9b4388245c0478) )
CONSOLE_ROM_LOAD( ggmicke3, "mickey's ultimate challenge (usa, europe).gg",                                              0x000000 , 0x40000,	 CRC(eccf7a4f) SHA1(f62c129b5142d3dac66392b521003111b9291b3e) )
CONSOLE_ROM_LOAD( ggmicrom, "micro machines (europe).gg",                                                                0x000000 , 0x40000,	 CRC(f7c524f6) SHA1(7b2d39b68622e18eac6c27fd961133b1d002342b) )
CONSOLE_ROM_LOAD( ggmicro1, "micro machines 2 - turbo tournament (europe).gg",                                           0x000000 , 0x80000,	 CRC(dbe8895c) SHA1(53ad6546462638ab246b4fdd7ca4b8966dde0d96) )
CONSOLE_ROM_LOAD( ggmighty, "mighty morphin power rangers (prototype - jul 16, 1994).gg",            0x000000 , 0x80000,	 CRC(2887f04a) SHA1(88a90ac68fe67872cdee9c4ab2b77595347297eb) )
CONSOLE_ROM_LOAD( ggmight1, "mighty morphin power rangers (usa, europe).gg",                                             0x000000 , 0x80000,	 CRC(9289dfcc) SHA1(86c4d12257faf355623f47f8fa22da23a3b36cd9) )
CONSOLE_ROM_LOAD( ggmight2, "mighty morphin power rangers - the movie (prototype - may 30, 1995).gg",0x000000 , 0x80000,	 CRC(8c665203) SHA1(ad8fa368c86687d99587aec697ed9f7b47c918b4) )
CONSOLE_ROM_LOAD( ggmight3, "mighty morphin power rangers - the movie (usa, europe).gg",                                 0x000000 , 0x80000,	 CRC(b47c19e5) SHA1(dfe7dc7b2df143da4f4eeb32051a6d373dddba5d) )
CONSOLE_ROM_LOAD( ggmlbpab, "mlbpa baseball (usa).gg",                                                                   0x000000 , 0x80000,	 CRC(1ecf07b4) SHA1(74c7433ae9807a0042741d1945472eafd88b48cd) )
CONSOLE_ROM_LOAD( ggmoldor, "moldorian - hikari to yami no sister (japan).gg",                                           0x000000 , 0x80000,	 CRC(4d5d15fb) SHA1(0dad260b5357b2f61d1452bb73d8321ca53d7262) )
CONSOLE_ROM_LOAD( ggmonste, "monster truck wars (usa, europe).gg",                                                       0x000000 , 0x40000,	 CRC(453c5cec) SHA1(f493d5aebef88b44cadcb3459d214a6c3ba155c8) )
CONSOLE_ROM_LOAD( ggmonst1, "monster world ii - dragon no wana (japan).gg",                                              0x000000 , 0x40000,	 CRC(ea89e0e7) SHA1(5c4d25432512852f48f22280544bd7d034aab744) )
CONSOLE_ROM_LOAD( ggmortal, "mortal kombat (japan) (v3.3).gg",                                                           0x000000 , 0x80000,	 CRC(dbff0461) SHA1(f28e50f1283d7a2516267a13a16a3e6914ae0a18) )
CONSOLE_ROM_LOAD( ggmorta1, "mortal kombat (usa, europe) (v2.6).gg",                                                     0x000000 , 0x80000,	 CRC(07494f2a) SHA1(ef634649b846b3f49d2c68739b36019e4fae0464) )
CONSOLE_ROM_LOAD( ggmorta2, "mortal kombat 3 (europe).gg",                                                               0x000000 , 0x80000,	 CRC(c2be62bb) SHA1(034ecd615609efb4d96669dda7f32f546d5782f8) )
CONSOLE_ROM_LOAD( ggmorta3, "mortal kombat ii (world).gg",                                                               0x000000 , 0x80000,	 CRC(4b304e0f) SHA1(320d2b8b62ef0109621bbe609b02bd8b0769a0b9) )
CONSOLE_ROM_LOAD( ggmspacm, "ms. pac-man (usa).gg",                                                                      0x000000 , 0x20000,	 CRC(5ee88bd5) SHA1(dbba762b62e786be2c1df30a595cf3bc11b106c5) )
CONSOLE_ROM_LOAD( ggnazopu, "nazo puyo (japan).gg",                                                                      0x000000 , 0x20000,	 CRC(bcce5fd4) SHA1(6ad654e11067ed12437022fcf22b9fea9be7ac46) )
CONSOLE_ROM_LOAD( ggnazop1, "nazo puyo 2 (japan).gg",                                                                    0x000000 , 0x40000,	 CRC(73939de4) SHA1(dbd511aff622c618eac0c21de36965b869362dbd) )
CONSOLE_ROM_LOAD( ggnazop2, "nazo puyo arle no roux (japan) (development edition).gg",                                   0x000000 , 0x40000,	 CRC(4c874466) SHA1(23d51aa54d04a145a9df457135b088eef359d46a) )
CONSOLE_ROM_LOAD( ggnazop3, "nazo puyo arle no roux (japan).gg",                                                         0x000000 , 0x40000,	 CRC(54ab42a4) SHA1(20308b7389a9e860697a66510d4925d1af3b769a) )
CONSOLE_ROM_LOAD( ggnbaact, "nba action (usa).gg",                                                                       0x000000 , 0x40000,	 CRC(19030108) SHA1(b81b3740e6dbc931dc4a867a8aabdb971492e2b1) )
CONSOLE_ROM_LOAD( ggnbaac1, "nba action starring david robinson (final a - feb 28, 1994).gg",        0x000000 , 0x40000,	 CRC(d15aa940) SHA1(54060a0430a898f9ac32eb685758f5144a347531) )
CONSOLE_ROM_LOAD( ggnbaac2, "nba action starring david robinson (final b - mar 01, 1994).gg",        0x000000 , 0x40000,	 CRC(4415c0bb) SHA1(d7062bdecbb42c1869ba70f5d6eed441607e8bd8) )
CONSOLE_ROM_LOAD( ggnbaac3, "nba action starring david robinson (final c - mar 02, 1994).gg",        0x000000 , 0x40000,	 CRC(5254577a) SHA1(41124a549e9b5362b496709f61ce6710df6caec2) )
CONSOLE_ROM_LOAD( ggnbaac4, "nba action starring david robinson (final d - mar 03, 1994).gg",        0x000000 , 0x40000,	 CRC(75a5bc5d) SHA1(226de9e66562f7dd05b0b3265aefa94f86f2a724) )
CONSOLE_ROM_LOAD( ggnbaac5, "nba action starring david robinson (final e - mar 04, 1994).gg",        0x000000 , 0x40000,	 CRC(80c0586c) SHA1(cd2114ce46eec5b0e4bc4f1c4c65926b4c37541a) )
CONSOLE_ROM_LOAD( ggnbaac6, "nba action starring david robinson (final f - mar 04, 1994).gg",        0x000000 , 0x40000,	 CRC(a82049df) SHA1(60e804882a04f376e6914ebd9683268d016d0d69) )
CONSOLE_ROM_LOAD( ggnbaac7, "nba action starring david robinson (final g - mar 05, 1994).gg",        0x000000 , 0x40000,	 CRC(e197a0bb) SHA1(7b6620a9f60d75595df59f3723c8c5b76e6b2d8f) )
CONSOLE_ROM_LOAD( ggnbaac8, "nba action starring david robinson (final h - mar 08, 1994).gg",        0x000000 , 0x40000,	 CRC(c9e98a49) SHA1(0ea3a2656145092d8df00b6a7668599b0ab1b8d3) )
CONSOLE_ROM_LOAD( ggnbaac9, "nba action starring david robinson (prototype - dec 01, 1993).gg",      0x000000 , 0x40000,	 CRC(8c089da5) SHA1(ac01abe3858ac97f31b23104231bb26bb2ee4a6c) )
CONSOLE_ROM_LOAD( ggnbaa10, "nba action starring david robinson (prototype - feb 02, 1994).gg",      0x000000 , 0x40000,	 CRC(f9d5500b) SHA1(6c427db53067dfaf1979422b970b79d6fa55fec8) )
CONSOLE_ROM_LOAD( ggnbaa11, "nba action starring david robinson (prototype - feb 03, 1994).gg",      0x000000 , 0x40000,	 CRC(e2341dce) SHA1(5a4ab43ddd63d3a9198a940479626b427ec39c6a) )
CONSOLE_ROM_LOAD( ggnbaa12, "nba action starring david robinson (prototype - feb 06, 1994).gg",      0x000000 , 0x40000,	 CRC(07649147) SHA1(c0389169ce2b8b619afa6b7e2c5cede667299e64) )
CONSOLE_ROM_LOAD( ggnbaa13, "nba action starring david robinson (prototype - feb 08, 1994).gg",      0x000000 , 0x40000,	 CRC(5e089fbc) SHA1(026cfde6ad4a499fa08ebec57a69cd80239f642b) )
CONSOLE_ROM_LOAD( ggnbaa14, "nba action starring david robinson (prototype - feb 12, 1994).gg",      0x000000 , 0x40000,	 CRC(0c0f6b4c) SHA1(006ce9972fd532abb1b426de2bf02e75dd616bba) )
CONSOLE_ROM_LOAD( ggnbaa15, "nba action starring david robinson (prototype - feb 15, 1994).gg",      0x000000 , 0x40000,	 CRC(e73b02a4) SHA1(6bff3fa4cab82f688a02318b19af57cb21f75ca5) )
CONSOLE_ROM_LOAD( ggnbaa16, "nba action starring david robinson (prototype - feb 17, 1994).gg",      0x000000 , 0x40000,	 CRC(c4b3328c) SHA1(60ebead82b6e30f00ea5ac37f30d854eddc37945) )
CONSOLE_ROM_LOAD( ggnbaa17, "nba action starring david robinson (prototype - feb 20, 1994).gg",      0x000000 , 0x40000,	 CRC(91e3026c) SHA1(eedd9e46158547c80d4c58745a68fe3d083288c2) )
CONSOLE_ROM_LOAD( ggnbaa18, "nba action starring david robinson (prototype - feb 21, 1994).gg",      0x000000 , 0x40000,	 CRC(9265f8c3) SHA1(74716d2e00728bee25985ca2acf0547080699f87) )
CONSOLE_ROM_LOAD( ggnbaa19, "nba action starring david robinson (prototype - feb 24, 1994).gg",      0x000000 , 0x40000,	 CRC(21a79f63) SHA1(bfbcb9dc6c2c66108ba8910df7b360f287feb997) )
CONSOLE_ROM_LOAD( ggnbaa20, "nba action starring david robinson (prototype - feb 25, 1994 - b).gg",  0x000000 , 0x40000,	 CRC(188a319e) SHA1(23cdda16537505afa407704f493c0ed4e51d6373) )
CONSOLE_ROM_LOAD( ggnbaa21, "nba action starring david robinson (prototype - feb 25, 1994).gg",      0x000000 , 0x40000,	 CRC(afc8a69e) SHA1(305c1ca1b947694b61cfd896abca5c6f9ec287f3) )
CONSOLE_ROM_LOAD( ggnbaa22, "nba action starring david robinson (prototype - feb 26, 1994).gg",      0x000000 , 0x40000,	 CRC(6896b65d) SHA1(1d75c23394eaf7506f54a4f55a9e2234c35a5b6d) )
CONSOLE_ROM_LOAD( ggnbaa23, "nba action starring david robinson (prototype - feb 27, 1994).gg",      0x000000 , 0x40000,	 CRC(ab721f11) SHA1(a11674848036a8d587c939ac568bc505d811c0ab) )
CONSOLE_ROM_LOAD( ggnbaa24, "nba action starring david robinson (prototype - feb 28, 1994).gg",      0x000000 , 0x40000,	 CRC(82e882d6) SHA1(e9b3acc9c18ff76d3a48400da39eae98f42d3e5d) )
CONSOLE_ROM_LOAD( ggnbaa25, "nba action starring david robinson (prototype - jan 04, 1994).gg",      0x000000 , 0x40000,	 CRC(c658b5b3) SHA1(9f7e49a7881333a0bc8e6c0ad2a6920102bdb23c) )
CONSOLE_ROM_LOAD( ggnbaa26, "nba action starring david robinson (prototype - jan 06, 1994).gg",      0x000000 , 0x40000,	 CRC(41dabd84) SHA1(01bb6913099fedbc2cf0193351f8a307facad3df) )
CONSOLE_ROM_LOAD( ggnbaa27, "nba action starring david robinson (prototype - jan 10, 1994).gg",      0x000000 , 0x40000,	 CRC(a34b2b4c) SHA1(377ccf6af5fd66672e212005529665c3934e4ead) )
CONSOLE_ROM_LOAD( ggnbaa28, "nba action starring david robinson (prototype - jan 24, 1994).gg",      0x000000 , 0x40000,	 CRC(9824f77d) SHA1(d38c5f823bbb8db43bf25a71d57329d7ca7e9087) )
CONSOLE_ROM_LOAD( ggnbaa29, "nba action starring david robinson (prototype - jan 29, 1994).gg",      0x000000 , 0x40000,	 CRC(0d6bf79d) SHA1(866f61bfd3e54dc6963fae24fda1333cdceef32d) )
CONSOLE_ROM_LOAD( ggnbaa30, "nba action starring david robinson (prototype - nov 28, 1993).gg",      0x000000 , 0x40000,	 CRC(31084021) SHA1(6e12de62fe88f12ec28e594871df90a4e42f4f33) )
CONSOLE_ROM_LOAD( ggnbajam, "nba jam (japan).gg",                                                                        0x000000 , 0x80000,	 CRC(a49e9033) SHA1(e7c040a58c8d35bf5b5b556b2d3c55e7a5eb0550) )
CONSOLE_ROM_LOAD( ggnbaja1, "nba jam (usa) (v1.1).gg",                                                                   0x000000 , 0x80000,	 CRC(820fa4ab) SHA1(30bdf6edfb1772054e15edefd69fbe16efd1797a) )
CONSOLE_ROM_LOAD( ggnbaja2, "nba jam (usa, europe).gg",                                                                  0x000000 , 0x80000,	 CRC(8f17597e) SHA1(2de5991810bad1a4120a2698530c66d4dbf16f7c) )
CONSOLE_ROM_LOAD( ggnbaja3, "nba jam tournament edition (usa, europe).gg",                                               0x000000 , 0x80000,	 CRC(86c32e5b) SHA1(c34e318852ca6f52e980c7a63721a145cd167843) )
CONSOLE_ROM_LOAD( ggnekoda, "neko daisuki! (japan).gg",                                                                  0x000000 , 0x80000,	 CRC(3679be80) SHA1(c83fd440895ceb50e4da2ab9db2a29ac21555e9d) )
CONSOLE_ROM_LOAD( ggnfl9pr, "nfl '95 (prototype - aug 08, 1994).gg",                                 0x000000 , 0x80000,	 CRC(8cd96d95) SHA1(2bcaa3b7d0ba5bb5dfb716071f365f6e0248bc0b) )
CONSOLE_ROM_LOAD( ggnfl9p1, "nfl '95 (prototype - aug 25, 1994 - a).gg",                             0x000000 , 0x80000,	 CRC(7f769052) SHA1(0d79198d43250ad4a745da7853050a3db8f2803c) )
CONSOLE_ROM_LOAD( ggnfl9p2, "nfl '95 (prototype - aug 25, 1994 - b).gg",                             0x000000 , 0x80000,	 CRC(fe140eaa) SHA1(b79af203bc01ea1c59563e34105cb36cad158cca) )
CONSOLE_ROM_LOAD( ggnfl9p3, "nfl '95 (prototype - aug 25, 1994).gg",                                 0x000000 , 0x80000,	 CRC(fe140eaa) SHA1(b79af203bc01ea1c59563e34105cb36cad158cca) )
CONSOLE_ROM_LOAD( ggnfl9p4, "nfl '95 (prototype - aug 26, 1994).gg",                                 0x000000 , 0x80000,	 CRC(f77138dd) SHA1(b86fa58449e1544014ffce590efe16678e93f811) )
CONSOLE_ROM_LOAD( ggnfl9p5, "nfl '95 (prototype - aug 31, 1994).gg",                                 0x000000 , 0x80000,	 CRC(a3b046e7) SHA1(d426cd29a03b2341c417c3d5b40f16c4e066f27e) )
CONSOLE_ROM_LOAD( ggnfl9p6, "nfl '95 (prototype - sep 02, 1994).gg",                                 0x000000 , 0x80000,	 CRC(3978387b) SHA1(f2e837a299bc357f8f75e8daaa38159d926d8202) )
CONSOLE_ROM_LOAD( ggnfl9p7, "nfl '95 (prototype - sep 08, 1994).gg",                                 0x000000 , 0x80000,	 CRC(ff70a26f) SHA1(95ef164e629eb5ac88201e2cb1606d305f1881b0) )
CONSOLE_ROM_LOAD( ggnfl9p8, "nfl '95 (prototype - sep 10, 1994).gg",                                 0x000000 , 0x80000,	 CRC(132db489) SHA1(5eebf128b61ce03ea2eb44e5b42ccdf4de80d0ec) )
CONSOLE_ROM_LOAD( ggnfl9p9, "nfl '95 (prototype - sep 11, 1994 - b).gg",                             0x000000 , 0x80000,	 CRC(c57c6afd) SHA1(087c59dace9afbd2cd6b53bfe896f33820b03f5e) )
CONSOLE_ROM_LOAD( ggnfl910, "nfl '95 (prototype - sep 11, 1994 - c).gg",                             0x000000 , 0x80000,	 CRC(088e4b6d) SHA1(7a5c9883fa5775ee357de76e60b5435acfa4f47f) )
CONSOLE_ROM_LOAD( ggnfl911, "nfl '95 (prototype - sep 12, 1994).gg",                                 0x000000 , 0x80000,	 CRC(b38f48b6) SHA1(dc3c1d7b0137d26d79cb7d0be5ed51d551a256d7) )
CONSOLE_ROM_LOAD( ggnfl912, "nfl '95 (prototype - sep 14, 1994 - f).gg",                             0x000000 , 0x80000,	 CRC(2828cb66) SHA1(e76270bfbe8a64173fba9ca14d15679fb340d0c9) )
CONSOLE_ROM_LOAD( ggnfl913, "nfl '95 (prototype - sep 14, 1994).gg",                                 0x000000 , 0x80000,	 CRC(474a162b) SHA1(441468692ee04852424dac693697389c93f44482) )
CONSOLE_ROM_LOAD( ggnfl9us, "nfl '95 (usa).gg",                                                                          0x000000 , 0x80000,	 CRC(dc5b0407) SHA1(d5f2b7b495794f11a9a67e2b34a44d59003f5960) )
CONSOLE_ROM_LOAD( ggnflqua, "nfl quarterback club '96 (usa, europe).gg",                                                 0x000000 , 0x80000,	 CRC(c348e53a) SHA1(fd4167dbc780ff402ba1df2671982ab722c0b3f3) )
CONSOLE_ROM_LOAD( ggnflqu1, "nfl quarterback club (world).gg",                                                           0x000000 , 0x80000,	 CRC(61785ed5) SHA1(ea42bb90eea90a159f8c662743aa59d6dd6f7250) )
CONSOLE_ROM_LOAD( ggnhlall, "nhl all-star hockey (prototype - dec 15, 1994).gg",                     0x000000 , 0x80000,	 CRC(e583d999) SHA1(dec66ddac97c91aebcefc479da79ea086b0ebea8) )
CONSOLE_ROM_LOAD( ggnhlal1, "nhl all-star hockey (prototype - dec 22, 1994).gg",                     0x000000 , 0x80000,	 CRC(dfba792a) SHA1(be689bef9395d698ed5f9629c80762d7f6847393) )
CONSOLE_ROM_LOAD( ggnhlal2, "nhl all-star hockey (prototype - dec 29, 1994).gg",                     0x000000 , 0x80000,	 CRC(e14d071b) SHA1(be2afd53ba0ceb64e9069c4fefd73db5b31ad9e2) )
CONSOLE_ROM_LOAD( ggnhlal3, "nhl all-star hockey (prototype - dec 31, 1994).gg",                     0x000000 , 0x80000,	 CRC(8a2b6323) SHA1(f7d636b7e75853a744c61da7ac3c91766fc34dc7) )
CONSOLE_ROM_LOAD( ggnhlal4, "nhl all-star hockey (prototype - jan 02, 1995).gg",                     0x000000 , 0x80000,	 CRC(2551f22c) SHA1(393d17319e28c5774e7a3f2c336a36f1279d6932) )
CONSOLE_ROM_LOAD( ggnhlal5, "nhl all-star hockey (prototype - jan 03, 1995).gg",                     0x000000 , 0x80000,	 CRC(ece5633b) SHA1(5560ce4cff2f2b4ca7a89c34d295ac11983aa698) )
CONSOLE_ROM_LOAD( ggnhlal6, "nhl all-star hockey (prototype - jan 07, 1995).gg",                     0x000000 , 0x80000,	 CRC(82504476) SHA1(7ff1ee75043b1fe81c7db4b1aeac0f3c3c84c90a) )
CONSOLE_ROM_LOAD( ggnhlal7, "nhl all-star hockey (prototype - jan 11, 1995).gg",                     0x000000 , 0x80000,	 CRC(49f8b9e4) SHA1(c5bc673a9e1c046a13d19151e52022dba3e862ba) )
CONSOLE_ROM_LOAD( ggnhlal8, "nhl all-star hockey (prototype - jan 13, 1995).gg",                     0x000000 , 0x80000,	 CRC(87d8fe13) SHA1(338d8d9a6adaa9f4cc1733a62de76ad240ff1f79) )
CONSOLE_ROM_LOAD( ggnhlal9, "nhl all-star hockey (prototype - jan 16, 1995).gg",                     0x000000 , 0x80000,	 CRC(50dcf5b6) SHA1(5e251060685b00d4b492e1eddfcabfa0d78d42cf) )
CONSOLE_ROM_LOAD( ggnhla10, "nhl all-star hockey (prototype - jan 20 ,1995).gg",                     0x000000 , 0x80000,	 CRC(499b06c2) SHA1(76de1dadc2fb155dbb3b4c17c77aad9e87d93271) )
CONSOLE_ROM_LOAD( ggnhla11, "nhl all-star hockey (prototype - jan 21, 1995).gg",                     0x000000 , 0x80000,	 CRC(16af7995) SHA1(7d0dd9e5d441e6e55d0c31f313c7761cf5860c16) )
CONSOLE_ROM_LOAD( ggnhla12, "nhl all-star hockey (prototype - jan 24, 1995 - a).gg",                 0x000000 , 0x80000,	 CRC(0b1c38f4) SHA1(91e8a0184d77dcd7c484b125b560b113aeaeaeb4) )
CONSOLE_ROM_LOAD( ggnhla13, "nhl all-star hockey (prototype - jan 24, 1995 - b).gg",                 0x000000 , 0x80000,	 CRC(0a4a6830) SHA1(c7c54814c416bd3a1eed38e13a1644fe3f57160e) )
CONSOLE_ROM_LOAD( ggnhla14, "nhl all-star hockey (prototype - jan 24, 1995 - c).gg",                 0x000000 , 0x80000,	 CRC(54f5efb2) SHA1(318b3f3615f7b94e9f375f8b1c7a0a98c2bfe3ab) )
CONSOLE_ROM_LOAD( ggnhla15, "nhl all-star hockey (prototype - jan 24, 1995).gg",                     0x000000 , 0x80000,	 CRC(74be3c4c) SHA1(235a09f13eecd83d6c278a5e476a93004ff78c9b) )
CONSOLE_ROM_LOAD( ggnhla16, "nhl all-star hockey (prototype - jan 25, 1995).gg",                     0x000000 , 0x80000,	 CRC(a587b13e) SHA1(4f6077aa192be69261cbce3ec3ddc35c6d04a0d2) )
CONSOLE_ROM_LOAD( ggnhla17, "nhl all-star hockey (usa).gg",                                                              0x000000 , 0x80000,	 CRC(4680c7aa) SHA1(9556d7a49372ebc8cfe3ab43704ceade86d5fef5) )
CONSOLE_ROM_LOAD( ggnhlhoc, "nhl hockey (usa, europe).gg",                                                               0x000000 , 0x80000,	 CRC(658713a5) SHA1(8f243a6011f769538349c968929a500aff7d3e6d) )
CONSOLE_ROM_LOAD( ggninjag, "ninja gaiden (japan).gg",                                                                   0x000000 , 0x20000,	 CRC(20ef017a) SHA1(acedddaa928a96085544440c2bec2685a6cdf501) )
CONSOLE_ROM_LOAD( ggninja1, "ninja gaiden (usa, europe).gg",                                                             0x000000 , 0x20000,	 CRC(c578756b) SHA1(1a5c44e76a0e913d76f590affae3b2e24fbd0f59) )
CONSOLE_ROM_LOAD( ggninkuj, "ninku (japan).gg",                                                                          0x000000 , 0x80000,	 CRC(c3056e15) SHA1(d22bfa865b34866568f3dd7fccec886170071c81) )
CONSOLE_ROM_LOAD( ggninkut, "ninku 2 - tenkuuryuu e no michi (japan).gg",                                                0x000000 , 0x80000,	 CRC(06247dd2) SHA1(fd6452974da734fcd4292cb0cd728a0ac9aef714) )
CONSOLE_ROM_LOAD( ggninkug, "ninku gaiden - hiroyuki daikatsugeki (japan).gg",                                           0x000000 , 0x80000,	 CRC(9140f239) SHA1(23003e39918f855bd37f58b7b8840960cc82196a) )
CONSOLE_ROM_LOAD( ggnomohi, "nomo hideo no world series baseball (japan).gg",                                            0x000000 , 0x80000,	 CRC(4ed45bda) SHA1(127a7e6706f6d9b129d5cf0dd2bb417e9b108748) )
CONSOLE_ROM_LOAD( ggolympi, "olympic gold (europe) (en,fr,de,es,it,nl,pt,sv) (v1.1).sms",                                0x000000 , 0x40000,	 CRC(1d93246e) SHA1(53fd026008be77cd0cda7080e67a87a7bad33a6a) )
CONSOLE_ROM_LOAD( ggolymp1, "olympic gold (japan, usa) (en,fr,de,es,it,nl,pt,sv).sms",                                   0x000000 , 0x40000,	 CRC(a2f9c7af) SHA1(b7e5ae436ccaa9984297b0c14969922d189cb10c) )
CONSOLE_ROM_LOAD( ggottifa, "ottifants, the (europe) (en,fr,de,es,it).gg",                                               0x000000 , 0x40000,	 CRC(1e673168) SHA1(e66185d8f389ea2c48842f2623349c5cc8b1463d) )
CONSOLE_ROM_LOAD( ggoutrun, "out run (japan).gg",                                                                        0x000000 , 0x20000,	 CRC(d58cb27c) SHA1(284a68102eb71958a3553626ea3dd56485453300) )
CONSOLE_ROM_LOAD( ggoutru1, "out run europa (usa, europe).sms",                                                          0x000000 , 0x40000,	 CRC(f037ec00) SHA1(dd842a7294eee7badf4353fbe3e5d87dd570c671) )
CONSOLE_ROM_LOAD( ggoutru2, "outrun (ju) [a1].gg",                                                                       0x000000 , 0x20000,	 CRC(4753c309) SHA1(25d999bb8edfb59075d774050c68d5c9f286793d) )
CONSOLE_ROM_LOAD( ggpacatt, "pac-attack (usa, europe).gg",                                                               0x000000 , 0x20000,	 CRC(9273ee2c) SHA1(e9e3d7c116e82e7fe696ac3e043d14ece51e9f8e) )
CONSOLE_ROM_LOAD( ggpacint, "pac-in-time (unknown) (proto).gg",                                                          0x000000 , 0x40000,	 CRC(64c28e20) SHA1(bc956615da23f13bddc491377b29631f9c0a4d5a) )
CONSOLE_ROM_LOAD( ggpacman, "pac-man (japan).gg",                                                                        0x000000 , 0x20000,	 CRC(a16c5e58) SHA1(d78b6aac927692f1b67e6a4b7494e2c7e709ae17) )
CONSOLE_ROM_LOAD( ggpanzer, "panzer dragoon mini (japan).gg",                                                            0x000000 , 0x80000,	 CRC(e9783cea) SHA1(c1498f68acb234f46ab6f443f484a48ebd183f0f) )
CONSOLE_ROM_LOAD( ggpaperb, "paperboy (usa, europe).gg",                                                                 0x000000 , 0x20000,	 CRC(f54b6803) SHA1(b1f81f9e2b7197b2fa1475b9cd422479780ef7f2) )
CONSOLE_ROM_LOAD( ggpaper1, "paperboy ii (usa, europe).gg",                                                              0x000000 , 0x40000,	 CRC(8b2c454b) SHA1(2fa97c21bfd9d3968c473b6fa4fb7485b6dfb35d) )
CONSOLE_ROM_LOAD( ggpengoj, "pengo (japan).gg",                                                                          0x000000 , 0x8000,	 CRC(ce863dba) SHA1(5883e2d19ab7126d52abc177a97d44bc88c319de) )
CONSOLE_ROM_LOAD( ggpengou, "pengo (usa, europe).gg",                                                                    0x000000 , 0x8000,	 CRC(0da23cc1) SHA1(e42f85feb631712b8615a0b19bfbf6432633ba00) )
CONSOLE_ROM_LOAD( ggpetclu, "pet club inu daisuki! (japan).gg",                                                          0x000000 , 0x80000,	 CRC(b42d8430) SHA1(0c0bcfd06084419e7c5921f92ccb0f977058c5a3) )
CONSOLE_ROM_LOAD( ggpetesa, "pete sampras tennis (europe).gg",                                                           0x000000 , 0x40000,	 CRC(c1756bee) SHA1(ab9b4c833207824efb14b712b4ec82721c8436bc) )
CONSOLE_ROM_LOAD( ggpgatou, "pga tour 96 (usa, europe).gg",                                                              0x000000 , 0x80000,	 CRC(542b6d8e) SHA1(dc71616c742f23979c5eb27aafa27961170e0ae8) )
CONSOLE_ROM_LOAD( ggpgato1, "pga tour golf (usa) (v1.1).gg",                                                             0x000000 , 0x40000,	 CRC(1c77d996) SHA1(cddc04025a10e4351a4c63d118a74bc8b7d2b257) )
CONSOLE_ROM_LOAD( ggpgato2, "pga tour golf (usa, europe).gg",                                                            0x000000 , 0x40000,	 CRC(9700bb65) SHA1(34a2b521c4577e4d1699311365722745d62f10aa) )
CONSOLE_ROM_LOAD( ggpgato3, "pga tour golf ii (usa, europe).gg",                                                         0x000000 , 0x80000,	 CRC(4a8ac851) SHA1(871b94f1ff63e2a89bc165382110d4f79df53fa3) )
CONSOLE_ROM_LOAD( ggphanta, "phantasy star adventure (japan).gg",                                                        0x000000 , 0x20000,	 CRC(1a51579d) SHA1(fdd940556f7d3af14979dbf057809d5a22e46d8e) )
CONSOLE_ROM_LOAD( ggphant1, "phantasy star gaiden (japan).gg",                                                           0x000000 , 0x40000,	 CRC(a942514a) SHA1(914f1e693f396794a37b5d99acaf5db54fe529c2) )
CONSOLE_ROM_LOAD( ggphanto, "phantom 2040 (usa, europe).gg",                                                             0x000000 , 0x80000,	 CRC(281b1c3a) SHA1(0e054455d99b6d1732abbe9d0ca1b25825b70b87) )
CONSOLE_ROM_LOAD( ggpinbal, "pinball dreams (usa).gg",                                                                   0x000000 , 0x20000,	 CRC(635c483a) SHA1(1734288c1ca2d83b28b5e266998fbbba76f665f6) )
CONSOLE_ROM_LOAD( ggpocket, "pocket jansou (japan).gg",                                                                  0x000000 , 0x20000,	 CRC(cc90c723) SHA1(5949695ae82b796d4cc141fcb57d01463e1b0ec6) )
CONSOLE_ROM_LOAD( ggpokerf, "poker faced paul's blackjack (usa).gg",                                                     0x000000 , 0x20000,	 CRC(89d34067) SHA1(010560dee1eafae3266eb9720e2f802c0deccf40) )
CONSOLE_ROM_LOAD( ggpoker1, "poker faced paul's gin (usa).gg",                                                           0x000000 , 0x20000,	 CRC(afd61b89) SHA1(e21d29b2864b6eed3a4eb4dcf7443f1114e92bd4) )
CONSOLE_ROM_LOAD( ggpoker2, "poker faced paul's poker (usa).gg",                                                         0x000000 , 0x20000,	 CRC(e783daf8) SHA1(c21b3a14bd560261c01eccb413b27fecf231495b) )
CONSOLE_ROM_LOAD( ggpoker3, "poker faced paul's solitaire (usa).gg",                                                     0x000000 , 0x20000,	 CRC(0e9b0c0a) SHA1(141b53c7f85b50626c6619094f4f8f7bec3676d2) )
CONSOLE_ROM_LOAD( ggpopbre, "pop breaker (japan).gg",                                                                    0x000000 , 0x20000,	 CRC(71deba5a) SHA1(9c358504d3c106dd62bd8981132b47cdb95903de) )
CONSOLE_ROM_LOAD( ggpopeye, "popeye no beach volleyball (japan).gg",                                                     0x000000 , 0x80000,	 CRC(3ef66810) SHA1(921e3922e1b550b6914fb06ba74d4661ef25a89e) )
CONSOLE_ROM_LOAD( ggpowers, "power strike ii (japan, europe).gg",                                                        0x000000 , 0x40000,	 CRC(09de1528) SHA1(e4db2140761b43426024bd08c4372bb9b8979d3d) )
CONSOLE_ROM_LOAD( ggpredat, "predator 2 (usa, europe).sms",                                                              0x000000 , 0x40000,	 CRC(e5f789b9) SHA1(76464809826a0ceed7cfd68a8fe5e06c06bd96fc) )
CONSOLE_ROM_LOAD( ggprimal, "primal rage (usa, europe).gg",                                                              0x000000 , 0x80000,	 CRC(2a34b5c7) SHA1(6d193840463722ed141ed503c2cfc7ae0077ce35) )
CONSOLE_ROM_LOAD( ggprince, "prince of persia (usa, europe) (beta).sms",                                                 0x000000 , 0x40000,	 CRC(45f058d6) SHA1(0672814b9fb20dd217141f7853db300343f2c1ea) )
CONSOLE_ROM_LOAD( ggprinc1, "prince of persia (usa, europe).sms",                                                        0x000000 , 0x40000,	 CRC(311d2863) SHA1(7820699ee6b214f3f02f724f4d7891184caf93f8) )
CONSOLE_ROM_LOAD( ggproyak, "pro yakyuu '91, the (japan).gg",                                                            0x000000 , 0x20000,	 CRC(6d3a10d3) SHA1(804cfac0a7578c3fd625f0084a24afa26a2dc015) )
CONSOLE_ROM_LOAD( ggproya1, "pro yakyuu gg league '94 (japan).gg",                                                       0x000000 , 0x80000,	 CRC(a1a19135) SHA1(faac2b420cb895aec4216d4c5ce21e5f2a4c4338) )
CONSOLE_ROM_LOAD( ggproya2, "pro yakyuu gg league (japan).gg",                                                           0x000000 , 0x40000,	 CRC(2da8e943) SHA1(bf78122a549ad9b016e3704690c7eea1574af140) )
CONSOLE_ROM_LOAD( ggpsychi, "psychic world (japan).gg",                                                                  0x000000 , 0x20000,	 CRC(afcc7828) SHA1(1c0074c811ed4eb369be31c1bc7d851e40ae8797) )
CONSOLE_ROM_LOAD( ggpsych1, "psychic world (usa, europe) (v1.1).gg",                                                     0x000000 , 0x20000,	 CRC(73779b22) SHA1(3be13f79eeb26b82343afab3e740b3a1d35978eb) )
CONSOLE_ROM_LOAD( ggputtpu, "putt & putter (japan).gg",                                                                  0x000000 , 0x20000,	 CRC(407ac070) SHA1(2d4a72e6f5db344240c2a65141b08e57a4b52416) )
CONSOLE_ROM_LOAD( ggputtp1, "putt & putter (usa, europe).gg",                                                            0x000000 , 0x20000,	 CRC(ecc301dd) SHA1(7038a6e60106eba19e0aff56c14749c2dbb5de5f) )
CONSOLE_ROM_LOAD( ggpuyopu, "puyo puyo (japan).gg",                                                                      0x000000 , 0x40000,	 CRC(d173a06f) SHA1(8ea2e623858221c5d39eb1e0f6532a0b23b00305) )
CONSOLE_ROM_LOAD( ggpuyop1, "puyo puyo 2 (japan).gg",                                                                    0x000000 , 0x80000,	 CRC(3ab2393b) SHA1(04ea9ff57faeeccd1bbb17490d22313ae94c86d6) )
CONSOLE_ROM_LOAD( ggpuzzle, "puzzle and action tanto-r (japan).gg",                                                      0x000000 , 0x80000,	 CRC(09151743) SHA1(75f54793ac09e22e0be1864ea16e68b2fb4610ff) )
CONSOLE_ROM_LOAD( ggpuzzl1, "puzzle bobble (japan).gg",                                                                  0x000000 , 0x40000,	 CRC(8e54ee04) SHA1(15568554cf6474e1ad64401217b702a048113a2d) )
CONSOLE_ROM_LOAD( ggquestf, "quest for the shaven yak starring ren hoek & stimpy (usa, europe).gg",                      0x000000 , 0x80000,	 CRC(6c451ee1) SHA1(83bc52f669183f99accb078a454f786b5e320e40) )
CONSOLE_ROM_LOAD( ggquizge, "quiz gear fight!!, the (japan).gg",                                                         0x000000 , 0x80000,	 CRC(736cdb76) SHA1(6ce8ff78d96a1a0e13997489d1a53b5a57a619c2) )
CONSOLE_ROM_LOAD( ggrbibas, "r.b.i. baseball '94 (usa).gg",                                                              0x000000 , 0x80000,	 CRC(6dc3295e) SHA1(21e3800ecfb6c8210cfc1213a6cbf0bb63519633) )
CONSOLE_ROM_LOAD( ggrcgran, "r.c. grand prix (usa, europe).sms",                                                         0x000000 , 0x40000,	 CRC(56201996) SHA1(c789e7f9450c8eaa08be1bf6c39e877973216431) )
CONSOLE_ROM_LOAD( ggrastan, "rastan saga (japan).sms",                                                                   0x000000 , 0x40000,	 CRC(9c76fb3a) SHA1(96bf8a67919218aac91fb74cde80a16f90df77d5) )
CONSOLE_ROM_LOAD( ggreveng, "revenge of drancon (usa).gg",                                                               0x000000 , 0x20000,	 CRC(03e9c607) SHA1(286f673b11739d624899479216e30b58efd049be) )
CONSOLE_ROM_LOAD( ggriddic, "riddick bowe boxing (japan).gg",                                                            0x000000 , 0x40000,	 CRC(a45fffb7) SHA1(af32ad098a1bf872d5a2cef38105704d3507ed75) )
CONSOLE_ROM_LOAD( ggriddi1, "riddick bowe boxing (usa).gg",                                                              0x000000 , 0x40000,	 CRC(38d8ec56) SHA1(b8487bdb0a6167753fc6de82714793181d7718db) )
CONSOLE_ROM_LOAD( ggriseof, "rise of the robots (usa, europe).gg",                                                       0x000000 , 0x80000,	 CRC(100b77b2) SHA1(9ba2f734eccf5b2ceefaa69cebdf7399bc9032d8) )
CONSOLE_ROM_LOAD( ggristar, "ristar (prototype - nov 01, 1994).gg",                                  0x000000 , 0x80000,	 CRC(44fa6ae6) SHA1(e2a06327647d9ad2358e34aae069d7789bc70e65) )
CONSOLE_ROM_LOAD( ggrista1, "ristar (prototype - nov 02, 1994).gg",                                  0x000000 , 0x80000,	 CRC(302d2b4b) SHA1(cf2a646d5c4b3f717a5c2a29d193210abbf770ca) )
CONSOLE_ROM_LOAD( ggrista2, "ristar (prototype - oct 19, 1994).gg",                                  0x000000 , 0x80000,	 CRC(672d38d5) SHA1(ac6d5e7f5c3fbd828876a12e10d89274025f3924) )
CONSOLE_ROM_LOAD( ggrista3, "ristar (prototype - oct 26, 1994).gg",                                  0x000000 , 0x80000,	 CRC(a302413c) SHA1(b13c32f50e7eb7d8147b7ad1d310e89e690ba6b2) )
CONSOLE_ROM_LOAD( ggrista4, "ristar (prototype - sep 09, 1994).gg",                                  0x000000 , 0x80000,	 CRC(a1c214bd) SHA1(f746e8e99f4fca811a32716d96a4e6528ec930eb) )
CONSOLE_ROM_LOAD( ggrista5, "ristar - the shooting star (world).gg",                                                     0x000000 , 0x80000,	 CRC(efe65b3b) SHA1(d0d950097471553b6a96dc9cf0fb14ddb3a7dda2) )
CONSOLE_ROM_LOAD( ggroadra, "road rash (usa).gg",                                                                        0x000000 , 0x80000,	 CRC(96045f76) SHA1(2cf136b5feb786770322e1a03e7e3577a1a9eec0) )
CONSOLE_ROM_LOAD( ggroboco, "robocop 3 (usa, europe).gg",                                                                0x000000 , 0x40000,	 CRC(069a0704) SHA1(8de7c9ac95b734af9e3fbe5700ac4c6599799702) )
CONSOLE_ROM_LOAD( ggroboc1, "robocop versus the terminator (usa, europe).gg",                                            0x000000 , 0x80000,	 CRC(4ab7fa4e) SHA1(13286df11fc66a8974a73a82e8478fa382fa2b43) )
CONSOLE_ROM_LOAD( ggroyals, "royal stone - hirakareshi toki no tobira (japan).gg",                                       0x000000 , 0x80000,	 CRC(445d7cd2) SHA1(c1afca3ac30cb9852f508f5dded7e50e08000f86) )
CONSOLE_ROM_LOAD( ggryuuky, "ryuukyuu (japan).gg",                                                                       0x000000 , 0x20000,	 CRC(95efd52b) SHA1(ffaa1c97c64aec30176254f1ef655c06c63e1b53) )
CONSOLE_ROM_LOAD( ggssluci, "s.s. lucifer - man overboard! (europe).gg",                                                 0x000000 , 0x40000,	 CRC(d9a7f170) SHA1(b167fda9f0e7a6a47027f782a08149e8d4f46e0c) )
CONSOLE_ROM_LOAD( ggsamura, "samurai shodown (usa).gg",                                                                  0x000000 , 0x80000,	 CRC(98171deb) SHA1(d7330f5abcadb5c199299b24c22334be0072ec80) )
CONSOLE_ROM_LOAD( ggsamur1, "samurai spirits (japan).gg",                                                                0x000000 , 0x80000,	 CRC(93fd73dc) SHA1(2aaf7b6f9d37275995d4a62bb8a465333d8b0bf4) )
CONSOLE_ROM_LOAD( ggscratc, "scratch golf (japan).gg",                                                                   0x000000 , 0x40000,	 CRC(ec0f2c72) SHA1(4c1d3b5057702341b5646d0a2fe65a9bda966211) )
CONSOLE_ROM_LOAD( ggsdgund, "sd gundam - winner's history (japan).gg",                                                   0x000000 , 0x80000,	 CRC(5e2b39b8) SHA1(24e217098845ab5a0eb29e9dc6af2e86be1b0a84) )
CONSOLE_ROM_LOAD( ggsegaga, "sega game pack 4 in 1 (europe).gg",                                                         0x000000 , 0x40000,	 CRC(0924d2ec) SHA1(02fa5c6c6f81f5f4e1d78eced5a37617888404d3) )
CONSOLE_ROM_LOAD( ggsensib, "sensible soccer (europe).gg",                                                               0x000000 , 0x20000,	 CRC(5b68da75) SHA1(c02830156779a27b79435ec0cbf7a03cbbfda920) )
CONSOLE_ROM_LOAD( ggshadam, "shadam crusader - harukanaru oukoku (japan).gg",                                            0x000000 , 0x80000,	 CRC(09f9ed60) SHA1(de4b546f61dd32106247d38643849f6aaeeedb07) )
CONSOLE_ROM_LOAD( ggshangh, "shanghai ii (japan).gg",                                                                    0x000000 , 0x20000,	 CRC(2ae8c75f) SHA1(5180891ec0ae08d784dd89222d9ffd7f88a59691) )
CONSOLE_ROM_LOAD( ggshaqfu, "shaq fu (usa, europe).gg",                                                                  0x000000 , 0x80000,	 CRC(6fcb8ab0) SHA1(bc9d0b0dc2b22b9530660f0a04b865492766c9d0) )
CONSOLE_ROM_LOAD( ggshikin, "shikinjou (japan).gg",                                                                      0x000000 , 0x20000,	 CRC(9c5c7f53) SHA1(bf36130b1be4bce6c6eb7b87db00d420797c3611) )
CONSOLE_ROM_LOAD( ggshinin, "shining force gaiden - ensei, jashin no kuni e (japan).gg",                                 0x000000 , 0x80000,	 CRC(4d1f4699) SHA1(bea1bea94ea745691ad944eaadc8a5576057ed53) )
CONSOLE_ROM_LOAD( ggshini1, "shining force gaiden - final conflict (japan).gg",                                          0x000000 , 0x80000,	 CRC(6019fe5e) SHA1(0d4bc152e7ae70457fa74f593e064403cd24ab72) )
CONSOLE_ROM_LOAD( ggshini2, "shining force gaiden ii - jashin no kakusei (japan).gg",                                    0x000000 , 0x80000,	 CRC(30374681) SHA1(2dd374db661315e51e9eedebf346a5a4ded0c3be) )
CONSOLE_ROM_LOAD( ggshini3, "shining force ii (prototype - apr 27, 1994).gg",                        0x000000 , 0x80000,	 CRC(65e5345c) SHA1(71ed14c75915d606e00481cc2fbbaa28b6d2ba4f) )
CONSOLE_ROM_LOAD( ggshini4, "shining force ii (prototype - jul 08, 1994).gg",                        0x000000 , 0x80000,	 CRC(80dca91d) SHA1(a9dd1254577bff20ee33f7bce56e2c4361f911c4) )
CONSOLE_ROM_LOAD( ggshini5, "shining force ii (prototype - jun 27, 1994).gg",                        0x000000 , 0x80000,	 CRC(8bfc56c3) SHA1(900f8640af14dd6c413f20058a98da11a0fd07b1) )
CONSOLE_ROM_LOAD( ggshini6, "shining force ii (prototype - may 30, 1994).gg",                        0x000000 , 0x80000,	 CRC(e97ec011) SHA1(bb7be9acb986a923c6c8ae41053c1b2f508885d1) )
CONSOLE_ROM_LOAD( ggshini7, "shining force ii - the sword of hajya (usa, europe).gg",                                    0x000000 , 0x80000,	 CRC(a6ca6fa9) SHA1(789734c4a837dffd2ad3e2c8de22cbd83836580d) )
CONSOLE_ROM_LOAD( ggshinob, "shinobi (usa, europe).gg",                                                                  0x000000 , 0x40000,	 CRC(30f1c984) SHA1(2e7303f82d885cb84fa557e211954808c8ebe779) )
CONSOLE_ROM_LOAD( ggshino1, "shinobi ii - the silent fury (world).gg",                                                   0x000000 , 0x40000,	 CRC(6201c694) SHA1(cd57301d16202ea02d9f97bd8b17d71772782c94) )
CONSOLE_ROM_LOAD( ggsidepo, "side pocket (usa).gg",                                                                      0x000000 , 0x40000,	 CRC(6a603eed) SHA1(794775a858ff04c9da1c897b51eede4677a35c21) )
CONSOLE_ROM_LOAD( ggsimpso, "simpsons, the - bart vs. the space mutants (usa, europe).gg",                               0x000000 , 0x40000,	 CRC(c0009274) SHA1(c8bbc1ea5b9b60ebcd15efc2dc850e0ffd20dae0) )
CONSOLE_ROM_LOAD( ggsimps1, "simpsons, the - bart vs. the world (usa, europe).gg",                                       0x000000 , 0x40000,	 CRC(da7bd5c7) SHA1(256672261c9a2d35e10eb06e990e8ebc46fb35c1) )
CONSOLE_ROM_LOAD( ggskweek, "skweek (japan).gg",                                                                         0x000000 , 0x20000,	 CRC(786dd67b) SHA1(17794ed08c1df2ebc992c5686dc1072a75731e4d) )
CONSOLE_ROM_LOAD( ggslider, "slider (usa, europe).gg",                                                                   0x000000 , 0x20000,	 CRC(4dc6f555) SHA1(ab37b26ca62339720d1cefcb152a0aca545359aa) )
CONSOLE_ROM_LOAD( ggsmurfs, "smurfs, the (europe) (en,fr,de,es).gg",                                                     0x000000 , 0x40000,	 CRC(354e1cbd) SHA1(faa80f644ece06b10b8e5ad035cbf518f80d609b) )
CONSOLE_ROM_LOAD( ggsolita, "solitaire funpak (usa).gg",                                                                 0x000000 , 0x40000,	 CRC(f6f24b75) SHA1(f1d31d734f3ef590b0aefd1b89a455e9040d102e) )
CONSOLE_ROM_LOAD( ggsolit1, "solitaire poker (usa, europe).gg",                                                          0x000000 , 0x20000,	 CRC(06f2fc46) SHA1(7478a2f641fa371999f2c9f0a1efd9917615be5f) )
CONSOLE_ROM_LOAD( ggsonict, "sonic & tails (japan).gg",                                                                  0x000000 , 0x80000,	 CRC(8ac0dade) SHA1(e70228cbde1b54f1520804c6e3c28b4130a68c84) )
CONSOLE_ROM_LOAD( ggsonic1, "sonic & tails 2 (japan).gg",                                                                0x000000 , 0x80000,	 CRC(496bce64) SHA1(bb14ed43cf815e82f55e79753d0a7c8a24e24e7f) )
CONSOLE_ROM_LOAD( ggsonicb, "sonic blast (prototype 611 - may 31, 1996, 13.49).gg",                  0x000000 , 0x80000,	 CRC(c09ef45b) SHA1(5d9fa949aeddfc4251d7b8a58cb1122f190ecd36) )
CONSOLE_ROM_LOAD( ggsonic2, "sonic blast (prototype 74 - jul 17, 1996, 09.11).gg",                   0x000000 , 0x100000,	 CRC(362b186d) SHA1(e7bb20410c7ab341a3f7df7fcfee3a6996823655) )
CONSOLE_ROM_LOAD( ggsonic3, "sonic blast (prototype 806 - aug 06, 1996, 18.37).gg",                  0x000000 , 0x100000,	 CRC(19dad067) SHA1(12a8a59da110b914acde68112db691df9595d4e8) )
CONSOLE_ROM_LOAD( ggsonic4, "sonic blast (prototype 821 - aug 22, 1996, 09.38).gg",                  0x000000 , 0x100000,	 CRC(5eecb549) SHA1(da497ae41be3fccc97eb18bd6349917e645c5179) )
CONSOLE_ROM_LOAD( ggsonic5, "sonic blast (prototype 827 - aug 28, 1996, 11.13).gg",                  0x000000 , 0x100000,	 CRC(e6847ac0) SHA1(f1a1edee0eb15faf74dd6896753f0f6abcf12a45) )
CONSOLE_ROM_LOAD( ggsonic6, "sonic blast (prototype 94 - sep 02, 1996, 17.47).gg",                   0x000000 , 0x100000,	 CRC(2f22a352) SHA1(8aa965b342466cc3ac4093bba61abf7d68b5ec86) )
CONSOLE_ROM_LOAD( ggsonic7, "sonic blast (world).gg",                                                                    0x000000 , 0x100000,	 CRC(031b9da9) SHA1(11241be4082f6f9d057488ae75ccdd482f623f8c) )
CONSOLE_ROM_LOAD( ggsonicc, "sonic chaos (usa, europe).gg",                                                              0x000000 , 0x80000,	 CRC(663f2abb) SHA1(5b5b7d9cd8adf0f8e1ee15fd4557828f91dfdca1) )
CONSOLE_ROM_LOAD( ggsonicd, "sonic drift (japan) (sample).gg",                                                           0x000000 , 0x80000,	 CRC(baac1fc0) SHA1(462bdf9bfac3eb9b389142b55be39608c3343223) )
CONSOLE_ROM_LOAD( ggsonic8, "sonic drift (japan).gg",                                                                    0x000000 , 0x80000,	 CRC(68f0a776) SHA1(fef5d69093df2d774ed274a4079790f8778577fc) )
CONSOLE_ROM_LOAD( ggsonic9, "sonic drift 2 (japan, usa).gg",                                                             0x000000 , 0x80000,	 CRC(d6e8a305) SHA1(fe597c5cfbbc31e54f2484eb5b33c21c66cf0290) )
CONSOLE_ROM_LOAD( ggsonicl, "sonic labyrinth (world).gg",                                                                0x000000 , 0x80000,	 CRC(5550173b) SHA1(e24bf33d8d5a79f371485f20f207b6b26f5b341e) )
CONSOLE_ROM_LOAD( ggsonics, "sonic spinball (prototype 0307 - mar 07, 1994, 05.24).gg",              0x000000 , 0x80000,	 CRC(3283580d) SHA1(1b6f1469d0e707aab3eba3c6748f350a30eb530f) )
CONSOLE_ROM_LOAD( ggsoni10, "sonic spinball (prototype 031094 - mar 10, 1994, 17.41).gg",            0x000000 , 0x80000,	 CRC(1a736612) SHA1(81dc53c9103fab356014e7e45082fc562cdd59ec) )
CONSOLE_ROM_LOAD( ggsoni11, "sonic spinball (prototype 031194 - mar 11, 1994, 12.09).gg",            0x000000 , 0x80000,	 CRC(1aed8f62) SHA1(cec96b3372a4ecb39ac7bd51829d4f641ff8d198) )
CONSOLE_ROM_LOAD( ggsoni12, "sonic spinball (prototype 032194 - mar 21, 1994, 07.12).gg",            0x000000 , 0x80000,	 CRC(46657b4e) SHA1(6b08dd5e60e957739cd7c8dea5f9fcb2bf82009c) )
CONSOLE_ROM_LOAD( ggsoni13, "sonic spinball (prototype 0328 - mar 28, 1994, 06.54).gg",              0x000000 , 0x80000,	 CRC(1233c3e3) SHA1(41260c00f83592c6c21800750bd25359f8cce911) )
CONSOLE_ROM_LOAD( ggsoni14, "sonic spinball (prototype 0329 - mar 29, 1994, 07.35).gg",              0x000000 , 0x80000,	 CRC(aa7aedb0) SHA1(f3a3b701f7700459b0a4175e6b8c24ab68518f40) )
CONSOLE_ROM_LOAD( ggsoni15, "sonic spinball (prototype 0330 - mar 30, 1994, 06.54).gg",              0x000000 , 0x80000,	 CRC(2ca34ab2) SHA1(a066324f8d781ea218ea61689eea6d6254bf9aab) )
CONSOLE_ROM_LOAD( ggsoni16, "sonic spinball (prototype 0405 - apr 05, 1994, 18.07).gg",              0x000000 , 0x80000,	 CRC(09b913d5) SHA1(35ed35fda5fc8d5f1ac1068157c176bb216769e4) )
CONSOLE_ROM_LOAD( ggsoni17, "sonic spinball (prototype 0412 - apr 12, 1994, 07.26).gg",              0x000000 , 0x80000,	 CRC(f8a432f6) SHA1(3fd285036f794574b7310ca093a6d5d5bc244bc7) )
CONSOLE_ROM_LOAD( ggsoni18, "sonic spinball (prototype 0413 - apr 13, 1994, 02.54).gg",              0x000000 , 0x80000,	 CRC(1f1abf2c) SHA1(a4c3d6b3601d321003aad3b759487bddb4cd64b3) )
CONSOLE_ROM_LOAD( ggsoni19, "sonic spinball (prototype 0415 - apr 15, 1994, 17.33).gg",              0x000000 , 0x80000,	 CRC(e3b5cd1e) SHA1(e59e3d9b0a8d9adb13a32cfdbe027ade81c8ded1) )
CONSOLE_ROM_LOAD( ggsoni20, "sonic spinball (prototype 0421 - apr 21, 1994, 05.30).gg",              0x000000 , 0x80000,	 CRC(bbaecf7c) SHA1(f0abf46487acc6a2a93b3e7e93dbe9f651ccbd41) )
CONSOLE_ROM_LOAD( ggsoni21, "sonic spinball (prototype 0427 - apr 27, 1994, 04.51).gg",              0x000000 , 0x5c000,	 CRC(07d32244) SHA1(2be84549aeecf580ef25290b7255270ede38b830) )
CONSOLE_ROM_LOAD( ggsoni22, "sonic spinball (prototype 0429 - apr 29, 1994, 06.01).gg",              0x000000 , 0x80000,	 CRC(30a7d062) SHA1(35954b7e65e663fba3066046e971316d5e573158) )
CONSOLE_ROM_LOAD( ggsoni23, "sonic spinball (prototype 0430 - apr 29, 1994, 21.48).gg",              0x000000 , 0x80000,	 CRC(221c4ba4) SHA1(ab9ac3b4ebecd02c8f3b0d29b921a3d8bcf96458) )
CONSOLE_ROM_LOAD( ggsoni24, "sonic spinball (prototype 0505 - may 05, 1994, 04.47).gg",              0x000000 , 0x80000,	 CRC(be76bf30) SHA1(975232a729179c1db5307c072593cdbf83e233d6) )
CONSOLE_ROM_LOAD( ggsoni25, "sonic spinball (prototype 0506 - may 06, 1994, 13.04).gg",              0x000000 , 0x80000,	 CRC(a4833d27) SHA1(36cd00138f78bf31ee6098d1f5b0b2e870ab5637) )
CONSOLE_ROM_LOAD( ggsoni26, "sonic spinball (prototype 0525 - may 25, 1994, 13.24).gg",              0x000000 , 0x80000,	 CRC(a035fd5c) SHA1(cf9afbc274afcd28931bb1298c53bfdf6e04a9b6) )
CONSOLE_ROM_LOAD( ggsoni27, "sonic spinball (prototype 0530 - may 30, 1994, 23.25).gg",              0x000000 , 0x80000,	 CRC(6107819d) SHA1(8c16865212ad284a0929869a95980bcdf3d9ba81) )
CONSOLE_ROM_LOAD( ggsoni28, "sonic spinball (prototype 503b - may 03, 1994, 19.27).gg",              0x000000 , 0x80000,	 CRC(e2fe976a) SHA1(7577eef2ac9823a539d6af1c2673d1702d29695f) )
CONSOLE_ROM_LOAD( ggsoni29, "sonic spinball (usa, europe).gg",                                                           0x000000 , 0x80000,	 CRC(a9210434) SHA1(df21d42b55b1b4a25704957fe323728b775eb84d) )
CONSOLE_ROM_LOAD( ggsoni30, "sonic the hedgehog (japan).gg",                                                             0x000000 , 0x40000,	 CRC(3e31cb8c) SHA1(8923295c96b2e05da0a83a827fd709b033fc7332) )
CONSOLE_ROM_LOAD( ggsoni31, "sonic the hedgehog (world) (proto).gg",                                                     0x000000 , 0x40000,	 CRC(816c0a1e) SHA1(7ff6810e4ac03e04584243995c3fd54b77896c23) )
CONSOLE_ROM_LOAD( ggsoni32, "sonic the hedgehog (world) (v1.1).gg",                                                      0x000000 , 0x40000,	 CRC(d163356e) SHA1(7dbbbca2229e74fcb8f90ec794aa6e5cb168e489) )
CONSOLE_ROM_LOAD( ggsoni33, "sonic the hedgehog - triple trouble (prototype 0808 - aug 08, 1994, 18.05).gg",0x000000 , 0x80000,	 CRC(80eb7cfb) SHA1(02257fece665d04d3c88b5f5589773d5a8433953) )
CONSOLE_ROM_LOAD( ggsoni34, "sonic the hedgehog - triple trouble (usa, europe).gg",                                      0x000000 , 0x80000,	 CRC(d23a2a93) SHA1(4965af7ffe60382ffa805710b7c8006419cc4ac4) )
CONSOLE_ROM_LOAD( ggsoni35, "sonic the hedgehog 2 (world).gg",                                                           0x000000 , 0x80000,	 CRC(95a18ec7) SHA1(dabb452e416b4fa9cb83d8ddd307c2a32c3a1a7f) )
CONSOLE_ROM_LOAD( ggsoukob, "soukoban (japan).gg",                                                                       0x000000 , 0x20000,	 CRC(0f3e3840) SHA1(e5865a22dc3a9714160ef14bc59d510502d39b97) )
CONSOLE_ROM_LOAD( ggspaceh, "space harrier (world).gg",                                                                  0x000000 , 0x20000,	 CRC(600c15b3) SHA1(d00b8ff195d4423f2a344490eb34156017f4ee64) )
CONSOLE_ROM_LOAD( ggspeedy, "speedy gonzales cheese catastrophe (prototype - feb 17, 1995).gg",      0x000000 , 0x80000,	 CRC(4e78fd36) SHA1(8897ba5aa76d0e17251b2765fafbdb0df41030a6) )
CONSOLE_ROM_LOAD( ggspeed1, "speedy gonzales cheese catastrophe (prototype - feb 24, 1995).gg",      0x000000 , 0x80000,	 CRC(4e78fd36) SHA1(8897ba5aa76d0e17251b2765fafbdb0df41030a6) )
CONSOLE_ROM_LOAD( ggspider, "spider-man - return of the sinister six (usa, europe).gg",                                  0x000000 , 0x40000,	 CRC(bc240779) SHA1(37e2b3fd35138e9e939d5152d86e307f7ac06f7e) )
CONSOLE_ROM_LOAD( ggspide1, "spider-man and the x-men in arcade's revenge (usa).gg",                                     0x000000 , 0x80000,	 CRC(742a372b) SHA1(4006a23571f194e1fcb3563557decd5d11e7b5c2) )
CONSOLE_ROM_LOAD( ggspide2, "spider-man vs. the kingpin (usa, europe).gg",                                               0x000000 , 0x40000,	 CRC(2651024e) SHA1(46b064b4b5a6444ce0e64e16a7e5cec2087fb4d3) )
CONSOLE_ROM_LOAD( ggspirou, "spirou (europe) (proto).gg",                                                                0x000000 , 0x80000,	 CRC(ab622adc) SHA1(40359adbe9950b8e5e46158f519ad782757f0884) )
CONSOLE_ROM_LOAD( ggsports, "sports illustrated championship football & baseball (usa, europe).gg",                      0x000000 , 0x80000,	 CRC(de25e2d8) SHA1(781bc3ef9fbbbfcb5452dad99633b65c172b62fa) )
CONSOLE_ROM_LOAD( ggsport1, "sports trivia (prototype - apr 03, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(3e3d6728) SHA1(8fc968be19d8da9335bf3a6dac97657058ef5a78) )
CONSOLE_ROM_LOAD( ggsport2, "sports trivia (prototype - apr 03, 1995 - qtest).gg",                   0x000000 , 0x40000,	 CRC(c68762e6) SHA1(dbab3669da5a204ce78af3fc5a1749a08c39262e) )
CONSOLE_ROM_LOAD( ggsport3, "sports trivia (prototype - apr 04, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(d61a366f) SHA1(463dbaafd144c430f3b62dbb53578f26441bfdb8) )
CONSOLE_ROM_LOAD( ggsport4, "sports trivia (prototype - apr 05, 1995 - 2meg - b).gg",                0x000000 , 0x40000,	 CRC(818ec54c) SHA1(48ff2e462d0b17022c8085133447dd7eedac898b) )
CONSOLE_ROM_LOAD( ggsport5, "sports trivia (prototype - apr 05, 1995 - 2meg - c).gg",                0x000000 , 0x40000,	 CRC(f88a55f4) SHA1(c857bef7eed535d1f827ad439df112b3b0c05cf8) )
CONSOLE_ROM_LOAD( ggsport6, "sports trivia (prototype - apr 05, 1995 - qtest).gg",                   0x000000 , 0x40000,	 CRC(93b98f19) SHA1(a57c18adfa86e86b3e43f605617205a219aafdfb) )
CONSOLE_ROM_LOAD( ggsport7, "sports trivia (prototype - apr 06, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(cab74070) SHA1(aa61ae6b979d30757b1192118796878e3e1c082f) )
CONSOLE_ROM_LOAD( ggsport8, "sports trivia (prototype - apr 07, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(352e8b8c) SHA1(e4938d6b435fce12b4b73591447422342b919e9f) )
CONSOLE_ROM_LOAD( ggsport9, "sports trivia (prototype - apr 07, 1995 - qtest).gg",                   0x000000 , 0x40000,	 CRC(961ae378) SHA1(34986c53709ef347a8ec620dbe7b35fef8ff3ef0) )
CONSOLE_ROM_LOAD( ggspor10, "sports trivia (prototype - apr 11, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(8bdb184d) SHA1(203f4ebd0ca75bbeeb3723372500336415f59da4) )
CONSOLE_ROM_LOAD( ggspor11, "sports trivia (prototype - apr 12, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(1e360a20) SHA1(5ced41cadede9959775f1d6cf229a19c0d739c88) )
CONSOLE_ROM_LOAD( ggspor12, "sports trivia (prototype - apr 25, 1995 - 1meg).gg",                    0x000000 , 0x20000,	 CRC(895af58a) SHA1(8e42323155c0e0f0cd050e66f89f821cb884f7a1) )
CONSOLE_ROM_LOAD( ggspor13, "sports trivia (prototype - apr 25, 1995 - qtest).gg",                   0x000000 , 0x20000,	 CRC(7524957c) SHA1(90834a82aa40f69abf57d34d1910d829d8632af0) )
CONSOLE_ROM_LOAD( ggspor14, "sports trivia (prototype - apr 27, 1995 - 1meg).gg",                    0x000000 , 0x20000,	 CRC(7898919f) SHA1(36d665e221ecf7c0d5f3af1edc83c9e56f3256af) )
CONSOLE_ROM_LOAD( ggspor15, "sports trivia (prototype - apr 28, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(26470d2b) SHA1(23a9d5dee62d64eed1de6e35ac75cbe5786a0c06) )
CONSOLE_ROM_LOAD( ggspor16, "sports trivia (prototype - mar 08, 1995).gg",                           0x000000 , 0x20000,	 CRC(c38d41c3) SHA1(d3503a568182f1f286203c2e2a5516f74684f4f3) )
CONSOLE_ROM_LOAD( ggspor17, "sports trivia (prototype - mar 09, 1995).gg",                           0x000000 , 0x20000,	 CRC(34407fe9) SHA1(c977c038df47192996e05c9db130bf2c82a129ff) )
CONSOLE_ROM_LOAD( ggspor18, "sports trivia (prototype - mar 13, 1995).gg",                           0x000000 , 0x40000,	 CRC(a8d1ac51) SHA1(58c08b83df499755a47dc8407807bd2f93a58583) )
CONSOLE_ROM_LOAD( ggspor19, "sports trivia (prototype - mar 16, 1995 - 1meg).gg",                    0x000000 , 0x20000,	 CRC(464f1b51) SHA1(151a9d25a29a41d00d20d9d6a93620682464e037) )
CONSOLE_ROM_LOAD( ggspor20, "sports trivia (prototype - mar 16, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(caf87d8b) SHA1(61e215dd6ac4a9ab334210a9d87876222a717e12) )
CONSOLE_ROM_LOAD( ggspor21, "sports trivia (prototype - mar 17, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(43bb6b10) SHA1(5b5034d5689bb116ca602ea30a696af60444ced8) )
CONSOLE_ROM_LOAD( ggspor22, "sports trivia (prototype - mar 20, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(e7aff566) SHA1(693cc753fc94eb5d79fb0bf0e4cb484dd1fb57f3) )
CONSOLE_ROM_LOAD( ggspor23, "sports trivia (prototype - mar 20, 1995 - qtest).gg",                   0x000000 , 0x40000,	 CRC(a3e57816) SHA1(70e71c0581019c89bd2c38ee45b05bff84fc3eb0) )
CONSOLE_ROM_LOAD( ggspor24, "sports trivia (prototype - mar 21, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(18cf6145) SHA1(400a91d37ad6eaf54d2b4057d562876507ea715e) )
CONSOLE_ROM_LOAD( ggspor25, "sports trivia (prototype - mar 23, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(27816c09) SHA1(5ad1ed30fcc414b237c6a9057e3f43913c3ebf23) )
CONSOLE_ROM_LOAD( ggspor26, "sports trivia (prototype - mar 23, 1995 - algotest).gg",                0x000000 , 0x40000,	 CRC(9a8ad5ca) SHA1(7a9dfd2ca7ecba07ef141ad9f2428052b441e200) )
CONSOLE_ROM_LOAD( ggspor27, "sports trivia (prototype - mar 23, 1995 - qtest).gg",                   0x000000 , 0x40000,	 CRC(acb7e580) SHA1(227f12188ceaa0577cd6604804d1228e342c67a2) )
CONSOLE_ROM_LOAD( ggspor28, "sports trivia (prototype - mar 27, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(517bd817) SHA1(3ae00363f54b73c47d6e6125e3a7d3741f33fccf) )
CONSOLE_ROM_LOAD( ggspor29, "sports trivia (prototype - mar 27, 1995 - algotest).gg",                0x000000 , 0x40000,	 CRC(511b1d24) SHA1(b7ba8f1c6ec2958da3a040ab56f9915f13723a70) )
CONSOLE_ROM_LOAD( ggspor30, "sports trivia (prototype - mar 29, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(e906fbd8) SHA1(3410bafb1757988f1cb270745dfa9ac22212539b) )
CONSOLE_ROM_LOAD( ggspor31, "sports trivia (prototype - mar 29, 1995 - algotest).gg",                0x000000 , 0x40000,	 CRC(e80459b3) SHA1(cfcb94207728f781602ff8375cda3c2de25b7eed) )
CONSOLE_ROM_LOAD( ggspor32, "sports trivia (prototype - mar 29, 1995 - qtest).gg",                   0x000000 , 0x40000,	 CRC(05047357) SHA1(50cce09ee3c077feaf7ad9df1e2a9f4fde0e7691) )
CONSOLE_ROM_LOAD( ggspor33, "sports trivia (prototype - mar 30, 1995 - 2meg - d).gg",                0x000000 , 0x40000,	 CRC(302b9b36) SHA1(d462337a78f85882e7ebcb95e129ab18e75e44a4) )
CONSOLE_ROM_LOAD( ggspor34, "sports trivia (prototype - mar 30, 1995 - qtest).gg",                   0x000000 , 0x40000,	 CRC(f3f9a87b) SHA1(0ac64a9077ddcb53d2d35748f13b9d462f27ab51) )
CONSOLE_ROM_LOAD( ggspor35, "sports trivia (prototype - may 02, 1995 - 2meg).gg",                    0x000000 , 0x40000,	 CRC(15e7e261) SHA1(03b4e8d8afc14d8df113043c3d53130df6eb769e) )
CONSOLE_ROM_LOAD( ggspor36, "sports trivia (prototype - may 04, 1995 - 1meg).gg",                    0x000000 , 0x20000,	 CRC(bba4cf7b) SHA1(7c17382789e6648019e99fb8feca84535f50ae4f) )
CONSOLE_ROM_LOAD( ggspor37, "sports trivia (usa).gg",                                                                    0x000000 , 0x20000,	 CRC(a7af7ca9) SHA1(7787c8f0178829fc2ce25930ad91f0b712fa3625) )
CONSOLE_ROM_LOAD( ggspor38, "sports trivia - championship edition (usa, europe).gg",                                     0x000000 , 0x40000,	 CRC(5b5de94d) SHA1(f2542d122570fad8d2f91aae8ef074e58487ede0) )
CONSOLE_ROM_LOAD( ggstartr, "star trek - the next generation - the advanced holodeck tutorial (usa).gg",                 0x000000 , 0x40000,	 CRC(80156323) SHA1(a508ff0ea93390e42e2440ed4aca531047281c23) )
CONSOLE_ROM_LOAD( ggstart1, "star trek generations - beyond the nexus (usa, europe).gg",                                 0x000000 , 0x40000,	 CRC(087fc5f0) SHA1(307e4956fd0d50f3732215574957b040937bbfca) )
CONSOLE_ROM_LOAD( ggstarwa, "star wars (europe).gg",                                                                     0x000000 , 0x80000,	 CRC(db9bc599) SHA1(682df750f372134734d8668f08b9a5acbb4f2cfd) )
CONSOLE_ROM_LOAD( ggstarw1, "star wars (usa).gg",                                                                        0x000000 , 0x80000,	 CRC(0228769c) SHA1(48c14c0c2b4e38ac122d9ccdcdc8b194e15ef032) )
CONSOLE_ROM_LOAD( ggstarga, "stargate (world).gg",                                                                       0x000000 , 0x40000,	 CRC(fc7c64e4) SHA1(011fd49600eaef8be7cbe35ab6eeb4e1554d836c) )
CONSOLE_ROM_LOAD( ggstreet, "streets of rage (world).gg",                                                                0x000000 , 0x40000,	 CRC(3d8bcf1d) SHA1(ca8c8a00ee838e994b2fa17e595ddd40d898cf42) )
CONSOLE_ROM_LOAD( ggstree1, "streets of rage ii (world).gg",                                                             0x000000 , 0x80000,	 CRC(0b618409) SHA1(2804b355347bda6e2903078ba30ed6b3a289ebba) )
CONSOLE_ROM_LOAD( ggstrike, "striker (europe) (en,fr,de,es,it).gg",                                                      0x000000 , 0x80000,	 CRC(b421c057) SHA1(dc51ed36b12d1a943bcf79d9ab246505a190f795) )
CONSOLE_ROM_LOAD( ggsuperb, "super battletank (usa).gg",                                                                 0x000000 , 0x40000,	 CRC(73d6745a) SHA1(f827545cccd5360552e839a377c1b886e6c80176) )
CONSOLE_ROM_LOAD( ggsuperc, "super columns (japan).gg",                                                                  0x000000 , 0x20000,	 CRC(2a100717) SHA1(a1de915b0f10894bedc6ee8f0fd1f2da65bcfa68) )
CONSOLE_ROM_LOAD( ggsuper1, "super columns (prototype - dec 01, 1994).gg",                           0x000000 , 0x20000,	 CRC(56cf1d4f) SHA1(29dac0da809c8a74c6610e4dde300efaddaca29a) )
CONSOLE_ROM_LOAD( ggsuper2, "super columns (prototype - dec 15, 1994).gg",                           0x000000 , 0x20000,	 CRC(abe92434) SHA1(3edad6d335d5f6ec3dc403fd642cd6a71e3c053d) )
CONSOLE_ROM_LOAD( ggsuper3, "super columns (prototype - dec 21, 1994).gg",                           0x000000 , 0x20000,	 CRC(81451fc0) SHA1(b7cabe08f0e0850b055fd0e694e175e8f1c47e4d) )
CONSOLE_ROM_LOAD( ggsuper4, "super columns (prototype - dec 26, 1994).gg",                           0x000000 , 0x20000,	 CRC(5c4c633d) SHA1(d3050de383e772bb068d4c722bbe91ff05172d45) )
CONSOLE_ROM_LOAD( ggsuper5, "super columns (prototype - dec 28, 1994).gg",                           0x000000 , 0x20000,	 CRC(3d931952) SHA1(b2bc04e1f7a00ec5431774db0b47da53db57d3a3) )
CONSOLE_ROM_LOAD( ggsuper6, "super columns (prototype - jan 06, 1995).gg",                           0x000000 , 0x20000,	 CRC(096f4ff5) SHA1(fed437cf7d22c685fef7b2e55579cd77bb48e232) )
CONSOLE_ROM_LOAD( ggsuper7, "super columns (prototype - nov 11, 1994).gg",                           0x000000 , 0x20000,	 CRC(f28f89d1) SHA1(e5b23a687c9dd285970f4783369e36c7a96d19fa) )
CONSOLE_ROM_LOAD( ggsuper8, "super columns (usa, europe).gg",                                                            0x000000 , 0x20000,	 CRC(8ba43af3) SHA1(ce59845e973b7fb7b3b2121b35a95fba5727df62) )
CONSOLE_ROM_LOAD( ggsuperg, "super golf (japan).gg",                                                                     0x000000 , 0x20000,	 CRC(528cbbce) SHA1(9ecb48513621086ec6d5bffa1375914f21f393e4) )
CONSOLE_ROM_LOAD( ggsuperk, "super kick off (japan).sms",                                                                0x000000 , 0x40000,	 CRC(10dbbef4) SHA1(cb4a08b89cc24154328309cab54bfd9d83e4754f) )
CONSOLE_ROM_LOAD( ggsuperm, "super momotarou dentetsu iii (japan).gg",                                                   0x000000 , 0x80000,	 CRC(b731bb80) SHA1(f62e0e433987f97143282d2526490cd45f3e7185) )
CONSOLE_ROM_LOAD( ggsuper9, "super monaco gp (japan).gg",                                                                0x000000 , 0x20000,	 CRC(4f686c4a) SHA1(2a61491785ad56f5bdc504c994f36ee8ea9dcf68) )
CONSOLE_ROM_LOAD( ggsupe10, "super monaco gp (usa, europe).gg",                                                          0x000000 , 0x20000,	 CRC(fcf12547) SHA1(d834e43d7ec6dbadf2e367afd45b7e1e4362035b) )
CONSOLE_ROM_LOAD( ggsupero, "super off road (usa, europe).gg",                                                           0x000000 , 0x20000,	 CRC(e8b42b1f) SHA1(c5ee89f785c44784867c3b33fd6466fc72e9042c) )
CONSOLE_ROM_LOAD( ggsupe11, "super off-road (u).gg",                                                                     0x000000 , 0x20000,	 CRC(2e217fae) SHA1(0d2fc2fa9e52e24cf0930e47c16e43a7c26adad7) )
CONSOLE_ROM_LOAD( ggsuperr, "super return of the jedi (usa, europe).gg",                                                 0x000000 , 0x80000,	 CRC(4a38b6b6) SHA1(a37858100903ad1e0224c870fe12419c25df90e0) )
CONSOLE_ROM_LOAD( ggsupers, "super smash t.v. (world).gg",                                                               0x000000 , 0x40000,	 CRC(1006e4e3) SHA1(85189e29f3f6b94f95723bc75571e9424df119f9) )
CONSOLE_ROM_LOAD( ggsupe12, "super space invaders (usa, europe).gg",                                                     0x000000 , 0x40000,	 CRC(dfe38e24) SHA1(3864c399f76e67ae4ff40d32a60c36ad16578988) )
CONSOLE_ROM_LOAD( ggsupert, "super tetris (k) [s][!].sms",                                                               0x000000 , 0x10000,	 CRC(bd1cc7df) SHA1(3772e9dc07b15de62326ee78981ec0b6f4387590) )
CONSOLE_ROM_LOAD( ggsupe13, "superman - the man of steel (europe).gg",                                                   0x000000 , 0x40000,	 CRC(73df5a15) SHA1(8e0d837cf285d8669d30ef1328453949cea70a6a) )
CONSOLE_ROM_LOAD( ggsurfni, "surf ninjas (usa).gg",                                                                      0x000000 , 0x80000,	 CRC(284482a8) SHA1(23e493f7c19ffb17e67392289c5a72dc9d0d6d9e) )
CONSOLE_ROM_LOAD( ggsylvan, "sylvan tale (japan).gg",                                                                    0x000000 , 0x80000,	 CRC(45ef2062) SHA1(bec44ab675bcd6b081590d4d52b6af4076c342e6) )
CONSOLE_ROM_LOAD( ggt2thea, "t2 - the arcade game (usa, europe).gg",                                                     0x000000 , 0x80000,	 CRC(9479c83a) SHA1(12b6f5542b6cebfe872096eab2a885d297eefa2f) )
CONSOLE_ROM_LOAD( ggtailsa, "tails adventures (world) (en,ja).gg",                                                       0x000000 , 0x80000,	 CRC(5bb6e5d6) SHA1(da3df145b8e9f2a2e680d2c92939084d4530ed90) )
CONSOLE_ROM_LOAD( ggtailsn, "tails no skypatrol (japan).gg",                                                             0x000000 , 0x40000,	 CRC(88618afa) SHA1(9cb440611e9e3a7957438698fede0978d568a807) )
CONSOLE_ROM_LOAD( ggtaisen, "taisen mahjong haopai (japan).gg",                                                          0x000000 , 0x20000,	 CRC(cf9c607c) SHA1(9cd50acaab1c2452e5a231e1a5646c3c38b50d9c) )
CONSOLE_ROM_LOAD( ggtaise1, "taisen mahjong haopai 2 (japan).gg",                                                        0x000000 , 0x80000,	 CRC(20527530) SHA1(8dfd49a2e740a232efc52ceefc85f51cf292d75e) )
CONSOLE_ROM_LOAD( ggtaise2, "taisen-gata daisenryaku g (japan).gg",                                                      0x000000 , 0x40000,	 CRC(7b7717b8) SHA1(d290bba12f4b7341c3ce2a00be8b8d7e548327e1) )
CONSOLE_ROM_LOAD( ggtaitoc, "taito chase h.q. (japan).sms",                                                              0x000000 , 0x20000,	 CRC(7bb81e3d) SHA1(b757b45a07ae6530443862e0eca547e16c23b4a3) )
CONSOLE_ROM_LOAD( ggtalesp, "tale spin (usa, europe).gg",                                                                0x000000 , 0x40000,	 CRC(f1732ffe) SHA1(60e5c27a07a69969ea1ba830cc82df33a5fbf227) )
CONSOLE_ROM_LOAD( ggtamafr, "tama & friends sanchoume kouen - tamalympic (japan).gg",                                    0x000000 , 0x40000,	 CRC(dd1d2ebf) SHA1(c8bf11726a152a88f2b1d900bbd974775a8e608b) )
CONSOLE_ROM_LOAD( ggtarotn, "tarot no yakata (japan).gg",                                                                0x000000 , 0x20000,	 CRC(57834c03) SHA1(b8b45b2e59f5d3239984205c120421923d833505) )
CONSOLE_ROM_LOAD( ggtarzan, "tarzan - lord of the jungle (europe).gg",                                                   0x000000 , 0x40000,	 CRC(ef3afe8b) SHA1(a787db71f221c71a89f39c6c3a153c43d6d5555a) )
CONSOLE_ROM_LOAD( ggtataka, "tatakae! pro yakyuu twin league (japan).gg",                                                0x000000 , 0x80000,	 CRC(bec57602) SHA1(8c629941ae7077862dd516283c656b5212920936) )
CONSOLE_ROM_LOAD( ggtazine, "taz in escape from mars (prototype - aug 10, 1994).gg",                 0x000000 , 0x80000,	 CRC(92388016) SHA1(ed5a66c278fc429fd4ddb993c4a7bdf2d2400a3a) )
CONSOLE_ROM_LOAD( ggtazin1, "taz in escape from mars (prototype - aug 12, 1994).gg",                 0x000000 , 0x80000,	 CRC(a43fdfad) SHA1(6482e281447b586c533a45527db52bd5c333ebdd) )
CONSOLE_ROM_LOAD( ggtazin2, "taz in escape from mars (prototype - aug 14, 1994).gg",                 0x000000 , 0x80000,	 CRC(9267d968) SHA1(8800da06ea2aa3982cf2e294b165f5e1a9cab63c) )
CONSOLE_ROM_LOAD( ggtazin3, "taz in escape from mars (prototype - aug 15, 1994).gg",                 0x000000 , 0x80000,	 CRC(9267d968) SHA1(8800da06ea2aa3982cf2e294b165f5e1a9cab63c) )
CONSOLE_ROM_LOAD( ggtazin4, "taz in escape from mars (prototype - aug 19, 1994).gg",                 0x000000 , 0x80000,	 CRC(57747640) SHA1(d32127a67f988062407d92bb1dfdf3ce38210e31) )
CONSOLE_ROM_LOAD( ggtazin5, "taz in escape from mars (prototype - aug 23, 1994).gg",                 0x000000 , 0x80000,	 CRC(6cd0fd78) SHA1(9cc498d9975fa2633a4ec98581768856884163a8) )
CONSOLE_ROM_LOAD( ggtazin6, "taz in escape from mars (prototype - aug 29, 1994 - b).gg",             0x000000 , 0x80000,	 CRC(3c03919d) SHA1(b1b5f7b06001f38e0533bc489b5c7f8b9caf6a5b) )
CONSOLE_ROM_LOAD( ggtazin7, "taz in escape from mars (prototype - aug 30, 1994).gg",                 0x000000 , 0x80000,	 CRC(09679b89) SHA1(20c0398e036f733734d2d38e8d2e3e57a1086106) )
CONSOLE_ROM_LOAD( ggtazin8, "taz in escape from mars (prototype - may 11, 1994).gg",                 0x000000 , 0x40000,	 CRC(030f396a) SHA1(47b98ee8dfe407bac65fd02257e99221feb088fc) )
CONSOLE_ROM_LOAD( ggtazin9, "taz in escape from mars (prototype - sep 02, 1994).gg",                 0x000000 , 0x80000,	 CRC(18913d93) SHA1(afca21f4f5337540343b6c74f36d6b2d0c9ca6c9) )
CONSOLE_ROM_LOAD( ggtazi10, "taz in escape from mars (prototype - sep 05, 1994 - b).gg",             0x000000 , 0x80000,	 CRC(d84a631c) SHA1(02b726d8c0da2f51076ad95ddc750d423636a807) )
CONSOLE_ROM_LOAD( ggtazi11, "taz in escape from mars (prototype - sep 05, 1994 - c).gg",             0x000000 , 0x80000,	 CRC(61330a58) SHA1(b383c0e67e47bb1b6f2402948408da1d5418c354) )
CONSOLE_ROM_LOAD( ggtazi12, "taz in escape from mars (prototype - sep 06, 1994 - d).gg",             0x000000 , 0x80000,	 CRC(1f040bca) SHA1(5fb66139767319777153faddbdfdb1168f898546) )
CONSOLE_ROM_LOAD( ggtazi13, "taz in escape from mars (prototype - sep 09, 1994 - b).gg",             0x000000 , 0x80000,	 CRC(c867da05) SHA1(c3cbe41444dadd60a0f79af213a50eab552f083f) )
CONSOLE_ROM_LOAD( ggtazi14, "taz in escape from mars (prototype - sep 10, 1994).gg",                 0x000000 , 0x80000,	 CRC(faf4bec0) SHA1(3d0da9536c47ecad367a83a6645172cee46b2ca8) )
CONSOLE_ROM_LOAD( ggtazi15, "taz in escape from mars (usa, europe).gg",                                                  0x000000 , 0x80000,	 CRC(eebad66b) SHA1(1d19306b7dbcb37fd1ab62021b5054efd2d04889) )
CONSOLE_ROM_LOAD( ggtazman, "taz-mania - the search for the lost seabirds (usa, europe).gg",                             0x000000 , 0x40000,	 CRC(36040c24) SHA1(0d0285bc5350146f365dae1f271ed0828971cf4d) )
CONSOLE_ROM_LOAD( ggtempoj, "tempo jr. (prototype - dec 05, 1994).gg",                               0x000000 , 0x80000,	 CRC(3475d48e) SHA1(c86b63d669464cba8bf167c33cfa8dc5bf1625b4) )
CONSOLE_ROM_LOAD( ggtempo1, "tempo jr. (prototype - dec 12, 1994).gg",                               0x000000 , 0x80000,	 CRC(fb9a5885) SHA1(6112068a8b6ad0e34afc2d576c2ef7e95af32c6d) )
CONSOLE_ROM_LOAD( ggtempo2, "tempo jr. (prototype - dec 26, 1994).gg",                               0x000000 , 0x80000,	 CRC(e484e41c) SHA1(9fb56c4cb39f48bdfb6a16a7af40b85888d81b3b) )
CONSOLE_ROM_LOAD( ggtempo3, "tempo jr. (prototype - feb 06, 1995).gg",                               0x000000 , 0x80000,	 CRC(3ef6551c) SHA1(f3a25425c939a3190c15a1c35a86cde116dcc5ea) )
CONSOLE_ROM_LOAD( ggtempo4, "tempo jr. (prototype - feb 15, 1995).gg",                               0x000000 , 0x80000,	 CRC(79e83d67) SHA1(bb2cfeb11e0319021a83a63556bd5e4f98e3d217) )
CONSOLE_ROM_LOAD( ggtempo5, "tempo jr. (prototype - jan 17, 1995).gg",                               0x000000 , 0x80000,	 CRC(ab6dc88c) SHA1(987bbf9f394a3aa7e79a95b847b093e45d532296) )
CONSOLE_ROM_LOAD( ggtempo6, "tempo jr. (prototype - jan 20, 1995).gg",                               0x000000 , 0x80000,	 CRC(96d64b16) SHA1(01a81e62f04759993d1fb865aa5f7feb086e15ec) )
CONSOLE_ROM_LOAD( ggtempo7, "tempo jr. (prototype - jan 31, 1995).gg",                               0x000000 , 0x80000,	 CRC(7afedf36) SHA1(75a0914f97622c3f148b7874a8b8ce564a150eae) )
CONSOLE_ROM_LOAD( ggtempo8, "tempo jr. (prototype - nov 28, 1994).gg",                               0x000000 , 0x80000,	 CRC(a33b5b92) SHA1(d909b2b153e500c506a5cee3439d3c514c58600b) )
CONSOLE_ROM_LOAD( ggtempo9, "tempo jr. (world).gg",                                                                      0x000000 , 0x80000,	 CRC(de466796) SHA1(a2d800d2836a03f81dd8f3dda23cd2d8bfff18a5) )
CONSOLE_ROM_LOAD( ggtengen, "tengen world cup soccer (usa, europe).gg",                                                  0x000000 , 0x40000,	 CRC(dd6d2e34) SHA1(8e1beab60e120924656d8a741a38b112abd7ef97) )
CONSOLE_ROM_LOAD( ggtermin, "terminator 2 - judgment day (usa, europe).gg",                                              0x000000 , 0x40000,	 CRC(1bd15773) SHA1(833c94ea65a7c36349b2bb0b2b637116f54a6762) )
CONSOLE_ROM_LOAD( ggtermi1, "terminator, the (usa, europe).gg",                                                          0x000000 , 0x40000,	 CRC(c029a5fd) SHA1(1889d019bd9f5919517805a2e02a9691de5ef634) )
CONSOLE_ROM_LOAD( ggtesser, "tesserae (usa, europe).gg",                                                                 0x000000 , 0x20000,	 CRC(ca0e11cc) SHA1(2b2652c7e03218b212e4d6a6246bd70e925e7ee1) )
CONSOLE_ROM_LOAD( ggtintin, "tintin in tibet (europe) (en,fr,de,es,nl,sv).gg",                                           0x000000 , 0x80000,	 CRC(969cf389) SHA1(2fdf4a953b53578befd69e9477ac6148cfa1c67c) )
CONSOLE_ROM_LOAD( ggtomand, "tom and jerry - the movie (usa).gg",                                                        0x000000 , 0x40000,	 CRC(5cd33ff2) SHA1(514f8bc2e9306f4005d5a8aa2dc49304d48bfc82) )
CONSOLE_ROM_LOAD( ggtorare, "torarete tamaruka (japan).gg",                                                              0x000000 , 0x80000,	 CRC(5bcf9b97) SHA1(fa87ac6b14c4b9eaa91fa8e4550b3c9049dd8ef2) )
CONSOLE_ROM_LOAD( ggtrueli, "true lies (world).gg",                                                                      0x000000 , 0x80000,	 CRC(5173b02a) SHA1(7ee525e68b9f3bca2a5bdd6de14711108dcbc288) )
CONSOLE_ROM_LOAD( ggultima, "ultimate soccer (japan, europe) (en,fr,de,es,it).gg",                                       0x000000 , 0x40000,	 CRC(820965a3) SHA1(7994621926628d2376a75e8d90cd066d48a4d502) )
CONSOLE_ROM_LOAD( ggurbans, "urban strike (usa, europe).gg",                                                             0x000000 , 0x80000,	 CRC(185e9fc1) SHA1(2d33d049a7f3dcde8c4f294cca5597ca590bb407) )
CONSOLE_ROM_LOAD( ggvampir, "vampire - master of darkness (usa).gg",                                                     0x000000 , 0x40000,	 CRC(7ec64025) SHA1(14e6b1e886355d902b34acdf503eced8df88afe4) )
CONSOLE_ROM_LOAD( ggvirtua, "virtua fighter animation (usa, europe).gg",                                                 0x000000 , 0x100000,	 CRC(d431c452) SHA1(222f3e49f595ceb4263af329c4021d64fc4772e6) )
CONSOLE_ROM_LOAD( ggvirtu1, "virtua fighter mini (japan).gg",                                                            0x000000 , 0x100000,	 CRC(c05657f8) SHA1(b0622ef2e58fc38af35ead0a632babc4bfe49e86) )
CONSOLE_ROM_LOAD( ggvrtroo, "vr troopers (usa, europe).gg",                                                              0x000000 , 0x80000,	 CRC(b0f22745) SHA1(0986935cee44541c1e24bcd4dc3d9f87f324bbbe) )
CONSOLE_ROM_LOAD( ggwaganl, "wagan land (japan).gg",                                                                     0x000000 , 0x40000,	 CRC(29e697b2) SHA1(6b74f3fddabd52ac6bb1b812043537154f8a43c5) )
CONSOLE_ROM_LOAD( ggwagyan, "wagyan land (j) [a1].gg",                                                                   0x000000 , 0x40000,	 CRC(d5369192) SHA1(1f5e511f6230797ef163b587f1988f097e795a61) )
CONSOLE_ROM_LOAD( ggwheelo, "wheel of fortune (usa).gg",                                                                 0x000000 , 0x20000,	 CRC(e91cdb2a) SHA1(5d3ce8b008e81bdda2e12b8036b4efb6dff69b9f) )
CONSOLE_ROM_LOAD( ggwimble, "wimbledon (world).gg",                                                                      0x000000 , 0x20000,	 CRC(ce1108fd) SHA1(6aa588e0aa93c5c74c80f7044de49933291af4e9) )
CONSOLE_ROM_LOAD( ggwinter, "winter olympics - lillehammer '94 (japan) (en,fr,de,es,it,pt,sv,no).gg",                    0x000000 , 0x80000,	 CRC(d5195a39) SHA1(578fc35fe155dca2c9adf17464d23aaf8205148f) )
CONSOLE_ROM_LOAD( ggwinte1, "winter olympics - lillehammer '94 (usa, europe) (en,fr,de,es,it,pt,sv,no).gg",              0x000000 , 0x80000,	 CRC(d15d335b) SHA1(6f9942792072626f1322e11835dbc5e2e94aa718) )
CONSOLE_ROM_LOAD( ggwizard, "wizard pinball (europe).gg",                                                                0x000000 , 0x40000,	 CRC(9e03f96c) SHA1(22c4165f41066d9a525543d716162bd70a39e9fb) )
CONSOLE_ROM_LOAD( ggwolfch, "wolfchild (europe).gg",                                                                     0x000000 , 0x40000,	 CRC(840a8f8e) SHA1(7889b67ee0e5c884fa267688aad4b6c23849268c) )
CONSOLE_ROM_LOAD( ggwonder, "wonder boy (europe).gg",                                                                    0x000000 , 0x20000,	 CRC(ea2dd3a7) SHA1(f2c546bc87c5e89719fe01a59142bb3250861b83) )
CONSOLE_ROM_LOAD( ggwonde1, "wonder boy (japan).gg",                                                                     0x000000 , 0x20000,	 CRC(9977fcb3) SHA1(7ff0f0757c7b2e84d99a4291656d74a20ec2651d) )
CONSOLE_ROM_LOAD( ggwonde2, "wonder boy - the dragon's trap (europe).gg",                                                0x000000 , 0x40000,	 CRC(a74c97a7) SHA1(d98344a2c644ce9a0184e8f836271c038aa16a23) )
CONSOLE_ROM_LOAD( ggwonde3, "wonder boy iii - the dragon's trap (europe) (beta).gg",                                     0x000000 , 0x40000,	 CRC(db1b5b44) SHA1(5108c4920b4a14fd06f1a024e1be5f6bf233bd84) )
CONSOLE_ROM_LOAD( ggwoodyp, "woody pop (usa, europe) (v1.1).gg",                                                         0x000000 , 0x8000,	 CRC(b74f3a4f) SHA1(4efbfa1d3234d8f1800a06ab72b2177fba6914cb) )
CONSOLE_ROM_LOAD( ggwoody1, "woody pop (usa, europe).gg",                                                                0x000000 , 0x8000,	 CRC(9c0e5a04) SHA1(9e7defda6873b7bca5650fad4426a6fb443522d8) )
CONSOLE_ROM_LOAD( ggworldc, "world class leader board (usa, europe).gg",                                                 0x000000 , 0x40000,	 CRC(868fe528) SHA1(23b28cf137adc947ffd1af649cf3c8d64e6fadc1) )
CONSOLE_ROM_LOAD( ggworld1, "world cup usa 94 (usa, europe) (en,fr,de,es,it,nl,pt,sv).gg",                               0x000000 , 0x80000,	 CRC(d2bb3690) SHA1(5596ecb5b7a28027e5c0ad1c8acc73c45e7a1265) )
CONSOLE_ROM_LOAD( ggworldd, "world derby (japan).gg",                                                                    0x000000 , 0x80000,	 CRC(1e81861f) SHA1(af96e8d9470df941c7c356cc9b6e143a3c44dd86) )
CONSOLE_ROM_LOAD( ggworlds, "world series baseball '95 (prototype - jul 09, 1994).gg",               0x000000 , 0x80000,	 CRC(410f1ca0) SHA1(a1f06ac03e229b6be08e995365bf6ffda0b32184) )
CONSOLE_ROM_LOAD( ggworld2, "world series baseball '95 (prototype - jul 19, 1994).gg",               0x000000 , 0x80000,	 CRC(5f7cca5f) SHA1(7b9750f398f1bab2a6d10df58e610a4ce59287bb) )
CONSOLE_ROM_LOAD( ggworld3, "world series baseball '95 (prototype - jul 22, 1994).gg",               0x000000 , 0x80000,	 CRC(6073cd59) SHA1(149f8d34be9f2cfc080f5e192712a134656d12f3) )
CONSOLE_ROM_LOAD( ggworld4, "world series baseball '95 (prototype - jul 28, 1994).gg",               0x000000 , 0x80000,	 CRC(4190ad97) SHA1(fddf978dc5c29ca234080fff32680fbf66d7be2c) )
CONSOLE_ROM_LOAD( ggworld5, "world series baseball '95 (prototype - jul 29, 1994).gg",               0x000000 , 0x80000,	 CRC(f1987de6) SHA1(5ba283dff711ad4a32d52aa077829dda43d52eaa) )
CONSOLE_ROM_LOAD( ggworld6, "world series baseball '95 (prototype - jun 29, 1994).gg",               0x000000 , 0x80000,	 CRC(496515a6) SHA1(3e05e8b9628853d05aef16a6b7d09e307c989548) )
CONSOLE_ROM_LOAD( ggworld7, "world series baseball '95 (usa).gg",                                                        0x000000 , 0x80000,	 CRC(578a8a38) SHA1(66d31ed6bb6dfedd769bf5e6c5dcbf899f2f2c8c) )
CONSOLE_ROM_LOAD( ggworld8, "world series baseball (usa) (v1.1).gg",                                                     0x000000 , 0x40000,	 CRC(bb38cfd7) SHA1(333dd99f11781d6de5720043530a460a409d652b) )
CONSOLE_ROM_LOAD( ggworld9, "world series baseball (usa).gg",                                                            0x000000 , 0x40000,	 CRC(3d8d0dd6) SHA1(ccfd03edf130f28e6bb4c2764df7ace7bbe9e159) )
CONSOLE_ROM_LOAD( ggwwfraw, "wwf raw (usa, europe).gg",                                                                  0x000000 , 0x80000,	 CRC(8dc68d92) SHA1(585e147026bd998062e64ed3c0aaa0a07e6ee734) )
CONSOLE_ROM_LOAD( ggwwfwre, "wwf wrestlemania steel cage challenge (europe).sms",                                        0x000000 , 0x40000,	 CRC(da8e95a9) SHA1(59e2fab18a0244efcc9cb9ad1e4ed3a1c777948d) )
CONSOLE_ROM_LOAD( ggxmenus, "x-men (usa).gg",                                                                            0x000000 , 0x80000,	 CRC(567a5ee6) SHA1(215e5f761475ca17a091371e39f636718f213403) )
CONSOLE_ROM_LOAD( ggxmenga, "x-men - gamemaster's legacy (prototype - aug 10, 1994).gg",             0x000000 , 0x80000,	 CRC(66cc4034) SHA1(46237cf1c2810a8f2e5c31907a1ae04b647256c8) )
CONSOLE_ROM_LOAD( ggxmeng1, "x-men - gamemaster's legacy (prototype - aug 15, 1994).gg",             0x000000 , 0x80000,	 CRC(66cc4034) SHA1(46237cf1c2810a8f2e5c31907a1ae04b647256c8) )
CONSOLE_ROM_LOAD( ggxmeng2, "x-men - gamemaster's legacy (prototype 36 - aug 31, 1994).gg",          0x000000 , 0x80000,	 CRC(271a0a1d) SHA1(9df11129d4f7e55a1380b139d1bb0cdb4137a702) )
CONSOLE_ROM_LOAD( ggxmeng3, "x-men - gamemaster's legacy (prototype 51 - sep 06, 1994).gg",          0x000000 , 0x80000,	 CRC(a3cf94ba) SHA1(1078ef9c16cb997f61eddbd07c1bfbc5f74b177b) )
CONSOLE_ROM_LOAD( ggxmeng4, "x-men - gamemaster's legacy (usa, europe).gg",                                              0x000000 , 0x80000,	 CRC(c169c344) SHA1(872596d40aae1755c9dda99180cb165166267904) )
CONSOLE_ROM_LOAD( ggxmenmo, "x-men - mojo world (prototype - jun 05, 1996).gg",                      0x000000 , 0x80000,	 CRC(626f9987) SHA1(b9a4d3bd1f33a988b48fdffedabd26ddaf7d7ab5) )
CONSOLE_ROM_LOAD( ggxmenm1, "x-men - mojo world (prototype - jun 13, 1996).gg",                      0x000000 , 0x80000,	 CRC(c4f3ced4) SHA1(eb9646133ca49838c7d559492f1a059398abe34f) )
CONSOLE_ROM_LOAD( ggxmenm2, "x-men - mojo world (prototype - jun 24, 1996).gg",                      0x000000 , 0x80000,	 CRC(78001a5d) SHA1(e7d3af2bb027af159d02eb85b8810438af59c8dd) )
CONSOLE_ROM_LOAD( ggxmenm3, "x-men - mojo world (prototype - jun 25, 1996).gg",                      0x000000 , 0x80000,	 CRC(d4d2f077) SHA1(3ade7aeea0d0d5e65d4da24021b565de891e45a8) )
CONSOLE_ROM_LOAD( ggxmenm4, "x-men - mojo world (prototype - jun 27, 1996).gg",                      0x000000 , 0x80000,	 CRC(425ac73f) SHA1(5690f9609c641ea7718ddb8e7c36342eeb4a25dd) )
CONSOLE_ROM_LOAD( ggxmenm5, "x-men - mojo world (prototype - jun 28, 1996).gg",                      0x000000 , 0x80000,	 CRC(d44925ea) SHA1(97fce993a317cbc09825849a45bc2c2ab3e97179) )
CONSOLE_ROM_LOAD( ggxmenm6, "x-men - mojo world (prototype - jun 29, 1996).gg",                      0x000000 , 0x80000,	 CRC(ba71da19) SHA1(cc3fc3b57bcd4daea90a572c935013d286ebbb99) )
CONSOLE_ROM_LOAD( ggxmenm7, "x-men - mojo world (usa, europe).gg",                                                       0x000000 , 0x80000,	 CRC(c2cba9d7) SHA1(cff15c4a3e555c2868af93c55386b5ab3d3db4e3) )
CONSOLE_ROM_LOAD( ggyogibe, "yogi bear in yogi bear's goldrush (unknown) (proto).gg",                                    0x000000 , 0x40000,	 CRC(e678f264) SHA1(ea5f9ce4b3618565ea24a858f7efe3988b82eb8a) )
CONSOLE_ROM_LOAD( ggyuyuha, "yu yu hakusho - horobishimono no gyakushuu (japan).gg",                                     0x000000 , 0x80000,	 CRC(88ebbf9e) SHA1(e75803c9241094f7cfe251b99cd370228cc0923c) )
CONSOLE_ROM_LOAD( ggyuyuh1, "yu yu hakusho 2 - gekitou! nanakyou no tatakai (japan).gg",                                 0x000000 , 0x80000,	 CRC(46ae9159) SHA1(140efe67e886f52aeda2089a73599f7680c89f24) )
CONSOLE_ROM_LOAD( ggzangea, "zan gear (japan).gg",                                                                       0x000000 , 0x20000,	 CRC(141aaf96) SHA1(115074a58606720755364eaf0a4bc60aabf18f94) )
CONSOLE_ROM_LOAD( ggzoolus, "zool (usa).gg",                                                                             0x000000 , 0x40000,	 CRC(b287c695) SHA1(8143c1d5e6c677ae5dd8143620b9fd02be8873f6) )
CONSOLE_ROM_LOAD( ggzoolno, "zool no yume bouken (japan).gg",                                                            0x000000 , 0x40000,	 CRC(e35ef7ed) SHA1(2c799ee084b858cb71cfaa7a3f6d3a4f364b6c43) )
CONSOLE_ROM_LOAD( ggzoopeu, "zoop (europe).gg",                                                                          0x000000 , 0x20000,	 CRC(f397f041) SHA1(f704412387c1fe91d94d2c1405f8a49768320d0c) )
CONSOLE_ROM_LOAD( ggzoopus, "zoop (usa).gg",                                                                             0x000000 , 0x20000,	 CRC(3247ff8b) SHA1(f58359ffa7bc3ec82913be128d141e5d41926b88) )
CONSOLE_ROM_LOAD( ggbiosse, "[bios] sega game gear (usa) (majesco).gg",                                                  0x000000 , 0x400,	 CRC(0ebea9d4) SHA1(914aa165e3d879f060be77870d345b60cfeb4ede) )


GAME( 19??, gg5in1fu, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) 5 in 1 Funpak (USA)", 0)
GAME( 19??, ggaahari, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Aa Harimanada (Japan)", 0)
GAME( 19??, ggaddams, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Addams Family, The (World)", 0)
GAME( 19??, ggadvent, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - Apr 27, 1995)", 0)
GAME( 19??, ggadven1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - Apr 29, 1995 - A)", 0)
GAME( 19??, ggadven2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - Apr 30, 1995)", 0)
GAME( 19??, ggadven3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - May 02, 1995)", 0)
GAME( 19??, ggadven4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - May 04, 1995)", 0)
GAME( 19??, ggadven5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - May 06, 1995 - B)", 0)
GAME( 19??, ggadven6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - May 06, 1995)", 0)
GAME( 19??, ggadven7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (Prototype - May 07, 1995)", 0)
GAME( 19??, ggadven8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Adventures of Batman & Robin, The (USA, Europe)", 0)
GAME( 19??, ggaerial, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Aerial Assault (Japan) (v1.1)", 0)
GAME( 19??, ggaeria1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Aerial Assault (World)", 0)
GAME( 19??, ggaladdi, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Aladdin (Japan)", 0)
GAME( 19??, ggaladd1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Aladdin (Prototype - Dec 29, 1993)", 0)
GAME( 19??, ggaladd2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Aladdin (Prototype - Jan 11, 1994)", 0)
GAME( 19??, ggaladd3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Aladdin (Prototype - Jan 13, 1994)", 0)
GAME( 19??, ggaladd4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Aladdin (Prototype WITH - Jan 23, 1994)", 0)
GAME( 19??, ggaladd5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Aladdin (USA, Europe)", 0)
GAME( 19??, ggalienu, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Alien 3 (USA, Europe)", 0)
GAME( 19??, ggaliens, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Alien Syndrome (Japan)", 0)
GAME( 19??, ggalien1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Alien Syndrome (USA, Europe)", 0)
GAME( 19??, ggandrea, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Andre Agassi Tennis (USA)", 0)
GAME( 19??, ggarcade, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Arcade Classics (USA)", 0)
GAME( 19??, ggarchri, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Arch Rivals (USA)", 0)
GAME( 19??, ggarenau, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Arena (USA, Europe)", 0)
GAME( 19??, ggarielt, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ariel the Little Mermaid (USA, Europe)", 0)
GAME( 19??, ggarliel, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Arliel - Crystal Densetsu (Japan)", 0)
GAME( 19??, ggasteri, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Asterix (Prototype - Feb 16, 1994)", 0)
GAME( 19??, ggaster1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Asterix (Prototype - Feb 22, 1994)", 0)
GAME( 19??, ggaster2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Asterix (Prototype - Jan 25, 1994)", 0)
GAME( 19??, ggaster3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Asterix (Prototype - Mar 13, 1994)", 0)
GAME( 19??, ggaster4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Asterix (Prototype - Mar 15, 1994)", 0)
GAME( 19??, ggaster5, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Asterix and the Great Rescue (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, ggaster6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Asterix and the Great Rescue (USA)", 0)
GAME( 19??, ggaster7, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Asterix and the Secret Mission (Europe) (En,Fr,De)", 0)
GAME( 19??, ggaxbatt, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ax Battler - A Legend of Golden Axe (USA, Europe) (v2.4)", 0)
GAME( 19??, ggaxbat1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ax Battler - Golden Axe Densetsu (Japan) (v1.5)", 0)
GAME( 19??, ggayrton, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ayrton Senna's Super Monaco GP II (Japan)", 0)
GAME( 19??, ggayrto1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ayrton Senna's Super Monaco GP II (USA, Europe)", 0)
GAME( 19??, ggbakuba, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Baku Baku Animal (USA)", 0)
GAME( 19??, ggbakub1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Baku Baku Animal - Sekai Shiikugakari Senshu-ken (Japan)", 0)
GAME( 19??, ggbarbie, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Barbie Super Model (Unknown) (Proto)", 0)
GAME( 19??, ggbartma, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bartman Meets Radioactive Man (USA, Europe)", 0)
GAME( 19??, ggbatman, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Batman Forever (World)", 0)
GAME( 19??, ggbatma1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Batman Returns (World)", 0)
GAME( 19??, ggbatter, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Batter Up (USA, Europe)", 0)
GAME( 19??, ggbattle, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Battleship (USA, Europe)", 0)
GAME( 19??, ggbattl1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Battletoads (Japan, Europe)", 0)
GAME( 19??, ggbattl2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Battletoads (USA)", 0)
GAME( 19??, ggbeavis, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Beavis and Butt-head (Europe)", 0)
GAME( 19??, ggbeavi1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Beavis and Butt-head (USA)", 0)
GAME( 19??, ggberens, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 01, 1994)", 0)
GAME( 19??, ggberen1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 11, 1994 - A)", 0)
GAME( 19??, ggberen2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 11, 1994)", 0)
GAME( 19??, ggberen3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 12, 1994)", 0)
GAME( 19??, ggberen4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 13, 1994)", 0)
GAME( 19??, ggberen5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 14, 1994)", 0)
GAME( 19??, ggberen6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 19, 1994)", 0)
GAME( 19??, ggberen7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 20, 1994)", 0)
GAME( 19??, ggberen8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 24, 1994)", 0)
GAME( 19??, ggberen9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 25, 1994 - B)", 0)
GAME( 19??, ggbere10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 26, 1994 - B)", 0)
GAME( 19??, ggbere11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Aug 26, 1994)", 0)
GAME( 19??, ggbere12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Jul 15, 1994 - B)", 0)
GAME( 19??, ggbere13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Jul 21, 1994)", 0)
GAME( 19??, ggbere14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Jul 22, 1994)", 0)
GAME( 19??, ggbere15, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Jul 27, 1994)", 0)
GAME( 19??, ggbere16, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears (Prototype - Jun 28, 1994)", 0)
GAME( 19??, ggbere17, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Berenstain Bears' Camping Adventure, The (USA)", 0)
GAME( 19??, ggberlin, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Berlin no Kabe (Japan)", 0)
GAME( 19??, ggbishou, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Bishoujo Senshi Sailor Moon S (Japan)", 0)
GAME( 19??, ggbonker, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 03, 1994)", 0)
GAME( 19??, ggbonke1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 05, 1994)", 0)
GAME( 19??, ggbonke2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 07, 1994 - C)", 0)
GAME( 19??, ggbonke3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 08, 1994 - B)", 0)
GAME( 19??, ggbonke4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 08, 1994 - C)", 0)
GAME( 19??, ggbonke5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 11, 1994)", 0)
GAME( 19??, ggbonke6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 12, 1994 - B)", 0)
GAME( 19??, ggbonke7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Dec 12, 1994 - D)", 0)
GAME( 19??, ggbonke8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Nov 15, 1994)", 0)
GAME( 19??, ggbonke9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Nov 21, 1994)", 0)
GAME( 19??, ggbonk10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Nov 23, 1994)", 0)
GAME( 19??, ggbonk11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Nov 26, 1994)", 0)
GAME( 19??, ggbonk12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Nov 29, 1994)", 0)
GAME( 19??, ggbonk13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (Prototype - Oct 31, 1994)", 0)
GAME( 19??, ggbonk14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bonkers Wax Up! (USA, Europe)", 0)
GAME( 19??, ggbramst, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bram Stoker's Dracula (USA)", 0)
GAME( 19??, ggbubble, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bubble Bobble (USA, Europe)", 0)
GAME( 19??, ggbugsbu, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bugs Bunny in Double Trouble (USA, Europe)", 0)
GAME( 19??, ggbustam, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Bust-A-Move (USA, Europe)", 0)
GAME( 19??, ggbuster, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Buster Ball (Japan)", 0)
GAME( 19??, ggbuste1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Buster Fight (Japan)", 0)
GAME( 19??, ggcaesar, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Caesars Palace (USA)", 0)
GAME( 19??, ggcaptai, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Captain America and the Avengers (USA, Europe)", 0)
GAME( 19??, ggcarlic, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Car Licence (Japan)", 0)
GAME( 19??, ggcasino, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Casino Funpak (USA)", 0)
GAME( 19??, ggcastle, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Castle of Illusion Starring Mickey Mouse (USA, Europe) (SMS Mode?)", 0)
GAME( 19??, ggchakan, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chakan (USA, Europe)", 0)
GAME( 19??, ggchaseh, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chase H.Q. (J) [S][!]", 0)
GAME( 19??, ggchessm, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chessmaster, The (USA, Europe)", 0)
GAME( 19??, ggchicag, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 03, 1995)", 0)
GAME( 19??, ggchica1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 05, 1995)", 0)
GAME( 19??, ggchica2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 07, 1995)", 0)
GAME( 19??, ggchica3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 10, 1995)", 0)
GAME( 19??, ggchica4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 11, 1995)", 0)
GAME( 19??, ggchica5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 19, 1995)", 0)
GAME( 19??, ggchica6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 20, 1995)", 0)
GAME( 19??, ggchica7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 21, 1995 - B)", 0)
GAME( 19??, ggchica8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jul 21, 1995)", 0)
GAME( 19??, ggchica9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 01, 1995)", 0)
GAME( 19??, ggchic10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 05, 1995)", 0)
GAME( 19??, ggchic11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 07, 1995)", 0)
GAME( 19??, ggchic12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 08, 1995)", 0)
GAME( 19??, ggchic13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 12, 1995)", 0)
GAME( 19??, ggchic14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 14, 1995)", 0)
GAME( 19??, ggchic15, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 19, 1995)", 0)
GAME( 19??, ggchic16, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 20, 1995)", 0)
GAME( 19??, ggchic17, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 22, 1995)", 0)
GAME( 19??, ggchic18, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 26, 1995)", 0)
GAME( 19??, ggchic19, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 28, 1995)", 0)
GAME( 19??, ggchic20, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 29, 1995 - B)", 0)
GAME( 19??, ggchic21, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 29, 1995)", 0)
GAME( 19??, ggchic22, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - Jun 30, 1995 - B)", 0)
GAME( 19??, ggchic23, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (Prototype - May 05, 1995)", 0)
GAME( 19??, ggchic24, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chicago Syndicate (USA, Europe)", 0)
GAME( 19??, ggchopli, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Choplifter III (USA, Europe)", 0)
GAME( 19??, ggchuckr, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chuck Rock (World)", 0)
GAME( 19??, ggchuck1, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Chuck Rock II - Son of Chuck (Europe)", 0)
GAME( 19??, ggchuck2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Chuck Rock II - Son of Chuck (USA)", 0)
GAME( 19??, ggcliffh, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Cliffhanger (USA, Europe)", 0)
GAME( 19??, ggclutch, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Clutch Hitter (USA)", 0)
GAME( 19??, ggcocaco, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Coca Cola Kid (Japan)", 0)
GAME( 19??, ggcolumn, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Columns (Japan)", 0)
GAME( 19??, ggcolum1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Columns (USA, Europe)", 0)
GAME( 19??, ggcoolsp, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Cool Spot (USA)", 0)
GAME( 19??, ggcosmic, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Cosmic Spacehead (Europe)", 0)
GAME( 19??, ggcrayon, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Crayon Shin-chan - Taiketsu! Kantam Panic!! (Japan)", 0)
GAME( 19??, ggcrysta, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Crystal Warriors (USA, Europe)", 0)
GAME( 19??, ggcutthr, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Cutthroat Island (USA, Europe)", 0)
GAME( 19??, ggdaffyd, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Daffy Duck in Hollywood (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, ggdeepdu, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Deep Duck Trouble Starring Donald Duck (USA, Europe)", 0)
GAME( 19??, ggdefend, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Defenders of Oasis (USA, Europe)", 0)
GAME( 19??, ggdesert, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Desert Speedtrap (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, ggdeser1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Desert Speedtrap (USA)", 0)
GAME( 19??, ggdeser2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Desert Strike - Return to the Gulf (USA, Europe)", 0)
GAME( 19??, ggdevili, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Devilish (Europe)", 0)
GAME( 19??, ggdevil1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Devilish (Japan)", 0)
GAME( 19??, ggdevil2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Devilish (USA)", 0)
GAME( 19??, ggdonald, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Donald Duck no 4-Tsu no Hihou (Japan)", 0)
GAME( 19??, ggdonal1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Donald Duck no Lucky Dime (Japan)", 0)
GAME( 19??, ggdonal2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Donald no Magical World (Japan) (En,Ja)", 0)
GAME( 19??, ggdoraem, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Doraemon - Waku Waku Pocket Paradise (Japan)", 0)
GAME( 19??, ggdouble, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Double Dragon (USA, Europe) (Beta)", 0)
GAME( 19??, ggdoubl1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Double Dragon (USA, Europe)", 0)
GAME( 19??, ggdrrobo, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Dr. Robotnik's Mean Bean Machine (USA, Europe)", 0)
GAME( 19??, ggdragon, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Dragon - The Bruce Lee Story (Europe)", 0)
GAME( 19??, ggdrago1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Dragon - The Bruce Lee Story (USA)", 0)
GAME( 19??, ggdrago2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Dragon Crystal (USA, Europe)", 0)
GAME( 19??, ggdrago3, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Dragon Crystal - Tsurani no Meikyuu (Japan)", 0)
GAME( 19??, ggdropzo, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Dropzone (Europe)", 0)
GAME( 19??, ggdunkki, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Dunk Kids (Japan)", 0)
GAME( 19??, ggdynami, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Dynamite Headdy (Japan)", 0)
GAME( 19??, ggdynam1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Dynamite Headdy (Prototype - Jul 01, 1994)", 0)
GAME( 19??, ggdynam2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Dynamite Headdy (Prototype - Jul 05, 1994)", 0)
GAME( 19??, ggdynam3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Dynamite Headdy (Prototype - Jun 15, 1994)", 0)
GAME( 19??, ggdynam4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Dynamite Headdy (USA, Europe)", 0)
GAME( 19??, ggearthw, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Earthworm Jim (USA)", 0)
GAME( 19??, ggeccoii, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ecco II - The Tides of Time (USA, Europe)", 0)
GAME( 19??, ggeccoth, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ecco the Dolphin (Japan)", 0)
GAME( 19??, ggeccot1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ecco the Dolphin (USA, Europe)", 0)
GAME( 19??, ggeccot2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ecco the Dolphin II (Japan)", 0)
GAME( 19??, ggerniee, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Ernie Els Golf (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, ggeterna, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Eternal Legend - Eien no Densetsu (Japan)", 0)
GAME( 19??, ggevande, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Evander Holyfield Boxing (USA, Europe)", 0)
GAME( 19??, ggexcell, 0       , gge, gamegear, smscm, ROT0, "Sega License", "(Game Gear) Excellent Dizzy Collection, The (Europe) (SMS Mode?)", 0)
GAME( 19??, ggexcel1, 0       , ggu, gamegear, smscm, ROT0, "Sega License", "(Game Gear) Excellent Dizzy Collection, The (Prototype) [S][!]", 0)
GAME( 19??, ggf15str, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) F-15 Strike Eagle (USA, Europe)", 0)
GAME( 19??, ggf1usae, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) F1 (USA, Europe)", 0)
GAME( 19??, ggfaceba, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Faceball 2000 (Japan)", 0)
GAME( 19??, ggfactor, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Factory Panic (Europe)", 0)
GAME( 19??, ggfantas, 0       , gge, gamegear, smscm, ROT0, "Sega License", "(Game Gear) Fantastic Dizzy (Europe) (En,Fr,De,Es,It) (SMS Mode?)", 0)
GAME( 19??, ggfanta1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Fantasy Zone Gear (Japan, Europe)", 0)
GAME( 19??, ggfanta2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Fantasy Zone Gear (JU) [a1]", 0)
GAME( 19??, ggfatalf, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Fatal Fury Special (USA)", 0)
GAME( 19??, ggfifain, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) FIFA International Soccer (Japan)", 0)
GAME( 19??, ggfifai1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) FIFA International Soccer (USA, Europe)", 0)
GAME( 19??, ggfifaso, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) FIFA Soccer 96 (USA, Europe) (En,Fr,De,Es)", 0)
GAME( 19??, ggforema, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Foreman for Real (World)", 0)
GAME( 19??, ggfrankt, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Frank Thomas Big Hurt Baseball (USA)", 0)
GAME( 19??, ggfraysh, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Fray - Shugyou Hen (Japan)", 0)
GAME( 19??, ggfredco, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Fred Couples' Golf (Japan)", 0)
GAME( 19??, ggfredc1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Fred Couples' Golf (USA)", 0)
GAME( 19??, ggfrogge, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Frogger (USA) (Proto)", 0)
GAME( 19??, ggfromtv, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) From TV Animation - Slam Dunk - Shouri e no Starting 5 (Japan)", 0)
GAME( 19??, ggglocai, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) G-LOC Air Battle (Japan) (v1.1)", 0)
GAME( 19??, gggloca1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) G-LOC Air Battle (Japan)", 0)
GAME( 19??, gggloca2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) G-LOC Air Battle (USA, Europe)", 0)
GAME( 19??, gggalaga, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Galaga '91 (Japan)", 0)
GAME( 19??, gggalag1, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Galaga 2 (Europe)", 0)
GAME( 19??, gggamble, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Gamble Panic (Japan)", 0)
GAME( 19??, gggambl1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Gambler Jikochuushinha (Japan)", 0)
GAME( 19??, ggganbar, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ganbare Gorby! (Japan)", 0)
GAME( 19??, gggarfie, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Garfield - Caught in the Act (USA, Europe)", 0)
GAME( 19??, gggaroud, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Garou Densetsu Special (Japan)", 0)
GAME( 19??, gggearst, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Gear Stadium (Japan)", 0)
GAME( 19??, gggears1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Gear Stadium Heiseiban (Japan)", 0)
GAME( 19??, gggearwo, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Gear Works (USA)", 0)
GAME( 19??, gggeorge, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) George Foreman's KO Boxing (USA, Europe)", 0)
GAME( 19??, ggggales, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) GG Aleste (Japan)", 0)
GAME( 19??, ggggdora, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) GG Doraemon - Noranosuke no Yabou (Japan)", 0)
GAME( 19??, ggggport, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) GG Portrait - Pai Chen (Japan)", 0)
GAME( 19??, ggggpor1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) GG Portrait - Yuuki Akira (Japan)", 0)
GAME( 19??, ggggshin, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) GG Shinobi, The (Japan)", 0)
GAME( 19??, gggodzil, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Godzilla - Kaijuu Daishingeki (Japan)", 0)
GAME( 19??, gggpride, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) GP Rider (Japan)", 0)
GAME( 19??, gggprid1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) GP Rider (Prototype - Jan 04, 1994)", 0)
GAME( 19??, gggprid2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) GP Rider (USA, Europe)", 0)
GAME( 19??, gggreend, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Greendog (USA, Europe)", 0)
GAME( 19??, gggriffi, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Griffin (Japan)", 0)
GAME( 19??, gggunsta, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Gunstar Heroes (Japan)", 0)
GAME( 19??, gghalley, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Halley Wars (Japan)", 0)
GAME( 19??, gghalle1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Halley Wars (USA, Europe)", 0)
GAME( 19??, ggheadbu, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Head Buster (Japan)", 0)
GAME( 19??, ggheavyw, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Heavy Weight Champ (Japan)", 0)
GAME( 19??, gghomeal, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Home Alone (USA, Europe)", 0)
GAME( 19??, gghonoon, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Honoo no Toukyuuji - Dodge Danpei (Japan)", 0)
GAME( 19??, gghookus, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Hook (USA, Europe)", 0)
GAME( 19??, gghurric, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Hurricanes (Europe)", 0)
GAME( 19??, gghyokko, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Hyokkori Hyoutan Jima - Hyoutan Jima no Daikoukai (Japan)", 0)
GAME( 19??, gghyperp, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Hyper Pro Yakyuu '92 (Japan)", 0)
GAME( 19??, ggichida, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ichidant~R GG (Japan)", 0)
GAME( 19??, gginthew, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) In the Wake of Vampire (Japan)", 0)
GAME( 19??, ggincred, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Incredible Crash Dummies, The (USA, Europe)", 0)
GAME( 19??, ggincre1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Incredible Hulk, The (USA, Europe)", 0)
GAME( 19??, ggindian, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Indiana Jones and the Last Crusade (U)", 0)
GAME( 19??, ggindia1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Indiana Jones and the Last Crusade (USA, Europe)", 0)
GAME( 19??, ggironma, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Iron Man X-O Manowar in Heavy Metal (U) [a1]", 0)
GAME( 19??, ggironm1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Iron Man X-O Manowar in Heavy Metal (USA, Europe)", 0)
GAME( 19??, ggitchys, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Itchy & Scratchy Game, The (USA, Europe)", 0)
GAME( 19??, ggjleagu, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) J.League GG Pro Striker '94 (Japan)", 0)
GAME( 19??, ggjleag1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) J.League Soccer - Dream Eleven (Japan)", 0)
GAME( 19??, ggjamesb, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) James Bond 007 - The Duel (Europe)", 0)
GAME( 19??, ggjamesp, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) James Pond 3 - Operation Starfi5h (Europe)", 0)
GAME( 19??, ggjames1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) James Pond II - Codename RoboCod (USA)", 0)
GAME( 19??, ggjangpu, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Jang Pung II (K) [S]", 0)
GAME( 19??, ggjeopar, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Jeopardy! (USA)", 0)
GAME( 19??, ggjeopa1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Jeopardy! - Sports Edition (USA, Europe)", 0)
GAME( 19??, ggjoemon, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Joe Montana's Football (Japan)", 0)
GAME( 19??, ggjoemo1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Joe Montana's Football (USA, Europe)", 0)
GAME( 19??, ggjourne, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Journey from Darkness - Strider Returns (USA, Europe)", 0)
GAME( 19??, ggjudged, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Judge Dredd (USA, Europe)", 0)
GAME( 19??, ggjuncti, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Junction (USA, Europe)", 0)
GAME( 19??, ggjungle, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Jungle Book, The (Europe)", 0)
GAME( 19??, ggjungl1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Jungle Book, The (USA)", 0)
GAME( 19??, ggjurass, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Jurassic Park (Japan)", 0)
GAME( 19??, ggjuras1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Jurassic Park (USA, Europe)", 0)
GAME( 19??, ggkaitou, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Kaitou Saint Tale (Japan)", 0)
GAME( 19??, ggkawasa, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Kawasaki Superbike Challenge (USA, Europe)", 0)
GAME( 19??, ggkenyuu, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Kenyuu Densetsu Yaiba (Japan)", 0)
GAME( 19??, ggkickru, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Kick & Rush (Japan)", 0)
GAME( 19??, ggkineti, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Kinetic Connection (Japan)", 0)
GAME( 19??, ggkishin, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Kishin Douji Zenki (Japan)", 0)
GAME( 19??, ggklaxus, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Klax (USA, Europe)", 0)
GAME( 19??, ggkrusty, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Krusty's Fun House (USA, Europe)", 0)
GAME( 19??, ggkunich, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Kuni-chan no Game Tengoku (Japan)", 0)
GAME( 19??, ggkunic1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Kuni-chan no Game Tengoku Part 2 (Japan)", 0)
GAME( 19??, gglandof, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Land of Illusion Starring Mickey Mouse (USA, Europe)", 0)
GAME( 19??, gglastac, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Last Action Hero (USA)", 0)
GAME( 19??, gglegend, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Legend of Illusion Starring Mickey Mouse (Prototype - Oct 11, 1994)", 0)
GAME( 19??, gglegen1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Legend of Illusion Starring Mickey Mouse (Prototype - Oct 14, 1994)", 0)
GAME( 19??, gglegen2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Legend of Illusion Starring Mickey Mouse (Prototype - Oct 17, 1994)", 0)
GAME( 19??, gglegen3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Legend of Illusion Starring Mickey Mouse (Prototype - Sep 22, 1994)", 0)
GAME( 19??, gglegen4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Legend of Illusion Starring Mickey Mouse (Prototype - Sep 30, 1994 - SEL)", 0)
GAME( 19??, gglegen5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Legend of Illusion Starring Mickey Mouse (Prototype - Sep 30, 1994)", 0)
GAME( 19??, gglegen6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Legend of Illusion Starring Mickey Mouse (USA, Europe)", 0)
GAME( 19??, gglemmin, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lemmings (World) (Beta)", 0)
GAME( 19??, gglemmi1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lemmings (World)", 0)
GAME( 19??, gglionki, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (E) [t1]", 0)
GAME( 19??, gglionk1, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Lion King, The (Europe)", 0)
GAME( 19??, gglionk2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 03, 1994)", 0)
GAME( 19??, gglionk3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 11, 1994)", 0)
GAME( 19??, gglionk4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 12, 1994)", 0)
GAME( 19??, gglionk5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 13, 1994)", 0)
GAME( 19??, gglionk6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 14, 1994)", 0)
GAME( 19??, gglionk7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 15, 1994)", 0)
GAME( 19??, gglionk8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 16, 1994)", 0)
GAME( 19??, gglionk9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 17, 1994 - 2)", 0)
GAME( 19??, gglion10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 17, 1994)", 0)
GAME( 19??, gglion11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (Prototype - Aug 20, 1994)", 0)
GAME( 19??, gglion12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (U) [t1]", 0)
GAME( 19??, gglion13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lion King, The (USA)", 0)
GAME( 19??, gglostwo, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lost World, The - Jurassic Park (USA)", 0)
GAME( 19??, ggluckyd, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Lucky Dime Caper, The (USA, Europe)", 0)
GAME( 19??, gglunars, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Lunar - Sanposuru Gakuen (Japan)", 0)
GAME( 19??, ggmadden, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Madden NFL '95 (USA)", 0)
GAME( 19??, ggmadde1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Madden NFL '96 (U) [!]", 0)
GAME( 19??, ggmadde2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Madden NFL '96 (USA, Europe)", 0)
GAME( 19??, ggmadoum, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Madou Monogatari A - Dokidoki Vacation (Japan)", 0)
GAME( 19??, ggmadou1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Madou Monogatari I - 3-Tsu no Madoukyuu (Japan)", 0)
GAME( 19??, ggmadou2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Madou Monogatari II - Arle 16-Sai (Japan)", 0)
GAME( 19??, ggmadou3, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Madou Monogatari III - Kyuukyoku Joou-sama (Japan) (v1.1)", 0)
GAME( 19??, ggmadou4, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Madou Monogatari III - Kyuukyoku Joou-sama (Japan)", 0)
GAME( 19??, ggmagick, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Magic Knight Rayearth (Japan)", 0)
GAME( 19??, ggmagic1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Magic Knight Rayearth 2 - Making of Magic Knight (Japan)", 0)
GAME( 19??, ggmagica, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Magical Puzzle Popils (World) (En,Ja)", 0)
GAME( 19??, ggmagic2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Magical Taruruuto-kun (Japan)", 0)
GAME( 19??, ggmajors, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Majors Pro Baseball, The (USA)", 0)
GAME( 19??, ggmappyj, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Mappy (Japan)", 0)
GAME( 19??, ggmarble, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Marble Madness (USA, Europe)", 0)
GAME( 19??, ggmarkos, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Marko's Magic Football (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, ggmegama, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mega Man (USA, Europe)", 0)
GAME( 19??, ggmegami, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Megami Tensei Gaiden - Last Bible (Japan)", 0)
GAME( 19??, ggmegam1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Megami Tensei Gaiden - Last Bible S (Japan)", 0)
GAME( 19??, ggmickma, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mick & Mack as the Global Gladiators (USA, Europe)", 0)
GAME( 19??, ggmickey, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Mickey Mouse Densetsu no Oukoku - Legend of Illusion (Japan)", 0)
GAME( 19??, ggmicke1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Mickey Mouse no Castle Illusion (Japan) (SMS Mode?)", 0)
GAME( 19??, ggmicke2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Mickey Mouse no Mahou no Crystal (Japan)", 0)
GAME( 19??, ggmicke3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mickey's Ultimate Challenge (USA, Europe)", 0)
GAME( 19??, ggmicrom, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Micro Machines (Europe)", 0)
GAME( 19??, ggmicro1, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Micro Machines 2 - Turbo Tournament (Europe)", 0)
GAME( 19??, ggmighty, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mighty Morphin Power Rangers (Prototype - Jul 16, 1994)", 0)
GAME( 19??, ggmight1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mighty Morphin Power Rangers (USA, Europe)", 0)
GAME( 19??, ggmight2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mighty Morphin Power Rangers - The Movie (Prototype - May 30, 1995)", 0)
GAME( 19??, ggmight3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mighty Morphin Power Rangers - The Movie (USA, Europe)", 0)
GAME( 19??, ggmlbpab, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) MLBPA Baseball (USA)", 0)
GAME( 19??, ggmoldor, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Moldorian - Hikari to Yami no Sister (Japan)", 0)
GAME( 19??, ggmonste, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Monster Truck Wars (USA, Europe)", 0)
GAME( 19??, ggmonst1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Monster World II - Dragon no Wana (Japan)", 0)
GAME( 19??, ggmortal, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Mortal Kombat (Japan) (v3.3)", 0)
GAME( 19??, ggmorta1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mortal Kombat (USA, Europe) (v2.6)", 0)
GAME( 19??, ggmorta2, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Mortal Kombat 3 (Europe)", 0)
GAME( 19??, ggmorta3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Mortal Kombat II (World)", 0)
GAME( 19??, ggmspacm, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ms. Pac-Man (USA)", 0)
GAME( 19??, ggnazopu, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Nazo Puyo (Japan)", 0)
GAME( 19??, ggnazop1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Nazo Puyo 2 (Japan)", 0)
GAME( 19??, ggnazop2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Nazo Puyo Arle no Roux (Japan) (Development Edition)", 0)
GAME( 19??, ggnazop3, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Nazo Puyo Arle no Roux (Japan)", 0)
GAME( 19??, ggnbaact, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action (USA)", 0)
GAME( 19??, ggnbaac1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final A - Feb 28, 1994)", 0)
GAME( 19??, ggnbaac2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final B - Mar 01, 1994)", 0)
GAME( 19??, ggnbaac3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final C - Mar 02, 1994)", 0)
GAME( 19??, ggnbaac4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final D - Mar 03, 1994)", 0)
GAME( 19??, ggnbaac5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final E - Mar 04, 1994)", 0)
GAME( 19??, ggnbaac6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final F - Mar 04, 1994)", 0)
GAME( 19??, ggnbaac7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final G - Mar 05, 1994)", 0)
GAME( 19??, ggnbaac8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Final H - Mar 08, 1994)", 0)
GAME( 19??, ggnbaac9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Dec 01, 1993)", 0)
GAME( 19??, ggnbaa10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 02, 1994)", 0)
GAME( 19??, ggnbaa11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 03, 1994)", 0)
GAME( 19??, ggnbaa12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 06, 1994)", 0)
GAME( 19??, ggnbaa13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 08, 1994)", 0)
GAME( 19??, ggnbaa14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 12, 1994)", 0)
GAME( 19??, ggnbaa15, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 15, 1994)", 0)
GAME( 19??, ggnbaa16, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 17, 1994)", 0)
GAME( 19??, ggnbaa17, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 20, 1994)", 0)
GAME( 19??, ggnbaa18, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 21, 1994)", 0)
GAME( 19??, ggnbaa19, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 24, 1994)", 0)
GAME( 19??, ggnbaa20, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 25, 1994 - B)", 0)
GAME( 19??, ggnbaa21, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 25, 1994)", 0)
GAME( 19??, ggnbaa22, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 26, 1994)", 0)
GAME( 19??, ggnbaa23, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 27, 1994)", 0)
GAME( 19??, ggnbaa24, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Feb 28, 1994)", 0)
GAME( 19??, ggnbaa25, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Jan 04, 1994)", 0)
GAME( 19??, ggnbaa26, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Jan 06, 1994)", 0)
GAME( 19??, ggnbaa27, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Jan 10, 1994)", 0)
GAME( 19??, ggnbaa28, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Jan 24, 1994)", 0)
GAME( 19??, ggnbaa29, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Jan 29, 1994)", 0)
GAME( 19??, ggnbaa30, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Action Starring David Robinson (Prototype - Nov 28, 1993)", 0)
GAME( 19??, ggnbajam, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) NBA Jam (Japan)", 0)
GAME( 19??, ggnbaja1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Jam (USA) (v1.1)", 0)
GAME( 19??, ggnbaja2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Jam (USA, Europe)", 0)
GAME( 19??, ggnbaja3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NBA Jam Tournament Edition (USA, Europe)", 0)
GAME( 19??, ggnekoda, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Neko Daisuki! (Japan)", 0)
GAME( 19??, ggnfl9pr, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Aug 08, 1994)", 0)
GAME( 19??, ggnfl9p1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Aug 25, 1994 - A)", 0)
GAME( 19??, ggnfl9p2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Aug 25, 1994 - B)", 0)
GAME( 19??, ggnfl9p3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Aug 25, 1994)", 0)
GAME( 19??, ggnfl9p4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Aug 26, 1994)", 0)
GAME( 19??, ggnfl9p5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Aug 31, 1994)", 0)
GAME( 19??, ggnfl9p6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 02, 1994)", 0)
GAME( 19??, ggnfl9p7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 08, 1994)", 0)
GAME( 19??, ggnfl9p8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 10, 1994)", 0)
GAME( 19??, ggnfl9p9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 11, 1994 - B)", 0)
GAME( 19??, ggnfl910, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 11, 1994 - C)", 0)
GAME( 19??, ggnfl911, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 12, 1994)", 0)
GAME( 19??, ggnfl912, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 14, 1994 - F)", 0)
GAME( 19??, ggnfl913, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (Prototype - Sep 14, 1994)", 0)
GAME( 19??, ggnfl9us, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL '95 (USA)", 0)
GAME( 19??, ggnflqua, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL Quarterback Club '96 (USA, Europe)", 0)
GAME( 19??, ggnflqu1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NFL Quarterback Club (World)", 0)
GAME( 19??, ggnhlall, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Dec 15, 1994)", 0)
GAME( 19??, ggnhlal1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Dec 22, 1994)", 0)
GAME( 19??, ggnhlal2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Dec 29, 1994)", 0)
GAME( 19??, ggnhlal3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Dec 31, 1994)", 0)
GAME( 19??, ggnhlal4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 02, 1995)", 0)
GAME( 19??, ggnhlal5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 03, 1995)", 0)
GAME( 19??, ggnhlal6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 07, 1995)", 0)
GAME( 19??, ggnhlal7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 11, 1995)", 0)
GAME( 19??, ggnhlal8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 13, 1995)", 0)
GAME( 19??, ggnhlal9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 16, 1995)", 0)
GAME( 19??, ggnhla10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 20 ,1995)", 0)
GAME( 19??, ggnhla11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 21, 1995)", 0)
GAME( 19??, ggnhla12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 24, 1995 - A)", 0)
GAME( 19??, ggnhla13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 24, 1995 - B)", 0)
GAME( 19??, ggnhla14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 24, 1995 - C)", 0)
GAME( 19??, ggnhla15, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 24, 1995)", 0)
GAME( 19??, ggnhla16, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (Prototype - Jan 25, 1995)", 0)
GAME( 19??, ggnhla17, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL All-Star Hockey (USA)", 0)
GAME( 19??, ggnhlhoc, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) NHL Hockey (USA, Europe)", 0)
GAME( 19??, ggninjag, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ninja Gaiden (Japan)", 0)
GAME( 19??, ggninja1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ninja Gaiden (USA, Europe)", 0)
GAME( 19??, ggninkuj, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ninku (Japan)", 0)
GAME( 19??, ggninkut, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ninku 2 - Tenkuuryuu e no Michi (Japan)", 0)
GAME( 19??, ggninkug, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ninku Gaiden - Hiroyuki Daikatsugeki (Japan)", 0)
GAME( 19??, ggnomohi, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Nomo Hideo no World Series Baseball (Japan)", 0)
GAME( 19??, ggolympi, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Olympic Gold (Europe) (En,Fr,De,Es,It,Nl,Pt,Sv) (v1.1) (SMS Mode?)", 0)
GAME( 19??, ggolymp1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Olympic Gold (Japan, USA) (En,Fr,De,Es,It,Nl,Pt,Sv) (SMS Mode?)", 0)
GAME( 19??, ggottifa, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Ottifants, The (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, ggoutrun, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Out Run (Japan)", 0)
GAME( 19??, ggoutru1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Out Run Europa (USA, Europe) (SMS Mode?)", 0)
GAME( 19??, ggoutru2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) OutRun (JU) [a1]", 0)
GAME( 19??, ggpacatt, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Pac-Attack (USA, Europe)", 0)
GAME( 19??, ggpacint, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Pac-In-Time (Unknown) (Proto)", 0)
GAME( 19??, ggpacman, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pac-Man (Japan)", 0)
GAME( 19??, ggpanzer, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Panzer Dragoon Mini (Japan)", 0)
GAME( 19??, ggpaperb, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Paperboy (USA, Europe)", 0)
GAME( 19??, ggpaper1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Paperboy II (USA, Europe)", 0)
GAME( 19??, ggpengoj, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pengo (Japan)", 0)
GAME( 19??, ggpengou, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Pengo (USA, Europe)", 0)
GAME( 19??, ggpetclu, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pet Club Inu Daisuki! (Japan)", 0)
GAME( 19??, ggpetesa, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Pete Sampras Tennis (Europe)", 0)
GAME( 19??, ggpgatou, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) PGA Tour 96 (USA, Europe)", 0)
GAME( 19??, ggpgato1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) PGA Tour Golf (USA) (v1.1)", 0)
GAME( 19??, ggpgato2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) PGA Tour Golf (USA, Europe)", 0)
GAME( 19??, ggpgato3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) PGA Tour Golf II (USA, Europe)", 0)
GAME( 19??, ggphanta, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Phantasy Star Adventure (Japan)", 0)
GAME( 19??, ggphant1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Phantasy Star Gaiden (Japan)", 0)
GAME( 19??, ggphanto, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Phantom 2040 (USA, Europe)", 0)
GAME( 19??, ggpinbal, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Pinball Dreams (USA)", 0)
GAME( 19??, ggpocket, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pocket Jansou (Japan)", 0)
GAME( 19??, ggpokerf, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Poker Faced Paul's Blackjack (USA)", 0)
GAME( 19??, ggpoker1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Poker Faced Paul's Gin (USA)", 0)
GAME( 19??, ggpoker2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Poker Faced Paul's Poker (USA)", 0)
GAME( 19??, ggpoker3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Poker Faced Paul's Solitaire (USA)", 0)
GAME( 19??, ggpopbre, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pop Breaker (Japan)", 0)
GAME( 19??, ggpopeye, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Popeye no Beach Volleyball (Japan)", 0)
GAME( 19??, ggpowers, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Power Strike II (Japan, Europe)", 0)
GAME( 19??, ggpredat, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Predator 2 (USA, Europe) (SMS Mode?)", 0)
GAME( 19??, ggprimal, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Primal Rage (USA, Europe)", 0)
GAME( 19??, ggprince, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Prince of Persia (USA, Europe) (Beta) (SMS Mode?)", 0)
GAME( 19??, ggprinc1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Prince of Persia (USA, Europe) (SMS Mode?)", 0)
GAME( 19??, ggproyak, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pro Yakyuu '91, The (Japan)", 0)
GAME( 19??, ggproya1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pro Yakyuu GG League '94 (Japan)", 0)
GAME( 19??, ggproya2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Pro Yakyuu GG League (Japan)", 0)
GAME( 19??, ggpsychi, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Psychic World (Japan)", 0)
GAME( 19??, ggpsych1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Psychic World (USA, Europe) (v1.1)", 0)
GAME( 19??, ggputtpu, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Putt & Putter (Japan)", 0)
GAME( 19??, ggputtp1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Putt & Putter (USA, Europe)", 0)
GAME( 19??, ggpuyopu, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Puyo Puyo (Japan)", 0)
GAME( 19??, ggpuyop1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Puyo Puyo 2 (Japan)", 0)
GAME( 19??, ggpuzzle, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Puzzle and Action Tanto-R (Japan)", 0)
GAME( 19??, ggpuzzl1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Puzzle Bobble (Japan)", 0)
GAME( 19??, ggquestf, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Quest for the Shaven Yak Starring Ren Hoek & Stimpy (USA, Europe)", 0)
GAME( 19??, ggquizge, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Quiz Gear Fight!!, The (Japan)", 0)
GAME( 19??, ggrbibas, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) R.B.I. Baseball '94 (USA)", 0)
GAME( 19??, ggrcgran, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) R.C. Grand Prix (USA, Europe) (SMS Mode?)", 0)
GAME( 19??, ggrastan, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Rastan Saga (Japan) (SMS Mode?)", 0)
GAME( 19??, ggreveng, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Revenge of Drancon (USA)", 0)
GAME( 19??, ggriddic, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Riddick Bowe Boxing (Japan)", 0)
GAME( 19??, ggriddi1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Riddick Bowe Boxing (USA)", 0)
GAME( 19??, ggriseof, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Rise of the Robots (USA, Europe)", 0)
GAME( 19??, ggristar, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ristar (Prototype - Nov 01, 1994)", 0)
GAME( 19??, ggrista1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ristar (Prototype - Nov 02, 1994)", 0)
GAME( 19??, ggrista2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ristar (Prototype - Oct 19, 1994)", 0)
GAME( 19??, ggrista3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ristar (Prototype - Oct 26, 1994)", 0)
GAME( 19??, ggrista4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ristar (Prototype - Sep 09, 1994)", 0)
GAME( 19??, ggrista5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ristar - The Shooting Star (World)", 0)
GAME( 19??, ggroadra, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Road Rash (USA)", 0)
GAME( 19??, ggroboco, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) RoboCop 3 (USA, Europe)", 0)
GAME( 19??, ggroboc1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) RoboCop versus The Terminator (USA, Europe)", 0)
GAME( 19??, ggroyals, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Royal Stone - Hirakareshi Toki no Tobira (Japan)", 0)
GAME( 19??, ggryuuky, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Ryuukyuu (Japan)", 0)
GAME( 19??, ggssluci, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) S.S. Lucifer - Man Overboard! (Europe)", 0)
GAME( 19??, ggsamura, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Samurai Shodown (USA)", 0)
GAME( 19??, ggsamur1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Samurai Spirits (Japan)", 0)
GAME( 19??, ggscratc, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Scratch Golf (Japan)", 0)
GAME( 19??, ggsdgund, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) SD Gundam - Winner's History (Japan)", 0)
GAME( 19??, ggsegaga, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Sega Game Pack 4 in 1 (Europe)", 0)
GAME( 19??, ggsensib, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Sensible Soccer (Europe)", 0)
GAME( 19??, ggshadam, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Shadam Crusader - Harukanaru Oukoku (Japan)", 0)
GAME( 19??, ggshangh, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Shanghai II (Japan)", 0)
GAME( 19??, ggshaqfu, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shaq Fu (USA, Europe)", 0)
GAME( 19??, ggshikin, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Shikinjou (Japan)", 0)
GAME( 19??, ggshinin, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Shining Force Gaiden - Ensei, Jashin no Kuni e (Japan)", 0)
GAME( 19??, ggshini1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Shining Force Gaiden - Final Conflict (Japan)", 0)
GAME( 19??, ggshini2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Shining Force Gaiden II - Jashin no Kakusei (Japan)", 0)
GAME( 19??, ggshini3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shining Force II (Prototype - Apr 27, 1994)", 0)
GAME( 19??, ggshini4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shining Force II (Prototype - Jul 08, 1994)", 0)
GAME( 19??, ggshini5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shining Force II (Prototype - Jun 27, 1994)", 0)
GAME( 19??, ggshini6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shining Force II (Prototype - May 30, 1994)", 0)
GAME( 19??, ggshini7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shining Force II - The Sword of Hajya (USA, Europe)", 0)
GAME( 19??, ggshinob, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shinobi (USA, Europe)", 0)
GAME( 19??, ggshino1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Shinobi II - The Silent Fury (World)", 0)
GAME( 19??, ggsidepo, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Side Pocket (USA)", 0)
GAME( 19??, ggsimpso, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Simpsons, The - Bart vs. The Space Mutants (USA, Europe)", 0)
GAME( 19??, ggsimps1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Simpsons, The - Bart vs. The World (USA, Europe)", 0)
GAME( 19??, ggskweek, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Skweek (Japan)", 0)
GAME( 19??, ggslider, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Slider (USA, Europe)", 0)
GAME( 19??, ggsmurfs, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Smurfs, The (Europe) (En,Fr,De,Es)", 0)
GAME( 19??, ggsolita, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Solitaire Funpak (USA)", 0)
GAME( 19??, ggsolit1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Solitaire Poker (USA, Europe)", 0)
GAME( 19??, ggsonict, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Sonic & Tails (Japan)", 0)
GAME( 19??, ggsonic1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Sonic & Tails 2 (Japan)", 0)
GAME( 19??, ggsonicb, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Blast (Prototype 611 - May 31, 1996, 13.49)", 0)
GAME( 19??, ggsonic2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Blast (Prototype 74 - Jul 17, 1996, 09.11)", 0)
GAME( 19??, ggsonic3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Blast (Prototype 806 - Aug 06, 1996, 18.37)", 0)
GAME( 19??, ggsonic4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Blast (Prototype 821 - Aug 22, 1996, 09.38)", 0)
GAME( 19??, ggsonic5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Blast (Prototype 827 - Aug 28, 1996, 11.13)", 0)
GAME( 19??, ggsonic6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Blast (Prototype 94 - Sep 02, 1996, 17.47)", 0)
GAME( 19??, ggsonic7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Blast (World)", 0)
GAME( 19??, ggsonicc, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Chaos (USA, Europe)", 0)
GAME( 19??, ggsonicd, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Sonic Drift (Japan) (Sample)", 0)
GAME( 19??, ggsonic8, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Sonic Drift (Japan)", 0)
GAME( 19??, ggsonic9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Drift 2 (Japan, USA)", 0)
GAME( 19??, ggsonicl, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Labyrinth (World)", 0)
GAME( 19??, ggsonics, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0307 - Mar 07, 1994, 05.24)", 0)
GAME( 19??, ggsoni10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 031094 - Mar 10, 1994, 17.41)", 0)
GAME( 19??, ggsoni11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 031194 - Mar 11, 1994, 12.09)", 0)
GAME( 19??, ggsoni12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 032194 - Mar 21, 1994, 07.12)", 0)
GAME( 19??, ggsoni13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0328 - Mar 28, 1994, 06.54)", 0)
GAME( 19??, ggsoni14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0329 - Mar 29, 1994, 07.35)", 0)
GAME( 19??, ggsoni15, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0330 - Mar 30, 1994, 06.54)", 0)
GAME( 19??, ggsoni16, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0405 - Apr 05, 1994, 18.07)", 0)
GAME( 19??, ggsoni17, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0412 - Apr 12, 1994, 07.26)", 0)
GAME( 19??, ggsoni18, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0413 - Apr 13, 1994, 02.54)", 0)
GAME( 19??, ggsoni19, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0415 - Apr 15, 1994, 17.33)", 0)
GAME( 19??, ggsoni20, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0421 - Apr 21, 1994, 05.30)", 0)
GAME( 19??, ggsoni21, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0427 - Apr 27, 1994, 04.51)", 0)
GAME( 19??, ggsoni22, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0429 - Apr 29, 1994, 06.01)", 0)
GAME( 19??, ggsoni23, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0430 - Apr 29, 1994, 21.48)", 0)
GAME( 19??, ggsoni24, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0505 - May 05, 1994, 04.47)", 0)
GAME( 19??, ggsoni25, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0506 - May 06, 1994, 13.04)", 0)
GAME( 19??, ggsoni26, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0525 - May 25, 1994, 13.24)", 0)
GAME( 19??, ggsoni27, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 0530 - May 30, 1994, 23.25)", 0)
GAME( 19??, ggsoni28, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (Prototype 503B - May 03, 1994, 19.27)", 0)
GAME( 19??, ggsoni29, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic Spinball (USA, Europe)", 0)
GAME( 19??, ggsoni30, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Sonic The Hedgehog (Japan)", 0)
GAME( 19??, ggsoni31, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic The Hedgehog (World) (Proto)", 0)
GAME( 19??, ggsoni32, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic The Hedgehog (World) (v1.1)", 0)
GAME( 19??, ggsoni33, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic The Hedgehog - Triple Trouble (Prototype 0808 - Aug 08, 1994, 18.05)", 0)
GAME( 19??, ggsoni34, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic The Hedgehog - Triple Trouble (USA, Europe)", 0)
GAME( 19??, ggsoni35, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sonic The Hedgehog 2 (World)", 0)
GAME( 19??, ggsoukob, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Soukoban (Japan)", 0)
GAME( 19??, ggspaceh, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Space Harrier (World)", 0)
GAME( 19??, ggspeedy, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Speedy Gonzales Cheese Catastrophe (Prototype - Feb 17, 1995)", 0)
GAME( 19??, ggspeed1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Speedy Gonzales Cheese Catastrophe (Prototype - Feb 24, 1995)", 0)
GAME( 19??, ggspider, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Spider-Man - Return of the Sinister Six (USA, Europe)", 0)
GAME( 19??, ggspide1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Spider-Man and the X-Men in Arcade's Revenge (USA)", 0)
GAME( 19??, ggspide2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Spider-Man vs. The Kingpin (USA, Europe)", 0)
GAME( 19??, ggspirou, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Spirou (Europe) (Proto)", 0)
GAME( 19??, ggsports, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Illustrated Championship Football & Baseball (USA, Europe)", 0)
GAME( 19??, ggsport1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 03, 1995 - 2MEG)", 0)
GAME( 19??, ggsport2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 03, 1995 - QTEST)", 0)
GAME( 19??, ggsport3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 04, 1995 - 2MEG)", 0)
GAME( 19??, ggsport4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 05, 1995 - 2MEG - B)", 0)
GAME( 19??, ggsport5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 05, 1995 - 2MEG - C)", 0)
GAME( 19??, ggsport6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 05, 1995 - QTEST)", 0)
GAME( 19??, ggsport7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 06, 1995 - 2MEG)", 0)
GAME( 19??, ggsport8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 07, 1995 - 2MEG)", 0)
GAME( 19??, ggsport9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 07, 1995 - QTEST)", 0)
GAME( 19??, ggspor10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 11, 1995 - 2MEG)", 0)
GAME( 19??, ggspor11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 12, 1995 - 2MEG)", 0)
GAME( 19??, ggspor12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 25, 1995 - 1MEG)", 0)
GAME( 19??, ggspor13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 25, 1995 - QTEST)", 0)
GAME( 19??, ggspor14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 27, 1995 - 1MEG)", 0)
GAME( 19??, ggspor15, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Apr 28, 1995 - 2MEG)", 0)
GAME( 19??, ggspor16, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 08, 1995)", 0)
GAME( 19??, ggspor17, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 09, 1995)", 0)
GAME( 19??, ggspor18, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 13, 1995)", 0)
GAME( 19??, ggspor19, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 16, 1995 - 1MEG)", 0)
GAME( 19??, ggspor20, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 16, 1995 - 2MEG)", 0)
GAME( 19??, ggspor21, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 17, 1995 - 2MEG)", 0)
GAME( 19??, ggspor22, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 20, 1995 - 2MEG)", 0)
GAME( 19??, ggspor23, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 20, 1995 - QTEST)", 0)
GAME( 19??, ggspor24, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 21, 1995 - 2MEG)", 0)
GAME( 19??, ggspor25, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 23, 1995 - 2MEG)", 0)
GAME( 19??, ggspor26, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 23, 1995 - ALGOTEST)", 0)
GAME( 19??, ggspor27, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 23, 1995 - QTEST)", 0)
GAME( 19??, ggspor28, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 27, 1995 - 2MEG)", 0)
GAME( 19??, ggspor29, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 27, 1995 - ALGOTEST)", 0)
GAME( 19??, ggspor30, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 29, 1995 - 2MEG)", 0)
GAME( 19??, ggspor31, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 29, 1995 - ALGOTEST)", 0)
GAME( 19??, ggspor32, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 29, 1995 - QTEST)", 0)
GAME( 19??, ggspor33, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 30, 1995 - 2MEG - D)", 0)
GAME( 19??, ggspor34, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - Mar 30, 1995 - QTEST)", 0)
GAME( 19??, ggspor35, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - May 02, 1995 - 2MEG)", 0)
GAME( 19??, ggspor36, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (Prototype - May 04, 1995 - 1MEG)", 0)
GAME( 19??, ggspor37, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia (USA)", 0)
GAME( 19??, ggspor38, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Sports Trivia - Championship Edition (USA, Europe)", 0)
GAME( 19??, ggstartr, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Star Trek - The Next Generation - The Advanced Holodeck Tutorial (USA)", 0)
GAME( 19??, ggstart1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Star Trek Generations - Beyond the Nexus (USA, Europe)", 0)
GAME( 19??, ggstarwa, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Star Wars (Europe)", 0)
GAME( 19??, ggstarw1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Star Wars (USA)", 0)
GAME( 19??, ggstarga, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Stargate (World)", 0)
GAME( 19??, ggstreet, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Streets of Rage (World)", 0)
GAME( 19??, ggstree1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Streets of Rage II (World)", 0)
GAME( 19??, ggstrike, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Striker (Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, ggsuperb, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Battletank (USA)", 0)
GAME( 19??, ggsuperc, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Super Columns (Japan)", 0)
GAME( 19??, ggsuper1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (Prototype - Dec 01, 1994)", 0)
GAME( 19??, ggsuper2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (Prototype - Dec 15, 1994)", 0)
GAME( 19??, ggsuper3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (Prototype - Dec 21, 1994)", 0)
GAME( 19??, ggsuper4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (Prototype - Dec 26, 1994)", 0)
GAME( 19??, ggsuper5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (Prototype - Dec 28, 1994)", 0)
GAME( 19??, ggsuper6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (Prototype - Jan 06, 1995)", 0)
GAME( 19??, ggsuper7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (Prototype - Nov 11, 1994)", 0)
GAME( 19??, ggsuper8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Columns (USA, Europe)", 0)
GAME( 19??, ggsuperg, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Super Golf (Japan)", 0)
GAME( 19??, ggsuperk, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Super Kick Off (Japan) (SMS Mode?)", 0)
GAME( 19??, ggsuperm, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Super Momotarou Dentetsu III (Japan)", 0)
GAME( 19??, ggsuper9, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Super Monaco GP (Japan)", 0)
GAME( 19??, ggsupe10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Monaco GP (USA, Europe)", 0)
GAME( 19??, ggsupero, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Off Road (USA, Europe)", 0)
GAME( 19??, ggsupe11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Off-Road (U)", 0)
GAME( 19??, ggsuperr, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Return of the Jedi (USA, Europe)", 0)
GAME( 19??, ggsupers, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Smash T.V. (World)", 0)
GAME( 19??, ggsupe12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Space Invaders (USA, Europe)", 0)
GAME( 19??, ggsupert, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Super Tetris (K) [S][!] (SMS Mode?)", 0)
GAME( 19??, ggsupe13, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Superman - The Man of Steel (Europe)", 0)
GAME( 19??, ggsurfni, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Surf Ninjas (USA)", 0)
GAME( 19??, ggsylvan, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Sylvan Tale (Japan)", 0)
GAME( 19??, ggt2thea, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) T2 - The Arcade Game (USA, Europe)", 0)
GAME( 19??, ggtailsa, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tails Adventures (World) (En,Ja)", 0)
GAME( 19??, ggtailsn, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Tails no Skypatrol (Japan)", 0)
GAME( 19??, ggtaisen, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Taisen Mahjong HaoPai (Japan)", 0)
GAME( 19??, ggtaise1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Taisen Mahjong HaoPai 2 (Japan)", 0)
GAME( 19??, ggtaise2, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Taisen-gata Daisenryaku G (Japan)", 0)
GAME( 19??, ggtaitoc, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Taito Chase H.Q. (Japan) (SMS Mode?)", 0)
GAME( 19??, ggtalesp, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tale Spin (USA, Europe)", 0)
GAME( 19??, ggtamafr, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Tama & Friends Sanchoume Kouen - Tamalympic (Japan)", 0)
GAME( 19??, ggtarotn, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Tarot no Yakata (Japan)", 0)
GAME( 19??, ggtarzan, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Tarzan - Lord of the Jungle (Europe)", 0)
GAME( 19??, ggtataka, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Tatakae! Pro Yakyuu Twin League (Japan)", 0)
GAME( 19??, ggtazine, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 10, 1994)", 0)
GAME( 19??, ggtazin1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 12, 1994)", 0)
GAME( 19??, ggtazin2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 14, 1994)", 0)
GAME( 19??, ggtazin3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 15, 1994)", 0)
GAME( 19??, ggtazin4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 19, 1994)", 0)
GAME( 19??, ggtazin5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 23, 1994)", 0)
GAME( 19??, ggtazin6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 29, 1994 - B)", 0)
GAME( 19??, ggtazin7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Aug 30, 1994)", 0)
GAME( 19??, ggtazin8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - May 11, 1994)", 0)
GAME( 19??, ggtazin9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Sep 02, 1994)", 0)
GAME( 19??, ggtazi10, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Sep 05, 1994 - B)", 0)
GAME( 19??, ggtazi11, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Sep 05, 1994 - C)", 0)
GAME( 19??, ggtazi12, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Sep 06, 1994 - D)", 0)
GAME( 19??, ggtazi13, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Sep 09, 1994 - B)", 0)
GAME( 19??, ggtazi14, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (Prototype - Sep 10, 1994)", 0)
GAME( 19??, ggtazi15, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz in Escape from Mars (USA, Europe)", 0)
GAME( 19??, ggtazman, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Taz-Mania - The Search for the Lost Seabirds (USA, Europe)", 0)
GAME( 19??, ggtempoj, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Dec 05, 1994)", 0)
GAME( 19??, ggtempo1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Dec 12, 1994)", 0)
GAME( 19??, ggtempo2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Dec 26, 1994)", 0)
GAME( 19??, ggtempo3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Feb 06, 1995)", 0)
GAME( 19??, ggtempo4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Feb 15, 1995)", 0)
GAME( 19??, ggtempo5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Jan 17, 1995)", 0)
GAME( 19??, ggtempo6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Jan 20, 1995)", 0)
GAME( 19??, ggtempo7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Jan 31, 1995)", 0)
GAME( 19??, ggtempo8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (Prototype - Nov 28, 1994)", 0)
GAME( 19??, ggtempo9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tempo Jr. (World)", 0)
GAME( 19??, ggtengen, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tengen World Cup Soccer (USA, Europe)", 0)
GAME( 19??, ggtermin, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Terminator 2 - Judgment Day (USA, Europe)", 0)
GAME( 19??, ggtermi1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Terminator, The (USA, Europe)", 0)
GAME( 19??, ggtesser, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tesserae (USA, Europe)", 0)
GAME( 19??, ggtintin, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Tintin in Tibet (Europe) (En,Fr,De,Es,Nl,Sv)", 0)
GAME( 19??, ggtomand, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Tom and Jerry - The Movie (USA)", 0)
GAME( 19??, ggtorare, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Torarete Tamaruka (Japan)", 0)
GAME( 19??, ggtrueli, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) True Lies (World)", 0)
GAME( 19??, ggultima, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Ultimate Soccer (Japan, Europe) (En,Fr,De,Es,It)", 0)
GAME( 19??, ggurbans, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Urban Strike (USA, Europe)", 0)
GAME( 19??, ggvampir, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Vampire - Master of Darkness (USA)", 0)
GAME( 19??, ggvirtua, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Virtua Fighter Animation (USA, Europe)", 0)
GAME( 19??, ggvirtu1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Virtua Fighter Mini (Japan)", 0)
GAME( 19??, ggvrtroo, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) VR Troopers (USA, Europe)", 0)
GAME( 19??, ggwaganl, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Wagan Land (Japan)", 0)
GAME( 19??, ggwagyan, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Wagyan Land (J) [a1]", 0)
GAME( 19??, ggwheelo, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Wheel of Fortune (USA)", 0)
GAME( 19??, ggwimble, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Wimbledon (World)", 0)
GAME( 19??, ggwinter, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Winter Olympics - Lillehammer '94 (Japan) (En,Fr,De,Es,It,Pt,Sv,No)", 0)
GAME( 19??, ggwinte1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Winter Olympics - Lillehammer '94 (USA, Europe) (En,Fr,De,Es,It,Pt,Sv,No)", 0)
GAME( 19??, ggwizard, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Wizard Pinball (Europe)", 0)
GAME( 19??, ggwolfch, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Wolfchild (Europe)", 0)
GAME( 19??, ggwonder, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Wonder Boy (Europe)", 0)
GAME( 19??, ggwonde1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Wonder Boy (Japan)", 0)
GAME( 19??, ggwonde2, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Wonder Boy - The Dragon's Trap (Europe)", 0)
GAME( 19??, ggwonde3, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Wonder Boy III - The Dragon's Trap (Europe) (Beta)", 0)
GAME( 19??, ggwoodyp, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Woody Pop (USA, Europe) (v1.1)", 0)
GAME( 19??, ggwoody1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Woody Pop (USA, Europe)", 0)
GAME( 19??, ggworldc, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Class Leader Board (USA, Europe)", 0)
GAME( 19??, ggworld1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Cup USA 94 (USA, Europe) (En,Fr,De,Es,It,Nl,Pt,Sv)", 0)
GAME( 19??, ggworldd, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) World Derby (Japan)", 0)
GAME( 19??, ggworlds, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball '95 (Prototype - Jul 09, 1994)", 0)
GAME( 19??, ggworld2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball '95 (Prototype - Jul 19, 1994)", 0)
GAME( 19??, ggworld3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball '95 (Prototype - Jul 22, 1994)", 0)
GAME( 19??, ggworld4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball '95 (Prototype - Jul 28, 1994)", 0)
GAME( 19??, ggworld5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball '95 (Prototype - Jul 29, 1994)", 0)
GAME( 19??, ggworld6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball '95 (Prototype - Jun 29, 1994)", 0)
GAME( 19??, ggworld7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball '95 (USA)", 0)
GAME( 19??, ggworld8, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball (USA) (v1.1)", 0)
GAME( 19??, ggworld9, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) World Series Baseball (USA)", 0)
GAME( 19??, ggwwfraw, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) WWF Raw (USA, Europe)", 0)
GAME( 19??, ggwwfwre, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) WWF Wrestlemania Steel Cage Challenge (Europe) (SMS Mode?)", 0)
GAME( 19??, ggxmenus, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men (USA)", 0)
GAME( 19??, ggxmenga, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Gamemaster's Legacy (Prototype - Aug 10, 1994)", 0)
GAME( 19??, ggxmeng1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Gamemaster's Legacy (Prototype - Aug 15, 1994)", 0)
GAME( 19??, ggxmeng2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Gamemaster's Legacy (Prototype 36 - Aug 31, 1994)", 0)
GAME( 19??, ggxmeng3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Gamemaster's Legacy (Prototype 51 - Sep 06, 1994)", 0)
GAME( 19??, ggxmeng4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Gamemaster's Legacy (USA, Europe)", 0)
GAME( 19??, ggxmenmo, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (Prototype - Jun 05, 1996)", 0)
GAME( 19??, ggxmenm1, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (Prototype - Jun 13, 1996)", 0)
GAME( 19??, ggxmenm2, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (Prototype - Jun 24, 1996)", 0)
GAME( 19??, ggxmenm3, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (Prototype - Jun 25, 1996)", 0)
GAME( 19??, ggxmenm4, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (Prototype - Jun 27, 1996)", 0)
GAME( 19??, ggxmenm5, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (Prototype - Jun 28, 1996)", 0)
GAME( 19??, ggxmenm6, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (Prototype - Jun 29, 1996)", 0)
GAME( 19??, ggxmenm7, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) X-Men - Mojo World (USA, Europe)", 0)
GAME( 19??, ggyogibe, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Yogi Bear in Yogi Bear's Goldrush (Unknown) (Proto)", 0)
GAME( 19??, ggyuyuha, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Yu Yu Hakusho - Horobishimono no Gyakushuu (Japan)", 0)
GAME( 19??, ggyuyuh1, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Yu Yu Hakusho 2 - Gekitou! Nanakyou no Tatakai (Japan)", 0)
GAME( 19??, ggzangea, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Zan Gear (Japan)", 0)
GAME( 19??, ggzoolus, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Zool (USA)", 0)
GAME( 19??, ggzoolno, 0       , ggj, gamegear, ggj, ROT0, "Sega License", "(Game Gear) Zool no Yume Bouken (Japan)", 0)
GAME( 19??, ggzoopeu, 0       , gge, gamegear, gge, ROT0, "Sega License", "(Game Gear) Zoop (Europe)", 0)
GAME( 19??, ggzoopus, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) Zoop (USA)", 0)
GAME( 19??, ggbiosse, 0       , ggu, gamegear, ggu, ROT0, "Sega License", "(Game Gear) [BIOS] Sega Game Gear (USA) (Majesco)", 0)

